@   Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
@   Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
@
@   This file is part of Jespa3D Engine.
@
@   Jespa3D Engine is free software; you can redistribute it and/or modify
@   it under the terms of the GNU General Public License as published by
@   the Free Software Foundation; either version 2 of the License, or
@   (at your option) any later version.
@
@   Jespa3D Engine is distributed in the hope that it will be useful,
@   but WITHOUT ANY WARRANTY; without even the implied warranty of
@   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
@   GNU General Public License for more details.
@
@   You should have received a copy of the GNU General Public License
@   along with Jespa3D Engine; ; see the file COPYING. if not, write to 
@   the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
@   Boston, MA  02111-1307  USA





@ /*************\
@ | INCLUSIONS  |
@ \*************/


.include "GFX/IncludeARM/Info_images.s"


@ /**************\
@ | DEFINCIONS   |
@ \**************/

.equ AMPLADA_PANTALLA,240
.equ ALTURA_PANTALLA,160
.equ CENTRE_X2D, 120
.equ CENTRE_Y2D, 80


@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@ LES SEGENTS DEFINICIONS DEFINEIXEN LA QUALITAT GRFIC EN X I/O EN Y. CAL POSAR LA DEFINICI COM A COMENTARI
@ SI ES VOL UTILITZAR MXIM NIVELL DE COORDENADA (X o Y).
@
@  IMPORTANT !!! SI ES VOL CREAR LA ROM GBA I SI ES POSA ALGUNA DE LES SEGENTS DEFINICIONS COM A COMENTARI,
@ CALDR MODIFICAR LES DEFINCIONS DE CAPALERA C ("definicions.h") DE MANERA QUE COINCIDEIXIN
@

@.equ    __BAIX_DETALL_X,1
@.equ    __BAIX_DETALL_Y,1

@.equ   __WITH_EFFECTS__,1


@@
@@
@@ FI DEFINICIONS NIVELL GRFIC
@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


.ifdef __BAIX_DETALL_X
	.equ __BAIX_NIVELL_X,1
    .equ AMPLADA_PANTALLA_EFECTIVA, 120
    .equ CENTRE_X2D_EFECTIU,60
	.equ	DETALL_GRAFIC_X,1
.else
    .equ AMPLADA_PANTALLA_EFECTIVA, 240
    .equ CENTRE_X2D_EFECTIU,120
	.equ	DETALL_GRAFIC_X,0
.endif



.ifdef __BAIX_DETALL_Y
	.equ __BAIX_NIVELL_Y,1
    .equ ALTURA_PANTALLA_EFECTIVA,80
    .equ CENTRE_Y2D_EFECTIU,40
	.equ	DETALL_GRAFIC_Y,1

.else
    .equ ALTURA_PANTALLA_EFECTIVA,160
    .equ CENTRE_Y2D_EFECTIU,80
	.equ	DETALL_GRAFIC_Y,0

.endif


.equ		PART_FRACCIONAL,	8

.equ MAXIMA_ILUMINACIO_LLINTERNA,			40
.equ MINIMA_DISTANCIA_LLINTERNA,			4 << PART_FRACCIONAL @, LSL #PART_FRACCIONAL
@.equ ATENUACIO_ILUMINACIO_LLINTERNA,		DOUBLE_TO_FIXED(-0.1259)
.equ MAXIMA_INTENSITAT,						150



.equ		ONE_FX,				1 << PART_FRACCIONAL



.equ Video,0x06000000




@ /*****************************\
@ | VARIABLES_GLOBALS EXTERNES  |
@ \*****************************/


@ Punter al vector de textures...
.ptr_textura:
	.word	Textura

@ Punter al buffer de video que s'esta treballant...
.ptr_video:
	.word VideoBuffer

.ptr_jugador:
	.word Jugador

@ Tamany de l'estructura "tImatge" (per ser modificada sense preucopar-se)...
.SIZEOF_IMAGE:
	.word Sizeof_tImatge

@ Tamany de l'estructura "tTextura"
.SIZEOF_TEXTURA:
	.word  Sizeof_tTextura


@
@ Macro per llegir el color de video, afegit color, ms anmascarat de pixel. Resultat guardat al registre anomenat color.
@ Tamb, es necessari el pas d' un registre auxiliar anomenat aux1.

.macro LECTURA_VIDEO_MES_ENMASCARAT	color, x, ptr_video, aux1
@@@@@@@@@@@@@- CARREGA PIXELS DE MEMORIA, EMMASCARANENT, i GUARDAT DEL PIXEL -@@@@2@@@@@@@@

            @ Crrega de pixels desde vram ...

            LDRH     \aux1, [\ptr_video]           @ Carrega dels pixel vram. (Els 8 bits de MENYS pes s el PIXEL PARELL, i els bits de MS pes representa el PIXEL SENAR)

            @ Emmascarat del pixel a salvaguardar i escriptura del pixel de textura (r3)

            @ if( x == 1) // Volem escriure pixel senar, per aix cal guardar pixel parell

            TSTS        \x,#1

            @ Escriptura de pixel senar --> cal guardar pixel parell...

            ANDNE     \aux1,     \aux1,        #255                @ r4 <- Color_Textura & 0xFF  (Machaquem el 8 bits de MES PES -Pixel senar-)
            ORRNE     \color,     \aux1,   \color,  LSL   #8       @ r4 <- (Pixel_Textura << 8) | r4 ( Guardem pixel senar)

            @else // Volem escriure pixel parell, per aix cal salvarguardar el pixel senar de la

            @ Escriptura de pixel parell --> cal guardar pixel senar...

            MOVEQ     \aux1,     \aux1,    LSR   #8                    @ r9 <- r9 >> 8  (Machaquem el 8 bits de MENYS PES -Pixel parell-)
            ORREQ     \color,     \color,   \aux1,  LSL   #8           @ r9 <- Pixel_Textura | r9 ( Guardem pixel parell)


@@@@2@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@2@@@@@@@@@@@@@@@@@@
.endm


@ /***********************\
@ | PROTOTIPUS DE FUNCIONS |
@ \***********************/


.GLOBL   ARM_PutSprite
.GLOBL   ARM_PutBlockSlice
.GLOBL   ARM_PutBlockSlice_With_V_POW_2
.GLOBL   ARM_PutBlockSlice_Fast

.GLOBL   ARM_PintarTiraPla
.GLOBL   ARM_PintarTerra_HIGH
.GLOBL   ARM_Obtenir_Cotes
.GLOBL   ARM_PintarTiraPla_FAST


