@   Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
@   Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
@
@   This file is part of Jespa3D Engine.
@
@   Jespa3D Engine is free software; you can redistribute it and/or modify
@   it under the terms of the GNU General Public License as published by
@   the Free Software Foundation; either version 2 of the License, or
@   (at your option) any later version.
@
@   Jespa3D Engine is distributed in the hope that it will be useful,
@   but WITHOUT ANY WARRANTY; without even the implied warranty of
@   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
@   GNU General Public License for more details.
@
@   You should have received a copy of the GNU General Public License
@   along with Jespa3D Engine; ; see the file COPYING. if not, write to 
@   the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
@   Boston, MA  02111-1307  USA




@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@                                                                      @
@ Jespa presents                                                       @
@  \________________                                                   @
@                                                                      @
@ Una divisi de 64 bits de numerador i 32 bits de divident  per       @
@ programes sota el chip ARM7TDMI.                                     @
@                                                                      @
@ Input                                                                @
@ -----                                                                @
@ r0 = Part alta  numerador.                                           @
@ r1 = Part baixa numerador.                                           @
@                                                                      @
@                                                                      @
@ r3 =  denominador.                                                   @
@                                                                      @
@ OutPut                                                               @
@ ------                                                               @
@ r0 = Quocient                                                        @
@ r1 = Modul                                                           @
@                                                                      @
@ Destruccio de registres:                                             @
@                                                                      @
@ r2,r4,r5,r6 i r7                                                     @
@                                                                      @
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@




.CODE 32
.SECTION .iwram
.ALIGN


.GLOBL   ARM_iDiv64
.GLOBL   ARM_uDiv32
.TYPE    ARM_iDiv64, function
.ALIGN
@.TEXT




@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@ INTEGER 64 bit DIVISION   ( r0 <-- r0:r1 div r3 )
@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@



ARM_iDiv64:

@ r7 : Signe del resultat de la divisi.
@

    STMFD   sp!, {lr}

    CMPS    r3,#0               @ Si Denominador = 0 llavors
    BEQ     ___Error_iDiv64         @ Error!, divisio per zero.

    MOV     r7,r0,LSR #31       @ Guardem signe numerador a r7.
    MOV     r6,r3,LSR #31       @ Guardem signe denominador a r6.
    EOR     r7,r7,r6            @ Guardem resultat signe a r7.
    
    MOV     r6,#0xFFFFFFFF
    
@ Executem la funci abs(r3)

    TSTS    r3,#0x80000000
    BEQ     ___R3_es_positiu_iDiv64

    EOR     r3,r3,r6
    ADD     r3,r3,#1

___R3_es_positiu_iDiv64:


@ Executem la funci abs(r0:r1)

  

    CMPS   r0,#0
    BPL     ___r0_r1_es_positiu_iDiv64

    EOR     r0,r0,r6
    EOR     r1,r1,r6
    
    ADDS    r1,r1,#1
    ADC     r0,r0,#0
    
@ si r0 = 0, llavors tractem una divisi de 32 bits /32 bits. Ok?
@ Divim r1 div r3

___r0_r1_es_positiu_iDiv64:

    TSTS     r0,r6       @ r0 & 0xFFFFFFFF
    BNE     ___Divisio64_iDiv64   @ Si no es igual a zero llavors executem divisio 64 bits, altrament...
    
    @ ... executem una divisio de 32:32 bits.
    
    TST     r1,r6
    BEQ     ___Acaba_iDiv64
    CMP     r1,r3
    MOVEQ   r0,#1
    BEQ     ___Acaba_iDiv64
    
 @ r6 <- (32 + lmbd(r3)) - lmb(r1)

    EOR     r2,r2,r2            @ r2 <- 0
    MOV     r4,#0x80000000
    EOR     r5,r5,r5            @ r5 <- 0
    EOR     r6,r6,r6            @ r6 <- 0

@ Comptem el numero de desplaaments fins a trobar el primer 1 en el r1.

    TSTS    r1,r4
    BNE     ___Ok1_iDiv64

___Again4_iDiv64:

    MOV     r4,r4,LSR #1
    ADD     r5,r5,#1
    TSTS    r1,r4
    
    BEQ    ___Again4_iDiv64

    B     ___Ok1_iDiv64


___Divisio64_iDiv64:

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@ Tenim una divisio de 64 bits / 32 bits.
@
@


@ r6 <- (32 + lmbd(r3)) - lmb(r0)

    EOR     r2,r2,r2            @ r2 <- 0
    MOV     r4,#0x80000000
    EOR     r5,r5,r5            @ r5 <- 0
    MOV     r6,#32              @ r6 <- 32

@ Comptem el numero de desplaaments fins a trobar el primer 1 en el r0.

    TSTS    r0,r4
    BNE     ___Ok1_iDiv64

___Again1_iDiv64:

    MOV     r4,r4,LSR #1
    ADD     r5,r5,#1
    TSTS    r0,r4
    BEQ    ___Again1_iDiv64

___Ok1_iDiv64:

@ Comptem el numero de desplaaments fins a trobar el primer 1 en el r3.

    MOV     r4,#0x80000000

    TSTS    r3,r4
    BNE     ___Ok2_iDiv64

___Again2_iDiv64:

    MOV     r4,r4,LSR #1
    ADD     r6,r6,#1
    TSTS    r3,r4
    BEQ     ___Again2_iDiv64


___Ok2_iDiv64:

@ Efectuem la diferencia de ambdos resultats.

    SUB     r4,r6,r5            @  r4 <- r6 - r5
    
@ r2:r3 SHL r4 vegades

    MOV     r6,#0x20
    SUB     r5,r6,r4            @ r5 <- 32 - r4
    MOV     r2,r3, LSR r5       @ r2 <- r3 >> (32 - r5)
    MOV     r3,r3, LSL r4       @ r3 <- r3 << r4
    
    SUB     r5,r5,#1
    
@ Bucle que s' anira calculant el quocient.

___Again3_iDiv64:                      @


@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@ Executem la funci subc(num1,num2).
@
@

    CMPS    r0,r2
    BCS     ___Numerador_mes_gran_igual_iDiv64     @  si r0 >= r2 llavors...

@ r0 < r2
@ Desplacem r0:r1 una vegada cap a l' esquerra.

___Numerador_es_mes_petit_iDiv64:

    MOVS    r1,r1,LSL #1
    MOV     r0,r0,LSL #1
    ORRCS   r0,r0,#1

@ I ja hem acabat :)

    B       ___fsubc_iDiv64
    
___Numerador_mes_gran_igual_iDiv64:

@ r0 >= r2

    BNE     ___Numerador_es_mes_gran_iDiv64

@ Registres r0 i r2 sn iguals, hem de comprobar els registres de menys pes (r1,r3)...

    CMPS    r3,r1
    BHI     ___Numerador_es_mes_petit_iDiv64           @ si r1 < r3 llavors...

___Numerador_es_mes_gran_iDiv64:

    SUBS    r1,r1,r3        @ r1 <- r1 - r3
    SBC     r0,r0,r2        @ r0 <- r0 - r2 Amb Carry

@ Desplacem r0:r1 en una unitat a l' esquerra.
    
    MOVS    r1,r1,LSL #1
    MOV     r0,r0,LSL #1
    ORRCS   r0,r0,#1
    
    ADDS    r1,r1,#1
    ADC     r0,r0,#0
    
___fsubc_iDiv64:
    

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

    SUB     r4,r4,#1            @ r4 <- r4 -1
    CMPS    r4,#0
    BPL     ___Again3_iDiv64           @ Mentre r6 >= 0 anar a ___Again3

@ Ens carreguem la porqueria. El resultat ens ha quedat a r1! ^_^ XD

    MOV     r0,r1, LSL r5
    MOV     r0,r0, LSR r5

@ Restaurem signe si cal...

___RestaurarSigne_iDiv64:

    CMPS    r7,#0

    MOVNE   r6,#0xFFFFFFFF

    EORNE   r0,r0,r6
    ADDNE   r0,r0,#1            @ r0 = Quocient.

___Acaba_iDiv64:


___Error_iDiv64:

    LDMFD   sp!, {lr}

    MOV     PC,lr


@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@ UNSIGNED 32 bit DIVISION  (r0 <- r0 div r1)
@
@ Numerador i denominador sn de longitud 31 bits + bit 32 = 0
@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@


ARM_uDiv32:
@
@ Aquesta rutina suposa que els operants d' entrada no tenen signe...
@
@

    MOV     r6,#0xFFFFFFFF

    TSTS    r1,r6       @ Si Denominador = 0 llavors
    BEQ     ___Error_uDiv32      @ Error!, divisio per zero.


    TSTS     r0,r6       @ r0 & 0xFFFFFFFF
    
@ Si el numerador s 0 acabem amb resultat 0 .
 
    BEQ      ___Acaba_uDiv32

    CMP      r0,r1                  @
    MOVCC   r0,#0

@ Si el numerador s ms petit que el denominador llavors acabem amb resultat 0 .

    BCC     ___Acaba_uDiv32

@ Si el numerador s igual que el denominador llavors acabem amb resultat 1 .

    MOVEQ   r0,#1
    BEQ     ___Acaba_uDiv32

@ Altrament, executem la operaci divisi 32 bits...


@ r6 <- lmbd(r1) - lmb(r0)

    EOR     r2,r2,r2            @ r2 <- 0
    MOV     r4,#0x80000000
    EOR     r5,r5,r5            @ r5 <- 0
    EOR     r6,r6,r6            @ r6 <- 0

@ Comptem el numero de desplaaments fins a trobar el primer 1 en el r0.

    TSTS    r0,r4
    BNE     ___Ok1_uDiv32

___Again1_uDiv32:

    MOV     r4,r4,LSR #1
    ADD     r5,r5,#1
    TSTS    r0,r4
    BEQ     ___Again1_uDiv32

___Ok1_uDiv32:

@ Comptem el numero de desplaaments fins a trobar el primer 1 en el r1.

    MOV     r4,#0x80000000
    TSTS    r1,r4
    BNE     ___Ok2_uDiv32

___Again2_uDiv32:

    MOV     r4,r4,LSR #1
    ADD     r6,r6,#1
    TSTS    r1,r4
    BEQ     ___Again2_uDiv32

@    ADD     r6,r6,#32

___Ok2_uDiv32:

@ Efectuem la diferencia de ambdos resultats.

    SUB     r4,r6,r5            @  r4 <- r6 - r5

@ Desplacem r1, r4 vegades a l' esquerra per amortitzar r1(denominador, que es ms petit) amb r0 (ms gran).

    MOV     r6,#32
    SUB     r5,r6,r4            @ r5 <- r6 - r4
    SUB     r5,r5,#1

    MOV     r1,r1, LSL r4       @ r1 <- r1 << r4


@ Bucle que s' anira calculant el quocient.

___Again3_uDiv32:                      @


@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@ Executem la funci subc(num1,num2).
@
@

    CMPS    r0,r1
    BCS     ___Numerador_es_mes_gran_igual_uDiv32     @  si r0 >= r1 llavors...



___Numerador_es_mes_petit_uDiv32:

@ Tenim que r0 < r1
@ Desplacem r0 una vegada cap a l' esquerra.

    MOV r0,r0,LSL #1

@ I ja hem acabat :)

    B       ___fsubc_uDiv32


___Numerador_es_mes_gran_igual_uDiv32:

    SUB    r0,r0,r1        @ r0 <- r0 - r1

@ Desplacem r0 en una unitat a l' esquerra.

    MOV     r0,r0,LSL #1

    ADD     r0,r0,#1

___fsubc_uDiv32:


@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

    SUB     r4,r4,#1            @ r4 <- r4 -1
    CMP     r4,#0
    BPL     ___Again3_uDiv32    @ Mentre r6 >= 0 anar a ___Again3

@ Ens carreguem la porqueria. El resultat ens ha quedat a r0! ^_^ XD

    MOV     r0,r0, LSL r5
    MOV     r0,r0, LSR r5

___Acaba_uDiv32:




___Error_uDiv32:

    MOV     PC,lr














