@   Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
@   Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
@
@   This file is part of Jespa3D Engine.
@
@   Jespa3D Engine is free software; you can redistribute it and/or modify
@   it under the terms of the GNU General Public License as published by
@   the Free Software Foundation; either version 2 of the License, or
@   (at your option) any later version.
@
@   Jespa3D Engine is distributed in the hope that it will be useful,
@   but WITHOUT ANY WARRANTY; without even the implied warranty of
@   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
@   GNU General Public License for more details.
@
@   You should have received a copy of the GNU General Public License
@   along with Jespa3D Engine; ; see the file COPYING. if not, write to 
@   the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
@   Boston, MA  02111-1307  USA


@ /***********************\
@ | ZONA MEMORIA i TAMANY  |
@ \***********************/

.SECTION .iwram @,"ax",%progbits
.ARM
.ALIGN



@ /***********************\
@ | PROTOTIPUS DE FUNCIONS |
@ \***********************/


.GLOBL   ARM_MemSet
.GLOBL   ARM_MemSet16

.TYPE    ARM_MemSet, function
.TYPE    ARM_MemSet16, function



@ /**************************\
@ | IMPLEMENTACIO DEFUNCIONS |
@ \**************************/



ARM_MemSet:
@
@ r0: dest
@ r1: valor (ha de ser un byte)
@ r2: tamany en bytes
@

	
SET_BYTE:

	STRB	r1,[r0],#1
	SUBS	r2,r2,#1
	BNE		SET_BYTE

ACABA_SET:

	BX		lr



ARM_MemSet16:
@
@ param1 (r0): dest (memoria alineat a multiple de 2)...
@ param2 (r1): valor (16 bits)
@ param3 (r2): numero de words
@

	STMFD	sp!,{r0-r4}

	CMP		r2,#1
	BLT		ACABA_SET16
	

	MOV		r3,r1
	ORR		r1,r3,r1,lsl #16
	

	TSTS	r0,#0x2             @ Si zero vol dir que es multiple de quatre...
	BEQ		CONFIGURA_BUCLE

@ merda!, cal guardar un half word...

@CONTINUA:
	STRH	r1,[r0],#2
	SUBS	r2,r2,#1		@ -1 hwords

CONFIGURA_BUCLE:
    
	@ Configurem mapeig rapid...
	AND         r4, r2, #0x1
    MOV         r2,r2, lsr #1   @ Ara r2 sn words...
    CMP         r2, #0
    BEQ         Acaba_Mapejar_Ultim_Valor

SET16_MEGA_RAPID:

	STR		r1,[r0],#4	
	SUBS	r2,r2,#1		@ -1 words
	BNE		SET16_MEGA_RAPID

	

Acaba_Mapejar_Ultim_Valor:

	CMP		r4,#0
	STRNEH	r1,[r0]


ACABA_SET16:


	LDMFD	sp!,{r0-r4}
	BX		lr


