@   Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
@   Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
@
@   This file is part of Jespa3D Engine.
@
@   Jespa3D Engine is free software; you can redistribute it and/or modify
@   it under the terms of the GNU General Public License as published by
@   the Free Software Foundation; either version 2 of the License, or
@   (at your option) any later version.
@
@   Jespa3D Engine is distributed in the hope that it will be useful,
@   but WITHOUT ANY WARRANTY; without even the implied warranty of
@   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
@   GNU General Public License for more details.
@
@   You should have received a copy of the GNU General Public License
@   along with Jespa3D Engine; ; see the file COPYING. if not, write to 
@   the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
@   Boston, MA  02111-1307  USA


@ /***********************\
@ | ZONA MEMORIA i TAMANY  |
@ \***********************/

.SECTION .iwram  @,"ax",%progbits
.ARM
.ALIGN


.include "ARM_FUNCTIONS/ARM_Defines.s"


@ /********\
@ | MACROS |
@ \********/

@ a <- min (b,c)

.macro MIN a, b, c

    CMP     \b, \c
    MOVLT   \a, \b
    MOVGE   \a, \c
    
.endm

@ a <- max (b,c)
.macro MAX  a, b, c

    CMP     \b, \c
    MOVGT   \a, \b
    MOVLE   \a, \c

.endm

@ a <- FIXED_MUL_256(b)
.macro  FIXED_MUL_256 a,b
		MOV	\a,\b,asl #8
.endm

@ n <- FastDiv5Fx(n)
.macro FastDiv5Fx n
		ADD	\n,\n,\n, asr #1
		MOV	\n,\n, asr #1
		ADD	\n,\n, \n, asr #4
		ADD	\n,\n, \n, asr #8
		MOV	\n,\n, asr #2
.endm

@ n <- FastDiv3Fx(n)
.macro FastDiv3Fx n
		ADD	\n,\n,\n, asr #2
		MOV	\n,\n, asr #1
		ADD	\n,\n, \n, asr #4
		ADD	\n,\n, \n, asr #8
		MOV	\n,\n, asr #1
.endm

@ n <- FIXED_DIV_120(n)
.macro FIXED_DIV_120 n
		FastDiv5Fx \n
		FastDiv3Fx \n
		MOV		   \n,\n, asr #3;
.endm





@ a <- INT_TO_FIXED(b)
.macro  INT_TO_FIXED a,b
		MOV	\a,\b
		MOV	\a,\a,asl #PART_FRACCIONAL
.endm

@ a <- FIXED_TO_INT(b)
.macro  FIXED_TO_INT  a, b
		MOV			  \a,\b
		MOV	          \a,\a,asr #PART_FRACCIONAL
.endm

@ a <- CEIL_FX(b) { RETORNA_PART_FRACCIONAL_FX(x) == 0 ? FIXED_TO_INT(x) : (((x) >= 0) ? FIXED_TO_INT(((x) + (ONE_FX))) : -FIXED_TO_INT(-(x)))}
.macro  CEIL_FX a,b
		MOV           \a,\b,asr #8
		TSTS          \b,#0xFF
		ADDNE         \a,\a,#1
		CMPNE         \b,#0
		SUBLT         \a, \a, #1
.endm			

		
.macro SET_MARK
								STMFD	    sp!,{r0,r1}
								ldr			r0,.ptr_video
								ldr			r0, [r0]
								MOV			r1,#0x10000
								SUB			r1,r1,#1
								STRH		r1,[r0]
								LDMFD	    sp!,{r0,r1}
.endm


#define CEIL_FX(x)			(((x) >= 0) ? FIXED_TO_INT(((x) + (ONE_FX-1))) : -FIXED_TO_INT(-(x)))

@ /*******************\
@ | VARIABLES GLOBALS |
@ \*******************/






@typedef struct _tParametresPintarParet{  // Cal canviar el nom per un de ms generic, pintar_tira, per exemple, ja que la funci pinta paisatges, sprites i blocks...
@
@	int				x,y1,y2,u1;
@	long			v1, Escale_v;
@	tImatge			*MipMap;
@	unsigned int	Intensitat;
@//	unsigned int    Color_Mascara;
@
@}tParametresPintarParet;




@.ParametresPintarParet:
@.word	x,0
@.word	h,0
@.word	n,0
@.word	o,0
@.word	p,0
@.word	k,0
@.word	l,0
@.word	m,0
@.word	n,0



@ /***********************\
@ | PROTOTIPUS DE FUNCIONS |
@ \***********************/

.GLOBL      ARM_RenderAffineWall
.TYPE       ARM_RenderAffineWall, function
.GLOBL   	caca



.caca_ptr:
.word caca




@
@
@
@
@

.equ	OFFSET_PRAW_YMIN				,			0	
.equ	OFFSET_PRAW_YMAX				,			4	
.equ	OFFSET_PRAW_YMIN_PORTAL_PTR		,			8			
.equ	OFFSET_PRAW_YMAX_PORTAL_PTR		,			12			
.equ	OFFSET_PRAW_YMIN_SOSTRE_PTR		,			16			
.equ	OFFSET_PRAW_YMAX_SOSTRE_PTR		,			20			
.equ	OFFSET_PRAW_YMIN_TERRA_PTR		,			24			
.equ	OFFSET_PRAW_YMAX_TERRA_PTR		,			28			
.equ	OFFSET_PRAW_X					,			32
.equ	OFFSET_PRAW_ITERACIONS			,			36		
.equ	OFFSET_PRAW_XMIN_PORTAL			,			40		
.equ	OFFSET_PRAW_XMAX_PORTAL			,			44		
.equ	OFFSET_PRAW_XMIN_SOSTRE			,			48		
.equ	OFFSET_PRAW_YMIN_SOSTRE			,			52		
.equ	OFFSET_PRAW_XMAX_SOSTRE			,			56		
.equ	OFFSET_PRAW_YMAX_SOSTRE			,			60		
.equ	OFFSET_PRAW_XMIN_TERRA			,			64		
.equ	OFFSET_PRAW_YMIN_TERRA			,			68		
.equ	OFFSET_PRAW_XMAX_TERRA			,			72		
.equ	OFFSET_PRAW_YMAX_TERRA			,			76		
.equ	OFFSET_PRAW_INTENSITAT_SECTOR	,			80				
.equ	OFFSET_PRAW_ID_TEXTURA_SUPERIOR	,			84				
.equ	OFFSET_PRAW_ID_TEXTURA_INFERIOR	,			88				
.equ	OFFSET_PRAW_ID_TEXTURA_PARET	,			92			
.equ	OFFSET_PRAW_TRACTAR_TERRA		,			96			
.equ	OFFSET_PRAW_TRACTAR_SOSTRE		,			100			
.equ	OFFSET_PRAW_VMED				,			104	
.equ	OFFSET_PRAW_CENTRE_PROJECCIO_Y	,			108				
.equ	OFFSET_PRAW_SECTOR_ADJACENT		,			112			
.equ	OFFSET_PRAW_Z					,			116
.equ	OFFSET_PRAW_U					,			120
.equ	OFFSET_PRAW_YSOSTRE_ACTUAL_FX	,			124				
.equ	OFFSET_PRAW_YSOSTRE_CONNECTANT_FX,			128					
.equ	OFFSET_PRAW_YTERRA_ACTUAL_FX	,			132				
.equ	OFFSET_PRAW_YTERRA_CONNECTANT_FX,			136					
.equ	OFFSET_PRAW_DELTA_Z				,			140	
.equ	OFFSET_PRAW_DELTA_U				,			144	
.equ	OFFSET_PRAW_INC_DYDX_SOSTRE_FX	,			148				
.equ	OFFSET_PRAW_INC_DYDX_SOSTRE_CONNECTANT_FX,	152							
.equ	OFFSET_PRAW_INC_DYDX_TERRA_FX			 ,	156			
.equ	OFFSET_PRAW_INC_DYDX_TERRA_CONNECTANT_FX ,	160							
.equ	OFFSET_PRAW_PROPIETATS_MAPEIG_LINIA      ,	164	


@
@
@//(...)
@
@typedef struct{
@
@	short  *ymin,							// offset 0
@		   *ymax,							// offset 4
@		   *ymin_portal_ptr,				// offset 8
@		   *ymax_portal_ptr,				// offset 12
@		   *ymin_sostre_ptr,				// offset 16
@		   *ymax_sostre_ptr,				// offset 20
@	       *ymin_terra_ptr,					// offset 24
@		   *ymax_terra_ptr;					// offset 28
@	int		x,								// offset 32
@			interacions;					// offset 36
@	int		xmin_portal,					// offset 40
@			xmax_portal,					// offset 44
@			xmin_sostre,					// offset 48
@			xmax_sostre,					// offset 52
@			xmin_terra,						// offset 56
@			xmax_terra;						// offset 60
@	int     intensitat_sector;				// offset 64
@	tTextura *Textura_Superior,				// offset 68
@			 *Textura_Inferior,				// offset 72
@			 *Textura_Paret;				// offset 76
@	int		 TractarTerra,					// offset 80
@			 TractarSostre;					// offset 84
@	FIXED32  vmed,							// offset 88
@			 centre_projeccio_y;			// offset 92
@	tSector *SectorAdjacent;				// offset 96
@	FIXED32  Z,								// offset 100
@		     U,								// offset 104
@		     DeltaZ,						// offset 108
@			 DeltaU;						// offset 112
@	FIXED32	 Ysostre_actual_FX,				// offset 116
@		     Ysostre_connectant_FX,			// offset 120
@		     Yterra_actual_FX,				// offset 124
@		     Yterra_connectant_FX,			// offset 128
@		     inc_dYdX_Sostre_FX,			// offset 132
@		     inc_dYdX_Sostre_Connectant_FX,	// offset 136
@		     inc_dYdX_Terra_FX,				// offset 140
@		     inc_dYdX_Terra_Connectant_FX;	// offset 144
@
@
@	
@	
@}tParametresRenderAffineWall;
@
@
@
@
@
@#define PTR_PRAW(x)		ptr_PRAW[(x) >> 2]		
@



ARM_RenderAffineWall:@(tParametresRenderAffineWall: *PRAW)
@{
@	// Parametres
@	// ----------
@	//
@	// r0 : Punter a l'estructura PRAW (ParametresRenderAffineWall)
@	//
	PTR_PRAW					.req	r0
@

@	int		y_retallat_sostre_actual,							// r1

	y_retallat_sostre_actual	.req	r1

@			y_retallat_terra_actual,							// r2

	y_retallat_terra_actual		.req	r2

@			intensitat_llinterna,intensitat_total,				// r3

	intensitat_llinterna		.req	r11
	intensitat_total			.req	r11

@			y1,Ysostre_actual,Yterra_connectant,ymin_portal,	// r4 (Ysostre_actual o Yterra_connectant)

	y1							.req	r4
	Ysostre_actual				.req	r4
	Yterra_connectant			.req	r4
	ymin_portal					.req	r4

@			y2,Ysostre_connectant,Yterra_actual,ymax_portal;	// r5 (Ysostre_connectant o Yterra_actual)

	y2							.req	r5
	Ysostre_connectant			.req	r5
	Yterra_actual				.req	r5
	ymax_portal					.req	r5

@
@	FIXED32	Z,Escale_v_FX;										// r6

	Z							.req	r9
	Escale_v_FX					.req	r9

@
@	int		x,MIPmap_Adequat,									// r7

	x							.req	r3
	MIPmap_Adequat				.req	r3

@			Propietats;											// r8

	Propietats					.req	r8

@
@	int		u1,xmin_portal,xmin_sostre,xmax_sostre,				// r9

	u_ini						.req	r6
	xmin_portal					.req	r6
	xmin_sostre					.req	r6
	xmax_sostre					.req	r6
	ymin_sostre					.req	r6
	ymax_sostre					.req	r6

@			v1,xmax_portal,xmin_terra,xmax_terra;				// r10

	v_ini						.req	r7
	xmax_portal					.req	r7
	xmin_terra					.req	r7
	xmax_terra					.req	r7
	ymin_terra					.req	r7
	ymax_terra					.req	r7

@
@	void	*void_ptr;											 // r11

	void_ptr					.req	r10
	ID_Textura					.req    r10

@	int		 aux1,												 // r12 

	aux1						.req	r12
@			 aux2;												 // r14 

	aux2						.req	r14
@
@	tParametresPintarParet  PPP;
@	int						*ptr_PRAW	= PRAW; // Es tractar PRAW com un vector lineal.
@
@	
@	
@	
@
@	// preservaci del registre r0 durant tot el tractament!!!
@	// r0 : ED punter de parametres affine.
@
@	   
		STMFD	sp!,{r0-r12,r14} 



@			
@			do
@			{
Continua_Render_Affine_Wall:

@				
@				void_ptr					= PTR_PRAW(OFFSET_PRAW_YMIN);// >> 2];
				LDR							void_ptr,[PTR_PRAW,#OFFSET_PRAW_YMIN]
@				y_retallat_sostre_actual	=*((short *)void_ptr);
				LDRSH						y_retallat_sostre_actual, [void_ptr]				
@				
@				void_ptr					= PTR_PRAW(OFFSET_PRAW_YMAX);// >> 2];//->ymax;
				LDR							void_ptr,[PTR_PRAW,#OFFSET_PRAW_YMAX]

@				y_retallat_terra_actual		=*((short *)void_ptr);
				LDRSH						y_retallat_terra_actual, [void_ptr]			


@				
@				if(y_retallat_sostre_actual <= y_retallat_terra_actual) // ok! Es pot pintar alguna cosa :)
				CMP		y_retallat_sostre_actual, y_retallat_terra_actual
				BGT		Proxima_Iteracio_1
@				{
@										
@					Z = PTR_PRAW(OFFSET_PRAW_Z);//->Z;
					LDR		Z,[PTR_PRAW, #OFFSET_PRAW_Z]



@					
@					intensitat_llinterna = INT_TO_FIXED(MAXIMA_ILUMINACIO_LLINTERNA);
					INT_TO_FIXED	intensitat_llinterna,#MAXIMA_ILUMINACIO_LLINTERNA

@					intensitat_llinterna = intensitat_llinterna - FIXED_DIV_16(Z);
					SUB				intensitat_llinterna,intensitat_llinterna, Z, asr #4

@					intensitat_llinterna = FIXED_TO_INT(intensitat_llinterna);
					FIXED_TO_INT	intensitat_llinterna,intensitat_llinterna

@					 
@					if(intensitat_llinterna < 0) intensitat_llinterna = 0;
					CMP		intensitat_llinterna,#0
					MOVLT	intensitat_llinterna,#0	

@					if(intensitat_llinterna > MINIMA_DISTANCIA_LLINTERNA) intensitat_llinterna = MAXIMA_ILUMINACIO_LLINTERNA;
					CMP		intensitat_llinterna,#MAXIMA_DISTANCIA_LLINTERNA
					MOVGT	intensitat_llinterna,#MAXIMA_DISTANCIA_LLINTERNA
@
@
@					aux1 = PTR_PRAW(OFFSET_PRAW_INTENSITAT_SECTOR);//->intensitat_sector;
					LDR	   aux1,[PTR_PRAW,#OFFSET_PRAW_INTENSITAT_SECTOR]

@					intensitat_total = intensitat_llinterna + aux1;
					ADD		intensitat_total, intensitat_llinterna, aux1

@					
@					if(intensitat_total >  MAXIMA_INTENSITAT) intensitat_total = MAXIMA_INTENSITAT;
					CMP		intensitat_total,#MAXIMA_INTENSITAT
					MOVGT	intensitat_total,#MAXIMA_INTENSITAT
@					
@					// Carregar dels quatre tipus de cotes Y + actualitzaci + guardat i sector adjacent (+1 registres)!!!!
@					void_ptr			= PTR_PRAW(OFFSET_PRAW_SECTOR_ADJACENT);//->SectorAdjacent;
					LDR					void_ptr,[PTR_PRAW,#OFFSET_PRAW_SECTOR_ADJACENT]



@
@			
@					if(void_ptr != NULL)	// s portal --> renderitzem tires de paret inferior/superior
					CMP					void_ptr, #0
					BEQ					PintarParet
@					{
@						Ysostre_actual		    = PTR_PRAW(OFFSET_PRAW_YSOSTRE_ACTUAL_FX);//->Ysostre_actual_FX);					
						LDR						  aux1,[PTR_PRAW, #OFFSET_PRAW_YSOSTRE_ACTUAL_FX]
						CEIL_FX					  Ysostre_actual,aux1
						
@						Ysostre_connectant		= PTR_PRAW(OFFSET_PRAW_YSOSTRE_CONNECTANT_FX);//->Ysostre_connectant_FX);
						LDR						  aux1,[PTR_PRAW, #OFFSET_PRAW_YSOSTRE_CONNECTANT_FX]
						CEIL_FX					  Ysostre_connectant,aux1

@						Ysostre_actual			= CEIL_FX(Ysostre_actual);
@						Ysostre_connectant		= CEIL_FX(Ysostre_connectant);						// Total registres utilitzats: 7!
@
@
@						if(Ysostre_actual < Ysostre_connectant)//((Ysostre_connectant >= y_retallat_sostre_actual) && (Ysostre_connectant > Ysostre_actual))) // { Renderitzem tira superior }
						CMP	Ysostre_actual,Ysostre_connectant
						BGE	Guardar_Retallat_Sostre_Minim

@						{
@							y1 = max(Ysostre_actual,y_retallat_sostre_actual);
							MAX		y1,Ysostre_actual,y_retallat_sostre_actual

@							y2 = min(Ysostre_connectant-1,y_retallat_terra_actual);

							SUB	aux1,Ysostre_connectant,#1
							MIN	y2,aux1,y_retallat_terra_actual

@
@							
@							if(y1 <= y2)
							CMP	y1,y2
							BGT	Guardar_Retallat_Sostre_Connectant
							

@
@                               void_ptr = (char *)Textura;
							    LDR			void_ptr, .ptr_textura
								LDR			void_ptr,[void_ptr]

@                               aux1 = PTR_PRAW(OFFSET_PRAW_TEXTURA_PARET);
								LDR			aux1, [PTR_PRAW, #OFFSET_PRAW_ID_TEXTURA_SUPERIOR]
				
								CMP			aux1, #0   @ Si = 0, no pintem...
								BEQ			Guardar_Retallat_Sostre_Connectant  
								BLT			DescartarObtencioUV_Superior


@                               aux2 = Sizeof_tTextura;
								LDR			aux2,.SIZEOF_TEXTURA
								LDR			aux2,[aux2]

@                               aux1 = aux1*aux2;
								MUL			aux1, aux2, aux1

@                               void_ptr = ((char *)void_ptr + aux1);
								ADD			void_ptr, void_ptr, aux1
	
@                               Propietats =  (int)((char *)void_ptr)[0x4*2]; // Lectura de les propietats d'imatge;
								
								LDR			Propietats,[void_ptr, #0x8];



@								
@										
@										// Necessito 1 registre (+1 reg auxiliar) !!!
@										Z = PTR_PRAW(OFFSET_PRAW_Z);//PRAW->Z;
										LDR		Z,[PTR_PRAW, #OFFSET_PRAW_Z]

@
@										Escale_v_FX = FIXED_MUL_256(Z);
										FIXED_MUL_256	Escale_v_FX,Z

@										FIXED_DIV_120(Escale_v_FX);
										FIXED_DIV_120	Escale_v_FX
										MOV				Escale_v_FX,Escale_v_FX,lsl #DETALL_GRAFIC_Y

@										
@
@										aux1 = Escale_v_FX >> 16;
										MOV		aux1, Escale_v_FX, asr #16
										


@
@										{
@										
@
@										aux1  = PTR_PRAW(OFFSET_PRAW_CENTRE_PROJECCIO_Y);//PRAW->centre_projeccio_y;
										LDR		aux1,[PTR_PRAW,#OFFSET_PRAW_CENTRE_PROJECCIO_Y]
@								

@
@										aux1		= (y1 - aux1); 
										SUB			aux1, y1, aux1

@										v1		    = aux1*Escale_v_FX; // ok --> no necessito centre_y (-1 reg), per aix v1 utilitzar el mateix registre que centre_y !!!
										MUL 		v_ini,aux1,Escale_v_FX

@										
@																													
@										// Total registres utilitzats: 11! --> (recorda que no pots utilitzar r15, r13, r14)
@
@										if(V_POWER_OF_2(Propietats))  
										IS_VPOW2		Propietats
@										{
@											// carrega de vmed ! (+1 reg: op. load + add)
@											aux1       = PTR_PRAW(OFFSET_PRAW_VMED);//PRAW->vmed;
											LDRNE		aux1,[PTR_PRAW,#OFFSET_PRAW_VMED]
@											v1         = v1 + aux1;
											ADDNE		v_ini,v_ini,aux1
@											
@										}
@//
@										
@										
@										u1	= PTR_PRAW(OFFSET_PRAW_U);//PRAW->U;
										LDR		u_ini,[PTR_PRAW,#OFFSET_PRAW_U]

DescartarObtencioUV_Superior:
@										
@
@										// Ja no necessito masc_u, ni propietats (-2 regs.)
@
@										// Total registres utilitzats: 11!
@
@										// +1 reg per obtenir escalat!!!
@										//
@										// Ja no necessito MIPmap_Adequat!!!
@										// Carrega de x!!!
@										// Total registres utilitzats: 12!
@										// x = PRAW->x;
@
@typedef struct{  // Cal canviar el nom per un de ms generic, pintar_tira, per exemple, ja que la funci pinta paisatges, sprites i blocks...
@
@	int          x,                      // Columna a on es pinta la tira.
@                y1,                     // Inici y pintat de tira. 
@                y2;                     // Fi    y pintat de tira
@    int         u1,                     // u1 en format APF 16.16 a l'espai 3D d'ull.
@                v1,                     // v1 en format APF 16.16 a l'espai 3D d'ull.
@                Escale_v;               // Escala en format 16.16.
@    int         ID_Textura;             // < 0 --> Pintat amb color [0,..256). == 0 no pinta. > 0 representa l'ID de textura a pintar.
@	int          Intensitat;             // Es pinta amb efecte de illuminaci. Si no hi consta a les propietats no es pintar.
@    int         Transparencia;          // Es pinta amb efecte de transparencia. Si no hi consta a les propietats no es pintar.
@    int         Propietats_Objecte;     // 16 bits de ms pes s'hi guarden les propietats de objecte. 16 bits de menys pes les de textura. (veure textura.h i objecte.h)
@//    int        Transparencia;
@//	unsigned int    Color_Mascara;  // Ja no cal desde que l'eina JespaGFX inserta el index paleta de mascara en ensamblador ARM
@
@}tParametresPintarParet2;			
@										x		    = PTR_PRAW(OFFSET_PRAW_X);//PRAW->x;
										LDR			x,[PTR_PRAW, #OFFSET_PRAW_X]

										LDR			ID_Textura, [PTR_PRAW, #OFFSET_PRAW_ID_TEXTURA_SUPERIOR]
										LDR			aux1, [PTR_PRAW, #OFFSET_PRAW_PROPIETATS_MAPEIG_LINIA]


@		MOV		aux1,#0x06000000
@		MOV		aux2,#0x0
@		STRH	aux2,[aux1]

@										
@										// Preguardar registres r0-r12,r14 !!!!!
										STMFD		sp!,{r0-r10}@-r3}

										
										@x,y1,y2,u_ini,v_ini,Escale_v_FX,void_ptr,intensitat_total}

										MOV			r1,x
										MOV			r2,y1
										MOV			r3,y2
										MOV			r4,u_ini
										MOV			r5,v_ini
										MOV			r6,Escale_v_FX
										MOV			r7,ID_Textura
										MOV			r8,intensitat_total
										MOV			r9,#0
										MOV			r10,aux1

										LDR			r0,.caca_ptr
										STMIA		r0,{r1-r10} 

								@		BL			ARM_PutBlockSlice_Fast



										BL			ARM_PutVerticalSlice

										LDMFD		sp!,{r0-r10} @-r7}@-r3}
@									}
@									
@								}

Guardar_Retallat_Sostre_Connectant:
						
@								Ysostre_connectant		= PTR_PRAW(OFFSET_PRAW_YSOSTRE_CONNECTANT_FX);//->Ysostre_connectant_FX);
								LDR						  aux1,[PTR_PRAW, #OFFSET_PRAW_YSOSTRE_CONNECTANT_FX]
								CEIL_FX					  Ysostre_connectant,aux1

@
@								void_ptr = PTR_PRAW(OFFSET_PRAW_YMIN_PORTAL_PTR);//PRAW->ymin_portal_ptr;
								LDR			void_ptr,[PTR_PRAW,#OFFSET_PRAW_YMIN_PORTAL_PTR]

@								//aux2 = (Ysostre_connectant+1);
@								aux1 = max(Ysostre_connectant,y_retallat_sostre_actual);
								MAX		aux1, Ysostre_connectant,y_retallat_sostre_actual

@								*((short *)void_ptr) = aux1;
								STRH		aux1,[void_ptr]
								B		Evaluar_Terra_Connnectant

@								// Actualitzem retallats!!!!
@
@							//}
@						}
@						else // No renderitza tira superior --> noms actualitzem retallats!!!
Guardar_Retallat_Sostre_Minim:
@						{

@							Ysostre_actual		    = PTR_PRAW(OFFSET_PRAW_YSOSTRE_ACTUAL_FX);//->Ysostre_actual_FX);					
							LDR						  aux1,[PTR_PRAW, #OFFSET_PRAW_YSOSTRE_ACTUAL_FX]
							CEIL_FX					  Ysostre_actual,aux1


@
@							void_ptr = PTR_PRAW(OFFSET_PRAW_YMIN_PORTAL_PTR);//PRAW->ymin_portal_ptr;
							LDR			void_ptr,[PTR_PRAW,#OFFSET_PRAW_YMIN_PORTAL_PTR]

@							aux1 = max(Ysostre_actual,y_retallat_sostre_actual);
							MAX		aux1,Ysostre_actual,y_retallat_sostre_actual

@							*((short *)void_ptr) = aux1;
							STRH		aux1,[void_ptr]

@						}
@
@						
Evaluar_Terra_Connnectant:
@
@						//Yterra_actual			= CEIL_FX(PRAW->Yterra_actual_FX);	
@						//Yterra_connectant		= CEIL_FX(PRAW->Yterra_connectant_FX);
@
						

@					
@						Yterra_connectant	= PTR_PRAW(OFFSET_PRAW_YTERRA_CONNECTANT_FX);//PRAW->Yterra_connectant_FX);		
						
						LDR					  aux1,[PTR_PRAW,#OFFSET_PRAW_YTERRA_CONNECTANT_FX]

						CEIL_FX				  Yterra_connectant,aux1

@						Yterra_actual		= PTR_PRAW(OFFSET_PRAW_YTERRA_ACTUAL_FX);//PRAW->Yterra_actual_FX);	
						LDR					  aux1,[PTR_PRAW,#OFFSET_PRAW_YTERRA_ACTUAL_FX]

						CEIL_FX				  Yterra_actual,aux1
@
@						Yterra_connectant	= CEIL_FX(Yterra_connectant);//PRAW->Yterra_connectant_FX);		
@						Yterra_actual		= CEIL_FX(Yterra_actual);//PRAW->Yterra_actual_FX);	
@

@

@						
@
@						if(Yterra_connectant < Yterra_actual) // { Renderitzem tira inferior }
						CMP	Yterra_connectant, Yterra_actual
						BGE	Guardar_Retallat_Terra_Maxim
@						{
@							
@							y1 = max((Yterra_connectant+1),y_retallat_sostre_actual);

							ADD		aux1,Yterra_connectant,#1
							MAX		y1,aux1,y_retallat_sostre_actual

@							STR		y1,[PTR_PRAW,#OFFSET_PRAW_YMIN_PROBA]

@							y2 = min(Yterra_actual,y_retallat_terra_actual);
							MIN		y2,Yterra_actual,y_retallat_terra_actual

@							STR					 y2,[PTR_PRAW,#OFFSET_PRAW_YMAX_PROBA]




@
@				
@							if(y1 <= y2)
							CMP	y1,y2
							BGT	Guardar_Retallat_Terra_Connectant


@
@                               void_ptr = (char *)Textura;
							    LDR			void_ptr, .ptr_textura
								LDR			void_ptr,[void_ptr]

@                               aux1 = PTR_PRAW(OFFSET_PRAW_TEXTURA_PARET);
								LDR			aux1, [PTR_PRAW, #OFFSET_PRAW_ID_TEXTURA_INFERIOR]
				
								CMP			aux1, #0   @ Si = 0, no pintem...
								BEQ			Guardar_Retallat_Terra_Connectant  



								BLT			DescartarObtencioUV_Inferior



@                               aux2 = Sizeof_tTextura;
								LDR			aux2,.SIZEOF_TEXTURA
								LDR			aux2,[aux2]

@                               aux1 = aux1*aux2;
								MUL			aux1, aux2, aux1

@                               void_ptr = ((char *)void_ptr + aux1);
								ADD			void_ptr, void_ptr, aux1
	
@                               Propietats =  (int)((char *)void_ptr)[0x4*2]; // Lectura de les propietats d'imatge;
								
								LDR			Propietats,[void_ptr, #0x8];



@								
@										
@										// Necessito 1 registre (+1 reg auxiliar) !!!
@										Z = PTR_PRAW(OFFSET_PRAW_Z);//PRAW->Z;
										LDR		Z,[PTR_PRAW, #OFFSET_PRAW_Z]

@
@										Escale_v_FX = FIXED_MUL_256(Z);
										FIXED_MUL_256	Escale_v_FX,Z

@										FIXED_DIV_120(Escale_v_FX);
										FIXED_DIV_120	Escale_v_FX
										MOV				Escale_v_FX,Escale_v_FX,lsl #DETALL_GRAFIC_Y

@										
@
@										aux1 = Escale_v_FX >> 16;
										MOV		aux1, Escale_v_FX, asr #16



@
@										{
@										
@
@										aux1  = PTR_PRAW(OFFSET_PRAW_CENTRE_PROJECCIO_Y);//PRAW->centre_projeccio_y;
										LDR		aux1,[PTR_PRAW,#OFFSET_PRAW_CENTRE_PROJECCIO_Y]
@								

@
@										aux1		= (y1 - aux1); 
										SUB			aux1, y1, aux1

@										v1		    = aux1*Escale_v_FX; // ok --> no necessito centre_y (-1 reg), per aix v1 utilitzar el mateix registre que centre_y !!!
										MUL 		v_ini,aux1,Escale_v_FX

@										
@																													
@										// Total registres utilitzats: 11! --> (recorda que no pots utilitzar r15, r13, r14)
@
@										if(V_POWER_OF_2(Propietats))  
										IS_VPOW2		Propietats
@										{
@											// carrega de vmed ! (+1 reg: op. load + add)
@											aux1       = PTR_PRAW(OFFSET_PRAW_VMED);//PRAW->vmed;
											LDRNE		aux1,[PTR_PRAW,#OFFSET_PRAW_VMED]
@											v1         = v1 + aux1;
											ADDNE		v_ini,v_ini,aux1
@											
@										}
@//
@										
@										
@										u1	= PTR_PRAW(OFFSET_PRAW_U);//PRAW->U;
										LDR		u_ini,[PTR_PRAW,#OFFSET_PRAW_U]

DescartarObtencioUV_Inferior:
@										
@
@										// Ja no necessito masc_u, ni propietats (-2 regs.)
@
@										// Total registres utilitzats: 11!
@
@										// +1 reg per obtenir escalat!!!
@										//
@										// Ja no necessito MIPmap_Adequat!!!
@										// Carrega de x!!!
@										// Total registres utilitzats: 12!
@										// x = PRAW->x;
@
@typedef struct{  // Cal canviar el nom per un de ms generic, pintar_tira, per exemple, ja que la funci pinta paisatges, sprites i blocks...
@
@	int          x,                      // Columna a on es pinta la tira.
@                y1,                     // Inici y pintat de tira. 
@                y2;                     // Fi    y pintat de tira
@    int         u1,                     // u1 en format APF 16.16 a l'espai 3D d'ull.
@                v1,                     // v1 en format APF 16.16 a l'espai 3D d'ull.
@                Escale_v;               // Escala en format 16.16.
@    int         ID_Textura;             // < 0 --> Pintat amb color [0,..256). == 0 no pinta. > 0 representa l'ID de textura a pintar.
@	int          Intensitat;             // Es pinta amb efecte de illuminaci. Si no hi consta a les propietats no es pintar.
@    int         Transparencia;          // Es pinta amb efecte de transparencia. Si no hi consta a les propietats no es pintar.
@    int         Propietats_Objecte;     // 16 bits de ms pes s'hi guarden les propietats de objecte. 16 bits de menys pes les de textura. (veure textura.h i objecte.h)
@//    int        Transparencia;
@//	unsigned int    Color_Mascara;  // Ja no cal desde que l'eina JespaGFX inserta el index paleta de mascara en ensamblador ARM
@
@}tParametresPintarParet2;			
@										x		    = PTR_PRAW(OFFSET_PRAW_X);//PRAW->x;
										LDR			x,[PTR_PRAW, #OFFSET_PRAW_X]

										LDR			ID_Textura, [PTR_PRAW, #OFFSET_PRAW_ID_TEXTURA_INFERIOR]
										LDR			aux1, [PTR_PRAW, #OFFSET_PRAW_PROPIETATS_MAPEIG_LINIA]


@		MOV		aux1,#0x06000000
@		MOV		aux2,#0x0
@		STRH	aux2,[aux1]

@										
@										// Preguardar registres r0-r12,r14 !!!!!
										STMFD		sp!,{r0-r10}@-r3}

										
										@x,y1,y2,u_ini,v_ini,Escale_v_FX,void_ptr,intensitat_total}

										MOV			r1,x
										MOV			r2,y1
										MOV			r3,y2
										MOV			r4,u_ini
										MOV			r5,v_ini
										MOV			r6,Escale_v_FX
										MOV			r7,ID_Textura
										MOV			r8,intensitat_total
										MOV			r9,#0
										MOV			r10,aux1

										LDR			r0,.caca_ptr
										STMIA		r0,{r1-r10} 

								@		BL			ARM_PutBlockSlice_Fast



										BL			ARM_PutVerticalSlice

										LDMFD		sp!,{r0-r10} @-r7}@-r3}
@									}
@							}

Guardar_Retallat_Terra_Connectant:
@					
@						   Yterra_connectant	= PTR_PRAW(OFFSET_PRAW_YTERRA_CONNECTANT_FX);//PRAW->Yterra_connectant_FX);		
							LDR					  aux1,[PTR_PRAW,#OFFSET_PRAW_YTERRA_CONNECTANT_FX]
							CEIL_FX				  Yterra_connectant,aux1

@							STR			aux1,[PTR_PRAW,#OFFSET_PRAW_YMIN_PROBA];
@							MOV			aux1, ymax_portal
@							STR			aux1,[PTR_PRAW,#OFFSET_PRAW_YMAX_PROBA];

@					
@							void_ptr = PTR_PRAW(OFFSET_PRAW_YMAX_PORTAL_PTR);//PRAW->ymax_portal_ptr;
							LDR			void_ptr,[PTR_PRAW,#OFFSET_PRAW_YMAX_PORTAL_PTR]


@							//aux2 = y1-1;
@							aux1 = min(Yterra_connectant,y_retallat_terra_actual);
							MIN		aux1, Yterra_connectant,y_retallat_terra_actual

							
@							*((short *)void_ptr) = aux1;
							STRH		 aux1, [void_ptr]
							B			 Continua_1

@						
@						}
@						else // Noms cal guardar retallat mxim...
Guardar_Retallat_Terra_Maxim:
@						{

@						Yterra_actual		= PTR_PRAW(OFFSET_PRAW_YTERRA_ACTUAL_FX);//PRAW->Yterra_actual_FX);	
						LDR					  aux1,[PTR_PRAW,#OFFSET_PRAW_YTERRA_ACTUAL_FX]
						CEIL_FX				  Yterra_actual,aux1	
@							
@						void_ptr = PTR_PRAW(OFFSET_PRAW_YMAX_PORTAL_PTR);//PRAW->ymax_portal_ptr;
						LDR		void_ptr,[PTR_PRAW,#OFFSET_PRAW_YMAX_PORTAL_PTR]

@						aux1 = min(Yterra_actual,y_retallat_terra_actual);
						MIN		aux1, Yterra_actual,y_retallat_terra_actual

@						*((short *)void_ptr) = aux1;
						STRH			aux1,[void_ptr]

@														
@						}
@		
				
Continua_1:
						
						
						@ Perr treure						
						
@						B		Evaluar_Sostre_Terra

@						// Info de portal retallat recursiu...
@						
@						void_ptr    = PTR_PRAW(OFFSET_PRAW_YMIN_PORTAL_PTR);//PRAW->ymin_portal_ptr;
						LDR				void_ptr,[PTR_PRAW,#OFFSET_PRAW_YMIN_PORTAL_PTR]

@						ymin_portal	= *((short *)void_ptr);
						LDRSH				ymin_portal,[void_ptr]

@
@						void_ptr    = PTR_PRAW(OFFSET_PRAW_YMAX_PORTAL_PTR);//PRAW->ymax_portal_ptr;
						LDR				void_ptr,[PTR_PRAW,#OFFSET_PRAW_YMAX_PORTAL_PTR]

@						ymax_portal	= *((short *)void_ptr);//*PRAW->ymax_portal_ptr;
						LDRSH				ymax_portal,[void_ptr]





@						
@						
@						if(ymin_portal <= ymax_portal) // Existeix portal...
						CMP		ymin_portal,ymax_portal
						BGT		Evaluar_Sostre_Terra
@						{

@							MOV			aux1, ymin_portal
@							STR			aux1,[PTR_PRAW,#OFFSET_PRAW_YMIN_PROBA];

@							MOV			aux1, ymax_portal
@							STR			aux1,[PTR_PRAW,#OFFSET_PRAW_YMAX_PROBA];

	
@							xmax_portal	= PTR_PRAW(OFFSET_PRAW_XMAX_PORTAL);//PRAW->xmax_portal;
							LDR				xmax_portal,[PTR_PRAW,#OFFSET_PRAW_XMAX_PORTAL]

@//							xmax_portal = 
@							x = PTR_PRAW(OFFSET_PRAW_X);//PRAW->x;
							LDR				x,[PTR_PRAW,#OFFSET_PRAW_X]

@							
@							if(xmax_portal == -1)
							CMP	xmax_portal,#-1

@							{// Cal inicialitzar cotes x ...
@								
@								//PRAW->xmin_portal = x;
@								//PRAW->xmax_portal = x;
@								PTR_PRAW(OFFSET_PRAW_XMIN_PORTAL) = x;
								STREQ	x,[PTR_PRAW,#OFFSET_PRAW_XMIN_PORTAL]

@
@							}
@							else
@							{// Actualitzem cota final
@								//PRAW->xmax_portal = x;
@								PTR_PRAW(OFFSET_PRAW_XMAX_PORTAL) = x;
								STR	x,[PTR_PRAW,#OFFSET_PRAW_XMAX_PORTAL]

@							}
@						}
@						
@						// Seguent actualitzaci punter per segent valor...
@					}
@					else // Renderitzem noms paret...
					B		Evaluar_Sostre_Terra

PintarParet:




@					{
@
@						Ysostre_actual		= PTR_PRAW(OFFSET_PRAW_YSOSTRE_ACTUAL_FX);//CEIL_FX(PRAW->Ysostre_actual_FX);
						LDR					  aux1,[PTR_PRAW, #OFFSET_PRAW_YSOSTRE_ACTUAL_FX]

@						Yterra_actual		= PTR_PRAW(OFFSET_PRAW_YTERRA_ACTUAL_FX);//CEIL_FX(PRAW->Yterra_actual_FX);	
						LDR					  aux2,[PTR_PRAW, #OFFSET_PRAW_YTERRA_ACTUAL_FX]

@
@						Ysostre_actual = CEIL_FX(Ysostre_actual); 
						CEIL_FX				Ysostre_actual,aux1

@						Yterra_actual  = CEIL_FX(Yterra_actual);
						CEIL_FX				Yterra_actual,aux2


@												
@					
@						y1 = max(y_retallat_sostre_actual,Ysostre_actual);
						MAX					y1,y_retallat_sostre_actual,Ysostre_actual

@						y2 = min(y_retallat_terra_actual,Yterra_actual);
						MIN					y2,y_retallat_terra_actual,Yterra_actual


@						
@						
@						if(y1 <= y2)

@						CMP	y1,y2
@						BGT	Evaluar_Sostre_Terra

@						{
@							


@                               void_ptr = (char *)Textura;
							    LDR			void_ptr, .ptr_textura
								LDR			void_ptr,[void_ptr]

 @                              aux1 = PTR_PRAW(OFFSET_PRAW_TEXTURA_PARET);
								LDR			aux1, [PTR_PRAW, #OFFSET_PRAW_ID_TEXTURA_PARET]

								
								CMP			aux1, #0   @ Si = 0, no hi ha cap textura associada per la paret --> no pintem...
								BLE			Evaluar_Sostre_Terra  
@								BLT			DescartarObtencioUV_Paret


								



@                               aux2 = Sizeof_tTextura;
								LDR			aux2,.SIZEOF_TEXTURA
								LDR			aux2,[aux2]

@                               aux1 = aux1*aux2;
								MUL			aux1, aux2, aux1

@                               void_ptr = ((char *)void_ptr + aux1);
								ADD			void_ptr, void_ptr, aux1
	
@                               Propietats =  (int)((char *)void_ptr)[0x4*2]; // Lectura de les propietats d'imatge;
								
								LDR			Propietats,[void_ptr, #0x8];



@								
@										
@										// Necessito 1 registre (+1 reg auxiliar) !!!
@										Z = PTR_PRAW(OFFSET_PRAW_Z);//PRAW->Z;
										LDR		Z,[PTR_PRAW, #OFFSET_PRAW_Z]

@
@										Escale_v_FX = FIXED_MUL_256(Z);
										FIXED_MUL_256	Escale_v_FX,Z

@										FIXED_DIV_120(Escale_v_FX);
										FIXED_DIV_120	Escale_v_FX
										MOV				Escale_v_FX,Escale_v_FX,lsl #DETALL_GRAFIC_Y

@										
@
@										aux1 = Escale_v_FX >> 16;


@
@										{
@										
@
@										aux1  = PTR_PRAW(OFFSET_PRAW_CENTRE_PROJECCIO_Y);//PRAW->centre_projeccio_y;
										LDR		aux1,[PTR_PRAW,#OFFSET_PRAW_CENTRE_PROJECCIO_Y]
@								

@
@										aux1		= (y1 - aux1); 
										SUB			aux1, y1, aux1

@										v1		    = aux1*Escale_v_FX; // ok --> no necessito centre_y (-1 reg), per aix v1 utilitzar el mateix registre que centre_y !!!
										MUL 		v_ini,aux1,Escale_v_FX

@										
@																													
@										// Total registres utilitzats: 11! --> (recorda que no pots utilitzar r15, r13, r14)
@
@										if(V_POWER_OF_2(Propietats))  
										IS_VPOW2		Propietats
@										{
@											// carrega de vmed ! (+1 reg: op. load + add)
@											aux1       = PTR_PRAW(OFFSET_PRAW_VMED);//PRAW->vmed;
											LDRNE		aux1,[PTR_PRAW,#OFFSET_PRAW_VMED]
@											v1         = v1 + aux1;
											ADDNE		v_ini,v_ini,aux1
@											
@										}
@//
@										
@										
@										u1	= PTR_PRAW(OFFSET_PRAW_U);//PRAW->U;
										LDR		u_ini,[PTR_PRAW,#OFFSET_PRAW_U]

DescartarObtencioUV_Paret:
@										
@
@										// Ja no necessito masc_u, ni propietats (-2 regs.)
@
@										// Total registres utilitzats: 11!
@
@										// +1 reg per obtenir escalat!!!
@										//
@										// Ja no necessito MIPmap_Adequat!!!
@										// Carrega de x!!!
@										// Total registres utilitzats: 12!
@										// x = PRAW->x;
@
@typedef struct{  // Cal canviar el nom per un de ms generic, pintar_tira, per exemple, ja que la funci pinta paisatges, sprites i blocks...
@
@	int          x,                      // Columna a on es pinta la tira.
@                y1,                     // Inici y pintat de tira. 
@                y2;                     // Fi    y pintat de tira
@    int         u1,                     // u1 en format APF 16.16 a l'espai 3D d'ull.
@                v1,                     // v1 en format APF 16.16 a l'espai 3D d'ull.
@                Escale_v;               // Escala en format 16.16.
@    int         ID_Textura;             // < 0 --> Pintat amb color [0,..256). == 0 no pinta. > 0 representa l'ID de textura a pintar.
@	int          Intensitat;             // Es pinta amb efecte de illuminaci. Si no hi consta a les propietats no es pintar.
@    int         Transparencia;          // Es pinta amb efecte de transparencia. Si no hi consta a les propietats no es pintar.
@    int         Propietats_Objecte;     // 16 bits de ms pes s'hi guarden les propietats de objecte. 16 bits de menys pes les de textura. (veure textura.h i objecte.h)
@//    int        Transparencia;
@//	unsigned int    Color_Mascara;  // Ja no cal desde que l'eina JespaGFX inserta el index paleta de mascara en ensamblador ARM
@
@}tParametresPintarParet2;			
@										x		    = PTR_PRAW(OFFSET_PRAW_X);//PRAW->x;
										LDR			x,[PTR_PRAW, #OFFSET_PRAW_X]

										LDR			ID_Textura, [PTR_PRAW, #OFFSET_PRAW_ID_TEXTURA_PARET]
										LDR			aux1, [PTR_PRAW, #OFFSET_PRAW_PROPIETATS_MAPEIG_LINIA]


@		MOV		aux1,#0x06000000
@		MOV		aux2,#0x0
@		STRH	aux2,[aux1]

										

@										
@										// Preguardar registres r0-r12,r14 !!!!!
										STMFD		sp!,{r0-r10}@-r3}

										
										@x,y1,y2,u_ini,v_ini,Escale_v_FX,void_ptr,intensitat_total}

										MOV			r1,x
										MOV			r2,y1
										MOV			r3,y2
										MOV			r4,u_ini
										MOV			r5,v_ini
										MOV			r6,Escale_v_FX
										MOV			r7,ID_Textura
										MOV			r8,intensitat_total
										MOV			r9,#0
										MOV			r10,aux1

										LDR			r0,.caca_ptr
										STMIA		r0,{r1-r10} 

								@		MOV			r0, rg1
								@		MOV			r1, r2
								@		MOV			r2, r3

								@		BL			ARM_PutBlockSlice_Fast



										BL			ARM_PutVerticalSlice

										LDMFD		sp!,{r0-r10} @-r7}@-r3}

@										// Empilar segents variables a r0!!!
@
@										PPP.x          = x;
@										PPP.y1         = y1;
@										PPP.y2         = y2;
@										PPP.v1         = v1;
@										PPP.u1         = u1;
@										PPP.Escale_v   = Escale_v_FX;
@										PPP.MipMap     = void_ptr;
@										PPP.Intensitat = intensitat_total;
@
@										// Total registres utilitzats: 11!
@										
@										// ok!, ja disposo de tots els parametres --> GUARDAT ALS PARAMETRES A L'ED!!!!!
@										
@										// Empilar registres r0-r12, r14, i guardar parametres empilats per r0!!!
@
@										
@										
@
@										//Escale_v = (Escale_v_FX >> MIPmap_Adequat);
@										//u_paret = CEIL_FX(PRAW->U);// & Mascara_u_Paret;
@										
@										//								PPP.Intensitat = RENDER_WITH_BRIGHT(MipMap->Propietats) ? intensitat_total : MAXIMA_INTENSITAT;
@										//PPP.MipMap = MipMap;
@										
@										PintarParet(PPP);
@										}
@									}
@									
@								//}
@						//	}
@						}
@					}


Evaluar_Sostre_Terra:

@
@				
@					aux1 = PTR_PRAW(OFFSET_PRAW_TRACTAR_SOSTRE);//PRAW->TractarSostre;
					LDR		aux1,[PTR_PRAW,#OFFSET_PRAW_TRACTAR_SOSTRE]

@				
@					if(aux1)
					CMP	aux1,#0
					BEQ	Evaluar_Terra
@					{
@						//
@						// Carrega de registres!!!!
@						//
@
@						Ysostre_actual	= PTR_PRAW(OFFSET_PRAW_YSOSTRE_ACTUAL_FX);//CEIL_FX(PRAW->Ysostre_actual_FX);
						LDR				  aux1,[PTR_PRAW,#OFFSET_PRAW_YSOSTRE_ACTUAL_FX]

@						Ysostre_actual  = CEIL_FX(Ysostre_actual);
						CEIL_FX			  Ysostre_actual,aux1

@						
@						
@						//y2		= CEIL_FX(PRAW->Yterra_actual_FX);
@						
@						
@						if(y_retallat_sostre_actual < Ysostre_actual) // retallat vlid...
						CMP		y_retallat_sostre_actual,Ysostre_actual
						BGE		Retallat_Sostre_Invalid		
@						{
@							x               = PTR_PRAW(OFFSET_PRAW_X);//PRAW->x;
							LDR				x,[PTR_PRAW,#OFFSET_PRAW_X]

@
@							// Actualitzaci buffer...
@
@							
@							xmax_sostre = PTR_PRAW(OFFSET_PRAW_XMAX_SOSTRE);
							LDR			xmax_sostre,[PTR_PRAW,#OFFSET_PRAW_XMAX_SOSTRE]
@							
@							if(xmax_sostre == -1/*PRAW->xmax_sostre == -1*/)
							CMP			xmax_sostre,#-1
							
@							{// Cal inicialitzar cotes x ...
@								//PRAW->xmin_sostre = PRAW->xmax_sostre = x;
@								PTR_PRAW(OFFSET_PRAW_XMIN_SOSTRE) = x;
								STREQ	x,[PTR_PRAW,#OFFSET_PRAW_XMIN_SOSTRE]
								

@								PTR_PRAW(OFFSET_PRAW_XMAX_SOSTRE) = x;
								STREQ	x,[PTR_PRAW,#OFFSET_PRAW_XMAX_SOSTRE]
@								
@
@							}
@							else
@							{// Actualitzem cota final
@								//PRAW->xmax_sostre = x;
@								PTR_PRAW(OFFSET_PRAW_XMAX_SOSTRE) = x;
								STRNE	x,[PTR_PRAW,#OFFSET_PRAW_XMAX_SOSTRE]

@							}
@							
@
@							void_ptr = PTR_PRAW(OFFSET_PRAW_YMIN_SOSTRE_PTR);//PRAW->ymin_sostre_ptr;
							LDR			void_ptr,[PTR_PRAW,#OFFSET_PRAW_YMIN_SOSTRE_PTR]

@							*((short *)void_ptr) = y_retallat_sostre_actual;
							STRH			y_retallat_sostre_actual,[void_ptr]
@

@							void_ptr = PTR_PRAW(OFFSET_PRAW_YMAX_SOSTRE_PTR);//(PRAW->ymax_sostre_ptr);
							LDR			void_ptr,[PTR_PRAW,#OFFSET_PRAW_YMAX_SOSTRE_PTR]


@							aux2 = (Ysostre_actual-1);
							SUB		aux2, Ysostre_actual,#1


@							aux1 = min(aux2,y_retallat_terra_actual);
							MIN		aux1, aux2,y_retallat_terra_actual


@							*((short *)void_ptr) = aux1;
							STRH		aux1,[void_ptr]


@@@@@@                     ymin_sostre = PTR_RAW(OFFSET_PRAW_YMIN_SOSTRE);
						   LDR			aux2,[PTR_PRAW,#OFFSET_PRAW_YMIN_SOSTRE]
@@@@@@                     ymax_sostre = PTR_RAW(OFFSET_PRAW_YMAX_SOSTRE);
						   LDR			ymax_sostre,[PTR_PRAW,#OFFSET_PRAW_YMAX_SOSTRE]
@@@@@@
@@@@@@                     if(ymax_sostre == -1) // Cal inicialitzar...
						   CMP	ymax_sostre,#-1
@@@@@@			           {
@@@@@@                           // ymin & ymax
@@@@@@                          PTR_RAW(OFFSET_PRAW_YMIN_SOSTRE) = y_retallat_sostre_actual;//PRAW->ymin_sostre_ptr;
								STREQ	y_retallat_sostre_actual,[PTR_PRAW,#OFFSET_PRAW_YMIN_SOSTRE]			
@@@@@@						    PTR_RAW(OFFSET_PRAW_YMAX_SOSTRE) = aux1;
								STREQ	aux1,[PTR_PRAW,#OFFSET_PRAW_YMAX_SOSTRE]
								BEQ		Evaluar_Terra
@@@@@@                     }
@@@@@@                     else // actualitzem...
@@@@@@                     {                            
@@@@@@                              y1 = min(ymin_sostre,y_retallat_sostre_actual);
									MIN		y1, aux2, y_retallat_sostre_actual
@@@@@@                              y2 = max(ymax_sostre,aux1);
									MAX		y2, ymax_sostre, aux1
@@@@@@                              PTR_RAW(OFFSET_PRAW_YMIN_SOSTRE) = y1;
									STR		y1,[PTR_PRAW,#OFFSET_PRAW_YMIN_SOSTRE]
@@@@@@                              PTR_RAW(OFFSET_PRAW_YMAX_SOSTRE) = y2;
									STR		y2,[PTR_PRAW,#OFFSET_PRAW_YMAX_SOSTRE]
@@@@@@                     }



							B		Evaluar_Terra

@							
@							
@
@						}
@						else // Invlid...
Retallat_Sostre_Invalid:
@						{
@
@						  //*(PRAW->ymin_sostre_ptr) = ALTURA_PANTALLA_EFECTIVA;
@						  //*(PRAW->ymax_sostre_ptr) = -1;
@							void_ptr = PTR_PRAW(OFFSET_PRAW_YMIN_SOSTRE_PTR);//(PRAW->ymin_sostre_ptr);
							LDR			void_ptr,[PTR_PRAW,#OFFSET_PRAW_YMIN_SOSTRE_PTR]

@							aux1	 = ALTURA_PANTALLA_EFECTIVA;
							MOV			aux1,#ALTURA_PANTALLA_EFECTIVA
							

@							*((short *)void_ptr) = aux1;//y_retallat_sostre_actual - 1;
							STRH		aux1,[void_ptr]

@
@							void_ptr = PTR_PRAW(OFFSET_PRAW_YMAX_SOSTRE_PTR);//(PRAW->ymax_sostre_ptr);
							LDR		void_ptr,[PTR_PRAW,#OFFSET_PRAW_YMAX_SOSTRE_PTR]

@							aux1 = -1;
							MOV	aux1,#-1

@							*((short *)void_ptr) = aux1;//y_retallat_sostre_actual - 1;
							STRH		aux1,[void_ptr]
	
@
@							
@						}
@						
@
@					}


Evaluar_Terra:
@				
@				
@					aux1 = PTR_PRAW(OFFSET_PRAW_TRACTAR_TERRA);//PRAW->TractarTerra;
					LDR		aux1,[PTR_PRAW,#OFFSET_PRAW_TRACTAR_TERRA]

@					if(aux1)
					CMP	aux1,#0
					BEQ Proxima_Iteracio_1	
@					{
@						//
@						// Una altre carrega de registres!!!!
@						//
@						Yterra_actual	= PTR_PRAW(OFFSET_PRAW_YTERRA_ACTUAL_FX);//CEIL_FX(PRAW->Yterra_actual_FX);
						LDR				aux1,[PTR_PRAW,#OFFSET_PRAW_YTERRA_ACTUAL_FX]

@						Yterra_actual   = CEIL_FX(Yterra_actual); 
						CEIL_FX			Yterra_actual,aux1

@						
@											
@						// Actualitzaci buffer...
@						
@						if(Yterra_actual < y_retallat_terra_actual) // retallat vlid...
						CMP		Yterra_actual,y_retallat_terra_actual
						BGE		Retallat_Terra_Invalid
@						{
@							x               = PTR_PRAW(OFFSET_PRAW_X);//PRAW->x;
							LDR				x,[PTR_PRAW,#OFFSET_PRAW_X]

@							xmax_terra      = PTR_PRAW(OFFSET_PRAW_XMAX_TERRA);
							LDR				xmax_terra,[PTR_PRAW,#OFFSET_PRAW_XMAX_TERRA]

@							
@							if(xmax_terra == -1)
							CMP	xmax_terra,#-1

@							{// Cal inicialitzar cotes x ...
@								
@								PTR_PRAW(OFFSET_PRAW_XMIN_TERRA) = x;
								STREQ	x,[PTR_PRAW,#OFFSET_PRAW_XMIN_TERRA]

@								PTR_PRAW(OFFSET_PRAW_XMAX_TERRA) = x;
								STREQ	x,[PTR_PRAW,#OFFSET_PRAW_XMAX_TERRA]

@								//PRAW->xmin_terra = PRAW->xmax_terra = x;
@							}
@							else
@							{// Actualitzem cota final
@								
@								//PRAW->xmax_terra = x;
@								PTR_PRAW(OFFSET_PRAW_XMAX_TERRA) = x;
								STRNE	x,[PTR_PRAW,#OFFSET_PRAW_XMAX_TERRA]

@							}
@							
@							
@							//if( y_retallat_sostre_actual <= Yterra_actual)
@
@							aux2 = (Yterra_actual+1);
							ADD		aux2,Yterra_actual,#1

@							aux1 = max(aux2,y_retallat_sostre_actual);
							MAX		aux1,aux2,y_retallat_sostre_actual

@
@							void_ptr = PTR_PRAW(OFFSET_PRAW_YMIN_TERRA_PTR);//PRAW->ymin_terra_ptr;
							LDR		void_ptr,[PTR_PRAW,#OFFSET_PRAW_YMIN_TERRA_PTR]

@							*((short *)void_ptr) = aux1;
							STRH		aux1,[void_ptr]

@
@							void_ptr = PTR_PRAW(OFFSET_PRAW_YMAX_TERRA_PTR);//PRAW->ymax_terra_ptr;
							LDR		void_ptr,[PTR_PRAW,#OFFSET_PRAW_YMAX_TERRA_PTR]

@							*((short *)void_ptr) = y_retallat_terra_actual;
							STRH		y_retallat_terra_actual,[void_ptr]


@@@@@@@                     ymin_terra = PTR_RAW(OFFSET_PRAW_YMIN_TERRA);
							LDR			ymin_terra,[PTR_PRAW, #OFFSET_PRAW_YMIN_TERRA]
@@@@@@@                     ymax_terra = PTR_RAW(OFFSET_PRAW_YMAX_TERRA);
							LDR			aux2,[PTR_PRAW, #OFFSET_PRAW_YMAX_TERRA]

@@@@@@@                     if(ymax_terra == -1) // Cal inicialitzar...
							CMP		ymax_terra,#-1
@@@@@@@                     {
@@@@@@@                            // ymin & ymax
@@@@@@@                            PTR_RAW(OFFSET_PRAW_YMIN_TERRA) = aux1;//PRAW->ymin_sostre_ptr;
								   STREQ		aux1,[PTR_PRAW, #OFFSET_PRAW_YMIN_TERRA]
@@@@@@@						       PTR_RAW(OFFSET_PRAW_YMAX_TERRA) = y_retallat_terra_actual;
								   STREQ		y_retallat_terra_actual,[PTR_PRAW, #OFFSET_PRAW_YMAX_TERRA]	
								   BEQ			Proxima_Iteracio_1
@@@@@@@
@@@@@@@                     }
@@@@@@@                     else // actualitzem...
@@@@@@@                     {                            
@@@@@@@                           y1 = min(ymin_terra,aux1);
								  MIN	y1, ymin_terra, aux1
@@@@@@@                           y2 = max(ymax_terra,y_retallat_terra_actual);
								  MAX	y2, aux2, y_retallat_terra_actual
@@@@@@@
@@@@@@@                           PTR_RAW(OFFSET_PRAW_YMIN_TERRA) = y1;
								  STR		y1,[PTR_PRAW, #OFFSET_PRAW_YMIN_TERRA]
@@@@@@@                           PTR_RAW(OFFSET_PRAW_YMAX_TERRA) = y2;
								  STR		y2,[PTR_PRAW, #OFFSET_PRAW_YMAX_TERRA]
@@@@@@@
@@@@@@@                     }


							B			Proxima_Iteracio_1

@
@							
@						}
@						else // el fem invlid !
Retallat_Terra_Invalid:
@						{
@
@							void_ptr = PTR_PRAW(OFFSET_PRAW_YMIN_TERRA_PTR);//(PRAW->ymin_terra_ptr);
							LDR		void_ptr,[PTR_PRAW,#OFFSET_PRAW_YMIN_TERRA_PTR]

@							aux1 = ALTURA_PANTALLA_EFECTIVA;
							MOV		aux1,#ALTURA_PANTALLA_EFECTIVA

@							*((short *)void_ptr) = aux1;//y_retallat_sostre_actual - 1;
							STRH		aux1,[void_ptr]

@
@							void_ptr = PTR_PRAW(OFFSET_PRAW_YMAX_TERRA_PTR);//(PRAW->ymax_terra_ptr);
							LDR		void_ptr,[PTR_PRAW,#OFFSET_PRAW_YMAX_TERRA_PTR]

@							aux1 = -1;
							MOV		aux1,#-1

@							*((short *)void_ptr) = aux1;//y_retallat_sostre_actual - 1;
							STRH		aux1,[void_ptr]

@
@						//	}
@							
@						}
@						
@
@					}
@
@				}


Proxima_Iteracio_1:
@				
@				// Actualitzat de vectors y pel retallat vertical en cas que terra/sostre siguin un portal...
@				
@
@
@				// 1era MEGA CARREGA + INCREMENTS CONSTANTS + GUARDAT DE REGISTRES (es necessari 12 registres) !!!!
@
@			PTR_PRAW(OFFSET_PRAW_YSOSTRE_ACTUAL_FX)		= PTR_PRAW(OFFSET_PRAW_YSOSTRE_ACTUAL_FX)			+ PTR_PRAW(OFFSET_PRAW_INC_DYDX_SOSTRE_FX);
@			PTR_PRAW(OFFSET_PRAW_YTERRA_ACTUAL_FX)		= PTR_PRAW(OFFSET_PRAW_YTERRA_ACTUAL_FX)			+ PTR_PRAW(OFFSET_PRAW_INC_DYDX_TERRA_FX);
@			PTR_PRAW(OFFSET_PRAW_YSOSTRE_CONNECTANT_FX)	= PTR_PRAW(OFFSET_PRAW_YSOSTRE_CONNECTANT_FX)		+ PTR_PRAW(OFFSET_PRAW_INC_DYDX_SOSTRE_CONNECTANT_FX);
@			PTR_PRAW(OFFSET_PRAW_YTERRA_CONNECTANT_FX)	= PTR_PRAW(OFFSET_PRAW_YTERRA_CONNECTANT_FX)		+ PTR_PRAW(OFFSET_PRAW_INC_DYDX_TERRA_CONNECTANT_FX);
@			PTR_PRAW(OFFSET_PRAW_Z)						= PTR_PRAW(OFFSET_PRAW_Z)							+ PTR_PRAW(OFFSET_PRAW_DELTA_Z);
@			PTR_PRAW(OFFSET_PRAW_U)						= PTR_PRAW(OFFSET_PRAW_U)							+ PTR_PRAW(OFFSET_PRAW_DELTA_U);	
			
			ADD			r14,PTR_PRAW,#OFFSET_PRAW_Z
			LDMIA		r14,{r1-r12}

			ADD			r1,r1,r7	@ Z <- Z + dz
			ADD			r2,r2,r8	@ U <- U + du
			ADD			r3,r3,r9    @;	r6	@ Ysostre_actual
			ADD			r4,r4,r10	@ Ysostre_connectant
			ADD			r5,r5,r11   @ #512@r9,#-4	@r10	@ Yterra 
			ADD			r6,r6,r12   @ Yterra_connectant



			STMIA		r14,{r1-r6}

			
@				
@			// 2ona MEGA CARREGA + INCREMENTS UNITARIS + GUARDAT DE REGISTRES (8 registres) !!!!


@			PTR_PRAW(OFFSET_PRAW_YMIN_PORTAL_PTR)	= PTR_PRAW(OFFSET_PRAW_YMIN_PORTAL_PTR)		+ 2;//PRAW->ymin_portal_ptr			+ 1;
@			PTR_PRAW(OFFSET_PRAW_YMAX_PORTAL_PTR)	= PTR_PRAW(OFFSET_PRAW_YMAX_PORTAL_PTR)		+ 2;//PRAW->ymax_portal_ptr			+ 1;
@			PTR_PRAW(OFFSET_PRAW_YMIN_SOSTRE_PTR)	= PTR_PRAW(OFFSET_PRAW_YMIN_SOSTRE_PTR)		+ 2;//->ymin_sostre_ptr			+ 1;
@			PTR_PRAW(OFFSET_PRAW_YMAX_SOSTRE_PTR)	= PTR_PRAW(OFFSET_PRAW_YMAX_SOSTRE_PTR)		+ 2;//->ymax_sostre_ptr			+ 1;
@			PTR_PRAW(OFFSET_PRAW_YMIN_TERRA_PTR)	= PTR_PRAW(OFFSET_PRAW_YMIN_TERRA_PTR)		+ 2;//;->ymin_terra_ptr			+ 1;
@			PTR_PRAW(OFFSET_PRAW_YMAX_TERRA_PTR)	= PTR_PRAW(OFFSET_PRAW_YMAX_TERRA_PTR)		+ 2;//;->ymax_terra_ptr			+ 1;
@			PTR_PRAW(OFFSET_PRAW_X)					= PTR_PRAW(OFFSET_PRAW_X)				+ 1;//->x						+ 1;
@			PTR_PRAW(OFFSET_PRAW_ITERACIONS)		= PTR_PRAW(OFFSET_PRAW_ITERACIONS)		- 1;//;->interacions				- 1;


@			LDR			void_ptr,[PTR_PRAW,#YMIN_PORTAL_PTR]
@			MOV			r1,#-4
@			STRH		r1,[void_ptr]

			ADD			r11,PTR_PRAW,#YMIN
			LDMIA		r11,{r1-r10}

			ADD			r1,r1,#2	@ ymin++
			ADD			r2,r2,#2	@ ymax++
			ADD			r3,r3,#2	@ ymin_portal_ptr++
			ADD			r4,r4,#2	@ ymax_portal_ptr++
			ADD			r5,r5,#2	@ ymin_sostre_ptr++
			ADD			r6,r6,#2	@ ymax_sostre_ptr++
			ADD			r7,r7,#2	@ ymin_terra_ptr++
			ADD			r8,r8,#2	@ ymax_terra_ptr++
			ADD			r9,r9,#1	@ x++
			SUBS		r10,r10,#1	@ iteracions--;

@			ADD			r11,PTR_PRAW,[PTR_PRAW,#YMIN_PORTAL_PTR]
			STMIA		r11,{r1-r10}



@				
@			aux1 = PTR_PRAW(OFFSET_PRAW_ITERACIONS);//PRAW->interacions;
@				
@			aux1 = PTR_PRAW(OFFSET_PRAW_ITERACIONS);//PRAW->interacions;
@				
@				//u_paisatge += du_paisatge;
@
@				//aux = PRAW->interacions;
@				//aux--;
@				
@				
@			}while(aux1 > 0);
			BNE		Continua_Render_Affine_Wall
@	//	}
@
	LDMFD	sp!,{r0-r12,r14}
	bx	lr
@
@}




@typedef struct _tParametresPintarParet{  // Cal canviar el nom per un de ms generic, pintar_tira, per exemple, ja que la funci pinta paisatges, sprites i blocks...
@
@	int				x,y1,y2,u1;
@	long			v1, Escale_v;
@	tImatge			*MipMap;
@	unsigned int	Intensitat;
@//	unsigned int    Color_Mascara;
@
@}tParametresPintarParet;

@	.data
@	.space	4
@	.comm	Param, 32, 32

.data
.size	caca, 32
caca:
	.space	32
