@ /***********************\
@ | ZONA MEMORIA i TAMANY  |
@ \***********************/

.SECTION .iwram  @,"ax",%progbits
.ARM
.ALIGN



.include "ARM_FUNCTIONS/ARM_Defines.s"
.include "ARM_FUNCTIONS/ARM_Util.s"

.equ		ONE_FX,				1 << PART_FRACCIONAL










@ /***********************\
@ | PROTOTIPUS DE FUNCIONS |
@ \***********************/


.GLOBL   ARM_PutBlockSlice
.GLOBL   ARM_PutBlockSlice_With_V_POW_2
.GLOBL    ARM_PutBlockSlice_Fast




.GLOBL   ARM_PintarTiraPla
.GLOBL   ARM_PintarTerra_HIGH
.GLOBL   ARM_Obtenir_Cotes
.GLOBL   ARM_PintarTiraPla_FAST
.GLOBL   ARM_PutVerticalSlice
.GLOBL   ARM_PutHorizontalSlice

.TYPE    ARM_PutBlockSlice, function
.TYPE    ARM_PutBlockSlice_With_V_POW_2, function
.TYPE    ARM_PutBlockSlice_Fast, function


.TYPE    ARM_PintarTiraPla, function
.TYPE    ARM_PintarTerra_HIGH, function
.TYPE    ARM_PintarTiraPla_FAST, function

.TYPE    ARM_PutVerticalSlice, function
.TYPE    ARM_PutHorizontalSlice, function



@ /**************************\
@ | IMPLEMENTACIO DEFUNCIONS |
@ \**************************/




ARM_PutBlockSlice_Fast:
@
@typedef struct _tParametresPintarParet{
@
@	int			x,y1,y2,u;
@	long	    v1, Escale_v;
@	tTextura    Textura;
@
@}tParametresPintarParet;
@
@
@

@ Utilitzaci de registres corresponents a variables del codi C
@ -------------------------------------------------------------
@
@ r0  = parametre punter a l'estructura tParametresPintarParet, x
@ r1  = y1, ptr_video + y1*240 + x
@ r2  = y2, NPixels
@ r3  = color



    STMFD   sp!, {r9}                        @ empilem registres				

    @ Crrega dels 9 parametres als registres r0-r8...

 @   LDMIA   r0,{r0-r10}

    MOV r9,   r10   @ Provisional...

@	y1 = PPP->y1;
@	y2 = PPP->y2;

@	if(y1 < 0 || y2 >= ALTURA_PANTALLA || y2 < 0 || y1 >= ALTURA_PANTALLA || y1 > y2) return;

    CMP     r1,#0
    BMI     Acaba_PutBlockSlice_Fast
    CMP     r1,#ALTURA_PANTALLA_EFECTIVA
    BCS     Acaba_PutBlockSlice_Fast
    CMP     r1,r2
    BGT     Acaba_PutBlockSlice_Fast

    CMP     r2,#0
    BMI     Acaba_PutBlockSlice_Fast
    CMP     r2,#ALTURA_PANTALLA_EFECTIVA
    BCS     Acaba_PutBlockSlice_Fast

@	y2d = y2 - y1 + 1;

    SUB     r2,r2,r1
    ADD     r2,r2,#1
	

@	dest_ptr = (char *)(SDL_WORK_VRAM + AMPLADA_PANTALLA*y1 + PPP->x);

    MOV     r9, r1, lsl #8              @ r1 <- r1*240
    SUB     r9, r9, r1, lsl #4

    ADD     r9, r9, #Video                 @ r9 <- 0x06000000 + y1*240

.ifdef __BAIX_NIVELL_X
    MOV     r1,r0, lsl #1                     @ r1 <- (x << 1)
.else
    MOV     r1,r0
    BIC     r1, r1, #1                        @ r1 <- r1 & 0xFFFFFFFE  (Perqu les lectures a VRAM (16 bits) s'afectuen de forma alineada, o sigui, s'ha de llegir mitja paraula (16 bits) des de columnes parells.)
.endif

    ADD     r1,r1,r9                     @ r1 <- 0x06000000 + y1*240 + (x << LOW_DETAIL)


@ COMENAMENT - DETERMINACI DE L'ADREA DE BUFER DE TREBALL
        MOV     r9,     #0x04000000                 @ r9 = 0x04000000
        LDR     r9,     [r9]                        @ r9 = val from addr 0x04000000
        AND     r9,     r9,     #0x10               @ r9 = r9 & 0x10
        MOV     r9,     r9,     LSR #4              @ r9 = r9 >> 4
@ FI - DETERMINACI DE L'ADREA DE BUFER DE TREBALL

        CMP     r9,     #1                          @ r9 == 1
        BNE     ARM_PutBlockSlice_Fast_Afegir_Offset_Secundari				@ != 1 -> Vol dir que el bufer de treball s el secundari...
        B       Continua_ARM_PutBlockSlice_Fast_H_1

ARM_PutBlockSlice_Fast_Afegir_Offset_Secundari:

        ADD     r1, r1, #0xA000

@ r10 = ptr_shade + intensitat



Continua_ARM_PutBlockSlice_Fast_H_1:


@		do{

@

.ifdef __BAIX_NIVELL_X

            MOV     r9, r3
            ORR     r9,r3,r9, lsl #8

.else

@@@@2@@@@@@@@- CARREGA PIXELS DE MEMORIA, EMMASCARANENT, i GUARDAT DEL PIXEL -@@@@2@@@@@@@@

            @ Crrega de pixels desde vram ...

            LDRH     r9, [r1]           @ Carrega dels pixel vram. (Els 8 bits de MENYS pes s el PIXEL PARELL, i els bits de MS pes representa el PIXEL SENAR)

            @ Emmascarat del pixel a salvaguardar i escriptura del pixel de textura (r3)

            @ if( x == 1) // Volem escriure pixel senar, per aix cal guardar pixel parell

            TSTS        r0,#1
            BEQ         EscriurePixelParell_ARM_PutBlockSlice_Fast

            @ Escriptura de pixel senar...

            AND     r9,     r9,        #255           @ r4 <- Color_Textura & 0xFF  (Machaquem el 8 bits de MES PES -Pixel senar-)
            ORR     r9,     r9,   r3,  LSL   #8       @ r4 <- (Pixel_Textura << 8) | r4 ( Guardem pixel senar)

            B           Escriure_pixel_a_VRAM_ARM_PutBlockSlice_Fast

            @else // Volem escriure pixel parell, per aix cal salvarguardar el pixel senar de la

EscriurePixelParell:
            @ Escriptura de pixel parell...

            MOV     r9,     r9,        LSR   #8           @ r9 <- r9 >> 8  (Machaquem el 8 bits de MENYS PES -Pixel parell-)
            ORR     r9,     r3,   r9,  LSL   #8           @ r9 <- Pixel_Textura | r9 ( Guardem pixel parell)


@@@@2@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@2@@@@@@@@@@@@@@@@@@

.endif

Escriure_pixel_a_VRAM_ARM_PutBlockSlice_Fast:
@			*dest_ptr = ptr_textura[v_actual];

            STRH    r9,[r1],#240

@           y2d --;

            SUBS    r2, r2, #1
		
@		}while(y2d > 0);
	
            BNE     Continua_ARM_PutBlockSlice_Fast_H_1
            
Acaba_PutBlockSlice_Fast:

       LDMFD   sp!, {r9}            @ Restore registers
        BX      lr






ARM_PutBlockSlice:


        BX      lr



ARM_PutBlockSlice_With_V_POW_2:


        BX      lr






ARM_PintarTiraPla:

@
@typedef struct _tParametresPintarPla{
@
@    int			    x1,x2,y;
@	long				u0, v0, du, dv; // Coordenades de mapeig
@	char                *ptr_textura;
@	unsigned int		Intensitat;
@	
@
@}tParametresPintarPla;
@
@
@

@ Utilitzaci de registres corresponents a variables del codi C
@ -------------------------------------------------------------
@
@ r0  = punter a l'estructura de pintat de pla, x1, --> ok!
@ r1  = x2, NPixels. --> ok!
@ r2  = y, ptr_video + y*240 + x1  --> ok!
@ r3  = u0 ok!
@ r4  = v0 ok!
@ r5  = du ok!
@ r6  = dv ok!
@ r7  = ptr_textura,dx_mapa. ok!
@ r8  = ptR_shade + Intensitat. ok!
@ r9  = aux, offset_textura, color
@ r10 = aux
@@ r12 = aux,ptr_shade + intensitat


    STMFD   sp!, {r0-r12}                        @ empilem registres				

    @ Crrega dels 9 parametres als registres r0-r8...

@	x  = PPS->x;
@	y1 = PPS->y1;
@	y2 = PPS->y2;
@	diff_altura = PPS->diff_altura;
@	Valor_Cosinus = PPS->Valor_Cosinus;
@	Valor_Sinus = PPS->Valor_Sinus;
@	Xj = PPS->Xj;
@	Zj = PPS->Zj;
@   ptr_textura = PPS->ptr_textura;

    LDMIA   r0,{r0-r8}

    @ r8 <-- ptr_shade + intensitat

    LDR     r9, .ptr_shade
    ADD     r8, r9, r8

@	x2d = x2 - x1 + 1;

    SUB     r1,r1,r0
    ADD     r1,r1,#1

    CMP     r1,#1
    BLT     Acabar_Pintar_Pla_H
    
	CMP     r1,#AMPLADA_PANTALLA_EFECTIVA
    BGT     Acabar_Pintar_Pla_H


@	dest_ptr           = (char *)(SDL_WORK_VRAM + AMPLADA_PANTALLA*y1 + x);

    MOV     r9, r2, lsl #8              @ r9 <- y*240
    SUB     r9, r9, r2, lsl #4
    ADD     r9, r9, #Video                 @ r9 <- 0x06000000 + y*240
.ifdef __BAIX_NIVELL_X
    MOV     r2,r0, lsl #1                     @ r2 <- (x1 << LOW_DETAIL)
.else
    MOV     r2,r0
    BIC     r2, r2, #1                        @ r2 <- r2 & 0xFFFFFFFE  (Perqu les lectures a VRAM (16 bits) s'afectuen de forma alineada, o sigui, s'ha de llegir mitja paraula (16 bits) des de columnes parells.)
.endif

    ADD     r2,r2,r9                     @ r2 <- 0x06000000 + y*240 + (x1 << LOW_DETAIL)


@ COMENAMENT - DETERMINACI DE L'ADREA DE BUFER DE TREBALL

        MOV     r9,     #0x04000000                 @ r9 = 0x04000000
        LDR     r9,     [r9]                        @ r9 = val from addr 0x04000000
        AND     r9,     r9,     #0x10               @ r9 = r9 & 0x10
        MOV     r9,     r9,     LSR #4              @ r9 = r9 >> 4
    
@ FI - DETERMINACI DE L'ADREA DE BUFER DE TREBALL

    CMP     r9,     #1                          @ r9 == 1
    BNE     Afegir_Offset_Secundari_S				@ != 1 -> Vol dir que el bufer de treball s el secundari...
    B       Continua_Pintar_Sostre


Afegir_Offset_Secundari_S:

        ADD     r2, r2, #0xA000	

Continua_Pintar_Sostre:


          TSTS         r0, #1    @ Si (r0 mod 2 == 1) llavors s'ha de escriure mitja paraula...
        ANDNE     r9, r3, #0x3F0000

        @ v <- (zmapa) & 64
        ANDNE     r10, r4, #0x3F0000

        ADDNE     r9, r9, r10, lsl #6

        LDRNEB    r9, [r7, r9, lsr #16]
.ifdef __WITH_LIGHT__
        LDRNEB    r9, [r8, r9, lsl #8]
.endif
        
.ifdef __BAIX_NIVELL_X

            @MOVNE     r10, r9
            ORRNE     r10,r9,r9, lsl #8
.else
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

            @ Crrega de pixels desde vram ...

            LDRNEH     r10, [r2]           @ Carrega dels pixel vram. (Els 8 bits de MENYS pes s el PIXEL PARELL, i els bits de MS pes representa el PIXEL SENAR)

            @ Emmascarat del pixel a salvaguardar i escriptura del pixel de textura (r3)

            @ if( x == 1) // Volem escriure pixel senar, per aix cal guardar pixel parell

            BEQ         EscriurePixelParell_Pla

            @ Escriptura de pixel senar...

            ANDNE     r10,     r10,        #255           @ r4 <- Color_Textura & 0xFF  (Machaquem el 8 bits de MES PES -Pixel senar-)
            ORRNE     r10,     r10,   r9,  LSL   #8       @ r4 <- (Pixel_Textura << 8) | r4 ( Guardem pixel senar)

            BNE           Escriure_primer_pixel_a_VRAM

            @else // Volem escriure pixel parell, per aix cal salvarguardar el pixel senar de la

EscriurePixelParell_Pla:
            @ Escriptura de pixel parell...

            MOV     r10,     r10,        LSR   #8           @ r9 <- r9 >> 8  (Machaquem el 8 bits de MENYS PES -Pixel parell-)
            ORR     r10,     r9,   r10,  LSL   #8           @ r9 <- Pixel_Textura | r9 ( Guardem pixel parell)
            
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

.endif

Escriure_primer_pixel_a_VRAM:

@			dest_ptr = ptr_textura[u+v];;

            STRNEH    r10,[r2] ,#2

@           x = x + dx_mapa

            ADDNE     r3,r3,r5

@           z = z + dz_amap

            ADDNE     r4,r4,r6
            
            


@  		    y2d --;
       SUBNE    r1, r1, #1
        
        AND         r12, r1, #0x1
        MOV         r1,r1, lsr #1
        CMP         r1, #0

        BEQ         Acaba_Pintar_Ultim_Pixel




@------------------------------------------------------------------------------------------
@==========================================================================================
@HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH

Continua_Pintar_ScanLine_Fast:

            @ Determinacoi component u ...
            
            @ u <- (xmapa) & 64

            AND     r9, r3, #0x3F0000
            
            @ v <- (zmapa) & 64
            AND     r10, r4, #0x3F0000
            
            ADD     r9, r9, r10, lsl #6
            
            LDRB    r9, [r7, r9, lsr #16]
.ifdef __WITH_LIGHT__
            LDRB    r9, [r8, r9, lsl #8]
.endif
            
            
@          x = x + dx_mapa

            ADD     r3,r3,r5

@          z = z + dz_amap

            ADD     r4,r4,r6

            @ u <- (xmapa) & 64

            AND     r10, r3, #0x3F0000

            @ v <- (zmapa) & 64
            AND     r11, r4, #0x3F0000

            ADD     r10, r10, r11, lsl #6

            LDRB    r10, [r7, r10, lsr #16]
.ifdef __WITH_LIGHT__
            LDRB    r10, [r8, r10, lsl #8]
.endif

.ifdef __BAIX_NIVELL_X


            @MOV     r11, r9
            ORR     r11,r9,r9, lsl #8
            
            @MOV     r9, r10
            ORR     r10,r10,r10, lsl #8
            
            ORR     r10,r11,r10, lsl #16
.else


            MOV     r11, r9
            ORR     r10, r9, r11, lsl #8


@@@@2@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@2@@@@@@@@@@@@@@@@@@

.endif

Escriure_pixel_a_VRAM_Pla_1:

@				dest_ptr = ptr_textura[u+v];;

.ifdef  __BAIX_NIVELL_X

                STR    r10,[r2] ,#4
.else
                STRH    r10,[r2] ,#2
.endif
                
@               x = x + dx_mapa

                ADD     r3,r3,r5

@               z = z + dz_amap

                ADD     r4,r4,r6


@				y2d --;
                SUBS    r1, r1, #1
		
@		}while(y2d > 0);

			    BNE     Continua_Pintar_ScanLine_Fast


@==========================================================================================
@HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
@------------------------------------------------------------------------------------------


Acaba_Pintar_Ultim_Pixel:





            CMP         r12, #0    @ Si (r12 mod 2 == 1) llavors {s'ha de escriure mitja paraula...}

            ANDNE     r9, r3, #0x3F0000

            @ v <- (zmapa) & 64
            ANDNE     r10, r4, #0x3F0000

            ADDNE     r9, r9, r10, lsl #6

            LDRNEB    r9, [r7, r9, lsr #16]
.ifdef __WITH_LIGHT__
            LDRNEB    r9, [r8, r9, lsl #8]
.endif


.ifdef  __BAIX_NIVELL_X
@            MOVNE     r10, r9
            ORRNE     r10,r9,r9, lsl #8
.else

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

            @ Crrega de pixels desde vram ...

            LDRNEH     r10, [r2]           @ Carrega dels pixel vram. (Els 8 bits de MENYS pes s el PIXEL PARELL, i els bits de MS pes representa el PIXEL SENAR)

            @ Emmascarat del pixel a salvaguardar i escriptura del pixel de textura (r3)

            @ if( x == 1) // Volem escriure pixel senar, per aix cal guardar pixel parell
            
            TSTS         r2,#1

            BEQ         U_EscriurePixelParell_Pla

            @ Escriptura de pixel senar...

            AND     r10,     r10,        #255           @ r4 <- Color_Textura & 0xFF  (Machaquem el 8 bits de MES PES -Pixel senar-)
            ORR     r10,     r10,   r9,  LSL   #8       @ r4 <- (Pixel_Textura << 8) | r4 ( Guardem pixel senar)
            CMP         r12, #0    @ Si (r12 mod 2 == 1) llavors {s'ha de escriure mitja paraula...}

            B         U_Escriure_ultim_pixel_a_VRAM

            @else // Volem escriure pixel parell, per aix cal salvarguardar el pixel senar de la

U_EscriurePixelParell_Pla:
            @ Escriptura de pixel parell...

            MOV     r10,     r10,        LSR   #8           @ r9 <- r9 >> 8  (Machaquem el 8 bits de MENYS PES -Pixel parell-)
            ORR     r10,     r9,   r10,  LSL   #8           @ r9 <- Pixel_Textura | r9 ( Guardem pixel parell)
            CMP         r12, #0    @ Si (r12 mod 2 == 1) llavors {s'ha de escriure mitja paraula...}

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
.endif

U_Escriure_ultim_pixel_a_VRAM:

            STRNEH    r10,[r2]






Acabar_Pintar_Pla_H:

        LDMFD   sp!, {r0-r12}            @ Restore registers
        BX      lr






@ The end...





@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@      x;                                        // r0. (Necessari conservar-lo per si volem pintar a alt detall.)
	   x			.req	r0

@      y1;   char  *ptr_dst;                     // r1. (void_ptr1 agafa el punter desti...)
	   y1			.req	r1
	   ptr_dst		.req	r1

@      y2,   y2d;                                // r2.
	   y2			.req	r2
	   y2d			.req	r2

@      U;    char  *ptr_src;                     // r3. (void_ptr2 agafa el punter font...)
	   U			.req	r3
	   ptr_src		.req	r3

@      V,                                        // r4.
	   V			.req	r4

@      Escale_FX,                                // r5.
	   Escale_FX	.req	r5

@      ID_Textura,color; void  *void_ptr;        // r6. (void_ptr agafa els punters: Textura, &Textura[ID_Textura], &Textura[ID_Textura]->GFX_MipMap[MIPmap_Adequat], punter_shade)
	   ID_Textura	.req	r6
	   color		.req	r6
	   void_ptr		.req	r6

@      Intensitat;    char  *ptr_intensitat;     // r7.  Punter + offset X (nivell intensitat).
	   Intensitat	.req	r7
	   ptr_intensitat	.req	r7

@      Transparencia; char  *ptr_transparencia;  // r8.  Punter + offset X (nivell transparencia).
	   Transparencia	.req	r8
	   ptr_transparencia	.req	r8

@      Propietats;                               // r9.
	   Propietats	.req	r9

@      MIPmap_Adequat,log2_U;                    // r10.
	   MIPmap_Adequat	.req	r10
	   log2_U			.req	r10

@      log2_V,mask_v;                            // r11.
	   log2_V	.req	r11
	   mask_v	.req	r11

@      aux1;                                     // r12.
	   aux1				  .req		r12
	   Propietats_Imatge  .req		r14
	   aux2				  .req		r14



@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


ARM_PutVerticalSlice_COLOR:@(char *ptr_dst, int y2d, int color)
@{

       MOV     aux1,color
       ORR     aux1,aux1,color, lsl #8
 

LOOP_PutVerticalSlice_Color:


@		do{

@

.ifdef __BAIX_NIVELL_X

@	{ No s'ha de fer res yupppiaeee XD }

.else

@@@@2@@@@@@@@- CARREGA PIXELS DE MEMORIA, EMMASCARANENT, i GUARDAT DEL PIXEL -@@@@2@@@@@@@@

            @ Crrega de pixels desde vram ...

            LDRH     aux1, [ptr_dst]           @ Carrega dels pixel vram. (Els 8 bits de MENYS pes s el PIXEL PARELL, i els bits de MS pes representa el PIXEL SENAR)

            @ Emmascarat del pixel a salvaguardar i escriptura del pixel de textura (r3)

            @ if( x == 1) // Volem escriure pixel senar, per aix cal guardar pixel parell

            TSTS        x,#1
            BEQ         WRITE_EVEN_PIXEL_PutVerticalSlice_Color			@ EVEN = PARELL

            @ Escriptura de pixel senar...

            AND     aux1,     aux1,        #255           @ r4 <- Color_Textura & 0xFF  (Machaquem el 8 bits de MES PES -Pixel senar-)
            ORR     aux1,     aux1,   color,  LSL   #8       @ r4 <- (Pixel_Textura << 8) | r4 ( Guardem pixel senar)

            B           WRITE_DST_PTR_PutVerticalSlice_Color

            @else // Volem escriure pixel parell, per aix cal salvarguardar el pixel senar de la

WRITE_EVEN_PIXEL_PutVerticalSlice_Color:

            @ Escriptura de pixel parell...

            MOV     aux1,     aux1,        LSR   #8              @ r9 <- r9 >> 8  (Machaquem el 8 bits de MENYS PES -Pixel parell-)
            ORR     aux1,     color,   aux1,  LSL   #8           @ r9 <- Pixel_Textura | r9 ( Guardem pixel parell)


@@@@2@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@2@@@@@@@@@@@@@@@@@@

.endif

WRITE_DST_PTR_PutVerticalSlice_Color:
@			*dest_ptr = ptr_textura[v_actual];

            STRH    aux1,[ptr_dst],#240

@           y2d --;

            SUBS    y2d, y2d, #1
		
@		}while(y2d > 0);
	
		BNE     LOOP_PutVerticalSlice_Color
		B Acaba_PutVerticalSlice
@}

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

ARM_PutVerticalSlice_COLOR_WITH_GLENZ:@(char *ptr_dst, int y2d, int color)
@{
       MOV     aux1,color
       ORR     aux1,aux1,color, lsl #8
 

LOOP_PutVerticalSlice_Color_With_Glenz:


@		do{

@

.ifdef __BAIX_NIVELL_X

@	{ No s'ha de fer res yupppiaeee XD }

.else

@@@@2@@@@@@@@- CARREGA PIXELS DE MEMORIA, EMMASCARANENT, i GUARDAT DEL PIXEL -@@@@2@@@@@@@@

            @ Crrega de pixels desde vram ...

            LDRH     aux1, [ptr_dst]           @ Carrega dels pixel vram. (Els 8 bits de MENYS pes s el PIXEL PARELL, i els bits de MS pes representa el PIXEL SENAR)

            @ Emmascarat del pixel a salvaguardar i escriptura del pixel de textura (r3)

            @ if( x == 1) // Volem escriure pixel senar, per aix cal guardar pixel parell

            TSTS        x,#1
            BEQ         WRITE_EVEN_PIXEL_PutVerticalSlice_Color_With_Glenz			@ EVEN = PARELL

            @ Escriptura de pixel senar...

            AND     aux1,     aux1,        #255           @ r4 <- Color_Textura & 0xFF  (Machaquem el 8 bits de MES PES -Pixel senar-)
            ORR     aux1,     aux1,   color,  LSL   #8       @ r4 <- (Pixel_Textura << 8) | r4 ( Guardem pixel senar)

            B           WRITE_DST_PTR_PutVerticalSlice_Color_With_Glenz

            @else // Volem escriure pixel parell, per aix cal salvarguardar el pixel senar de la

WRITE_EVEN_PIXEL_PutVerticalSlice_Color_With_Glenz:

            @ Escriptura de pixel parell...

            MOV     aux1,     aux1,        LSR   #8              @ r9 <- r9 >> 8  (Machaquem el 8 bits de MENYS PES -Pixel parell-)
            ORR     aux1,     color,   aux1,  LSL   #8           @ r9 <- Pixel_Textura | r9 ( Guardem pixel parell)


@@@@2@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@2@@@@@@@@@@@@@@@@@@

.endif

WRITE_DST_PTR_PutVerticalSlice_Color_With_Glenz:
@			*dest_ptr = ptr_textura[v_actual];

            STRH    aux1,[ptr_dst],#240

@           y2d --;

            SUBS    y2d, y2d, #1
		
@		}while(y2d > 0);
	
		BNE     LOOP_PutVerticalSlice_Color_With_Glenz
		B Acaba_PutVerticalSlice
@}

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

ARM_PutVerticalSlice_BLOCK_VPOW2_WITHOUT_EFFECT:@(char *ptr_dst, char *ptr_src, int y2d, int V, int Escale_FX, int mask_v, int log2_U)
@{
LOOP_PutVerticalSlice_Block_VPOW2_Without_effect:


@		do{

@			v_actual = ((v >> PART_FRACCIONAL) & Mascara_Altura_Textura);

            AND     aux1, mask_v, V, lsr #16
			 

@			color <- ptr_textura[v_actual];


            MOV		 aux1, aux1, lsl log2_U
			LDRB     color, [ptr_src, aux1]

			ADD     V,V,Escale_FX

@           intensitat
.ifdef __WITH_LIGHT__
 @           LDRB      color,[ptr_intensitat, color, lsl #8]
.endif


.ifdef __BAIX_NIVELL_X



			SUBS    y2d, y2d, #1
            ORR     aux1,color,color, lsl #8

.else

@@@@2@@@@@@@@- CARREGA PIXELS DE MEMORIA, EMMASCARANENT, i GUARDAT DEL PIXEL -@@@@2@@@@@@@@

            @ Crrega de pixels desde vram ...

            LDRH     aux1, [ptr_dst]           @ Carrega dels pixel vram. (Els 8 bits de MENYS pes s el PIXEL PARELL, i els bits de MS pes representa el PIXEL SENAR)

            @ Emmascarat del pixel a salvaguardar i escriptura del pixel de textura (r3)

            @ if( x == 1) // Volem escriure pixel senar, per aix cal guardar pixel parell

            TSTS        x,#1
            BEQ         WRITE_EVEN_PIXEL_LOOP_PutVerticalSlice_Block_VPOW2_Without_effect

            @ Escriptura de pixel senar...

            AND     aux1,     aux1,        #255           @ r4 <- Color_Textura & 0xFF  (Machaquem el 8 bits de MES PES -Pixel senar-)
            ORR     aux1,     aux1,   color,  LSL   #8       @ r4 <- (Pixel_Textura << 8) | r4 ( Guardem pixel senar)

            B           WRITE_DST_PTR_PutVerticalSlice_Block_VPOW2_Without_effect

            @else // Volem escriure pixel parell, per aix cal salvarguardar el pixel senar de la

WRITE_EVEN_PIXEL_LOOP_PutVerticalSlice_Block_VPOW2_Without_effect:
            @ Escriptura de pixel parell...

            MOV     aux1,     aux1,        LSR   #8           @ r9 <- r9 >> 8  (Machaquem el 8 bits de MENYS PES -Pixel parell-)
            ORR     aux1,     color,   aux1,  LSL   #8           @ r9 <- Pixel_Textura | r9 ( Guardem pixel parell)


@@@@2@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@2@@@@@@@@@@@@@@@@@@

.endif

WRITE_DST_PTR_PutVerticalSlice_Block_VPOW2_Without_effect:

@			*dest_ptr = ptr_textura[v_actual];

            STRH    aux1,[ptr_dst],#240

@			v += Escale_v;
            

@           y2d --;

            
		
@		}while(y2d > 0);
	
           BNE     LOOP_PutVerticalSlice_Block_VPOW2_Without_effect
		   B Acaba_PutVerticalSlice
@}

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

ARM_PutVerticalSlice_SPRITE_VPOW2_WITHOUT_EFFECT:@(char *ptr_dst, char *ptr_src, int y2d, int V, int Escale_FX, int mask_v, int log2_U)
@{
@{
LOOP_PutVerticalSlice_Sprite_VPOW2_Without_effect:


@		do{

@			v_actual = ((v >> PART_FRACCIONAL) & Mascara_Altura_Textura);

            AND     aux1, mask_v, V, lsr #16

@			color <- ptr_textura[v_actual];


            MOV		 aux1, aux1, lsl log2_U
			LDRB     color, [ptr_src, aux1]

			ADD     V,V,Escale_FX

@           intensitat
.ifdef __WITH_LIGHT__
 @           LDRB      color,[ptr_intensitat, color, lsl #8]
.endif


.ifdef __BAIX_NIVELL_X



			SUBS    y2d, y2d, #1
            ORR     aux1,color,color, lsl #8

.else

@@@@2@@@@@@@@- CARREGA PIXELS DE MEMORIA, EMMASCARANENT, i GUARDAT DEL PIXEL -@@@@2@@@@@@@@

            @ Crrega de pixels desde vram ...

            LDRH     aux1, [ptr_dst]           @ Carrega dels pixel vram. (Els 8 bits de MENYS pes s el PIXEL PARELL, i els bits de MS pes representa el PIXEL SENAR)

            @ Emmascarat del pixel a salvaguardar i escriptura del pixel de textura (r3)

            @ if( x == 1) // Volem escriure pixel senar, per aix cal guardar pixel parell

            TSTS        x,#1
            BEQ         WRITE_EVEN_PIXEL_LOOP_PutVerticalSlice_Sprite_VPOW2_Without_effect

            @ Escriptura de pixel senar...

            AND     aux1,     aux1,        #255           @ r4 <- Color_Textura & 0xFF  (Machaquem el 8 bits de MES PES -Pixel senar-)
            ORR     aux1,     aux1,   color,  LSL   #8       @ r4 <- (Pixel_Textura << 8) | r4 ( Guardem pixel senar)

            B           WRITE_DST_PTR_PutVerticalSlice_Sprite_VPOW2_Without_effect

            @else // Volem escriure pixel parell, per aix cal salvarguardar el pixel senar de la

WRITE_EVEN_PIXEL_LOOP_PutVerticalSlice_Sprite_VPOW2_Without_effect:
            @ Escriptura de pixel parell...

            MOV     aux1,     aux1,        LSR   #8           @ r9 <- r9 >> 8  (Machaquem el 8 bits de MENYS PES -Pixel parell-)
            ORR     aux1,     color,   aux1,  LSL   #8           @ r9 <- Pixel_Textura | r9 ( Guardem pixel parell)


@@@@2@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@2@@@@@@@@@@@@@@@@@@

.endif

WRITE_DST_PTR_PutVerticalSlice_Sprite_VPOW2_Without_effect:

@			*dest_ptr = ptr_textura[v_actual];

            STRH    aux1,[ptr_dst],#240

@			v += Escale_v;
            

@           y2d --;

            
		
@		}while(y2d > 0);
	
 BNE     LOOP_PutVerticalSlice_Sprite_VPOW2_Without_effect
B Acaba_PutVerticalSlice
@}

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

ARM_PutVerticalSlice_BLOCK_VPOW2_WITH_EFFECT:@(char *ptr_dst, char *ptr_src, int y2d, int V, int Escale_FX, int mask_v, int log2_U, int Propietats)
@{
LOOP_PutVerticalSlice_Block_VPOW2_With_effect:


@		do{

@			v_actual = ((v >> PART_FRACCIONAL) & Mascara_Altura_Textura);

            AND     aux1, mask_v, V, lsr #16
@            MOV     aux1, aux1

@			color <- ptr_textura[v_actual];


            MOV		 aux1, aux1, lsl log2_U
			LDRB     color, [ptr_src, aux1]

			ADD     V,V,Escale_FX

@           intensitat
.ifdef __WITH_LIGHT__
 @           LDRB      color,[ptr_intensitat, color, lsl #8]
.endif


.ifdef __BAIX_NIVELL_X

@            MOV     r12, r3

			SUBS    y2d, y2d, #1
            ORR     aux1,color,color, lsl #8

.else

@@@@2@@@@@@@@- CARREGA PIXELS DE MEMORIA, EMMASCARANENT, i GUARDAT DEL PIXEL -@@@@2@@@@@@@@

            @ Crrega de pixels desde vram ...

            LDRH     aux1, [ptr_dst]           @ Carrega dels pixel vram. (Els 8 bits de MENYS pes s el PIXEL PARELL, i els bits de MS pes representa el PIXEL SENAR)

            @ Emmascarat del pixel a salvaguardar i escriptura del pixel de textura (r3)

            @ if( x == 1) // Volem escriure pixel senar, per aix cal guardar pixel parell

            TSTS        x,#1
            BEQ         WRITE_EVEN_PIXEL_LOOP_PutVerticalSlice_Block_VPOW2_With_effect

            @ Escriptura de pixel senar...

            AND     aux1,     aux1,        #255           @ r4 <- Color_Textura & 0xFF  (Machaquem el 8 bits de MES PES -Pixel senar-)
            ORR     aux1,     aux1,   color,  LSL   #8       @ r4 <- (Pixel_Textura << 8) | r4 ( Guardem pixel senar)

            B           WRITE_DST_PTR_PutVerticalSlice_Block_VPOW2_With_effect

            @else // Volem escriure pixel parell, per aix cal salvarguardar el pixel senar de la

WRITE_EVEN_PIXEL_LOOP_PutVerticalSlice_Block_VPOW2_With_effect:
            @ Escriptura de pixel parell...

            MOV     aux1,     aux1,        LSR   #8           @ r9 <- r9 >> 8  (Machaquem el 8 bits de MENYS PES -Pixel parell-)
            ORR     aux1,     color,   aux1,  LSL   #8           @ r9 <- Pixel_Textura | r9 ( Guardem pixel parell)


@@@@2@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@2@@@@@@@@@@@@@@@@@@

.endif

WRITE_DST_PTR_PutVerticalSlice_Block_VPOW2_With_effect:

@			*dest_ptr = ptr_textura[v_actual];

            STRH    aux1,[ptr_dst],#240

@			v += Escale_v;
            

@           y2d --;

            
		
@		}while(y2d > 0);
	
           BNE     LOOP_PutVerticalSlice_Block_VPOW2_With_effect
		   B Acaba_PutVerticalSlice

@}

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

ARM_PutVerticalSlice_SPRITE_VPOW2_WITH_EFFECT:@(char *ptr_dst, char *ptr_src, int y2d, int V, int Escale_FX, int mask_v, int log2_U, int Propietats)
@{
B Acaba_PutVerticalSlice
@}

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

ARM_PutVerticalSlice:
@{


 @   //
 @   // Carrega de informaci...
 @   //
 @   x                       = PPP->x;
 @   y1                      = PPP->y1;
 @   y2                      = PPP->y2;
 @   U                       = PPP->u1;
 @   V                       = PPP->v1;
 @   Escale_FX               = PPP->Escale_v;
 @   ID_Textura              = PPP->ID_Textura;
 @   Intensitat              = PPP->Intensitat;
 @   Transparencia           = PPP->Transparencia;
 @   Propietats              = PPP->Propietats_Objecte;

   STMFD   sp!, {r0-r12,r14}                        @ empilem registres	
    
 @   // Filtre per si l' interval a pintar es vlid...
 @  if(y1 < 0 || y2 >= ALTURA_PANTALLA_EFECTIVA || y2 < 0 || y1 >= ALTURA_PANTALLA_EFECTIVA || y1 > y2) return;

	LDMIA	r0,{r0-r9}
   
    
	CMP     y1,#0
    BMI     Acaba_PutVerticalSlice
    CMP     y1,#ALTURA_PANTALLA_EFECTIVA
    BCS     Acaba_PutVerticalSlice
    CMP     y1,y2
    BGT     Acaba_PutVerticalSlice

    CMP     y2,#0
    BMI     Acaba_PutVerticalSlice
    CMP     y2,#ALTURA_PANTALLA_EFECTIVA
    BCS     Acaba_PutVerticalSlice

@	y2d = y2 - y1 + 1;

    SUB     y2d,y2,y1
    ADD     y2d,y2d,#1
    
    
@   // Punter desti...
 @   ptr_dst = (char *)(WORK_VRAM + AMPLADA_PANTALLA*(y1 << DETALL_GRAFIC_Y) + (x << DETALL_GRAFIC_X));
    
.ifdef __BAIX_NIVELL_X
    MOV     aux1,x, lsl #1                     @ r1 <- (x << 1)
.else
    MOV     aux1,x
    BIC     aux1, aux1, #1                        @ r1 <- r1 & 0xFFFFFFFE  (Perqu les lectures a VRAM (16 bits) s'afectuen de forma alineada, o sigui, s'ha de llegir mitja paraula (16 bits) des de columnes parells.)
.endif

	
	MOV     aux2, y1, lsl #8
	SUB	    aux2, aux2, y1, lsl #4

	LDR		ptr_dst, .ptr_video
	LDR		ptr_dst,[ptr_dst]
	ADD		ptr_dst, ptr_dst, aux1
	ADD		ptr_dst, ptr_dst, aux2

 @   ptr_intensitat    = ((char *)Shade + Intensitat);

	MOV		aux1, Intensitat
	LDR		ptr_intensitat,.ptr_shade
	ADD		ptr_intensitat, ptr_intensitat, aux1
@   ptr_transparencia = ((char *)Glenz + Transparencia);

    

    
 @   if(ID_Textura < 0) // Pintat d'un sol color...
	 CMP		ID_Textura, #0
	 BGE		Paint_With_Texture		
 @   {
 @       color = (-ID_Textura)&0xFF;
		 RSB	 ID_Textura, ID_Textura, #0
		 AND	 color, ID_Textura, #0xFF

 @       if(RENDER_WITH_BRIGHT(Propietats))
		 RENDER_WITH_BRIGHT	 Propietats
		 BEQ	Continue_Paint_Color_Without_Bright
 @       {
 @           color = ptr_intensitat[color];
 @       }
Continue_Paint_Color_Without_Bright:

 @       if(1)     SDL_PutVerticalSlice_COLOR(ptr_dst, y2d,color);
 @       else      SDL_PutVerticalSlice_COLOR_WITH_GLENZING(ptr_dst, y2d,color);

		RENDER_WITH_GLENZ		Propietats
		BNE						ARM_PutVerticalSlice_COLOR
		B						ARM_PutVerticalSlice_COLOR_WITH_GLENZ
        
 @   }
 @   else // Pintat amb textura...

 Paint_With_Texture:

 @   {       
 @      // Punter Textura...
 @       // Offset en bytes tamany info textura...
 @       aux1 = Sizeof_tTextura*ID_Textura;
		 LDR	aux1,.SIZEOF_TEXTURA
		 LDR	aux1,[aux1]
		 MUL	aux1,ID_Textura, aux1

 @       void_ptr = (char *)Textura;
		 LDR		void_ptr,.ptr_textura
		 LDR		void_ptr,[void_ptr]	@.ptr_textura


 @       // Punter + offset a la info de textura...
 @       void_ptr = ((char *)void_ptr + aux1);
		 ADD		void_ptr,void_ptr, aux1


 @      // Llegim propietats de imatge...
 @      aux1 = (int)((char *)void_ptr)[0x2*4];
		LDR		Propietats_Imatge,[void_ptr,#0x8]



 @      // Mirem si s potencia de 2...
 @      if(!V_POWER_OF_2(aux1) || !U_POWER_OF_2(aux1)) return;
		IS_VPOW2		Propietats_Imatge
		BEQ				Acaba_PutVerticalSlice
		IS_UPOW2		Propietats_Imatge
		BEQ	     		Acaba_PutVerticalSlice

		
 @      // Determinar si la textura representa un panorama...
 @      if(IS_PANORAMA(aux1)) // En principi no hi ha pintat de efectes (perqu ho vols?)...
		IS_PANORAMA	Propietats_Imatge
		BEQ	Paint_With_Perspective
 @      {
           
		B Acaba_PutVerticalSlice
 @      }
 @      else // Pintat amb perspectiva, enmascarar UV, calcular mipmap, etc.
 Paint_With_Perspective:
 @      {

            
 @        //  short Propietats_Objecte = (PPP->Propietats >> 16);

            
 @          // Calculem mipmaps...
 @          aux1 = Escale_FX >> 16;
			MOV		aux1, Escale_FX, asr #16

 @          MIPmap_Adequat = 0;
			MOV		MIPmap_Adequat, #0

 @          while ((aux1 > 1)) {aux1 = aux1 >> 1; MIPmap_Adequat = MIPmap_Adequat+1;}
Seguir_Obtencio_MipMap:				

			CMP		aux1,#0
			BLE		Exit_Obtencio_MipMap
			MOV		aux1,aux1,asr #1
			ADD		MIPmap_Adequat,MIPmap_Adequat,#1
			B		Seguir_Obtencio_MipMap

Exit_Obtencio_MipMap:

 @                      
 @          // Numero de NMipmaps (+1 reg aux)...
 @          aux1 = (int)((char *)void_ptr)[0x1*4];
			LDR		aux1,[void_ptr,#0x4]

 @                      
@			if(MIPmap_Adequat >= aux1)
			CMP		MIPmap_Adequat,aux1
@			{
@					MIPmap_Adequat = aux1-1;
					SUBGE		MIPmap_Adequat,aux1,#1
@			}
            
 @          // Carrega de punter mipmap (al punter textura. Donat que no ja no necessito ms punter Textura_Superior,
 @          // s'utilitzar void_ptr)...

			MOV			MIPmap_Adequat,#0

 @          // Actualitzem U,V, i Escala...
 @          U         = (U          >> MIPmap_Adequat);
			MOV			U,U , asr MIPmap_Adequat

 @          V         = (V          >> MIPmap_Adequat);
			MOV			V,V , asr MIPmap_Adequat

 @          Escale_FX = (Escale_FX  >> MIPmap_Adequat);
 			MOV			Escale_FX,Escale_FX, asr MIPmap_Adequat

 @          // Offset vector GFX_MipMap en bytes...
 @          aux1 = MIPmap_Adequat*Sizeof_tImatge;
			LDR		aux1,.SIZEOF_IMAGE
			LDR		aux1,[aux1]
			MUL		aux1, MIPmap_Adequat, aux1

 @          // Obtenim punter mipmap...
 @          void_ptr = *((int **)void_ptr);
			LDR		void_ptr,[void_ptr]
            
 @          // Punter mitmap mitjanat offset aux1...
 @          void_ptr = ((char *)void_ptr + aux1);
			ADD		void_ptr, void_ptr, aux1

 @          // Mascares UV...
 @          log2_U = (int)((char *)void_ptr)[0x4*3]; // Lectura del log2 U en format 16.16
			
			LDR		log2_U, [void_ptr, #0xc]


 @          aux1 = (1 << log2_U);
			MOV		aux1, #1
			MOV		aux1,aux1,lsl log2_U

 @          aux1 = aux1 - 1;
			SUB		aux1, aux1, #1

 @          aux1 = aux1 & (U >> 8); // U esta en APF 16.8
			AND		aux1, aux1, U, asr #8

 @          // Punter pixels de la textura...
 @          ptr_src  = (((int *)void_ptr)[0x4*0]);
			LDR		ptr_src, [void_ptr]

 @          //  + Offset U.
 @          ptr_src  = ptr_src + aux1;
			ADD		ptr_src, ptr_src, aux1


 @          // mascara V
 @          log2_V = (int)((char *)void_ptr)[0x4*4]; // Lectura del log2 V en format 16.16         
			LDR		aux1 ,[void_ptr, #16]
			
 @          mask_v = (1 << log2_V);
			MOV	mask_v,#1
			MOV	mask_v,mask_v,asl aux1

 @          mask_v = mask_v-1;
			SUB		mask_v, mask_v, #1

			
 @          // Log2 U 
 @          //log2_U   =    (int)((char *)void_ptr)[0x4*6];

@			B   ARM_PutVerticalSlice_BLOCK_VPOW2_WITHOUT_EFFECT



 @          // Mirem si pintem textura amb efecte...
 @          if() // Pintat sense efecte...
 			CMP		Propietats,#0
			BNE		Paint_With_Effect
 @          {
 @              // Mirem si es de tipus sprite...
 @              if(1) // No ho s..
 @                  SDL_PutVerticalSlice_BLOCK_VPOW2_WITHOUT_EFFECT(ptr_dst, ptr_src, y2d, V, Escale_FX, mask_v, log2_U);
 @              else // Ho s...
 @                  SDL_PutVerticalSlice_SPRITE_VPOW2_WITHOUT_EFFECT(ptr_dst, ptr_src, y2d, V, Escale_FX, mask_v, log2_U);

				IS_SPRITE	Propietats_Imatge
				BEQ			ARM_PutVerticalSlice_BLOCK_VPOW2_WITHOUT_EFFECT
				BNE			ARM_PutVerticalSlice_SPRITE_VPOW2_WITHOUT_EFFECT


                
 @          }
 @          else // Pintat amb efecte mirem al mateix codi, el color de mascara.
 @          {
Paint_With_Effect:

 @             // Mirem si es de tipus sprite...
 @              if(1) // No ho s...
 @                  SDL_PutVerticalSlice_BLOCK_VPOW2_WITH_EFFECT(ptr_dst, ptr_src, y2d, V, Escale_FX, mask_v, log2_U,Propietats);
 @              else // Ho s...
 @                  SDL_PutVerticalSlice_SPRITE_VPOW2_WITH_EFFECT(ptr_dst, ptr_src, y2d, V, Escale_FX, mask_v, log2_U,Propietats);

 				IS_SPRITE	Propietats_Imatge
				BEQ			ARM_PutVerticalSlice_BLOCK_VPOW2_WITH_EFFECT
				BNE			ARM_PutVerticalSlice_SPRITE_VPOW2_WITH_EFFECT
                
 @          }
            
 @      }
 @  }

Acaba_PutVerticalSlice:

   LDMFD    sp!, {r0-r12,r14}                        @ empilem registres	    
   BX		lr
    
@}


ARM_PutHorizontalSlice:


	BX		lr
