@   Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
@   Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
@
@   This file is part of Jespa3D Engine.
@
@   Jespa3D Engine is free software; you can redistribute it and/or modify
@   it under the terms of the GNU General Public License as published by
@   the Free Software Foundation; either version 2 of the License, or
@   (at your option) any later version.
@
@   Jespa3D Engine is distributed in the hope that it will be useful,
@   but WITHOUT ANY WARRANTY; without even the implied warranty of
@   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
@   GNU General Public License for more details.
@
@   You should have received a copy of the GNU General Public License
@   along with Jespa3D Engine; ; see the file COPYING. if not, write to 
@   the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
@   Boston, MA  02111-1307  USA


@ /***********************\
@ | ZONA MEMORIA i TAMANY  |
@ \***********************/

.SECTION .iwram,"ax",%progbits
.ARM
.ALIGN



@ /***********************\
@ | PROTOTIPUS DE FUNCIONS |
@ \***********************/


.GLOBL   ARM_PutSprite
.TYPE    ARM_PutSprite, function



@ /**************************\
@ | IMPLEMENTACIO DEFUNCIONS |
@ \**************************/


ARM_PutSprite:

@
@Recordant l'estructura, del pas de parametres per aquesta funci, en C,
@
@ typedef struct _tParametresScanLineVertical{
@
@	int pos_x, pos_y, amplada, altura, mascara;
@	char *src
@
@ }tParametresScanLineVertical;
@
@
@

@ Utilitzaci de registres i variables compreses
@ ----------------------------------------------
@
@ r0  = parametre punter a l'estructura tParametresPuSprite, pos_x, dest_ptr 
@ r1  = pos_y, src_ptr
@ r2  = amplada 
@ r3  = altura,x_text
@ r4  = mascara
@ r5  = src,y_text,y
@ r6  = aux,x
@ r7  = aux,x1,x2d
@ r8  = aux,x2
@ r9  = aux,y1,y2d
@ r10 = aux,y2

@	int x,y,y_text, x_text, y1, y2, x1 , x2;
@	char *dest_ptr, *src_ptr,color;

    STMFD   sp!, {r4-r11}            @ Store registers

	LDMIA	r0,{r0-r5}

@	if(((y_pos+altura_block) < 0) || ((y_pos) >= ALTURA_PANTALLA) || ((x_pos + amplada_block) < 0) || (x_pos >= AMPLADA_PANTALLA)) return;

	MOV	r6,r1
	ADD	r6,r6,r3
	CMP	r6,#0
	BLT	_AcabaPutSprite

	CMP	r1,#160
	BGE	_AcabaPutSprite

	MOV	r6,r0
	ADD	r6,r6,r2
	CMP	r6,#0
	BLT	_AcabaPutSprite

	CMP	r0,#240
	BGE	_AcabaPutSprite
	
@	else
@	{
@		y1 = max(0,y_pos);

		CMP	r1,#0
		BGE	_Agafar_Y_POS1
		
		EOR	r9,r9,r9
		B	_Continua_PutSprite_1
		
_Agafar_Y_POS1:

		MOV	r9,r1

_Continua_PutSprite_1:
@
@		y2 = min(ALTURA_PANTALLA-1,(y_pos+altura_block));
@

		MOV	r10,r1
		ADD	r10,r10,r3
		CMP	r10,#239
		BLE	_Continua_PutSprite_2
		
		MOV	r10,#159		

_Continua_PutSprite_2:
@
@		x1 = max(0,x_pos);
@

		CMP	r0,#0
		BGE	_Agafar_X_POS1
		
		EOR	r7,r7,r7
		B	_Continua_PutSprite_3
_Agafar_X_POS1:

		MOV	r7,r0

_Continua_PutSprite_3:

@
@		x2 = min(AMPLADA_PANTALLA-1,(x_pos+amplada_block));
@

		MOV	r8,r0
		ADD	r8,r8,r2
		CMP	r8,#239
		BLT	_Continua_PutSprite_4
		
		MOV	r8,#239		

_Continua_PutSprite_4:

@
@		y_text = y1 - y_pos;
@

		MOV	R6,R5
		SUB	r5,r9,r1
		
@		
@		x_text = x1 - x_pos;
@

		SUB	r3,r7,r0

@
@		dest_ptr = (char *)(dest + AMPLADA_PANTALLA*y1 + x1);
@		
		
@ START - F_DISCNT_BUFSEL_GET
        MOV     r0,     #0x04000000                 @ r0 = 0x04000000
        LDR     r1,     [r0]                        @ r1 = val from addr 0x04000000
        AND     r1,     r1,     #0x10               @ r1 = r1 & 0x10
        MOV     r1,     r1,     LSR #4              @ r1 = r1 >> 4
@ End - F_DISCNT_BUFSEL_GET
        

        MOV     r0,     r9,     LSL #8
        SUB     r0,     r0,     r9,      LSL #4
        ADD     r0,     r0,     r7                  @ r3 = r3 + x
        ADD     r0,     r0,     #0x6000000          @ r3 = r3 + VRAM_ADDR

        CMP     r1,     #1                          @ r4 == 1
        BNE     .CalcVRamAddr2						    @ != 1
	B	Calcular_SRC

.CalcVRamAddr2:	   
	ADD	r0,r0,#0xA000


Calcular_SRC:
@       src_ptr = (char *)(src + y_text*amplada_block + x_text);



	MUL	r1,r5,r2
	ADD	r1,r1,r3
	ADD	r1,r1,r6

@	y2d = y2 - y1

	SUB	r6,r10,r9

@	x2d = x2 - x1

	SUB	r7,r8,r7
	
    MOV r10,#0
    SUB r10,r10,#2


@@@@@@@@@@@@@@@@@@@@@@@- BUCLE PRINCIPAL DEL PINTAT SPRITE -@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



Mentre_Y:		                     

	MOV	R5,r7     @ x = x2
Mentre_X:

	LDRB	r8,[r1],#1	  @ Color = *(src++);

	CMP	r8,r4

	BEQ	No_Pinta_Pixel

					@ Pintem pixel...

    AND     r11, r0, r10
	LDRH    r9,[r11]			@ Llegim 16 bits de video...
				
	TSTS  r0,#1			@ dst & (0x1)

        BEQ   Pixel_Parell_H

					@ Machaquem la posici senar (8 bits de menys pes)...

         AND     r9,r9,#0xFF              @ r9 = r9 & 0xFF
         ORR     r9,r9,r8,LSL #8         @ r9 = r9 | (r8 >> 8)

         B       _Continua_PutSprite_5

Pixel_Parell_H:  			@ Machaquem la posici parell (8 bits de ms pes)...

          MOV  r9,r9,LSR #8                 @ r8 = r9 >> 8
          ORR  r9,r8,r9,LSL #8              @ r9 = r8 | r9 << 8

_Continua_PutSprite_5:            				

 
        STRH	r9,[r0]	 	 @ *((short *)(ptr_video)) = Color; ptr_video += 240;

No_Pinta_Pixel:	
	
	
    ADD     r0,r0,#1
	SUBS	R5,R5,#1				
	BNE	Mentre_X

					@ dest_ptr += (AMPLADA_PANTALLA-amplada_block);



    ADD	r0,r0,#240
	SUB	r0,r0,r2

					@ src_ptr += x_text;

	ADD	r1,r1,r3
	

	SUBS	R6,R6,#1
	BNE  	Mentre_Y        
                                            				


@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@				
				
_AcabaPutSprite:

        LDMFD   sp!, {r4-r11}            @ Restore registers
        BX      lr





