//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA





#include "Animacio.h"

#include "GFX/IncludeC/info_animations.c"


PAnimacio *TaulaAnimacions
#ifdef __HAM__
MEM_IN_EWRAM
#endif
;

char		ID_PAISATGE_ANIMATION 
#ifdef __HAM__
MEM_IN_EWRAM
#endif
;

void Afegir_Frame(PFrame *LlistaFrames, tTextura *Textura, int Modul_Temps_Proxim_Frame)
{
	PFrame NouFrame, Node_Actual;


	//NouFrame = (PFrame) malloc(sizeof(tFrame));
	Reservar_Memoria(NouFrame,tFrame,1);

	if(NouFrame == NULL)
	{
		//
		return;
	}
	else
	{
		NouFrame->Textura     = Textura;
		NouFrame->ModulTemps = Modul_Temps_Proxim_Frame;

		if(*LlistaFrames == NULL) // primer frame...
		{
			*LlistaFrames = NouFrame;
			
			(*LlistaFrames)->PProximFrame = *LlistaFrames; // llista encadenada. :)
		
		}
		else // + de un frame
		{
			Node_Actual = NouFrame->PProximFrame = *LlistaFrames;

			// Busquem l'ultim node per enganxar-lo amb el primer...

			while(Node_Actual->PProximFrame != *LlistaFrames) Node_Actual = Node_Actual->PProximFrame;
			
			Node_Actual->PProximFrame = (*LlistaFrames) = NouFrame;						
		}
	
	}


}


int Ini_Animacions()
{
	PFrame LlistaFrames = NULL;
//	PAnimacio p;
	int i,ani,ok = CERT;

	i = 0;

//	TaulaAnimacions = (PAnimacio *)malloc(sizeof(PAnimacio)*NANIMATIONS);

	Reservar_Memoria(TaulaAnimacions, PAnimacio, N_ANIMATIONS);

	if(TaulaAnimacions == NULL)
	{

        PRINT_ERROR("\n No s'ha pogut assignar memoria a la taula animacions!",0);
        return FALS;
    }
	
	for(i = 0; i < N_ANIMATIONS && ok; i++)
	{
	//	p = (PAnimacio)malloc(sizeof(tAnimacio));
	//	TaulaAnimacions[i] = (PAnimacio)malloc(sizeof(tAnimacio));

		Reservar_Memoria(TaulaAnimacions[i], tAnimacio, 1);
		
		if(TaulaAnimacions[i] == NULL) ok = FALS;
	}

	
	if(!ok)
	{

        PRINT_ERROR("\nNO hi ha suficient memoria per inicialitzar %ia animaci!",i+1);
		return FALS;
	}

	for(ani = 0; ani < N_ANIMATIONS; ani++)
	{
		LlistaFrames = NULL;
		
		for(i = 0; i <= N_IMAGES; i++)
		{
			if(Info_Animation[i].n_animation == ani)
			{
				Afegir_Frame(&LlistaFrames, &Textura[Info_Animation[i].id_image], 0x1F);
			}
			
			
		}
		
		//Assignacio llista de frames a la taula...
		
		TaulaAnimacions[ani]->Textura = LlistaFrames->Textura;
		TaulaAnimacions[ani]->Frame  = LlistaFrames;
	}

	return CERT;

}


void Borrar_Animacio(PFrame LlistaFrames)
{
	PFrame Node_Actual, PrimerNode;

	PrimerNode = LlistaFrames;


	while(LlistaFrames->PProximFrame != PrimerNode)
	{
		Node_Actual = LlistaFrames;

		LlistaFrames = LlistaFrames->PProximFrame;

		Alliberar_Punter(Node_Actual);
		
	}

	// Alliberem l'ultim node...
	Alliberar_Punter(PrimerNode);	

}
