//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA

#ifndef __ANIMACIO_H__
#define __ANIMACIO_H__

#include "Textura.h"
#include "memoria.h"
#include "definicions.h"
#include "GFX\IncludeC\info_animations.h"


// Tipus definits...

typedef struct  _tFrame  *PFrame;

typedef struct _tFrame{
	
	tTextura *Textura;
	PFrame  PProximFrame;
	int  ModulTemps;
	
}tFrame;


typedef struct  _tAnimacio  *PAnimacio;

typedef struct _tAnimacio{
	
	tTextura *Textura;
	PFrame   Frame;
	
}tAnimacio;

////////////////////////
// Variables globals...
///////////////////////


extern PAnimacio *TaulaAnimacions;
extern char		 ID_PAISATGE_ANIMATION;


//////////////////
// Prototipus...
//////////////////




int Ini_Animacions(void);
void Afegir_Frame(PFrame *LlistaFrames, tTextura *Textura, int ModulTemps);
void Borrar_Animacio(PFrame Llista);


#endif
