//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA


#ifndef ___ARITMETICA_H
#define ___ARITMETICA_H

///////////////////////////////////////////////////////////////
//															 //
//     DEFINICI DE LA CLASSE ARITMTICA FIXE 16:8   	     //
//														     //
// ------------------------------------------------------	 //
//														     //
//														     //
// jespa : u1034294@correu.udg.es						     //
//  \_____												     //
//														     //
// Agraiments a : Night Stalker                              //
//														     //
//														     //
///////////////////////////////////////////////////////////////



#include "stdio.h"
#include "math.h"

#ifdef __arm__  // Estem treballant sobre la plataforma GBA...
#define __ARITMETICA_FIXA__
#else // Estem treballant sobre un computadora que disposa de copoprocesador per reals... (plataforma SDL)
#define __ARITMETICA_FIXA__
#endif

// Operacions comunes APF i APR.

#define FIXED_SIGN(x) ((x) < 0 ? 1:0)

#ifdef _WINDOWS
			int WIN_MulFx_16_16(int num1,int num2);
			int WIN_MulFx_24_8(int num1,int num2);
			int WIN_DivFx_16_16(int numerador,int denominador);
			int WIN_DivFx_Entera(int numerador,int denominador);
#endif


#ifdef __ARITMETICA_REAL__

	typedef float   FIXED32;



	///////////////////////
	// DEFINICIONS  AR   //
	///////////////////////

	#define ONE_FX			(1.0f)
	#define ONE_FX_16_16    (256.0f)

		
	//////////////////////
	// ...DE CONVERSI  //
	//////////////////////

	#define AJUST_ENTER			(0.49f)
	#define ONE_DIV_2_FX		(0.5f)
	#define ONE_DIV_2_FX_16_16  ONE_DIV_2_FX

	#define INT_TO_FIXED(x)	((float)(x))
	#define INT_TO_FIXED_16_16(x)     ((x)*256.0f)

	#define FIXED_TO_INT(x)  ((int)(x))

	#define ROUND_FIXED_TO_INT(x)  ((int)((x) + AJUST_ENTER))

	#define CEIL_FX(x)   ((int)ceil((x)))
	#define FLOOR_FX(x)  ((int)floor((x)))
	#define FLOOR_FX_16_16	FLOOR_FX
//	#define ROUND_FX(x)  ((int)floor((x) + AJUST_ENTER))

	#define ROUND_FX(x) (((x)<0)? CEIL_FX((x) - AJUST_ENTER) : FLOOR_FX((x) + AJUST_ENTER))

	#define CEIL_FX_16_16 CEIL_FX
	#define CEIL_FX_20_4 CEIL_FX


	#define RETORNA_PART_FRACCIONAL_FX_16_16(n)     	 (float)fmod(n,1)
	#define PARTIR_NUMERO_FX_16_16	 PARTIR_NUMERO_FX



	#define DOUBLE_TO_FIXED(x)	 ((float)(x))
	#define	DOUBLE_TO_FIXED_16_16((float)(x))
	#define FIXED_TO_DOUBLE(x)	 ((double)(x))

	#define MAX_FX 999999.9f
	#define MIN_FX -999999.9f

	#define OVERFLOW_FX(x) (x) >= 0 ? MAX_FX : MIN_FX;

	#define ABS_FX(x) (FIXED32)(fabs(x))

	#define FIXED_MUL_2(x) ((x)*2)
	#define FIXED_DIV_2(x) ((x)/2)

	#define FIXED_MUL_4(x) ((x)*4)	
	#define FIXED_DIV_4(x) ((x)/4)


	#define FIXED_MUL_8(x) ((x)*8)	
	#define FIXED_DIV_8(x) ((x)/8)

	#define FIXED_MUL_16(x) ((x)*16)	
	#define FIXED_DIV_16(x) ((x)/16)

	#define FIXED_MUL_32(x) ((x)*32)	
	#define FIXED_DIV_32(x) ((x)/32)
	
	#define FIXED_MUL_64(x) ((x)*64)	
	#define FIXED_DIV_64(x) ((x)/64)

	#define FIXED_MUL_128(x) ((x)*128)	
	#define FIXED_DIV_128(x) ((x)/128)


	#define FIXED_MUL_256(x) ((x)*256)	
	#define FIXED_DIV_256(x) ((x)/256)

	#define FIXED_MUL_512(x) ((x)*512)	
	#define FIXED_DIV_512(x) ((x)/512)

	#define FIXED_MUL_1024(x) ((x)*1024)	
	#define FIXED_DIV_1024(x) ((x)/1024)
	
	#define FIXED_MUL_4096(x) ((x)*4096)	
	#define FIXED_DIV_4096(x) ((x)/4096)

	#define FIXED_MUL_16384(x) ((x)*16384)
	#define FIXED_DIV_16384(x) ((x)/16384)

	#define POWER_TWO_MUL(x,n_shifts) ((x)*(pow(2,(unsigned)(n_shifts))))
	#define POWER_TWO_DIV(x,n_shifts) ((x)/(pow(2,(unsigned)(n_shifts))))

    






	///////////////////////////////////
	// OPERACIONS ARITMETIQUES REALS //
	///////////////////////////////////



	#define MulFx(x,y) ((x)*(y))
	#define DivFx(x,y) ((x)/(y))
	#define MulFx_16_16 MulFx
	#define DivFx_16_16 DivFx

#endif

#if defined(__ARITMETICA_FIXA__) && (defined(_WINDOWS) || defined(__arm__)) // Podem fer servir APF a 32 bits :)...

	#define PART_ENTERA      16
	#define PART_FRACCIONAL  8


#else // Nomes podem fer us d'una aritmetica 16:8

	#define PART_ENTERA     16
	#define PART_FRACCIONAL 8

#endif


////////////////////////////////////////////
// DEFINCI DE LA CLASSE ARITMTICA 16:8 //
///////////////////////////////////////////


#ifdef __ARITMETICA_FIXA__

	typedef int   FIXED32;





	///////////////////////
	// DEFINICIONS  APF  //
	///////////////////////

	#define ONE_FX			(0x1 << PART_FRACCIONAL)
	#define ONE_FX_20_4		(0x1 << 4)
	#define ONE_FX_16_16    (0x1 << 16)

	#define ONE_DIV_2_FX    (ONE_FX >> 1)
	#define ONE_DIV_2_FX_16_16    (ONE_FX_16_16 >> 1)

		
	//////////////////////
	// ...DE CONVERSI  //
	//////////////////////

	#define AJUST_ENTER     ((0x1 << (PART_FRACCIONAL - 1)) - 1)

	#define INT_TO_FIXED(x)	((x) << PART_FRACCIONAL)

	#define INT_TO_FIXED_20_4(x)	((x) << 4)
	#define INT_TO_FIXED_16_16(x)	((x) << 16)

	#define FIXED_TO_INT(x)		   ((x) >> PART_FRACCIONAL)
	#define FIXED_TO_INT_20_4(x)   ((x) >> 4)
	#define FIXED_TO_INT_16_16(x)  ((x) >> 16)

	#define ROUND_FIXED_TO_INT(x)  (((x) >> PART_FRACCIONAL) + AJUST_ENTER)

	
	#define FLOOR_FX(x)			(((x) < 0) ?       (-FIXED_TO_INT      (-((x) - (ONE_FX      -1)))) : (FIXED_TO_INT(x)))
	#define FLOOR_FX_16_16(x)	((RETORNA_PART_FRACCIONAL_FX_16_16(x) == 0) ? (FIXED_TO_INT_16_16(x)) : (((x) < 0) ? (-FIXED_TO_INT_16_16(-((x) - (ONE_FX_16_16-1)))) : (FIXED_TO_INT_16_16(x))))
	#define CEIL_FX_16_16(x)	RETORNA_PART_FRACCIONAL_FX_16_16(x) == 0 ? FIXED_TO_INT_16_16(x) : (((x) >= 0) ? FIXED_TO_INT_16_16(((x) + (ONE_FX_16_16))) : -FIXED_TO_INT_16_16(-(x)))	
	#define CEIL_FX(x)			(((RETORNA_PART_FRACCIONAL_FX(x)) == 0) ? FIXED_TO_INT(x)		 : (((x) >= 0) ? (FIXED_TO_INT((      (x) + (ONE_FX))      )) : (FIXED_TO_INT((x)))))

	#define CEIL_FX_20_4(x)		(((x) >= 0) ? FIXED_TO_INT_20_4(((x) + (ONE_FX_20_4-1))) : -FIXED_TO_INT_20_4(-(x)))

	#define ROUND_FX(x) (((x)<0)? CEIL_FX((x) - AJUST_ENTER) : FLOOR_FX((x) + AJUST_ENTER))


	#define RETORNA_PART_FRACCIONAL_FX(n)		((n) & 0xFF)//(ONE_FX       - 1))
	#define RETORNA_PART_FRACCIONAL_FX_16_16(n) ((n) & (ONE_FX_16_16 - 1))








	#define DOUBLE_TO_FIXED(x)		 ((int)((x)*(ONE_FX)))
	#define DOUBLE_TO_FIXED_16_16(x) ((int)((x)*((ONE_FX) << 8)))
	#define FIXED_TO_DOUBLE(x) (((double) x) / ONE_FX)

	#define MAX_FX 0x7FFFFFFF
	#define MIN_FX 0x80000000

	#define OVERFLOW_FX(x) (x) >= 0 ? MAX_FX : MIN_FX;
	#define ABS_FX(x) abs(x)

	#define FIXED_MUL_2(x) ((x) << 1)		
	#define FIXED_DIV_2(x) ((x) >> 1)

	#define FIXED_MUL_4(x) ((x)<<2)	
	#define FIXED_DIV_4(x) ((x)>>2)

	#define FIXED_MUL_8(x) ((x)<<3)	
	#define FIXED_DIV_8(x) ((x)>>3)
	
	#define FIXED_MUL_16(x) ((x)<<4)	
	#define FIXED_DIV_16(x) ((x)>>4)

	#define FIXED_MUL_32(x) ((x)<<5)	
	#define FIXED_DIV_32(x) ((x)>>5)
	
	#define FIXED_MUL_64(x) ((x)<<6)	
	#define FIXED_DIV_64(x) ((x)>>6)

	#define FIXED_MUL_128(x) ((x)<<7)	
	#define FIXED_DIV_128(x) ((x)>>7)

	#define FIXED_MUL_256(x) ((x) << 8)	
	#define FIXED_DIV_256(x) ((x) >> 8)

	#define FIXED_MUL_512(x) ((x) << 9)	
	#define FIXED_DIV_512(x) ((x) >> 9)

	#define FIXED_MUL_1024(x) ((x) << 10)	
	#define FIXED_DIV_1024(x) ((x) >> 10)	
	
	#define FIXED_MUL_2048(x) ((x) << 11)	
	#define FIXED_DIV_2048(x) ((x) >> 11)	

	#define FIXED_MUL_4096(x) ((x)<<12)
	#define FIXED_DIV_4096(x) ((x)>>12)

	#define FIXED_MUL_16384(x) ((x)<<14)
	#define FIXED_DIV_16384(x) ((x)>>14)

	#define FIXED_MUL_65536(x) ((x)<<16)
	#define FIXED_DIV_65536(x) ((x)>>16)

	#define POWER_TWO_MUL(x,n_shifts) ((x) << (n_shifts))
	#define POWER_TWO_DIV(x,n_shifts) ((x) >> (n_shifts))


	// Rpida divisi d'una variable en punt fixe entre 5 aproximada amb desplaaments...
	#define FastDiv5Fx(n)\
	{\
		n = ((n >> 1) + n) >> 1;\
		n = ((n >> 4) + n)     ;\
		n = ((n >> 8) + n) >> 2;\
	}

	// Rpida divisi d'una variable en punt fixe entre 3 aproximada amb desplaaments...
	#define FastDiv3Fx(n)\
	{\
		n = ((n >> 2) + n) >> 1;\
		n = ((n >> 4) + n)     ;\
		n = ((n >> 8) + n) >> 1;\
	}

	#define FIXED_DIV_120(n)\
		FastDiv5Fx(n);\
		FastDiv3Fx(n);\
		n >>= 3;\

 #define FIXED_DIV_60(n)\
		FastDiv5Fx(n);\
		FastDiv3Fx(n);\
		n >>= 2;\

#define FastDiv10Fx(n)\
		n = ((n >> 1 ) + n) >> 1 ;\
		n = ((n >> 4 ) + n)      ;\
		n = ((n >> 8 ) + n)      ;\
		n = ((n >> 16) + n) >> 3 ;\

#define FastDiv960Fx(n)\
	FastDiv5Fx(n);\
	FastDiv3Fx(n);\
	n = (n >> 6);\
	
#define FastDiv320Fx(n)\
	FastDiv5Fx(n);\
	n = (n >> 6);\

	

	//////////////////////////////////////////
	// OPERACIONS ARITMETIQUES EN PUNT FIXE //
	//////////////////////////////////////////




		#ifdef _WINDOWS

			#define MulFx(x,y)  (((y)*(x)) >> PART_FRACCIONAL)
			#define DivFx(numerador,denominador)  (((numerador) << PART_FRACCIONAL)/(denominador))

			
		
			#define MulFx_16_16  WIN_MulFx_16_16
			#define DivFx_16_16  WIN_DivFx_16_16
			#define DivFx_Entera WIN_DivFx_Entera

		#endif

		#ifdef __arm__


			
			extern inline FIXED32 ARM_MulFx24(FIXED32 num1,FIXED32 num2);
			extern inline FIXED32 ARM_DivFx24(FIXED32 numerador,FIXED32 denominador);

   
            extern inline FIXED32 ARM_MulFx32(FIXED32 num1,FIXED32 nom2);
			extern inline FIXED32 ARM_DivFx32(FIXED32 numerador,FIXED32 denominador);
			extern inline FIXED32 ARM_DivFx_Entera(FIXED32 numerador,int denominador);
		
			#define DivFx_16_16  ARM_DivFx32
			#define MulFx_16_16  ARM_MulFx32
			
			#define MulFx(x,y)  (((y)*(x)) >> PART_FRACCIONAL)
      		#define DivFx        ARM_DivFx24
			#define DivFx_16_16  ARM_DivFx32
			#define DivFx_Entera ARM_DivFx_Entera
			
		#endif

		
			

			
	//	#endif
	//#endif
#endif



#define C_MulFx_16_16(num1, num2) ((s32)(((s64)((s64)(num1) * (s64)(num2))) >> 16))
#define C_DivFx_16_16(num ,  den) ((s32)(((s64)(num) << 16) / (s64)(den )))


#endif






