//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA



#include "main.h"
#include "Font.h"
#include "GFX/Fonts/Font.raw.c"	// Dades fonts monotextura.
//#include "GFX/IncludeC/Font2.raw.c" // Dades fonts sprite.
#include "ctype.h"

#ifdef __HAM__

 void itoa(int Numero,char *Cadena,int radix)
 {
    int Longitud;
	int Potencia;
    int i;
    
	Longitud = log10(abs(Numero));
    Potencia = pow(10,Longitud);
    
    for(i=0;i<=(Longitud);i++)
	{
		    Cadena[i] = 48 + Numero/Potencia; 
			Numero %= Potencia;
			Potencia /= 10;
	}
    
	Cadena[i] = '\0';
 }

#endif


int traduccio_caracter(char c)
{

 switch(c)
 {
  case '0':return 0;
  case '1':return 1;
  case '2':return 2;
  case '3':return 3;
  case '4':return 4;
  case '5':return 5;
  case '6':return 6;
  case '7':return 7;
  case '8':return 8;
  case '9':return 9;
  case ';':return 10; 
  case ':':return 11;
  case ',':return 12;
  case '!':return 13;
  case '.':return 14;
  case '':return 15;
  case '?':return 16;
  case '':return 17;
  case '(':return 18;
  case ')':return 19;
  case '-':return 20;
  case 'A':return 21;
  case 'B':return 22;
  case 'C':return 23;
  case '':return 24;
  case 'D':return 25;
  case 'E':return 26;
  case 'F':return 27;
  case 'G':return 28;
  case 'H':return 29;
  case 'I':return 30;
  case 'J':return 31;
  case 'K':return 32;
  case 'L':return 33;
  case 'M':return 34;
  case 'N':return 35;
  case 'O':return 36;
  case 'P':return 37;
  case 'Q':return 38;
  case 'R':return 39;
  case 'S':return 40;
  case 'T':return 41;
  case 'U':return 42;
  case 'V':return 43;
  case 'W':return 44;
  case 'X':return 45;
  case 'Y':return 46;
  case 'Z':return 47;
  
  default: return 48;
 }

}

int traduccio_caracter_Font2(char c)
{

 switch(c)
 {
  case 'A':return 0;
  case 'B':return 1;
  case 'C':return 2;
  case 'D':return 3;
  case 'E':return 4;
  case 'F':return 5;
  case 'G':return 6;
  case 'H':return 7;
  case 'I':return 8;
  case 'J':return 9;
  case 'K':return 10; 
  case 'L':return 11;
  case 'M':return 12;
  case 'N':return 13;
  case 'O':return 14;
  case 'P':return 15;
  case 'Q':return 16;
  case 'R':return 17;
  case 'S':return 18;
  case 'T':return 19;
  case 'U':return 20;
  case 'V':return 21;
  case 'W':return 22;
  case 'X':return 23;
  case 'Y':return 24;
  case 'Z':return 25;
  case '0':return 26;
  case '1':return 27;
  case '2':return 28;
  case '3':return 29;
  case '4':return 30;
  case '5':return 31;
  case '6':return 32;
  case '7':return 33;
  case '8':return 34;
  case '9':return 35;
  case '.':return 36;
  case ':':return 37;
  case ' ':return 38;
  case '-':return 39;
  default: return 38;
 }

}


void PutChar(u16 x, u16 y,u8 caracter,u16 alt_caracter, u8 textura_escullida,unsigned short negreta,unsigned short invert)
{
 u16 offset_inici,by;

 u8 getbyte;
 u8 offset_textura;


 offset_textura = textura_escullida*64;
 offset_inici = caracter*8;

         if(!invert)
         {
          for(by=0;by<alt_caracter;by++,offset_inici++)
          {
           getbyte = FntMonoText[offset_inici];
           if ((getbyte&128)!=0)
           {
            PutPixel(x,y+by,textura[offset_textura]);
            if(negreta) PutPixel(x+1,y+by+1,textura[offset_textura]);
           }
           offset_textura++;
           getbyte = FntMonoText[offset_inici];
           if ((getbyte&64)!=0) 
           {
            PutPixel(x+1,y+by,textura[offset_textura]);
            if(negreta) PutPixel(x+2,y+by+1,textura[offset_textura]);
           }
           offset_textura++;
           getbyte = FntMonoText[offset_inici];
           if ((getbyte&32)!=0) 
           { 
            PutPixel(x+2,y+by,textura[offset_textura]);
            if(negreta) PutPixel(x+3,y+by+1,textura[offset_textura]);
           }
           offset_textura++;
           getbyte = FntMonoText[offset_inici];
           if ((getbyte&16)!=0) 
           { 
            PutPixel(x+3,y+by,textura[offset_textura]);
            if(negreta) PutPixel(x+4,y+by+1,textura[offset_textura]);
           }
           offset_textura++;
           getbyte = FntMonoText[offset_inici];
           if ((getbyte&8)!=0) 
           { 
            PutPixel(x+4,y+by,textura[offset_textura]);
            if(negreta) PutPixel(x+5,y+by+1,textura[offset_textura]);
           }
           offset_textura++;
           getbyte = FntMonoText[offset_inici];
           if ((getbyte&4)!=0) 
           { 
            PutPixel(x+5,y+by,textura[offset_textura]);
            if(negreta) PutPixel(x+6,y+by+1,textura[offset_textura]);
           }
           offset_textura++;
           getbyte = FntMonoText[offset_inici];
           if ((getbyte&2)!=0) 
           { 
            PutPixel(x+6,y+by,textura[offset_textura]);
            if(negreta) PutPixel(x+7,y+by+1,textura[offset_textura]);
           }
           offset_textura++;
           getbyte = FntMonoText[offset_inici];
           if ((getbyte&1)!=0) 
           {
            PutPixel(x+7,y+by,textura[offset_textura]);
            if(negreta) PutPixel(x+8,y+by+1,textura[offset_textura]);
           }
           offset_textura++;
          }
         }
         else
         {
          for(by=0;by<alt_caracter;by++,offset_inici++)
          {
           getbyte = FntMonoText[offset_inici];
           if ((getbyte&1)!=0) 
           {
            PutPixel(x,y+by,textura[offset_textura]);
            if(negreta) PutPixel(x+7,y+by+1,textura[offset_textura]);
           }
           offset_textura++;
           getbyte = FntMonoText[offset_inici];
           if ((getbyte&2)!=0) 
           { 
            PutPixel(x+1,y+by,textura[offset_textura]);
            if(negreta) PutPixel(x+7,y+by+1,textura[offset_textura]);
           }
           offset_textura++;
           getbyte = FntMonoText[offset_inici];
           if ((getbyte&4)!=0) 
           { 
            PutPixel(x+2,y+by,textura[offset_textura]);
            if(negreta) PutPixel(x+7,y+by+1,textura[offset_textura]);
           }
           offset_textura++;
           getbyte = FntMonoText[offset_inici];
           if ((getbyte&8)!=0) 
           { 
            PutPixel(x+3,y+by,textura[offset_textura]);
            if(negreta) PutPixel(x+7,y+by+1,textura[offset_textura]);
           }
           offset_textura++;
           getbyte = FntMonoText[offset_inici];
           if ((getbyte&16)!=0) 
           { 
            PutPixel(x+4,y+by,textura[offset_textura]);
            if(negreta) PutPixel(x+7,y+by+1,textura[offset_textura]);
           }
           offset_textura++;
           getbyte = FntMonoText[offset_inici];
           if ((getbyte&32)!=0) 
           {
            PutPixel(x+5,y+by,textura[offset_textura]);
            if(negreta) PutPixel(x+7,y+by+1,textura[offset_textura]);
           }
           offset_textura++;
           getbyte = FntMonoText[offset_inici];
           if ((getbyte&64)!=0) 
           {
            PutPixel(x+6,y+by,textura[offset_textura]);
            if(negreta) PutPixel(x+7,y+by+1,textura[offset_textura]);
           }
           offset_textura++;
           getbyte = FntMonoText[offset_inici];
           if ((getbyte&128)!=0) 
           { 
            PutPixel(x+7,y+by,textura[offset_textura]);
            if(negreta) PutPixel(x+7,y+by+1,textura[offset_textura]);
           }
           offset_textura++;
        
          }
        
         }
}

	
	
void EscriureTextAPantalla(unsigned X,unsigned Y,char *Text,char Textura)
{
 u16 OffsetX = X,OffsetY = Y,i = 0;
 tParametresPutSprite P_PutSprite;
	
 
 
	 
 
 while(Text[i]!=MARCA_FI_STRING && OffsetY < ALTURA_PANTALLA)
 {
	 P_PutSprite.x_pos = OffsetX;
	 P_PutSprite.y_pos = OffsetY;
	 P_PutSprite.amplada_sprite = 8;
	 P_PutSprite.altura_sprite = 8;
	 P_PutSprite.mascara = 0;
	 P_PutSprite.src = (char *)&Font_00[traduccio_caracter_Font2((char)toupper(Text[i]))*8*8];


     PutSprite(&P_PutSprite);

     i++;
   
     OffsetX += AMPLADA_FONT_MONOTEXTURA;

     if(OffsetX >= AMPLADA_PANTALLA || Text[i] == MARCA_RETURN_STRING) 
	 {
		   OffsetX = X;
		   OffsetY += ALTURA_FONT_MONOTEXTURA;

		   if( Text[i] == MARCA_RETURN_STRING ) i++ ;
	 }

	   
 }
}




void EscriureNumeroRealAPantalla(unsigned X,unsigned Y,double NumeroReal,char Textura)
{
	char string[25];// = {'\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'};
     int sig = 5;   

     
	 gcvt(NumeroReal, sig, string);
	 
     EscriureTextAPantalla(X,Y,string,0);

}



void EscriureNumeroEnterAPantalla(unsigned X,unsigned Y,int Numero,char Textura)
{
	char string[10] = {'\0','\0','\0','\0','\0'};
     

     

	 itoa(abs(Numero), string, 10);
	 
     EscriureTextAPantalla(X,Y,string,0);

}


