#ifndef	__IMAGE_INFO_H__	
#define	__IMAGE_INFO_H__	



#define	N_IMAGES	39
#define	TRUE	1
#define	FALSE	0



#define	MASK_COLOR	254
#define	BLACK_COLOR	0
#define	GREY_COLOR	78
#define	WHITE_COLOR	50
#define	RED_COLOR	71
#define	GREEN_COLOR	25
#define	BLUE_COLOR	97



// ID defines & mask utilities...


#define		BIT_IS_UPOW2			4
#define		BIT_IS_VPOW2			5
#define		BIT_IS_SPRITE			3
#define		BIT_IS_PANORAMA			1
#define		BIT_RENDER_WITH_BRIGHT	0
#define		BIT_RENDER_WITH_GLENZ   1



#define		IS_PASSABLE(p)	     ((p)&(0x1 << BIT_IS_PASSABLE)) 
#define		IS_PANORAMA(p)	     ((p)&(0x1 << BIT_IS_PANORAMA)) 
#define		WITH_MIPMAPS(p)	     ((p)&(0x1 << BIT_WITH_MIPMAPS))
#define		IS_SPRITE(p)		 ((p)&(0x1 << BIT_IS_SPRITE))   
#define		IS_UPOW2(p) 	     ((p)&(0x1 << BIT_IS_UPOW2))
#define		IS_VPOW2(p) 	     ((p)&(0x1 << BIT_IS_VPOW2))
#define		RENDER_WITH_BRIGHT(p)((p)&(0x1 << BIT_RENDER_WITH_BRIGHT))
#define		RENDER_WITH_GLENZ(p) ((p)&(0x1 << BIT_RENDER_WITH_GLENZ))



typedef struct{
                       	int n_image;
                       	int width;
                       	int height;
                       	int N_MipMaps;
                       	int Propietries;
                       	char name[50];    
}tInfo_Image;

extern const tInfo_Image Info_Image[N_IMAGES];
extern const unsigned short Palette[256];
extern const unsigned char Shade[];
extern const unsigned short Shade16[];
extern const unsigned char Glenz[];
extern const unsigned short Glenz16[];

// Font data files...


extern const unsigned char Font_00[];

// MipMap data files...


extern const unsigned char images[];

#endif
