#ifndef __GESTNODES_H__
#define __GESTNODES_H__


/*************\
| INCLUSIONS  |
\*************/

#include "memoria.h"
#include "definicions.h"

/*************\
| DEFINICIONS |
\*************/

#define FILO				0
#define FIFO				1
#define LIFO				2	// Existeix ?
#define LILO				3   // Existeix ?
#define ORDER_TO_ASCENDENT	4
#define ORDER_TO_DESCENDENT	5

/********************\
| DEFINICIO DE TIPUS |
\********************/

#define tGeneric  void *

typedef struct _tNodeSectorDepenent *PNodeSectorDepenent;
typedef struct _tNode	*PNode;


//typedef struct void		*Estructura_Info_Generica;



typedef struct _tNode{

	int ID_Node;	// Per poder ordenar els nodes segons ID.

	tGeneric InfoNode; // Tipus info de node genrica.

	PNode Seguent;  // Segent node...
	PNode Anterior; // Anterior node...

}tNode;


typedef struct _tLlistaNodes *PLlistaNodes;

typedef struct _tLlistaNodes{
	PNode Primer;
	PNode Ultim;
	PNode NodeActual;

	int n_nodes;

	// mes info...
}tLlistaNodes;

/*
typedef struct _tNodeSectorDepenent{

	//PNodeSectorDepenent LlistaSectorsDepenents;

	int					ID_SectorOrganitzador;

	PNodeSector         LListaSectorsDepenents;


}tNodeSectorDepenent;

typedef struct _tNodeOrganitzador{

	PNodeSectorDepenent LlistaSectorsDepenents;

	PNodeSector         LListaSectorsUnificats;


}_tNodeOrganitzador;
*/
/*******************\
| VARIABLES GLOBALS |
\*******************/


/********\
| MACROS |
\********/






/**********************************\
| PROTOTIPUS DE FUNCIONS I ACCIONS |
\**********************************/

void NODE_InitLlista(tLlistaNodes *LlistaNodes);
int  NODE_Empilar(int ID_Node, tGeneric Info, tLlistaNodes *LlistaNodes, int tipus_empilatge);
int  NODE_EmpilarNode(tNode *Node, tLlistaNodes *LlistaNodes, int tipus_empilatge);




PNode NODE_Extraure(int ID_Node, tLlistaNodes *LlistaNodes);
PNode NODE_Cerca   (int ID_Node, PLlistaNodes  LlistaNodes);
//int NODE_LlistaNoBuida(LlistaSectors) LlistaSector.


void NODE_Borrar(int ID_Node, tLlistaNodes *LlistaNodes);
void NODE_BorrarNodeRef(PNode Node_A_Borrar, tLlistaNodes *LlistaNodes);
void NODE_Borrar_tots_els_nodes(tLlistaNodes *LlistaNodes);






#endif
