//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA

#include "Jugador.h"

#define MAX_VELOCITAT_CAIGUDA 64+8

tJugador Jugador;

const int Velocitat_Caiguda[MAX_VELOCITAT_CAIGUDA] = {
	
	11, 10, 9, 8, 7, 6, 4, 0, -4, -6, -7, -8, -9, -10, -11, -12, -13, -14, -14, -15, -15, -16, -17, -17, -18, -18, -19, -19, -20, -20, -21, -21,
		-22, -22, -23, -23, -23, -24, -24, -25, -25, -25, -26, -26, -26, -27, -27, -28, -28, -28, -29, -29, -29, -30, -30, -30, 
		-30, -31, -31, -31, -32, -32, -32, -33, -33, -33, -34, -34, -34, -34, -35 
		
};




tPunt_Fixa_2D InterseccioRaigParet(const tJugador *Jugador,tPunt_Fixa_2D PartidaRaig, int Altura,const tSector *Sector)
{
	tPunt_Fixa_2D interseccio;
	tLiniaSector *LiniaSector,*LiniaSector_Seguent;
	tSector *Sector_Seguent;
	int LiniaActual,id_sector,id_mapa;
	short Altura_Terra, Altura_Sostre;//,dir_y;
	u16	Propietats;

	//tVertex V0,V1;
	
	
	
	if(Sector != NULL)
	{
		
		LiniaActual = LiniaInterseccio(CENTRE_X2D_EFECTIU,Jugador,Sector,&interseccio,FALS);
		
		if(LiniaActual < 0) return PartidaRaig;
		
		LiniaSector = (tLiniaSector *)&Sector->LiniaSector[LiniaActual];
		
		if((LiniaSector->Portal == PARET))  return interseccio;
		else 
		{	
			// Obtenim els punters de sector i de lnia de sector adjacents...
			id_mapa		= DECODE_ID_MAP(LiniaSector->Portal);
			id_sector	= DECODE_ID_SECTOR(LiniaSector->Portal);
			
			Sector_Seguent		 = &MapaMon->Mapa2D[id_mapa].Sector[id_sector];
			LiniaSector_Seguent  = &Sector_Seguent->LiniaSector[DECODE_ID_LINE(LiniaSector->Portal)];
			
			
			Propietats = Sector_Seguent->Propietats;
			
			Altura_Terra = Sector_Seguent->AlturaTerra;
			Altura_Sostre = Sector_Seguent->AlturaSostre;
			
			/*		Altura_Terra =  LiniaSector->Linia_Adjacent->Linia.V0.Y_terra + ht_x1 + FIXED_TO_INT(MulFx(Jugador->X-SectorSeguent->QuadratSector.x1,SectorSeguent->inc_dYdX_Terra)) + SectorSeguent->ht_z1 + FIXED_TO_INT(MulFx(Jugador->Z-SectorSeguent->QuadratSector.z1,SectorSeguent->inc_dYdZ_Terra));
			Altura_Sostre = SectorSeguent->hs_x1 + FIXED_TO_INT(MulFx(Jugador->X-SectorSeguent->QuadratSector.x1,SectorSeguent->inc_dYdX_Sostre)) + SectorSeguent->hs_z1 + FIXED_TO_INT(MulFx(Jugador->Z-SectorSeguent->QuadratSector.z1,SectorSeguent->inc_dYdZ_Sostre));*/
			
			//V0 = LiniaSector_Seguent->Linia.V1;
			//V1 = LiniaSector_Seguent->Linia.V0;
			
			//Altura_Terra = V0.Y_terra;
			
			//if(V0.Y_terra < V1.Y_terra) dir_y= 1;
			//else dir_y =-1;
			
			
			//if(X_FLOOR_WITH_SLOPE(Propietats))	Altura_Terra += CEIL_FX(MulFx(Sector_Seguent->inc_dY_Terra,(PartidaRaig.X-V0.X)))*dir_y;
			//if(Z_FLOOR_WITH_SLOPE(Propietats))  Altura_Terra += CEIL_FX(MulFx(Sector_Seguent->inc_dY_Terra,(PartidaRaig.Z-V0.Z)))*dir_y;
			
			
			//Altura_Sostre  = V0.Y_sostre;
			
			//	if(V0.Y_sostre < V1.Y_sostre) dir_y= 1;
			//	else dir_y =-1;
			
			//	if(X_CEIL_WITH_SLOPE(Propietats))	Altura_Sostre += CEIL_FX(MulFx(Sector_Seguent->inc_dY_Sostre,(PartidaRaig.X-V0.X)))*dir_y;
			//	if(Z_CEIL_WITH_SLOPE(Propietats))   Altura_Sostre += CEIL_FX(MulFx(Sector_Seguent->inc_dY_Sostre,(PartidaRaig.Z-V0.Z)))*dir_y;
			
			
			if((Altura - Altura_Terra)	< MINIMA_ALTURA_JUGADOR)  return interseccio;
			else
			{
				if((Altura_Sostre - Altura)	< MINIMA_ALTURA_JUGADOR) return interseccio; 
				else
				{
					
					//SectorSeguent = LiniaSector->Portal;
					
					return InterseccioRaigParet(Jugador, interseccio, Altura, Sector_Seguent);
				}
			}
		}
	}
	else return PartidaRaig;
}

static int Bloqueig_Start = 0;

void JUGADOR_ObtenirAlturesMinMax(tJugador *Jugador, const tSector *Sector, short *Min_Altura, short *Max_Altura)
{
    tJugador J;
    u32  id_portal_encoded, id_mapa, id_sector;
    tSector *Sector_Sostre, *Sector_Terra;
    s32 Linia1, Linia2, y1, y2;
    tPunt_Fixa_2D interseccio1, interseccio2;
    tLiniaSector *LiniaSector1, *LiniaSector2;
    FIXED32 pendent_x, pendent_z;

	
    // Aconseguim altura de sostre...
    id_portal_encoded = Sector->Portal_Sostre;
	if(id_portal_encoded != SOLID)
	{
		id_mapa  = DECODE_ID_MAP(id_portal_encoded);
		id_sector = DECODE_ID_SECTOR(id_portal_encoded);
		
		Sector_Sostre = &MapaMon->Mapa2D[id_mapa].Sector[id_sector];
		
		//Altura_Sostre = Sector_Sostre->AlturaSostre;
		
	}
	else
	{
		Sector_Sostre = (tSector *)Sector;
	}

    J = *Jugador;
    // obtenim dos lnies de intersecci per el sector de sostre...
    if((Linia1 = LiniaInterseccio(AMPLADA_PANTALLA_EFECTIVA >> 1,&J, Sector_Sostre, &interseccio1, FALS)) < 0)
    {
        *Max_Altura = (Sector_Sostre)->AlturaSostre;
    }
    else
    {
   
        J.AngleDireccio += GRAU_180;

        if((Linia2 = LiniaInterseccio(AMPLADA_PANTALLA_EFECTIVA >> 1,&J, Sector_Sostre, &interseccio2, FALS)) < 0)
        {
            *Max_Altura = (Sector_Sostre)->AlturaSostre;
        }
        else // ok... 
        {

            LiniaSector1 = (tLiniaSector *)&Sector_Sostre->LiniaSector[Linia1];
            LiniaSector2 = (tLiniaSector *)&Sector_Sostre->LiniaSector[Linia2];

            // Calculem altures de sostre, segons interseccions...
            y1 = ALTURA_SOSTRE_MON_XZ(interseccio1.X,interseccio1.Z,LiniaSector1->Linia);
            y2 = ALTURA_SOSTRE_MON_XZ(interseccio2.X,interseccio2.Z,LiniaSector2->Linia);


            pendent_x = (interseccio2.X-interseccio1.X) == 0? 0:DivFx((y2-y1),(interseccio2.X-interseccio1.X));
            pendent_z = (interseccio2.Z-interseccio1.Z) == 0? 0:DivFx((y2-y1),(interseccio2.Z-interseccio1.Z));

            
            *Max_Altura = FIXED_TO_INT(y1 + MulFx(pendent_x,J.X - interseccio1.X ) + MulFx(pendent_z,J.Z - interseccio1.Z));//FIXED_TO_INT(y2) + FIXED_TO_INT(y1);

            


        }
    }
	
    ////////////////////////////////////////////////////////////////////////////////
    //
    // Aconseguim altura de terra...
    //
	id_portal_encoded = (Sector)->Portal_Terra;
	if(id_portal_encoded != SOLID)
	{	  
		id_mapa  = DECODE_ID_MAP(id_portal_encoded);
		id_sector = DECODE_ID_SECTOR(id_portal_encoded);
		
		Sector_Terra = &MapaMon->Mapa2D[id_mapa].Sector[id_sector];
		
		//Altura_Terra = Sector_Terra->AlturaTerra;
	}
	else
	{
		//Altura_Terra =  (*Sector)->AlturaTerra;
        Sector_Terra = (tSector *)Sector;
	}

    J.AngleDireccio = GRAU_90;
    if((Linia2 = LiniaInterseccio(AMPLADA_PANTALLA_EFECTIVA >> 1,&J, Sector_Terra, &interseccio2, FALS)) < 0)
    {
        *Min_Altura = (Sector_Terra)->AlturaTerra;
    }
    else
    {
   
        J.AngleDireccio = GRAU_270;

        if((Linia1 = LiniaInterseccio(AMPLADA_PANTALLA_EFECTIVA >> 1,&J, Sector_Terra, &interseccio1, FALS)) < 0)
        {
            *Min_Altura = (Sector_Terra)->AlturaTerra;
        }
        else // ok... 
        {

            LiniaSector1 = (tLiniaSector *)&Sector_Terra->LiniaSector[Linia1];
            LiniaSector2 = (tLiniaSector *)&Sector_Terra->LiniaSector[Linia2];

            // Calculem altures de sostre, segons interseccions...
            y1 = ALTURA_TERRA_MON_XZ(interseccio1.X,interseccio1.Z,LiniaSector1->Linia);
            y2 = ALTURA_TERRA_MON_XZ(interseccio2.X,interseccio2.Z,LiniaSector2->Linia);

            if(y1 != y2)
            {
                int caca = 0;
            }

            pendent_x = (interseccio2.X-interseccio1.X) == 0? 0:DivFx((y2-y1),(interseccio2.X-interseccio1.X));
            pendent_z = (interseccio2.Z-interseccio1.Z) == 0? 0:DivFx((y2-y1),(interseccio2.Z-interseccio1.Z));

            
            *Min_Altura = FIXED_TO_INT(y1 + MulFx(pendent_x,J.X - interseccio1.X ) + MulFx(pendent_z,J.Z - interseccio1.Z));//FIXED_TO_INT(y2) + FIXED_TO_INT(y1);

            


        }
    }

    //
    //
    ////////////////////////////////////////////////////////////////////////////////


}



void ActualitzarJugador(tJugador *Jugador, tSector **Sector)//,const tSector *Sector)
{
	
	int		DeltaX, DeltaZ;//, i;
	int		Raig_Intersecta_Vertex;
	short		Altura_Terra, Altura_Sostre;
	u16		Propietats;
//	u32		id_portal_encoded, id_mapa, id_sector;
	u8	Modificat;
//	tCachedVertex *_CachedVertex = CachedVertexs;//,*CachedVertex;
	
	tSector	*SectorAnterior = *Sector, *Nou_Sector,*Sector_Terra = NULL, *Sector_Sostre = NULL;
	// tLinia InfoLiniaIntersectant;
	
	// tLiniaSector   *LiniaSector;
	tPunt_Fixa_2D PuntPartida,PuntPartida2;
	tJugador J;
	
	tPunt_Fixa_2D interseccio;
	
	
	PuntPartida2.X = PuntPartida.X = Jugador->X;
	PuntPartida2.Z = PuntPartida.Z = Jugador->Z;
	
	DeltaX = CEIL_FX(FIXED_MUL_16(FIXED_DIV_256(_Cosinus[Jugador->AngleDireccio])));
	DeltaZ = CEIL_FX(FIXED_MUL_16(FIXED_DIV_256(  _Sinus[Jugador->AngleDireccio])));
	
	
	
	
	if(TeclaAmunt()) // Realitzem els increments DeltaX, DeltaY.
	{
		(Jugador->X) += INT_TO_FIXED(DeltaX);
		(Jugador->Z) += INT_TO_FIXED(DeltaZ);
	}
	
	if(TeclaAvall()) // Realitzem el contrari, decrementar.
	{
		DeltaX = -DeltaX;
		DeltaZ = -DeltaZ;
		
		(Jugador->X) += INT_TO_FIXED(DeltaX); 
		(Jugador->Z) += INT_TO_FIXED(DeltaZ);
		
	}
	
    // Actualitzaci del gir...
	
	if (TeclaDreta()) 
    {
        Jugador->AngleDireccio += VELOCITAT_GIR;
    }
	
	if(TeclaEsquerra()) 
    {
        Jugador->AngleDireccio -= VELOCITAT_GIR;
    }
	
	
	if(Tecla_R()) 
	{
		if((Jugador->Horitzo-VELOCITAT_PITCH) < (-CENTRE_Y2D_EFECTIU)) Jugador->Horitzo = -CENTRE_Y2D_EFECTIU;
		else Jugador->Horitzo-=VELOCITAT_PITCH;
	}
	else
	{
		if(Tecla_L()) 
		{
			if((Jugador->Horitzo+VELOCITAT_PITCH) > (CENTRE_Y2D_EFECTIU-1)) Jugador->Horitzo = (CENTRE_Y2D_EFECTIU-1);
			else Jugador->Horitzo+=VELOCITAT_PITCH;
		}
		else // No s'aha apretat cap dels botons...
		{
			if((Jugador->Horitzo) < 0) if((Jugador->Horitzo += VELOCITAT_PITCH) > 0) Jugador->Horitzo = 0;
			if((Jugador->Horitzo) > 0) if((Jugador->Horitzo -= VELOCITAT_PITCH) < 0) Jugador->Horitzo = 0;
			
		}
	}


	
	
	if(Bloqueig_Start > 0) Bloqueig_Start-- ;
	if(Tecla_Start() && !Bloqueig_Start) 
	{ 
		Jugador->ModeVolar = 1 - Jugador->ModeVolar; 
		Bloqueig_Start = 10; 
		
		Jugador->Sequencia_Caiguda = CERT;
		Jugador->Temps_Caiguda = 8;
		
		
	};
	
	
	
	Nou_Sector = MON_SectorJugador(Jugador);
	
	
	if(Nou_Sector == NULL ) // El jugador ha surtit del mapa --> No actualitzarem jugador
	{
		if(*Sector != NULL)
		{
			Jugador->X = PuntPartida.X;
			Jugador->Z = PuntPartida.Z;
		}
		else // EXCEPCI --> Jugador fora de mapa!!!
		{
			return;
		}
		
	}
	else
	{
		*Sector = Nou_Sector;
	}
	
	
	
	
	Propietats = (*Sector)->Propietats;
	
	//  Altures terra/sostre del sector...
	//	Altura_Terra = (*Sector)->QuadratSector3D.y1_terra;
	//	if(X_FLOOR_WITH_SLOPE(Propietats))	Altura_Terra += CEIL_FX(MulFx((*Sector)->inc_dY_Terra,(Jugador->X-(*Sector)->QuadratSector3D.x1)));
	//	if(Z_FLOOR_WITH_SLOPE(Propietats))  Altura_Terra += CEIL_FX(MulFx((*Sector)->inc_dY_Terra,(Jugador->Z-(*Sector)->QuadratSector3D.z1)));
	
	//	Altura_Sostre = (*Sector)->QuadratSector3D.y1_sostre;
	//	if(X_CEIL_WITH_SLOPE(Propietats))	Altura_Sostre += CEIL_FX(MulFx((*Sector)->inc_dY_Sostre,(Jugador->X-(*Sector)->QuadratSector3D.x1)));
	//	if(Z_CEIL_WITH_SLOPE(Propietats))  Altura_Sostre += CEIL_FX(MulFx((*Sector)->inc_dY_Sostre,(Jugador->Z-(*Sector)->QuadratSector3D.z1)));
	
    JUGADOR_ObtenirAlturesMinMax(Jugador, *Sector, &Altura_Terra, &Altura_Sostre);
	//  Altura_Sostre = (*Sector)->hs_x1 + CEIL_FX( MulFx(Jugador->X-(*Sector)->QuadratSector.x1,(*Sector)->inc_dYdX_Sostre)) + (*Sector)->hs_z1 + CEIL_FX(MulFx(Jugador->Z-(*Sector)->QuadratSector.z1,(*Sector)->inc_dYdZ_Sostre));
	
	// Zona de detecci collisi jugador amb paret...
	
	if(*Sector != NULL) 
	{
		J.X = PuntPartida.X = Jugador->X;
		J.Z = PuntPartida.Z = Jugador->Z;
		
		
		if(DeltaX > 0) // Jugador camina cap a la dreta...
		{
			// s llena un raig a la dreta...
			
			if(!Punt_Pertany_A_Sector(Jugador->X + PARET_MES_PROXIMA,Jugador->Z, *Sector,&Raig_Intersecta_Vertex)) // Jugador surt de mapa...
			{
				J.AngleDireccio = 0;
				
				interseccio = InterseccioRaigParet(&J,PuntPartida,Jugador->Altura,*Sector);
				if((interseccio.X - Jugador->X) < PARET_MES_PROXIMA) 
				{
					J.X = PuntPartida.X = Jugador->X = INT_TO_FIXED(CEIL_FX(interseccio.X)) - PARET_MES_PROXIMA;
					
					if(!Punt_Pertany_A_Sector(Jugador->X,Jugador->Z, *Sector,&Raig_Intersecta_Vertex) )
						if((*Sector = MON_SectorJugador(Jugador)) == NULL) return;
				}
				
				
				
			}
		}
		
		if(DeltaX < 0) // Jugador camina cap a l'esquerra...
		{
			// s llena un raig a l'esquerra...
			
			if(!Punt_Pertany_A_Sector(Jugador->X - PARET_MES_PROXIMA,Jugador->Z, *Sector,&Raig_Intersecta_Vertex) ) // Jugador surt de mapa...
			{
				J.AngleDireccio = GRAU_180;
				
				interseccio = InterseccioRaigParet(&J, PuntPartida,Jugador->Altura,*Sector);
				if((Jugador->X - interseccio.X) < PARET_MES_PROXIMA) 
				{
					J.X = PuntPartida.X = Jugador->X = INT_TO_FIXED(CEIL_FX(interseccio.X)) + PARET_MES_PROXIMA;
					
					if(!Punt_Pertany_A_Sector(Jugador->X,Jugador->Z, *Sector,&Raig_Intersecta_Vertex) )
						if((*Sector = MON_SectorJugador(Jugador)) == NULL) return;
				}
				
			}
			
		}
		
		if(DeltaZ > 0) // Jugador camina cap al avall (sud)...
		{
			// Lleno un raig cap al sud...
			
			if(!Punt_Pertany_A_Sector(Jugador->X ,Jugador->Z + PARET_MES_PROXIMA, *Sector,&Raig_Intersecta_Vertex)) // Jugador surt de mapa...
			{
				J.AngleDireccio = GRAU_90;
				
				interseccio = InterseccioRaigParet(&J, PuntPartida,Jugador->Altura,*Sector);
				if((interseccio.Z - Jugador->Z) < PARET_MES_PROXIMA) 
				{
					
					
					J.Z = PuntPartida.Z = Jugador->Z = INT_TO_FIXED(CEIL_FX(interseccio.Z)) - PARET_MES_PROXIMA;
					
					if(!Punt_Pertany_A_Sector(Jugador->X,Jugador->Z, *Sector,&Raig_Intersecta_Vertex) )
						if((*Sector = MON_SectorJugador(Jugador)) == NULL) return;
				}
				
				
			}
			
		}
		
		if(DeltaZ < 0) // Jugador camina cap amunt (nord)...
		{
			
			// Lleno un raig cap al nord...
			
			
			if(!Punt_Pertany_A_Sector(Jugador->X ,Jugador->Z - PARET_MES_PROXIMA, *Sector,&Raig_Intersecta_Vertex) ) // Jugador surt de mapa...
			{
				
				J.AngleDireccio = GRAU_270;
				
				interseccio = InterseccioRaigParet(&J, PuntPartida, Jugador->Altura,*Sector);
				if((Jugador->Z - interseccio.Z) < PARET_MES_PROXIMA) 
				{
					
					J.Z = PuntPartida.Z = Jugador->Z = INT_TO_FIXED(CEIL_FX(interseccio.Z)) + PARET_MES_PROXIMA;
					
					if(!Punt_Pertany_A_Sector(Jugador->X,Jugador->Z, *Sector,&Raig_Intersecta_Vertex) )
						if((*Sector = MON_SectorJugador(Jugador)) == NULL) return;
						
				}
				
				
			}
			
		}
		
		
		// detecci collisi a les 4 direccions restants...
		
		//if(Correccio_DeltaX == 0 && Correccio_DeltaZ == 0)
		{
			
			if(DeltaX > 0) // Jugador camina cap al nord-est...
			{
				
				// Lleno un raig cap al nord-est...
				
				if(!Punt_Pertany_A_Sector(Jugador->X + PARET_MES_PROXIMA,Jugador->Z - PARET_MES_PROXIMA, *Sector,&Raig_Intersecta_Vertex) ) // Jugador surt de mapa...
				{
					J.AngleDireccio = GRAU_315;
					
					interseccio = InterseccioRaigParet(&J, PuntPartida, Jugador->Altura,*Sector);
					
					Modificat = FALSE;
					if((interseccio.X - Jugador->X) < PARET_MES_PROXIMA) {J.X = PuntPartida.X = Jugador->X = INT_TO_FIXED(CEIL_FX(interseccio.X)) - PARET_MES_PROXIMA;Modificat=TRUE;}
					if((Jugador->Z - interseccio.Z) < PARET_MES_PROXIMA) {J.Z = PuntPartida.Z = Jugador->Z = INT_TO_FIXED(FLOOR_FX(interseccio.Z)) + PARET_MES_PROXIMA; Modificat=TRUE;}
					
					if(Modificat)
					{
						
						if(!Punt_Pertany_A_Sector(Jugador->X,Jugador->Z, *Sector,&Raig_Intersecta_Vertex) )
							if((*Sector = MON_SectorJugador(Jugador)) == NULL) return;
					}
				}
				
				
			}
			
			// Lleno un raig cap al sud-est...
			
			
			if(!Punt_Pertany_A_Sector(Jugador->X + PARET_MES_PROXIMA,Jugador->Z + PARET_MES_PROXIMA, *Sector,&Raig_Intersecta_Vertex) ) // Jugador surt de mapa...
			{
				//---------------->>>>				  
				J.AngleDireccio = GRAU_45;
				interseccio = InterseccioRaigParet(&J, PuntPartida, Jugador->Altura,*Sector);
				
				Modificat = FALSE;
				if((interseccio.X - Jugador->X) < PARET_MES_PROXIMA) {J.X = PuntPartida.X = Jugador->X = INT_TO_FIXED(CEIL_FX(interseccio.X)) - PARET_MES_PROXIMA; Modificat=TRUE;}
				if((interseccio.Z - Jugador->Z) < PARET_MES_PROXIMA) {J.Z = PuntPartida.Z = Jugador->Z = INT_TO_FIXED(CEIL_FX(interseccio.Z)) - PARET_MES_PROXIMA;  Modificat=TRUE;}
				
				if(Modificat)
				{
					if(!Punt_Pertany_A_Sector(Jugador->X,Jugador->Z, *Sector,&Raig_Intersecta_Vertex) )
						if((*Sector = MON_SectorJugador(Jugador)) == NULL) return;
				}
				
				
			}
			
			
			
		}
		
		if(DeltaX < 0) // Jugador camina cap a l'esquerra...
		{
			// Lleno un raig cap al nord-oest...
			
			
			if(!Punt_Pertany_A_Sector(Jugador->X - PARET_MES_PROXIMA,Jugador->Z - PARET_MES_PROXIMA, *Sector,&Raig_Intersecta_Vertex) ) // Jugador surt de mapa...
			{
				// Aqui peta...
				J.AngleDireccio = GRAU_225;
				
				interseccio = InterseccioRaigParet(&J, PuntPartida, Jugador->Altura,*Sector);
				
				Modificat = FALSE;
				if((  Jugador->X - interseccio.X) < PARET_MES_PROXIMA) {J.X = PuntPartida.X = Jugador->X = INT_TO_FIXED(FLOOR_FX(interseccio.X)) + PARET_MES_PROXIMA; Modificat=TRUE;}
				if(( Jugador->Z - interseccio.Z) < PARET_MES_PROXIMA) {J.Z = PuntPartida.Z = Jugador->Z = INT_TO_FIXED(FLOOR_FX(interseccio.Z)) + PARET_MES_PROXIMA;  Modificat=TRUE;}
				
				if(Modificat)
				{
					
					if(!Punt_Pertany_A_Sector(Jugador->X,Jugador->Z, *Sector,&Raig_Intersecta_Vertex) )
						if((*Sector = MON_SectorJugador(Jugador)) == NULL) return;
				}
				
				
			}
			
			
			// Lleno un raig cap al sud-oest...
			
			if(!Punt_Pertany_A_Sector(Jugador->X - PARET_MES_PROXIMA,Jugador->Z + PARET_MES_PROXIMA, *Sector,&Raig_Intersecta_Vertex) ) // Jugador surt de mapa...
			{
				//------> peta
				J.AngleDireccio = GRAU_135;
				interseccio = InterseccioRaigParet(&J, PuntPartida,Jugador->Altura,*Sector);
				
				Modificat = FALSE;
				
				
				if((Jugador->X - interseccio.X ) < PARET_MES_PROXIMA ) {J.X = PuntPartida.X = Jugador->X = INT_TO_FIXED(FLOOR_FX(interseccio.X)) + PARET_MES_PROXIMA; Modificat=TRUE;}
				if((interseccio.Z - Jugador->Z ) < PARET_MES_PROXIMA) {J.Z = PuntPartida.Z = Jugador->Z = INT_TO_FIXED(CEIL_FX(interseccio.Z)) - PARET_MES_PROXIMA;  Modificat=TRUE;}
				
				if(Modificat)
				{
					if(!Punt_Pertany_A_Sector(Jugador->X,Jugador->Z, *Sector,&Raig_Intersecta_Vertex) )
						if((*Sector = MON_SectorJugador(Jugador)) == NULL) return;
				}
				
				
				
			}
			
			
		}
		
		if(DeltaZ > 0) // Jugador camina cap avall...
		{
			
			// Lleno un raig cap al sud-oest...
			
			if(!Punt_Pertany_A_Sector(Jugador->X - PARET_MES_PROXIMA,Jugador->Z + PARET_MES_PROXIMA, *Sector,&Raig_Intersecta_Vertex) ) // Jugador surt de mapa...
			{
				
				J.AngleDireccio = GRAU_135;
				// Aqui peta...
				interseccio = InterseccioRaigParet(&J, PuntPartida, Jugador->Altura,*Sector);
				
				Modificat= FALSE;
				if((Jugador->X - interseccio.X) < PARET_MES_PROXIMA) {J.X = PuntPartida.X = Jugador->X = INT_TO_FIXED(FLOOR_FX(interseccio.X)) + PARET_MES_PROXIMA; Modificat=TRUE;}
				if((interseccio.Z - Jugador->Z) < PARET_MES_PROXIMA) {J.Z = PuntPartida.Z = Jugador->Z = INT_TO_FIXED(CEIL_FX(interseccio.Z)) - PARET_MES_PROXIMA;  Modificat=TRUE;}
				
				if(Modificat)
				{
					if(!Punt_Pertany_A_Sector(Jugador->X,Jugador->Z, *Sector,&Raig_Intersecta_Vertex) )
						if((*Sector = MON_SectorJugador(Jugador)) == NULL) return;
				}
				
				
			}
			
			
			// Lleno un raig cap al sud-est...
			if(!Punt_Pertany_A_Sector(Jugador->X + PARET_MES_PROXIMA,Jugador->Z + PARET_MES_PROXIMA, *Sector,&Raig_Intersecta_Vertex) ) // Jugador surt de mapa...
			{
				J.AngleDireccio = GRAU_45;
				
				interseccio = InterseccioRaigParet(&J, PuntPartida,Jugador->Altura,*Sector);
				
				Modificat = FALSE;
				if((interseccio.X - Jugador->X) < PARET_MES_PROXIMA) {J.X = PuntPartida.X = Jugador->X = INT_TO_FIXED(CEIL_FX(interseccio.X)) - PARET_MES_PROXIMA; Modificat=TRUE;}
				if((interseccio.Z - Jugador->Z) < PARET_MES_PROXIMA) {J.Z = PuntPartida.Z = Jugador->Z = INT_TO_FIXED(CEIL_FX(interseccio.Z)) - PARET_MES_PROXIMA;  Modificat=TRUE;}
				
				if(Modificat)
				{
					if(!Punt_Pertany_A_Sector(Jugador->X,Jugador->Z, *Sector,&Raig_Intersecta_Vertex) )
						if((*Sector = MON_SectorJugador(Jugador)) == NULL) return;
				}
				
				
			}
			
			
		}
		
		if(DeltaZ < 0) // Jugador camina cap amunt...
		{
			
			// Lleno un raig cap al nord-oest...
			
			if(!Punt_Pertany_A_Sector(Jugador->X - PARET_MES_PROXIMA,Jugador->Z - PARET_MES_PROXIMA, *Sector,&Raig_Intersecta_Vertex) ) // Jugador surt de mapa...
			{
				J.AngleDireccio = GRAU_225;
				
				interseccio = InterseccioRaigParet(&J, PuntPartida,Jugador->Altura,*Sector);
				
				Modificat = FALSE;
				if((Jugador->X - interseccio.X) < PARET_MES_PROXIMA) {J.X = PuntPartida.X = Jugador->X = INT_TO_FIXED(FLOOR_FX(interseccio.X)) + PARET_MES_PROXIMA; Modificat=TRUE;}
				if((Jugador->Z - interseccio.Z) < PARET_MES_PROXIMA) {J.Z = PuntPartida.Z = Jugador->Z = INT_TO_FIXED(FLOOR_FX(interseccio.Z)) + PARET_MES_PROXIMA;  Modificat=TRUE;}
				
				if(Modificat)
				{
					if(!Punt_Pertany_A_Sector(Jugador->X,Jugador->Z, *Sector,&Raig_Intersecta_Vertex) )
						if((*Sector = MON_SectorJugador(Jugador)) == NULL) return;	
				}
				
			}
			
			
			// Lleno un raig cap al nord-est...
			if(!Punt_Pertany_A_Sector(Jugador->X + PARET_MES_PROXIMA,Jugador->Z - PARET_MES_PROXIMA, *Sector,&Raig_Intersecta_Vertex) ) // Jugador surt de mapa...
			{
				
				J.AngleDireccio = GRAU_315;
				
				interseccio = InterseccioRaigParet(&J, PuntPartida,Jugador->Altura,*Sector);
				
				Modificat = FALSE;				  
				if((interseccio.X - Jugador->X) < PARET_MES_PROXIMA) {J.X = PuntPartida.X = Jugador->X = INT_TO_FIXED(CEIL_FX(interseccio.X)) - PARET_MES_PROXIMA; Modificat=TRUE;}
				if((Jugador->Z - interseccio.Z) < PARET_MES_PROXIMA) {J.Z = PuntPartida.Z = Jugador->Z = INT_TO_FIXED(FLOOR_FX(interseccio.Z)) + PARET_MES_PROXIMA;  Modificat=TRUE;}
				
				if(Modificat)
				{
					if(!Punt_Pertany_A_Sector(Jugador->X,Jugador->Z, *Sector,&Raig_Intersecta_Vertex) )
						if((*Sector = MON_SectorJugador(Jugador)) == NULL) return;
				}
				
				
			}
			
			
			
		}
		  
		  
		  
		  
		  
		  
		  
		  
		  
		  if(Jugador->ModeVolar)
		  {
			  Jugador->Sequencia_Caiguda = 0;
			  Jugador->Sequencia_Salt = 0;
			  Jugador->Temps_Caiguda = 0;
			  Jugador->Temps_Salt = 8;
			  
			  if(Tecla_A()) // vola amunt...
			  {
				  if((Jugador->Altura + VELOCITAT_VOLAR) < (Altura_Sostre - ALTURA_JUGADOR)) Jugador->Altura += VELOCITAT_VOLAR;		
				  else Jugador->Altura = Altura_Sostre - ALTURA_JUGADOR;
			  }
			  else if(Tecla_B()) // vola avall...
			  {
				  if((Jugador->Altura - VELOCITAT_VOLAR) > (Altura_Terra + MINIMA_ALTURA_JUGADOR)) Jugador->Altura -= VELOCITAT_VOLAR;		
				  else Jugador->Altura = Altura_Terra + MINIMA_ALTURA_JUGADOR;
			  }
			  else
			  {
				  if(Jugador->Altura < (Altura_Terra + MINIMA_ALTURA_JUGADOR))   Jugador->Altura = (Altura_Terra + MINIMA_ALTURA_JUGADOR);
				  else if((Jugador->Altura ) > (Altura_Sostre - ALTURA_JUGADOR)) Jugador->Altura = Altura_Sostre - ALTURA_JUGADOR;		
				  
			  }
			  
		  }
		  else
		  {
			  
			  
			  if(!Jugador->Sequencia_Caiguda)
			  {
				  if(!Jugador->Sequencia_Salt)
				  {
					  if(Tecla_A()) // Ok -> Jugador comena a saltar
					  {
						  Jugador->Sequencia_Salt = CERT;
						  Jugador->Temps_Salt = 0;
					  }
				  }
				  
				  
				  
				  else // Encara hi ha sequencia de salt...
				  {
					  if(Jugador->Temps_Salt < 8) 
					  {
						  if((Jugador->Altura + Velocitat_Caiguda[Jugador->Temps_Salt]) < (Altura_Sostre - MINIMA_ALTURA_JUGADOR)) Jugador->Altura += Velocitat_Caiguda[Jugador->Temps_Salt];
						  else Jugador->Altura = (Altura_Sostre - MINIMA_ALTURA_JUGADOR);
						  
						  Jugador->Temps_Salt++;
					  }
					  
					  else // Seqencia de caiguda
					  {
						  Jugador->Sequencia_Salt = FALS;
						  Jugador->Sequencia_Caiguda = CERT;
						  Jugador->Temps_Caiguda = 8;
					  }
					  
				  }
				  
			  }
			  
			  
			  
			  if(!Jugador->Sequencia_Salt)
			  {
				  
				  if(!Jugador->Sequencia_Caiguda) // El jugador camina o el jugador ha arribat al punt ms del salt...
				  {
					  if(Jugador->Altura > (Altura_Terra + ALTURA_JUGADOR) && (*Sector != SectorAnterior) )  Jugador->Sequencia_Caiguda = CERT;
					  else
					  {
						  if(Tecla_B())
							  if((Jugador->Altura - VELOCITAT_AJUPIR_SE) > (MINIMA_ALTURA_JUGADOR + Altura_Terra))	Jugador->Altura -= VELOCITAT_AJUPIR_SE;
							  else Jugador->Altura = (MINIMA_ALTURA_JUGADOR + Altura_Terra);
							  
							  else if((Jugador->Altura + VELOCITAT_AIXECAR_SE) < (ALTURA_JUGADOR + Altura_Terra)) Jugador->Altura += VELOCITAT_AIXECAR_SE;
							  
							  else Jugador->Altura = (ALTURA_JUGADOR + Altura_Terra);
							  
					  }
				  }
				  else // El jugador comena a caure... 
				  {
					  if(Jugador->Altura > (Altura_Terra + ALTURA_JUGADOR))
						  Jugador->Altura += Velocitat_Caiguda[Jugador->Temps_Caiguda < MAX_VELOCITAT_CAIGUDA ? Jugador->Temps_Caiguda++ : MAX_VELOCITAT_CAIGUDA - 1];
					  else // El jugador ha tocat terra...
					  {
						  
						  if((Jugador->Altura < (Altura_Terra + MINIMA_ALTURA_JUGADOR)) || (Jugador->Temps_Caiguda > 16))	Jugador->Altura = MINIMA_ALTURA_JUGADOR + Altura_Terra ;
						  
						  Jugador->Sequencia_Caiguda = FALS;
						  Jugador->Temps_Caiguda = 8;
						  
					  }
				  }
			  }
		  }
		  
		  
		  if(Jugador->Altura == (*Sector)->AlturaSostre)	Jugador->Altura--;
		  else 
		  {
			  if(Jugador->Altura > (*Sector)->AlturaSostre) //*Sector = MON_SectorJugador(Jugador);
			  {
				  if(Sector_Sostre != NULL) *Sector = Sector_Sostre;
			  }
		  }
		  
		  if(Jugador->Altura == (*Sector)->AlturaTerra)	Jugador->Altura++;
		  else 
		  {
			  if(Jugador->Altura < (*Sector)->AlturaTerra)// *Sector = MON_SectorJugador(Jugador);
			  {
				  if(Sector_Terra != NULL) *Sector = Sector_Terra;	
			  }
		  }
		  
		  
		  
		  /*if(!Tecla_B())	Jugador->Altura = (*Sector)->AlturaTerra + ALTURA_JUGADOR;
		  else if(Jugador->Salt)Jugador->Altura = (*Sector)->AlturaTerra + ALTURA_JUGADOR_AJUPIT;*/
		  
//		  if(VertexsPrecalculats)
//		  {
			 // if(Jugador->AngleDireccioAnterior != Jugador->AngleDireccio)
//			  {
				  Jugador->AngleDireccioAnterior = Jugador->AngleDireccio;
				  MemSet(CachedVertexs,0,sizeof(tCachedVertex)*MapaMon->NVertexs);
//				  VertexsPrecalculats = FALSE; // S'ha de tornar a calcular els vertexs :_(
			/*  }
			  else 
			  {

				  if((PuntPartida2.X != PuntPartida.X) || (PuntPartida2.Z != PuntPartida.Z)) // translaci vertexs!!!
				  {
					  i = MapaMon->NVertexs;
					  
					  DeltaX = PuntPartida2.X;
					  DeltaZ = PuntPartida2.Z;
					  
					  punt_mon_A_pla_projeccio(Jugador,DeltaX,DeltaZ,&PuntPartida2);
					  
					  DeltaX = PuntPartida2.X;
					  DeltaZ = PuntPartida2.Z;
					  
					  CachedVertex = CachedVertexs;
					  
					  while(i--)
					  {
						  
						  if(CachedVertex->Rotated)
						  {
							  CachedVertex->TransformedVertex.X += PuntPartida2.X;
							  CachedVertex->TransformedVertex.Z += PuntPartida2.Z;
							  
						  }

						  CachedVertex++;
						  // Jugador->DesplacamentX_EspaiUll = PuntPartida2.X;
						  //Jugador->DesplacamentZ_EspaiUll = PuntPartida2.Z;
					  }
				  }*/
//			  }
			  
//		  }	
		  
  }
  
  
  
}

void JUGADOR_Init(void)
{
    int Carrega_per_defecte = TRUE;

#ifdef __SDL__

    FILE *fp;
    tFixed_Jugador Info_File_Jugador;


	if(fp=fopen("infoJugador.dat","rb"))
	{
		fread(&Info_File_Jugador,sizeof(tFixed_Jugador),1,fp);

#ifndef __ARITMETICA_FIXA__
		Jugador.X = (float)Info_File_Jugador.X/(1 << PART_FRACCIONAL);
		Jugador.Z = (float)Info_File_Jugador.Z/(1 << PART_FRACCIONAL);
#else
		Jugador.X = Info_File_Jugador.X;
		Jugador.Z = Info_File_Jugador.Z;
#endif
		memcpy(&Jugador.AngleDireccio,&Info_File_Jugador.AngleDireccio,sizeof(tFixed_Jugador) - sizeof(Jugador.X) - sizeof(Jugador.Z));// (Sizeof int pq una adrea s de 32 bits)
		//memcpy(&Jugador.AngleDireccio,&Info_File_Jugador.AngleDireccio,sizeof(&Info_File_Jugador.ModeVolar - &Info_File_Jugador.AngleDireccio)*sizeof(int *));
		//Jugador.AngleDireccio = Info_File_Jugador.Angle;
		//Jugador.Altura = Info_File_Jugador.Altura;
		

		fclose(fp);

		fp = NULL;

		Carrega_per_defecte = FALS;
	}

    atexit(JUGADOR_GuardarInfo);
#endif

    



	if(Carrega_per_defecte)
	{
        // INICI
		Jugador.X = DOUBLE_TO_FIXED(384.5);
		Jugador.Z = DOUBLE_TO_FIXED(668.5);
		Jugador.AngleDireccioAnterior = Jugador.AngleDireccio = (char)(0.0f/INCREMENT_ANGLE_JUGADOR);
		Jugador.Altura = 36;
        Jugador.ModeVolar = FALSE;

        // CAPTURA 1: VISTA DESNIVELLS AMB 3D ESTES.
		/*Jugador.X = DOUBLE_TO_FIXED(1501.5);
		Jugador.Z = DOUBLE_TO_FIXED(479.5);
		Jugador.AngleDireccioAnterior = Jugador.AngleDireccio = (char)((326.25/(double)INCREMENT_ANGLE_JUGADOR));
		Jugador.Altura = 48;
        Jugador.ModeVolar = FALSE;*/

     /*   // CAPTURA 2: PAISATGES.
		Jugador.X = DOUBLE_TO_FIXED(1997.5);
		Jugador.Z = DOUBLE_TO_FIXED(-15.5);
		Jugador.AngleDireccioAnterior = Jugador.AngleDireccio = (char)((11.25/(double)INCREMENT_ANGLE_JUGADOR));
		Jugador.Altura = 144;
        Jugador.ModeVolar = TRUE;*/

     /*   // CAPTURA 3: PENDENTS + OBJECTE AMB TRANSPARENCIA.
		Jugador.X = DOUBLE_TO_FIXED(1824.5);
		Jugador.Z = DOUBLE_TO_FIXED(101.5);
		Jugador.AngleDireccioAnterior = Jugador.AngleDireccio = (char)((225.0/(double)INCREMENT_ANGLE_JUGADOR));
		Jugador.Altura = 120;
        Jugador.ModeVolar = TRUE;*/

/*        // CAPTURA 4: EFECTE PORTAL.
		Jugador.X = DOUBLE_TO_FIXED(1214.5);
		Jugador.Z = DOUBLE_TO_FIXED(662.5);
		Jugador.AngleDireccioAnterior = Jugador.AngleDireccio = (char)((123.75/(double)INCREMENT_ANGLE_JUGADOR));
		Jugador.Altura = 48;
        Jugador.ModeVolar = TRUE;*/

        
        Jugador.Horitzo = 0;
		
		Jugador.Sequencia_Caiguda = 8;
		Jugador.Sequencia_Salt = FALS;
		Jugador.DesplacamentX_EspaiUll = 0;
		Jugador.DesplacamentZ_EspaiUll = 0;
		Jugador.Temps_Caiguda = Jugador.Temps_Salt = 0;
	}
	


}


void JUGADOR_GuardarInfo(void)
{
#ifdef __SDL__

    FILE *fp;
    tFixed_Jugador Info_File_Jugador;


	if(fp=fopen("infoJugador.dat","wb"))
	{
#ifndef __ARITMETICA_FIXA__
		Info_File_Jugador.X = (int)((Jugador.X)*(1 << PART_FRACCIONAL));
		Info_File_Jugador.Z = (int)((Jugador.Z)*(1 << PART_FRACCIONAL));
#else
		Info_File_Jugador.X = Jugador.X;
		Info_File_Jugador.Z = Jugador.Z;
#endif
		
		memcpy(&Info_File_Jugador.AngleDireccio,&Jugador.AngleDireccio,sizeof(tFixed_Jugador) - sizeof(Jugador.X) - sizeof(Jugador.Z));// (Sizeof int pq una adrea s de 32 bits)

		fwrite(&Info_File_Jugador,sizeof(tFixed_Jugador),1,fp);
		fclose(fp);
	}
#endif

}

