//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA


#ifndef __LLISTA_DINAMICA_H__
#define __LLISTA_DINAMICA_H__


/*************\
| INCLUSIONS  |
\*************/

#include "memoria.h"
#include "definicions.h"
#include "Llista_Estatica.h"

/*************\
| DEFINICIONS |
\*************/

#define FILO				0
#define FIFO				1
#define LIFO				2	// Existeix ?
#define LILO				3   // Existeix ?
#define ORDER_TO_ASCENDENT	4
#define ORDER_TO_DESCENDENT	5

/********************\
| DEFINICIO DE TIPUS |
\********************/

/*typedef struct{
	void *ptr_info;
	void (*ptr_destructor_function)(void *Info); // Destructor generic al punter info.
}tGeneric;*/

#define tGeneric	void *

typedef struct _tNodeSectorDepenent *PNodeSectorDepenent;
typedef struct _tNode	*PNode;


//typedef struct void		*Estructura_Info_Generica;



typedef struct _tNode{

	int ID_Node;	// Per poder ordenar els nodes segons ID.

	tGeneric InfoNode; // Tipus info de node genrica.

	PNode Seguent;  // Segent node...
	PNode Anterior; // Anterior node...

}tNode;


typedef struct _tLlistaNodes *PLlistaNodes;

typedef struct _tLlistaNodes{
	PNode Primer;
	PNode Ultim;
//	PNode NodeActual;

	int n_nodes,max_nodes;

	tLlistaEstatica LE;

	//(*)()

	// mes info...
}tLlistaNodes;

/*
typedef struct _tNodeSectorDepenent{

	//PNodeSectorDepenent LlistaSectorsDepenents;

	int					ID_SectorOrganitzador;

	PNodeSector         LListaSectorsDepenents;


}tNodeSectorDepenent;

typedef struct _tNodeOrganitzador{

	PNodeSectorDepenent LlistaSectorsDepenents;

	PNodeSector         LListaSectorsUnificats;


}_tNodeOrganitzador;
*/
/*******************\
| VARIABLES GLOBALS |
\*******************/


/********\
| MACROS |
\********/






/**********************************\
| PROTOTIPUS DE FUNCIONS I ACCIONS |
\**********************************/

void	LD_InitLlista(tLlistaNodes *LlistaNodes);
PNode	LD_Empilar(int ID_Node, tGeneric Info, tLlistaNodes *LlistaNodes, int tipus_empilatge);
void	LD_SetSuportLlista(int NElements, tLlistaNodes *LlistaNodes);
int		LD_EmpilarNode(tNode *Node, tLlistaNodes *LlistaNodes, int tipus_empilatge);




PNode LD_Extraure(int ID_Node, tLlistaNodes *LlistaNodes);
PNode LD_ExtraurePrimer(tLlistaNodes *LlistaNodes);
PNode LD_Cerca   (int ID_Node, PLlistaNodes  LlistaNodes);
//int LD_LlistaNoBuida(LlistaSectors) LlistaSector.

void LD_ColocarNodeADarrera(PNode Node_A_Recolocar, tLlistaNodes *LlistaNodes);
void LD_Borrar(int ID_Node, tLlistaNodes *LlistaNodes);
void LD_BorrarNodeRef(PNode Node_A_Borrar, tLlistaNodes *LlistaNodes);
void LD_Borrar_tots_els_nodes(tLlistaNodes *LlistaNodes);






#endif
