//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA


#ifndef __LLISTA_ESTATICA_H__
#define __LLISTA_ESTATICA_H__

#include "memoria.h"

typedef struct{
	int		NElements,MaxElements;
	void	**InfoLlistaEstatica;
}tLlistaEstatica;


typedef struct{
	int		Elements_Y,Max_Y;
	void	**InfoLlistaEstaticaY;
}tLlistaEstaticaX;

typedef struct{
	int					Elements_X,Max_X;
	tLlistaEstaticaX	*LlistaEstaticaX;
}tTaulaEstatica;



void LE_InitLlista(int MaxElements,tLlistaEstatica *LE);
void LE_Guardar(int ID_Element,void *Info,tLlistaEstatica *Llista);
void *LE_Extraure(int ID_Index,tLlistaEstatica *Llista);
void LE_BorrarLlista(tLlistaEstatica *LE);
void LE_Borrar(int ID_Index,tLlistaEstatica *Llista);



void TE_InitTaula(int MaxElementsAmplada,int MaxElementsAltura,tTaulaEstatica *TE);
void TE_Guardar(int id_x,int id_y,void *Info,tTaulaEstatica *Taula);
void *TE_Extraure(int id_x,int id_y,tTaulaEstatica *Taula);
void TE_BorrarLlista(tTaulaEstatica *LE);
void TE_Borrar(int id_x,int id_y,tTaulaEstatica *Taula);

#endif

