#include "Gestio_Nodes.h"
//#include 

//PNode LlistaNodes = NULL;
//PNode LlistaNodes = NULL;

void NODE_InitLlista(tLlistaNodes *LlistaNodes)
{
	memset(LlistaNodes,0,sizeof(tLlistaNodes));
}


//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
////
////	IMPLEMENTACI GESTIO DE NODES AMB CRREGA DE INFORMACI GENERICA...
////
////
 int NODE_EmpilarInfoFIFO(int ID_Node,tGeneric Info, tLlistaNodes *LlistaNodes)
{
	PNode NouNode;
	//llista_aux = LlistaNodes;
	
	Reservar_Memoria(NouNode,tNode,1);//sizeof(tNode))) == NULL) 
	
	if(NouNode == NULL)
	{
		PRINT_ERROR("\nMemria insuficient per donar %i bytes per empilar info FIFO!!!",sizeof(tNode));
		return FALS;
	}
	
	// mplim info nou node...	
	NouNode->ID_Node = ID_Node;
	NouNode->InfoNode = Info;
	
	if(LlistaNodes->Primer == NULL) // Primer nou node...
	{

		LlistaNodes->NodeActual =LlistaNodes->Ultim =LlistaNodes->Primer = NouNode;
		NouNode->Seguent = NouNode;
		NouNode->Anterior = NouNode;
		LlistaNodes->n_nodes = 1;
	}
	else // Encuem node al estil FIFO (First Input - First OutPut)...
	{
		// Actualitzaci apuntadors nou node...
		NouNode->Seguent =  LlistaNodes->Primer;
		NouNode->Anterior = LlistaNodes->Ultim;
		
		// llista nodes actualitzada...
		if(LlistaNodes->Ultim == LlistaNodes->Primer)
			LlistaNodes->Primer->Seguent = NouNode;

		LlistaNodes->Primer->Anterior = NouNode;
		
		LlistaNodes->Ultim->Seguent = NouNode;
		LlistaNodes->Ultim = NouNode;
		

		
		
		
		LlistaNodes->n_nodes++;
		
		
	}
	
	return CERT;
	
}



 int NODE_EmpilarInfoFILO(int ID_Node,tGeneric Info, tLlistaNodes *LlistaNodes)
{
	PNode NouNode;
	//llista_aux = (*LlistaNodes);
	
	Reservar_Memoria(NouNode,tNode,1);//sizeof(tNode))) == NULL) 
	
	if(NouNode == NULL)
	{
		PRINT_ERROR("\nMemria insuficient per donar %i bytes per empilar info FILO!!!",sizeof(tNode));
		return FALS;
	}
	
	// mplim info nou node...	
	NouNode->ID_Node = ID_Node;
	NouNode->InfoNode = Info;
	
	if(LlistaNodes->Primer == NULL) // Primer nou node...
	{
		NouNode->Seguent = NouNode;
		NouNode->Anterior = NouNode;
		LlistaNodes->NodeActual =LlistaNodes->Ultim =LlistaNodes->Primer = NouNode;
		LlistaNodes->n_nodes = 1;
	}
	else // Encuem node al estil de pila (First Input - Last OutPut)...
	{
		// Actualitzaci apuntadors nou node...
		NouNode->Seguent =  LlistaNodes->Primer;
		NouNode->Anterior = LlistaNodes->Ultim;
		
		// Actualitzaci llista nodes...

		if(LlistaNodes->Ultim == LlistaNodes->Primer)
			LlistaNodes->Ultim->Anterior = NouNode;
	
		LlistaNodes->Ultim->Seguent = NouNode;

		LlistaNodes->Primer->Anterior = NouNode;

		LlistaNodes->Primer = NouNode;
				

		LlistaNodes->n_nodes++;
		
	}
	
	return CERT;
	
}



 int NODE_EmpilarInfoLIFO(int ID_Node,tGeneric Info, tLlistaNodes *LlistaNodes)
{
	return CERT;	
}



 int NODE_EmpilarInfoLILO(int ID_Node,tGeneric Info, tLlistaNodes *LlistaNodes)
{
	return CERT;
}




 int NODE_EmpilarInfo_ORDER_TO_ASCENDENT(int ID_Node,tGeneric Info, tLlistaNodes *LlistaNodes)
{
	//
	// PRE: Es suposa que la llista ja esta ordenada ascendenment.
	//
	PNode NouNode,Previus_Node,Actual_Node;
	//PLlistaNodes llista_aux;
	int End;
	
	//llista_aux = (*LlistaNodes);
	
	Reservar_Memoria(NouNode,tNode,1);//sizeof(tNode))) == NULL) 
	
	if(NouNode == NULL)
	{
		PRINT_ERROR("\nMemria insuficient per donar %i bytes per empilar info FILO!!!",sizeof(tNode));
		return FALS;
	}
	
	// mplim info nou node...	
	NouNode->ID_Node = ID_Node;
	NouNode->InfoNode = Info;
	
	if(LlistaNodes->Primer == NULL) // Primer nou node...
	{
		NouNode->Seguent = NouNode;
		NouNode->Anterior = NouNode;
		LlistaNodes->NodeActual =LlistaNodes->Ultim =LlistaNodes->Primer = NouNode;
		LlistaNodes->n_nodes = 1;
	}
	else // Encuem el node en ordre ASCENDENT segons el seu ID...
	{
		
		Previus_Node = Actual_Node = LlistaNodes->Primer;
		End = FALS;
		
		while((Actual_Node != NULL) && !End)
		{
			if( ID_Node < Actual_Node->ID_Node)
			{
				End = CERT;			
			}
			else
			{
				Previus_Node = Actual_Node;
				Actual_Node = Actual_Node->Seguent;				
				
			}
			
			
		}
		
		
		if(Previus_Node == LlistaNodes->Primer && Actual_Node == LlistaNodes->Primer) // The new node will be the first of list nodes...
		{
			
			// Actualitzaci apuntadors nou node...
			NouNode->Seguent =  LlistaNodes->Primer;
			NouNode->Anterior = LlistaNodes->Ultim;
			
			// llista nodes actualitzada...
			LlistaNodes->Ultim = NouNode;
			LlistaNodes->n_nodes++;
			
		}
		else
		{	
			if(Actual_Node == LlistaNodes->Ultim) // The new node will be the first of list nodes...
			{
				// Actualitzaci apuntadors nou node...
				NouNode->Seguent =  LlistaNodes->Primer;
				NouNode->Anterior = LlistaNodes->Ultim;
				
				// Actualitzaci llista nodes...
				LlistaNodes->Primer = NouNode;
				LlistaNodes->n_nodes++;
				
			}
			else // El node esta entremitg de la llista...
			{
				// Actualitzaci apuntadors nou node...
				NouNode->Seguent  = Actual_Node;
				NouNode->Anterior = Previus_Node;
				
				// Actualitzaci apuntadors del node previ i actual...
				Previus_Node->Seguent = NouNode;
				Actual_Node->Anterior = NouNode;
			}
			
		}
		
		
		
	}
	
	
	return CERT;
	
	
	
}



 int NODE_EmpilarInfo_ORDER_TO_DESCENDENT(int ID_Node,tGeneric Info, tLlistaNodes *LlistaNodes)
{
	//
	// PRE: Es suposa que la llista ja esta ordenada descendenment.
	//
	PNode NouNode,Previus_Node,Actual_Node;
//	PLlistaNodes llista_aux;
	int End;
	//llista_aux = (*LlistaNodes);
	
	Reservar_Memoria(NouNode,tNode,1);//sizeof(tNode))) == NULL) 
	
	if(NouNode == NULL)
	{
		PRINT_ERROR("\nMemria insuficient per donar %i bytes per empilar info FILO!!!",sizeof(tNode));
		return FALS;
	}
	
	// mplim info nou node...	
	NouNode->ID_Node = ID_Node;
	NouNode->InfoNode = Info;
	
	if(LlistaNodes->Primer == NULL) // Primer nou node...
	{
		NouNode->Seguent = NouNode;
		NouNode->Anterior = NouNode;
		LlistaNodes->NodeActual =LlistaNodes->Ultim =LlistaNodes->Primer = NouNode;
		LlistaNodes->n_nodes = 1;
	}
	else // Encuem el node en ordre DESCENDENT segons el seu ID...
	{
		
		Previus_Node = Actual_Node = LlistaNodes->Primer;
		End = FALS;
		
		while((Actual_Node != NULL) && !End)
		{
			if( ID_Node > Actual_Node->ID_Node)
			{
				End = CERT;			
			}
			else
			{
				Previus_Node = Actual_Node;
				Actual_Node = Actual_Node->Seguent;				
				
			}
			
			
		}
		
		
		if(Previus_Node == LlistaNodes->Primer && Actual_Node == LlistaNodes->Primer) // The new node will be the first of list nodes...
		{
			
			// Actualitzaci apuntadors nou node...
			NouNode->Seguent =  LlistaNodes->Primer;
			NouNode->Anterior = LlistaNodes->Ultim;
			
			// llista nodes actualitzada...
			LlistaNodes->Ultim = NouNode;
			LlistaNodes->n_nodes++;
			
		}
		else
		{	
			if(Actual_Node == LlistaNodes->Ultim) // The new node will be the first of list nodes...
			{
				// Actualitzaci apuntadors nou node...
				NouNode->Seguent =  LlistaNodes->Primer;
				NouNode->Anterior = LlistaNodes->Ultim;
				
				// Actualitzaci llista nodes...
				LlistaNodes->Primer = NouNode;
				LlistaNodes->n_nodes++;
				
			}
			else // El node esta entremitg de la llista...
			{
				// Actualitzaci apuntadors nou node...
				NouNode->Seguent  = Actual_Node;
				NouNode->Anterior = Previus_Node;
				
				// Actualitzaci apuntadors del node previ i actual...
				Previus_Node->Seguent = NouNode;
				Actual_Node->Anterior = NouNode;
				
				
				LlistaNodes->n_nodes++;
			}
			
		}
	}
	
	
	return CERT;
	
}

int NODE_Empilar(int ID_Node, tGeneric Info, tLlistaNodes *LlistaNodes, int tipus_empilatge)
{
	switch(tipus_empilatge)
	{
	case FILO: return NODE_EmpilarInfoFILO(ID_Node, Info, LlistaNodes);break;
	case FIFO:return NODE_EmpilarInfoFIFO(ID_Node, Info, LlistaNodes);break;
	case LIFO:return NODE_EmpilarInfoLIFO(ID_Node, Info, LlistaNodes);break;
	case LILO:return NODE_EmpilarInfoLILO(ID_Node, Info, LlistaNodes);break;
	case ORDER_TO_ASCENDENT: return NODE_EmpilarInfo_ORDER_TO_ASCENDENT(ID_Node, Info, LlistaNodes);break;
	case ORDER_TO_DESCENDENT:return NODE_EmpilarInfo_ORDER_TO_DESCENDENT(ID_Node, Info, LlistaNodes);break;
	default:
		PRINT_ERROR("\nEl tipus de empilatge s invalid!!!",0);
		return FALS;
	}

	
}

////
////  
////
////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
////
////  
////
////

 int NODE_EmpilarNodeFIFO(tNode *Node, tLlistaNodes *LlistaNodes)
{
	if(LlistaNodes->Primer == NULL) // Primer node ...
	{
		Node->Anterior = Node;
		Node->Seguent = Node;
		LlistaNodes->Primer = LlistaNodes->Ultim = Node;
		LlistaNodes->n_nodes = 1;

	}
	else // Empilatge FIFO...
	{
	/*	
		LlistaNodes->Ultim = Node;
		LlistaNodes->n_nodes++;*/
		
		Node->Seguent  = LlistaNodes->Primer;
		Node->Anterior = LlistaNodes->Ultim;

		if(LlistaNodes->Ultim == LlistaNodes->Primer)
			LlistaNodes->Primer->Seguent = Node;

		LlistaNodes->Primer->Anterior = Node;
		
		LlistaNodes->Ultim->Seguent = Node;
		LlistaNodes->Ultim = Node;
		
		LlistaNodes->n_nodes++;
	}




}

 int NODE_EmpilarNodeFILO(tNode *Node, tLlistaNodes *LlistaNodes)
{
	if(LlistaNodes == NULL) // Primer node ...
	{
		Node->Anterior = Node;
		Node->Seguent = Node;
		LlistaNodes->Primer = LlistaNodes->Ultim = Node;
		LlistaNodes->n_nodes = 1;

	}
	else // Empilatge FILO...
	{
		Node->Seguent  = LlistaNodes->Primer;
		Node->Anterior = LlistaNodes->Ultim;

		if(LlistaNodes->Ultim == LlistaNodes->Primer)
			LlistaNodes->Ultim->Anterior = Node;
	
		LlistaNodes->Ultim->Seguent = Node;

		LlistaNodes->Primer->Anterior = Node;

		LlistaNodes->Primer = Node;
				

		LlistaNodes->n_nodes++;
		LlistaNodes->n_nodes++;
	}

	//return CERT;



}

int NODE_EmpilarNode(tNode *Node, tLlistaNodes *LlistaNodes, int tipus_empilatge)
{

	switch(tipus_empilatge)
	{
	case FILO: NODE_EmpilarNodeFILO(Node,  LlistaNodes);break;
	case FIFO: NODE_EmpilarNodeFIFO(Node, LlistaNodes);break;
	default:
		PRINT_ERROR("\nEl tipus de empilatge s invalid!!!",0);
		return FALS;
	}


	return CERT;


}


////
////  
////
////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

/*
PNode NODE_CercaRecursiva(int ID_Node, PNode Node_Actual,int nivell)
{
		if(nivell == 0)
		{
			return NULL;
		}
		else
		{
			if(Node_Actual->ID_Node == ID_Node) return Node_Actual;
			else return NODE_CercaRecursiva(ID_Node, Node_Actual->Seguent,--nivell);
		}
}*/


PNode NODE_Cerca(int ID_Node, PLlistaNodes LlistaNodes)
{
	int NNodes;
	PNode Node_Actual;

	if(LlistaNodes == NULL) return NULL;

	NNodes = LlistaNodes->n_nodes;
	Node_Actual = LlistaNodes->Primer;
	
	while(NNodes--)
	{
		if(Node_Actual->ID_Node == ID_Node) return Node_Actual;
		
		Node_Actual = Node_Actual->Seguent;

	}

	return NULL;
/*	if(LlistaNodes == NULL)
	{
		return NULL;	
	}
	else
	{
		return NODE_CercaRecursiva(ID_Node, LlistaNodes->Primer,LlistaNodes->n_nodes);
	}*/
}


PNode NODE_Extraure(int ID_Node, tLlistaNodes *LlistaNodes)
{
	PNode NodeExtret;


	NodeExtret = NODE_Cerca(ID_Node,LlistaNodes);

	if(NodeExtret != NULL) // Realitzem les conexions pertinents...
	{

		if(LlistaNodes->n_nodes == 1)
		{
			NodeExtret = LlistaNodes->Primer;

			LlistaNodes->Primer = NULL;
			LlistaNodes->NodeActual = NULL;
			LlistaNodes->Ultim = NULL;
			LlistaNodes->n_nodes = 0;
		}
		else
		{
			
			if(NodeExtret == LlistaNodes->Primer)
			{
				LlistaNodes->Primer   = NodeExtret->Seguent;
				//LlistaNodes->Primer->Anterior = LlistaNodes->Ultim;
				//LlistaNodes->Ultim->Seguent = LlistaNodes->Primer;
				LlistaNodes->n_nodes--;
			}
			else
			{
				if(NodeExtret == LlistaNodes->Ultim)
				{
					LlistaNodes->Ultim			= NodeExtret->Anterior;
					//LlistaNodes->Primer->Anterior = LlistaNodes->Ultim;
					//LlistaNodes->Ultim->Seguent = LlistaNodes->Primer;
					LlistaNodes->n_nodes--;
				}
				else // cap problema...
				{
										
				}
				
			}

			NodeExtret->Seguent->Anterior  = NodeExtret->Anterior;
			NodeExtret->Anterior->Seguent  = NodeExtret->Seguent;

			// Fet..
		}

		
	
	}

	return NodeExtret;
	
}

void NODE_ColocarNodeADarrera(PNode Node_A_Recolocar, tLlistaNodes *LlistaNodes)
{
	
			if(Node_A_Recolocar == LlistaNodes->Primer)
			{
				LlistaNodes->Primer   = Node_A_Recolocar->Seguent;
				//LlistaNodes->Primer->Anterior = LlistaNodes->Ultim;
				//LlistaNodes->Ultim->Seguent = LlistaNodes->Primer;
//				LlistaNodes->n_nodes--;
			}
			else
			{
				if(Node_A_Recolocar == LlistaNodes->Ultim)
				{
					LlistaNodes->Ultim			= Node_A_Recolocar->Anterior;
					//LlistaNodes->Primer->Anterior = LlistaNodes->Ultim;
					//LlistaNodes->Ultim->Seguent = LlistaNodes->Primer;
		
				}
				else // cap problema...
				{
										
				}
				
			}

			Node_A_Recolocar->Seguent->Anterior  = Node_A_Recolocar->Anterior;
			Node_A_Recolocar->Anterior->Seguent  = Node_A_Recolocar->Seguent;

			// I ara el coloquem al final...

			NODE_EmpilarNode(Node_A_Recolocar, LlistaNodes, FIFO);
	
}

void NODE_Borrar(int ID_Node, tLlistaNodes *LlistaNodes)
{
	PNode Node_A_Borrar;

	if((Node_A_Borrar = NODE_Cerca(ID_Node,LlistaNodes)) != NULL)
	{
		if((Node_A_Borrar == LlistaNodes->Primer) && (Node_A_Borrar == LlistaNodes->Ultim))
		{
			// Un sol node...
			Alliberar_Punter(Node_A_Borrar->InfoNode);
			Alliberar_Punter(Node_A_Borrar);

			LlistaNodes->NodeActual = LlistaNodes->Primer = LlistaNodes->Ultim = NULL;
			LlistaNodes->n_nodes = 0;	


		}
		else
		{
			if(Node_A_Borrar == LlistaNodes->Primer)
			{
				LlistaNodes->Primer = Node_A_Borrar->Seguent;		
			}
			else
			{
				if(Node_A_Borrar == LlistaNodes->Ultim)
				{
					LlistaNodes->Ultim = Node_A_Borrar->Anterior;
				}
			}
			
			Node_A_Borrar->Seguent->Anterior = Node_A_Borrar->Anterior;
			Node_A_Borrar->Anterior->Seguent = Node_A_Borrar->Seguent;
			
			Alliberar_Punter(Node_A_Borrar->InfoNode);
			Alliberar_Punter(Node_A_Borrar);

			LlistaNodes->n_nodes--;	
		
		
		}

	
	}
	

}


//
// METODE DE DESEMPILAR NODE PER REFERENCIA (+ RAPID)
//
void NODE_BorrarNodeRef(PNode Node_A_Borrar, tLlistaNodes *LlistaNodes)
{
	if(LlistaNodes != NULL && Node_A_Borrar != NULL)
	{
		if((LlistaNodes->Primer == Node_A_Borrar) && (LlistaNodes->Ultim == Node_A_Borrar)) // Un node...
		{
			LlistaNodes->Primer = LlistaNodes->Ultim = LlistaNodes->NodeActual = NULL;

			Alliberar_Punter(Node_A_Borrar->InfoNode);
			Alliberar_Punter(Node_A_Borrar);
			Node_A_Borrar = NULL;
			LlistaNodes->n_nodes = 0;
		}
		else // + de un node...
		{
			if(Node_A_Borrar == LlistaNodes->Primer)
			{
				LlistaNodes->Primer = Node_A_Borrar->Seguent;		
				//LlistaNodes->Ultim->Anterior = LlistaNodes->Primer;
			}
			else 
			{
				if(Node_A_Borrar == LlistaNodes->Ultim)
				{
					LlistaNodes->Ultim = Node_A_Borrar->Anterior;
				}
			}
			
			Node_A_Borrar->Seguent->Anterior = Node_A_Borrar->Anterior;
			Node_A_Borrar->Anterior->Seguent = Node_A_Borrar->Seguent;
			
			Alliberar_Punter(Node_A_Borrar->InfoNode);
			Alliberar_Punter(Node_A_Borrar);
			
			LlistaNodes->n_nodes--;	
		}
		
	}
}


void NODE_Borrar_tots_els_nodes(tLlistaNodes *LlistaNodes)
{
	PNode Node_Actual = LlistaNodes->Primer,Node_A_Borrar;
	int NNodes = LlistaNodes->n_nodes;


	while(NNodes--)
	{
		Node_A_Borrar = Node_Actual;
		Node_Actual = Node_Actual->Seguent;

		Alliberar_Punter(Node_A_Borrar->InfoNode);
		Alliberar_Punter(Node_A_Borrar);
	
	
	}


	LlistaNodes->Primer = LlistaNodes->Ultim = LlistaNodes->NodeActual = NULL;


}


