void Init_Mapa2D_1(tMapaMon *MapaMon)
{
	int NumeroDeMapa = MapaMon->N_Mapes2D;
 //   s16 textura_superior,textura_mitg,textura_inferior;

	tVertex V0,V1;
	tParametres_Nou_Sector Parametres_Sector;
	tSector   Nou_Sector;

    u32 Propietats = 0;

    SET_BIT(Propietats, BIT_RENDER_WITH_BRIGHT);
	

	//-----------------------------------------//
	// Inicialitzaci del Inicialitzacio_Mapa. //
	//-----------------------------------------//


	MAPA_CrearNouMapa(0,&MapaMon->Mapa2D[NumeroDeMapa]);

    
	//----------------------------
	//
	// Construcci de primer sector:
	// ____________________________
	//
	//
	// Sector 0: Vista previa del primer sector (un quadrat)...
	//
	// 
	//
	//     (254,576)		Linia 0		  (512,576)
	//         *----------------------*
	//  	   | 				      |
	//  	   |                      |  Linia 1
	//  	   |                      |
	// Linia 5 |                    ---- (512, 640)
	//  	   |                      |
	//  	   |                      |  Portal al sector 1 (Linia 2)
	//  	   |                      |
	//	       |                    ---- (512, 704)
	//  	   |                      |
	//  	   |                      |  Linia 3
	//  	   |                      |
	//   	   *----------------------*
	//   (254,768)       Linia 4         (512,768)
	//

	//-----------------------------------//
	// Inicialitzaci base del sector 0. //
	//-----------------------------------//

	Parametres_Sector.iluminacio = 1;
	Parametres_Sector.Textura_Sostre = 2;
	Parametres_Sector.Textura_Terra = 3;
	Parametres_Sector.AlturaTerra = 0;
	Parametres_Sector.AlturaSostre = 80;

	Sector_NouSector(Parametres_Sector,&Nou_Sector);


	//-------------------------------------------//
	// Inicialitzaci de les linees de sector 0. //
	//-------------------------------------------//

  

	// Linia 0.
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X     = INT_TO_FIXED(254) ; V0.Z = INT_TO_FIXED(576 );
	V1.X     = INT_TO_FIXED(512 ); V1.Z = INT_TO_FIXED(576 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3,15,3,Propietats,&Nou_Sector);
	
	// Linia 1.
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(512);    V0.Z = INT_TO_FIXED(576);
	V1.X = INT_TO_FIXED(512);    V1.Z = INT_TO_FIXED(640 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3,16,3,Propietats,&Nou_Sector);
	
	// Linia 2. (Portal al sector 1)
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(512)  ; V0.Z = INT_TO_FIXED(640 );
	V1.X = INT_TO_FIXED(512 ); V1.Z = INT_TO_FIXED(704 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
    SECTOR_AfegirLinia(V0,V1,1,0,1,Propietats,&Nou_Sector);
	
	// Linia 3.
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(512 ); V0.Z = INT_TO_FIXED(704 );
	V1.X = INT_TO_FIXED(512 ); V1.Z = INT_TO_FIXED(768 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3,16,3,Propietats,&Nou_Sector);
	
	// Linia 4.
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(512)  ; V0.Z = INT_TO_FIXED(768 );
	V1.X = INT_TO_FIXED(254)  ; V1.Z = INT_TO_FIXED(768 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3,15,3,Propietats,&Nou_Sector);
	

	// Linia 5.
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(254 ); V0.Z = INT_TO_FIXED(768 );
	V1.X = INT_TO_FIXED(254 ); V1.Z = INT_TO_FIXED(576 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3,16,3,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);


	//////////////////////////////////////////////////////////////////////
	// Construcci sector S1 : Pass ascensor al pis amb llum intermitent//
	//////////////////////////////////////////////////////////////////////


	Parametres_Sector.iluminacio = 1;
	Parametres_Sector.Textura_Sostre = 9;
	Parametres_Sector.Textura_Terra = 9;
	Parametres_Sector.AlturaTerra = 0;
	Parametres_Sector.AlturaSostre = 80;

	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 .
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(512 ); V0.Z = INT_TO_FIXED(640 );
	V1.X = INT_TO_FIXED(528 ); V1.Z = INT_TO_FIXED(640 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,1,2,Propietats,&Nou_Sector);

	// Linia 1 (portal al al nivell -S2-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(528 ); V0.Z = INT_TO_FIXED(640 );
	V1.X = INT_TO_FIXED(528 ); V1.Z = INT_TO_FIXED(704 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,0,1,Propietats,&Nou_Sector);

	// Linia 2 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(528 ); V0.Z = INT_TO_FIXED(704 );
	V1.X = INT_TO_FIXED(512 ); V1.Z = INT_TO_FIXED(704 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,1,2,Propietats,&Nou_Sector);


	// Linia 3 (portal al ascensor -S0-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(512 ); V0.Z = INT_TO_FIXED(704 );
	V1.X = INT_TO_FIXED(512 ); V1.Z = INT_TO_FIXED(640 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,0,1,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);


	////////////////////////////////////////////////////////////////////////////
	// Construcci sector S2: Part passadis amb llum intermitent sincronitzat //
	////////////////////////////////////////////////////////////////////////////


	Parametres_Sector.iluminacio = 1;
	Parametres_Sector.Textura_Sostre = 4;
	Parametres_Sector.Textura_Terra = 5;
	Parametres_Sector.AlturaTerra = 0;
	Parametres_Sector.AlturaSostre = 80;

	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 (portal al sector -S4-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(528 ); V0.Z = INT_TO_FIXED(640 );
	V1.X = INT_TO_FIXED(704 ); V1.Z = INT_TO_FIXED(640 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
    SECTOR_AfegirLinia(V0,V1,1,0,1,Propietats,&Nou_Sector);

	// Linia 1 .
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(704 ); V0.Z = INT_TO_FIXED(640 );
	V1.X = INT_TO_FIXED(704 ); V1.Z = INT_TO_FIXED(704 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,19,1,Propietats,&Nou_Sector);

	// Linia 2 (portal al sector S3).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(704 ); V0.Z = INT_TO_FIXED(704 );
	V1.X = INT_TO_FIXED(528 ); V1.Z = INT_TO_FIXED(704 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,0,1,Propietats,&Nou_Sector);


	// Linia 3 (portal al pass de ascensor -S1-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(528 ); V0.Z = INT_TO_FIXED(704 );
	V1.X = INT_TO_FIXED(528 ); V1.Z = INT_TO_FIXED(640 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,0,1,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);





	////////////////////////////////////////////
	// Construcci sector S3: Part passadis 1 //
	////////////////////////////////////////////


	Parametres_Sector.iluminacio = -52;
	Parametres_Sector.Textura_Sostre = 4;
	Parametres_Sector.Textura_Terra = 5;
	Parametres_Sector.AlturaTerra = 0;
	Parametres_Sector.AlturaSostre = 80;
	
	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 (portal la part de passadis amb llum intermitent sincronitzat -S2-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(528 ); V0.Z = INT_TO_FIXED(704 );
	V1.X = INT_TO_FIXED(704 ); V1.Z = INT_TO_FIXED(704 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,0,1,Propietats,&Nou_Sector);

	// Linia 1 
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(704 ); V0.Z = INT_TO_FIXED(704 );
	V1.X = INT_TO_FIXED(704 ); V1.Z = INT_TO_FIXED(1000);
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,19,1,Propietats,&Nou_Sector);

	// Linia 2 
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(704 ); V0.Z = INT_TO_FIXED(1000 );
	V1.X = INT_TO_FIXED(528 ); V1.Z = INT_TO_FIXED(1000);
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,19,1,Propietats,&Nou_Sector);


	// Linia 3 
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(528 ); V0.Z = INT_TO_FIXED(1000);
	V1.X = INT_TO_FIXED(528 ); V1.Z = INT_TO_FIXED(704 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,19,1,Propietats,&Nou_Sector);

  	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);


	////////////////////////////////////////////
	// Construcci sector S4: Part passadis 2 //
	////////////////////////////////////////////


	Parametres_Sector.iluminacio = -52;
	Parametres_Sector.Textura_Sostre = 4;
	Parametres_Sector.Textura_Terra = 5;
	Parametres_Sector.AlturaTerra = 0;
	Parametres_Sector.AlturaSostre = 80;

	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(528 ); V0.Z = INT_TO_FIXED(478 );
	V1.X = INT_TO_FIXED(600 ); V1.Z = INT_TO_FIXED(478 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,19,1,Propietats,&Nou_Sector);

	// Linia 1 (portal al sector amb pendent -S21-)
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(600 ); V0.Z = INT_TO_FIXED(478 );
	V1.X = INT_TO_FIXED(690 ); V1.Z = INT_TO_FIXED(478 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,19,1,Propietats,&Nou_Sector);


	// Linia 2
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(690 ); V0.Z = INT_TO_FIXED(478 );
	V1.X = INT_TO_FIXED(704 ); V1.Z = INT_TO_FIXED(478 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,19,1,Propietats,&Nou_Sector);

	// Linia 3 (portal al tunel que connecta amb el sector hexagonal -S5-)
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(704 ); V0.Z = INT_TO_FIXED(478);
	V1.X = INT_TO_FIXED(704 ); V1.Z = INT_TO_FIXED(542 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,0,1,Propietats,&Nou_Sector);

	// Linia 4
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(704 ); V0.Z = INT_TO_FIXED(542 );
	V1.X = INT_TO_FIXED(704 ); V1.Z = INT_TO_FIXED(640 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,19,1,Propietats,&Nou_Sector);


	// Linia 5 (portal al passadis amb intermitencia -S2-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(704 ); V0.Z = INT_TO_FIXED(640 );
	V1.X = INT_TO_FIXED(528 ); V1.Z = INT_TO_FIXED(640 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,0,1,Propietats,&Nou_Sector);


	// Linia 6.
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(528 ); V0.Z = INT_TO_FIXED(640 );
	V1.X = INT_TO_FIXED(528 ); V1.Z = INT_TO_FIXED(478);
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,19,1,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);


	/////////////////////////////////////////////////////////////////
	// Construcci sector S5: Tunel connectant al sector hexagonal //
	/////////////////////////////////////////////////////////////////


	Parametres_Sector.iluminacio = -52;
	Parametres_Sector.Textura_Sostre = 4;
	Parametres_Sector.Textura_Terra =  5;
	Parametres_Sector.AlturaTerra = 0;
	Parametres_Sector.AlturaSostre = 80;

	Sector_NouSector(Parametres_Sector,&Nou_Sector);
	

	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 .
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(704 ); V0.Z = INT_TO_FIXED(478 );
	V1.X = INT_TO_FIXED(768 ); V1.Z = INT_TO_FIXED(478 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,19,1,Propietats,&Nou_Sector);

	// Linia 1 (portal que connecta al sector hexagonal -S6-)
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(768 ); V0.Z = INT_TO_FIXED(478);
	V1.X = INT_TO_FIXED(768 ); V1.Z = INT_TO_FIXED(542 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,0,1,Propietats,&Nou_Sector);

	// Linia 2 
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(768 ); V0.Z = INT_TO_FIXED(542 );
	V1.X = INT_TO_FIXED(704 ); V1.Z = INT_TO_FIXED(542);
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,19,1,Propietats,&Nou_Sector);


	// Linia 3 (portal que connecta al passadis -S4-)
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(704 ); V0.Z = INT_TO_FIXED(542);
	V1.X = INT_TO_FIXED(704 ); V1.Z = INT_TO_FIXED(478);
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,0,1,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);

	/////////////////////////////////////////////////////////////////
	// Construcci sector S6: Tunel connectant al sector hexagonal //
	/////////////////////////////////////////////////////////////////
	//   
	// ==============================================================================
	//


	//
	// Construcci del 6 sector:
	// ____________________________
	//
	//
	// Sector 1: HEXAGON.
    //
	// 
	//
	//.					            (930,0)  Linea 0	   (1374,0)
	//.					                  *--------------*
	//.					                 / |            | \
	//.					        L13     /  |           |   \     Linea 1
	//.				               	   /    |		  |	    \
	//.					              /     |         |      \
	//					             | (768,162)      |       ---  (1536,162)
	//					        L11  |      |         |        |
	//					             |      |         |        |    linia 2
    // Portal al sector 0 (Linea 7) ----(768,478)     |       ---  (1536,384)
	//					         L10 |      |         |        |
	//					            ----(768,542)     |        |    linia 3
	//				   	          L9 |  (768,606)     |       --- (1536,606)
	//					              \	     |        |       /  
	//					               \      |      |       /
	//				                L8  \     |      |      /    Linea 4
	//				                     \ (960,768) (1088,768)  /           
	//					   	   	          *-----|---|----*
	//				             (930,768)  L7      L6  L5    (1374,768)
	//

	Parametres_Sector.iluminacio = -52;
	Parametres_Sector.Textura_Sostre =  4;
	Parametres_Sector.Textura_Terra =  6;
	Parametres_Sector.AlturaTerra = 8;
	Parametres_Sector.AlturaSostre = 300;
	

	Sector_NouSector(Parametres_Sector,&Nou_Sector);
	
	
	// Linea 0 (portal la part del sector hexagonal illuminat -S19-)
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(930)  ; V0.Z = INT_TO_FIXED(0 );
	V1.X = INT_TO_FIXED(1088) ; V1.Z = INT_TO_FIXED(768 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,0,1,Propietats,&Nou_Sector);


	// Linea 1 
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1088); V0.Z = INT_TO_FIXED(768 );
	V1.X = INT_TO_FIXED(930);  V1.Z = INT_TO_FIXED(768 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,18,1,Propietats,&Nou_Sector);

	// Linea 2.
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(930) ; V0.Z = INT_TO_FIXED(768 );
	V1.X = INT_TO_FIXED(768) ; V1.Z = INT_TO_FIXED(606 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,18,1,Propietats,&Nou_Sector);


	// Linea 3.
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(768) ; V0.Z = INT_TO_FIXED(606 );
	V1.X = INT_TO_FIXED(768) ; V1.Z = INT_TO_FIXED(542 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,18,1,Propietats,&Nou_Sector);

	// Linea 4 (portal al tunel connectant -S5-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(768)  ; V0.Z = INT_TO_FIXED(542 );
	V1.X = INT_TO_FIXED(768) ; V1.Z = INT_TO_FIXED(478 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,18,0,18,Propietats,&Nou_Sector);


	// Linea 5.
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(768) ; V0.Z = INT_TO_FIXED(478 );
	V1.X = INT_TO_FIXED(768) ; V1.Z = INT_TO_FIXED(162 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,18,1,Propietats,&Nou_Sector);
	
	// Linea 6.
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(768)  ; V0.Z = INT_TO_FIXED(162 );
	V1.X = INT_TO_FIXED(930) ; V1.Z = INT_TO_FIXED(0 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,18,1,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);

	////////////////////////////////////////////////////////////////
	// Construcci del sector hexagonal iluminat (S7) : 4 lnies //
	////////////////////////////////////////////////////////////////



	Parametres_Sector.iluminacio = 2;
	Parametres_Sector.Textura_Sostre = 4;
	Parametres_Sector.Textura_Terra = 6;
	Parametres_Sector.AlturaTerra = 8;
	Parametres_Sector.AlturaSostre = 300;
	

	Sector_NouSector(Parametres_Sector,&Nou_Sector);
	
	
	// Linea 0.
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(930)  ; V0.Z = INT_TO_FIXED(0 );
	V1.X = INT_TO_FIXED(1374) ; V1.Z = INT_TO_FIXED(0 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,1,18,1,Propietats,&Nou_Sector);

	// Linea 1 (Portal a la parts del sector hexagonal -S20-)
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1374) ; V0.Z = INT_TO_FIXED(0 );
	V1.X = INT_TO_FIXED(1216) ; V1.Z = INT_TO_FIXED(768 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);

   // Linea 2.(portal al pou -S18-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1216)  ; V0.Z = INT_TO_FIXED(768 );
	V1.X = INT_TO_FIXED(1088 ); V1.Z = INT_TO_FIXED(768 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,24,17,Propietats,&Nou_Sector);

	// Linea 3.(portal a la part 1era del sector hexagonal -S6-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1088)  ; V0.Z = INT_TO_FIXED(768);
	V1.X = INT_TO_FIXED(930) ; V1.Z = INT_TO_FIXED(0 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);
    
	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);

	///////////////////////////////////////////////////////////////
	// Construcci de la resta sector hexagonal (S8) : 6 lnies //
	///////////////////////////////////////////////////////////////

	
	Parametres_Sector.iluminacio = -52;
	Parametres_Sector.Textura_Sostre = 4;
	Parametres_Sector.Textura_Terra = 6;
	Parametres_Sector.AlturaTerra = 8;
	Parametres_Sector.AlturaSostre = 300;
		

	Sector_NouSector(Parametres_Sector,&Nou_Sector);
	

	// Linea 0.
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1374) ; V0.Z = INT_TO_FIXED(0 );
	V1.X = INT_TO_FIXED(1414) ; V1.Z = INT_TO_FIXED(40 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,18,2,Propietats,&Nou_Sector);


    V0.X = INT_TO_FIXED(1414) ; V0.Z = INT_TO_FIXED(40 );
	V1.X = INT_TO_FIXED(1496) ; V1.Z = INT_TO_FIXED(122 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,18,0,18,Propietats,&Nou_Sector);


    V0.X = INT_TO_FIXED(1496) ; V0.Z = INT_TO_FIXED(122 );
	V1.X = INT_TO_FIXED(1536) ; V1.Z = INT_TO_FIXED(162 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,18,18,18,Propietats,&Nou_Sector);

	// Linea 1 (repla)
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1536) ; V0.Z = INT_TO_FIXED(162 );
	V1.X = INT_TO_FIXED(1536) ; V1.Z = INT_TO_FIXED(273 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,18,Propietats,&Nou_Sector);

   // Linea 2.(portal al repla -SX-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1536)  ; V0.Z = INT_TO_FIXED(273 );
	V1.X = INT_TO_FIXED(1536 ); V1.Z = INT_TO_FIXED(384 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3/*-GREY_COLOR*/,0,18,Propietats,&Nou_Sector);


	// Linea 3.(portal al primer esgla SX).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1536)  ; V0.Z = INT_TO_FIXED(384 );
	V1.X = INT_TO_FIXED(1536) ; V1.Z = INT_TO_FIXED(606 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,18,Propietats,&Nou_Sector);
    
	// Linea 4.
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1536)   ; V0.Z = INT_TO_FIXED(606 );
	V1.X = INT_TO_FIXED(1374) ; V1.Z = INT_TO_FIXED(768 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,18,2,Propietats,&Nou_Sector);


	// Linea 5.
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1374)   ; V0.Z = INT_TO_FIXED(768 );
	V1.X = INT_TO_FIXED(1216) ; V1.Z = INT_TO_FIXED(768 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,18,2,Propietats,&Nou_Sector);


	// Linea 6 {Portal al sector hexagonal illuminat -S19-	}
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1216)   ; V0.Z = INT_TO_FIXED(768);
	V1.X = INT_TO_FIXED(1374) ; V1.Z = INT_TO_FIXED(0);
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);

	//////////////////////////////////////////
	// Construcci del pou (S18) : 4 lnies //
	//////////////////////////////////////////

	
	
	Parametres_Sector.iluminacio = 2;
	Parametres_Sector.Textura_Sostre = 7;
	Parametres_Sector.Textura_Terra = 11;
	Parametres_Sector.AlturaTerra = 0;
	Parametres_Sector.AlturaSostre = 300;
	

	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 (portal al sector hexagonal illuminat -S19-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1088); V0.Z = INT_TO_FIXED(768);
	V1.X = INT_TO_FIXED(1216 ); V1.Z = INT_TO_FIXED(768);
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,7,0,7,Propietats,&Nou_Sector);
	//MapaMon->Mapa2D[NumeroDeMapa].Sector[numero_sector].LiniaSector[0].Propietats = 0x2;
	

	// Linia 1 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1216); V0.Z = INT_TO_FIXED(768 );
	V1.X = INT_TO_FIXED(1216 ); V1.Z = INT_TO_FIXED(896 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,7,7,7,Propietats,&Nou_Sector);

	// Linia 2 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1216 ); V0.Z = INT_TO_FIXED(896);
	V1.X = INT_TO_FIXED(1088 ); V1.Z = INT_TO_FIXED(896 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,7,7,7,Propietats,&Nou_Sector);


	// Linia 3 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1088 ); V0.Z = INT_TO_FIXED(896 );
	V1.X = INT_TO_FIXED(1088 ); V1.Z = INT_TO_FIXED(768 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,7,7,7,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);

	



////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////
	// Construcci del 7er sector (S7) : 7 lnies //  
	////////////////////////////////////////////////

	Parametres_Sector.iluminacio = -82;
	Parametres_Sector.Textura_Sostre = 4;
	Parametres_Sector.Textura_Terra = 5;
	Parametres_Sector.AlturaTerra = 0;
	Parametres_Sector.AlturaSostre = 240;

	Sector_NouSector(Parametres_Sector,&Nou_Sector);
	
	// Linia 0 (Portal al sector 8 -1er esgla-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1536)  ; V0.Z = INT_TO_FIXED(162 );
	V1.X = INT_TO_FIXED(1792 ); V1.Z = INT_TO_FIXED(162 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,8,2,Propietats,&Nou_Sector);

	// Linia 1 (Portal al sector 9 -2on esgla-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1792 ); V0.Z = INT_TO_FIXED(162 );
	V1.X = INT_TO_FIXED(1792 ); V1.Z = INT_TO_FIXED(273 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,2,Propietats,&Nou_Sector);

	// Linia 2 (Portal al sector 10 -3er esgla-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1792 ); V0.Z = INT_TO_FIXED(273 );
	V1.X = INT_TO_FIXED(1728 ); V1.Z = INT_TO_FIXED(273 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,2,Propietats,&Nou_Sector);

	// Linia 3 (Portal al sector 11 -4rt esgla-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1728 ); V0.Z = INT_TO_FIXED(273 );
	V1.X = INT_TO_FIXED(1664 ); V1.Z = INT_TO_FIXED(273 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,2,Propietats,&Nou_Sector);
	

	// Linia 4 (Portal al sector 12 -repl-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1664 ); V0.Z = INT_TO_FIXED(273 );
	V1.X = INT_TO_FIXED(1600 ); V1.Z = INT_TO_FIXED(273 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,2,Propietats,&Nou_Sector);
	
	// Linia 5 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1600 ); V0.Z = INT_TO_FIXED(273 );
	V1.X = INT_TO_FIXED(1536 ); V1.Z = INT_TO_FIXED(273 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,2,Propietats,&Nou_Sector);

	// Linia 6 (portal al sector hexagonal -S6-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1536 ); V0.Z = INT_TO_FIXED(273 );
	V1.X = INT_TO_FIXED(1536 ); V1.Z = INT_TO_FIXED(162 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,2,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);


	////////////////////////////////////////////////
	// Construcci del 8er sector (S8) : 7 lnies //  
	////////////////////////////////////////////////

	Parametres_Sector.iluminacio = -82;
	Parametres_Sector.Textura_Sostre = 4;
	Parametres_Sector.Textura_Terra = 5;
	Parametres_Sector.AlturaTerra = 0;
	Parametres_Sector.AlturaSostre = 240;

	Sector_NouSector(Parametres_Sector,&Nou_Sector);
	
	// Linia 0 (Portal al sector 8 -1er esgla-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1536)  ; V0.Z = INT_TO_FIXED(384 );
	V1.X = INT_TO_FIXED(1600 ); V1.Z = INT_TO_FIXED(384 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,2,Propietats,&Nou_Sector);

	// Linia 1 (Portal al sector 9 -2on esgla-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1600 ); V0.Z = INT_TO_FIXED(384 );
	V1.X = INT_TO_FIXED(1664 ); V1.Z = INT_TO_FIXED(384 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,2,Propietats,&Nou_Sector);

	// Linia 2 (Portal al sector 10 -3er esgla-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1664 ); V0.Z = INT_TO_FIXED(384 );
	V1.X = INT_TO_FIXED(1728 ); V1.Z = INT_TO_FIXED(384 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,2,Propietats,&Nou_Sector);

	// Linia 3 (Portal al sector 11 -4rt esgla-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1728 ); V0.Z = INT_TO_FIXED(384 );
	V1.X = INT_TO_FIXED(1792 ); V1.Z = INT_TO_FIXED(384 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,2,Propietats,&Nou_Sector);
	

	// Linia 4 (Portal al sector 12 -repl-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1792 ); V0.Z = INT_TO_FIXED(384 );
	V1.X = INT_TO_FIXED(1792 ); V1.Z = INT_TO_FIXED(606 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,2,Propietats,&Nou_Sector);
	
	// Linia 5 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1792 ); V0.Z = INT_TO_FIXED(606 );
	V1.X = INT_TO_FIXED(1536 ); V1.Z = INT_TO_FIXED(606 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,8,2,Propietats,&Nou_Sector);

	// Linia 6 (portal al sector hexagonal -S6-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1536 ); V0.Z = INT_TO_FIXED(606 );
	V1.X = INT_TO_FIXED(1536 ); V1.Z = INT_TO_FIXED(384 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,2,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);




////////////////////////////////////////////////////////////////////////////////////////////////
//		CONSTRUCCI DELS ESGLAONS...
////////////////////////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////
	// Construcci del 1er esgla (S8) : 4 lnies //
	////////////////////////////////////////////////


	Parametres_Sector.iluminacio = -60;
	Parametres_Sector.Textura_Sostre = 4;
	Parametres_Sector.Textura_Terra = 5;
	Parametres_Sector.AlturaTerra = 16;
	Parametres_Sector.AlturaSostre = 240;


	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1536 ); V0.Z = INT_TO_FIXED(273 );
	V1.X = INT_TO_FIXED(1600 ); V1.Z = INT_TO_FIXED(273 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3,0,2,Propietats,&Nou_Sector);

	// Linia 1 (portal al segon esgla -s9-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1600 ); V0.Z = INT_TO_FIXED(273 );
	V1.X = INT_TO_FIXED(1600 ); V1.Z = INT_TO_FIXED(384 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3,0,2,Propietats,&Nou_Sector);

	// Linia 2 (portal al sector 7 -s7- ( no actiu) ).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1600 ); V0.Z = INT_TO_FIXED(384 );
	V1.X = INT_TO_FIXED(1536 ); V1.Z = INT_TO_FIXED(384 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3,0,2,Propietats,&Nou_Sector);

	// Linia 3 (portal al sector 6 -s6-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1536 ); V0.Z = INT_TO_FIXED(384 );
	V1.X = INT_TO_FIXED(1536 ); V1.Z = INT_TO_FIXED(273 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3/*-GREY_COLOR*/,0,2,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);

	////////////////////////////////////////////////
	// Construcci del 2on esgla (S9) : 4 lnies //
	////////////////////////////////////////////////
	
	Parametres_Sector.iluminacio = -70;
	Parametres_Sector.Textura_Sostre = 4;
	Parametres_Sector.Textura_Terra = 5;
	Parametres_Sector.AlturaTerra = 32;
	Parametres_Sector.AlturaSostre = 240;

	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1600 ); V0.Z = INT_TO_FIXED(273 );
	V1.X = INT_TO_FIXED(1664 ); V1.Z = INT_TO_FIXED(273 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3,0,2,Propietats,&Nou_Sector);

	// Linia 1 (portal al 3er esgla -s10-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1664 ); V0.Z = INT_TO_FIXED(273 );
	V1.X = INT_TO_FIXED(1664 ); V1.Z = INT_TO_FIXED(384 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3/*-GREY_COLOR*/,0,2,Propietats,&Nou_Sector);

	// Linia 2 (portal al sector 7 -s7-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1664 ); V0.Z = INT_TO_FIXED(384 );
	V1.X = INT_TO_FIXED(1600 ); V1.Z = INT_TO_FIXED(384 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3,0,2,Propietats,&Nou_Sector);

	// Linia 3 (portal al primer esgla -s8-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1600 ); V0.Z = INT_TO_FIXED(384 );
	V1.X = INT_TO_FIXED(1600 ); V1.Z = INT_TO_FIXED(273 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3/*-GREY_COLOR*/,0,2,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);

	////////////////////////////////////////////////
	// Construcci del 3er esgla (S10) : 4 lnies //
	////////////////////////////////////////////////


	Parametres_Sector.iluminacio = -80;
	Parametres_Sector.Textura_Sostre = 4;
	Parametres_Sector.Textura_Terra = 5;
	Parametres_Sector.AlturaTerra = 48;
	Parametres_Sector.AlturaSostre = 240;



	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1664 ); V0.Z = INT_TO_FIXED(273 );
	V1.X = INT_TO_FIXED(1728 ); V1.Z = INT_TO_FIXED(273 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3,0,2,Propietats,&Nou_Sector);

	// Linia 1 (portal al 4r esgla -s11-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1728 ); V0.Z = INT_TO_FIXED(273 );
	V1.X = INT_TO_FIXED(1728 ); V1.Z = INT_TO_FIXED(384 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3/*-GREY_COLOR*/,0,2,Propietats,&Nou_Sector);

	// Linia 2 (portal al sector 7 -s7-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1728 ); V0.Z = INT_TO_FIXED(384 );
	V1.X = INT_TO_FIXED(1664 ); V1.Z = INT_TO_FIXED(384 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3,0,2,Propietats,&Nou_Sector);

	// Linia 3 (portal al segon esgla -s9-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1664 ); V0.Z = INT_TO_FIXED(384 );
	V1.X = INT_TO_FIXED(1664 ); V1.Z = INT_TO_FIXED(273 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3/*-GREY_COLOR*/,0,2,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);



	////////////////////////////////////////////////
	// Construcci del 4rt esgla (S11) : 4 lnies //
	////////////////////////////////////////////////

	
	Parametres_Sector.iluminacio = -90;
	Parametres_Sector.Textura_Sostre = 4;
	Parametres_Sector.Textura_Terra = 5;
	Parametres_Sector.AlturaTerra = 64;
	Parametres_Sector.AlturaSostre = 240;
	

	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1728 ); V0.Z = INT_TO_FIXED(273 );
	V1.X = INT_TO_FIXED(1792 ); V1.Z = INT_TO_FIXED(273 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);

	// Linia 1 (portal al repla -s12-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1792 ); V0.Z = INT_TO_FIXED(273 );
	V1.X = INT_TO_FIXED(1792 ); V1.Z = INT_TO_FIXED(384 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3/*-GREY_COLOR*/,0,2,Propietats,&Nou_Sector);

	// Linia 2 (portal al sector 7 -s7-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1792 ); V0.Z = INT_TO_FIXED(384 );
	V1.X = INT_TO_FIXED(1728 ); V1.Z = INT_TO_FIXED(384 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3,0,2,Propietats,&Nou_Sector);

	// Linia 3 (portal al tercer esgla -s10-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1728 ); V0.Z = INT_TO_FIXED(384 );
	V1.X = INT_TO_FIXED(1728 ); V1.Z = INT_TO_FIXED(273 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,3/*-GREY_COLOR*/,0,2,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);

////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////
	// Construcci del repla (S12) : 10 lnies //
	////////////////////////////////////////////

	
	Parametres_Sector.iluminacio = -100;
	Parametres_Sector.Textura_Sostre = 4;
	Parametres_Sector.Textura_Terra = 5;
	Parametres_Sector.AlturaTerra = 80;
	Parametres_Sector.AlturaSostre = 240;


	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0.
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1792 ); V0.Z = INT_TO_FIXED(162 );
	V1.X = INT_TO_FIXED(1800 ); V1.Z = INT_TO_FIXED(162 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,8,2,Propietats,&Nou_Sector);

	// Linia 1. (portal pati 1 -S14-)
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1800 ); V0.Z = INT_TO_FIXED(162 );
	V1.X = INT_TO_FIXED(1864 ); V1.Z = INT_TO_FIXED(162 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,8,Propietats,&Nou_Sector);

	// Linia 2.
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1864 ); V0.Z = INT_TO_FIXED(162 );
	V1.X = INT_TO_FIXED(1900 ); V1.Z = INT_TO_FIXED(162 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,8,2,Propietats,&Nou_Sector);

	// Linia 3. (portal pati 2 -S15-)
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1900 ); V0.Z = INT_TO_FIXED(162 );
	V1.X = INT_TO_FIXED(1964 ); V1.Z = INT_TO_FIXED(162 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,8,Propietats,&Nou_Sector);

	// Linia 4.
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1964 ); V0.Z = INT_TO_FIXED(162 );
	V1.X = INT_TO_FIXED(2048 ); V1.Z = INT_TO_FIXED(162 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,8,8,Propietats,&Nou_Sector);

	// Linia 5 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(2048 ); V0.Z = INT_TO_FIXED(162 );
	V1.X = INT_TO_FIXED(2048 ); V1.Z = INT_TO_FIXED(262 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,8,8,Propietats,&Nou_Sector);


	// Linia 6 (portal la finestra -s13-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(2048 ); V0.Z = INT_TO_FIXED(262 );
	V1.X = INT_TO_FIXED(2048 ); V1.Z = INT_TO_FIXED(506 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,8,Propietats,&Nou_Sector);

	// Linia 7 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(2048 ); V0.Z = INT_TO_FIXED(506 );
	V1.X = INT_TO_FIXED(2048 ); V1.Z = INT_TO_FIXED(606 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,8,8,Propietats,&Nou_Sector);

	// Linia 8 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(2048 ); V0.Z = INT_TO_FIXED(606 );
	V1.X = INT_TO_FIXED(1792 ); V1.Z = INT_TO_FIXED(606 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,8,8,Propietats,&Nou_Sector);

	// Linia 9 (portal al repla baix -s7-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;	
	V0.X = INT_TO_FIXED(1792 ); V0.Z = INT_TO_FIXED(606 );
	V1.X = INT_TO_FIXED(1792 ); V1.Z = INT_TO_FIXED(384 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,8,Propietats,&Nou_Sector);

	// Linia 10 (portal 4rt esgla -s11-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1792 ); V0.Z = INT_TO_FIXED(384 );
	V1.X = INT_TO_FIXED(1792 ); V1.Z = INT_TO_FIXED(273 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);	
	
	// Linia 11 (portal al repl).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1792 ); V0.Z = INT_TO_FIXED(273 );
	V1.X = INT_TO_FIXED(1792 ); V1.Z = INT_TO_FIXED(162 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);



	////////////////////////////////////////////////
	// Construcci de la finestra (S13) : 4 lnies //
	////////////////////////////////////////////////


	Parametres_Sector.iluminacio = -120;
	Parametres_Sector.Textura_Sostre = 8;
	Parametres_Sector.Textura_Terra = 8;
	Parametres_Sector.AlturaTerra = 114;
	Parametres_Sector.AlturaSostre = 174;
	


	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(2048 ); V0.Z = INT_TO_FIXED(262 );
	V1.X = INT_TO_FIXED(2064 ); V1.Z = INT_TO_FIXED(262 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,8,2,Propietats,&Nou_Sector);

	// Linia 1 (paisatge).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(2064 ); V0.Z = INT_TO_FIXED(262 );
	V1.X = INT_TO_FIXED(2064 ); V1.Z = INT_TO_FIXED(506 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,25,2,Propietats,&Nou_Sector);

	// Linia 2 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(2064 ); V0.Z = INT_TO_FIXED(506 );
	V1.X = INT_TO_FIXED(2048 ); V1.Z = INT_TO_FIXED(506 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,8,2,Propietats,&Nou_Sector);

	// Linia 3 (portal al repla -s12-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(2048 ); V0.Z = INT_TO_FIXED(506 );
	V1.X = INT_TO_FIXED(2048 ); V1.Z = INT_TO_FIXED(262 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);
	
	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);


	//////////////////////////////////////////////////
	// Construcci del portal pat 1 (S14) : 4 lnies //
	//////////////////////////////////////////////////


	
	Parametres_Sector.iluminacio = -120;
	Parametres_Sector.Textura_Sostre =8; 
	Parametres_Sector.Textura_Terra = 5;
	Parametres_Sector.AlturaTerra = 80;
	Parametres_Sector.AlturaSostre = 190;
	

	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 1 (portal al pati (S15).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1800 ); V0.Z = INT_TO_FIXED(130 );
	V1.X = INT_TO_FIXED(1864 ); V1.Z = INT_TO_FIXED(130 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);

	// Linia 1 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1864 ); V0.Z = INT_TO_FIXED(130 );
	V1.X = INT_TO_FIXED(1864 ); V1.Z = INT_TO_FIXED(162 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,8,2,Propietats,&Nou_Sector);

	// Linia 2 (portal al sector (S12).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1864 ); V0.Z = INT_TO_FIXED(162 );
	V1.X = INT_TO_FIXED(1800 ); V1.Z = INT_TO_FIXED(162 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);

	// Linia 3 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1800 ); V0.Z = INT_TO_FIXED(162 );
	V1.X = INT_TO_FIXED(1800 ); V1.Z = INT_TO_FIXED(130 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,8,2,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);


	//////////////////////////////////////////////////
	// Construcci del portal pat 2 (S15) : 4 lnies //
	//////////////////////////////////////////////////


	
	Parametres_Sector.iluminacio = -120;
	Parametres_Sector.Textura_Sostre =8; 
	Parametres_Sector.Textura_Terra = 5;
	Parametres_Sector.AlturaTerra = 80;
	Parametres_Sector.AlturaSostre = 190;
	

	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 1 (portal al pati (S15).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1900 ); V0.Z = INT_TO_FIXED(130 );
	V1.X = INT_TO_FIXED(1964 ); V1.Z = INT_TO_FIXED(130 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);

	// Linia 1 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1964 ); V0.Z = INT_TO_FIXED(130 );
	V1.X = INT_TO_FIXED(1964 ); V1.Z = INT_TO_FIXED(162 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,8,2,Propietats,&Nou_Sector);

	// Linia 2 (portal al sector (S12).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1964 ); V0.Z = INT_TO_FIXED(162 );
	V1.X = INT_TO_FIXED(1900 ); V1.Z = INT_TO_FIXED(162 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);

	// Linia 3 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1900 ); V0.Z = INT_TO_FIXED(162 );
	V1.X = INT_TO_FIXED(1900 ); V1.Z = INT_TO_FIXED(130 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,8,2,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);

	////////////////////////////////////////////
	// Construcci del pati  (S16) : 8 lnies //
	////////////////////////////////////////////

	
	Parametres_Sector.iluminacio = -130;
	Parametres_Sector.Textura_Sostre = 25;
	Parametres_Sector.Textura_Terra = 5;
	Parametres_Sector.AlturaTerra = 80;
	Parametres_Sector.AlturaSostre = 512;


	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 (portal al 1era barana -S16-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1700 ); V0.Z = INT_TO_FIXED((-64) );
	V1.X = INT_TO_FIXED(2048 ); V1.Z = INT_TO_FIXED((-64) );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,8,Propietats,&Nou_Sector);

	// Linia 1 (portal a la segona barana -S17-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(2048 ); V0.Z = INT_TO_FIXED((-64) );
	V1.X = INT_TO_FIXED(2048 ); V1.Z = INT_TO_FIXED(130 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,8,Propietats,&Nou_Sector);

	// Linia 2 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(2048 ); V0.Z = INT_TO_FIXED(130 );
	V1.X = INT_TO_FIXED(1964 ); V1.Z = INT_TO_FIXED(130 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,8,8,Propietats,&Nou_Sector);


	// Linia 3 (portal pati 2).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1964 ); V0.Z = INT_TO_FIXED(130 );
	V1.X = INT_TO_FIXED(1900 ); V1.Z = INT_TO_FIXED(130 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,8,Propietats,&Nou_Sector);


	// Linia 4 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1900 ); V0.Z = INT_TO_FIXED(130 );
	V1.X = INT_TO_FIXED(1864 ); V1.Z = INT_TO_FIXED(130 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,8,8,Propietats,&Nou_Sector);

	// Linia 3 (portal pati 1 al sector (S13).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1864 ); V0.Z = INT_TO_FIXED(130 );
	V1.X = INT_TO_FIXED(1800 ); V1.Z = INT_TO_FIXED(130 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,8,Propietats,&Nou_Sector);

	// Linia 4 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1800 ); V0.Z = INT_TO_FIXED(130 );
	V1.X = INT_TO_FIXED(1700 ); V1.Z = INT_TO_FIXED(130 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,8,8,Propietats,&Nou_Sector);

	// Linia 5 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1700 ); V0.Z = INT_TO_FIXED(130 );
	V1.X = INT_TO_FIXED(1700 ); V1.Z = INT_TO_FIXED((120)  );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,8,8,Propietats,&Nou_Sector);

    // Linia 6 (portal repla).
    	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1700 ); V0.Z = INT_TO_FIXED(120 );
	V1.X = INT_TO_FIXED(1700 ); V1.Z = INT_TO_FIXED((33)  );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,8,Propietats,&Nou_Sector);

    // Linia 7 (portal sector amb pendent).
    	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1700 ); V0.Z = INT_TO_FIXED(33 );
	V1.X = INT_TO_FIXED(1700 ); V1.Z = INT_TO_FIXED((-54)  );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,8,Propietats,&Nou_Sector);

    // Linia 8 (paret).
    	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1700 ); V0.Z = INT_TO_FIXED(-54 );
	V1.X = INT_TO_FIXED(1700 ); V1.Z = INT_TO_FIXED((-64)  );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,8,8,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);


	//////////////////////////////////////////////////
	// Construcci de 1era  barana (S17) : 4 lnies //
	//////////////////////////////////////////////////

    
	Parametres_Sector.iluminacio = -130;
	Parametres_Sector.Textura_Sostre = 25;
	Parametres_Sector.Textura_Terra = 8;
	Parametres_Sector.AlturaTerra = 117;
	Parametres_Sector.AlturaSostre = 512;


	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 (portal al paisatge).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1700 ); V0.Z = INT_TO_FIXED((-74) );
	V1.X = INT_TO_FIXED(2058 ); V1.Z = INT_TO_FIXED((-74)  );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,25,2,Propietats,&Nou_Sector);

	// Linia 1 (portal la barana 2 -S17-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(2058  ); V0.Z = INT_TO_FIXED((-74) );
	V1.X = INT_TO_FIXED(2048 ); V1.Z = INT_TO_FIXED((-64) );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);

	// Linia 2 (portal al pati).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(2048  ); V0.Z = INT_TO_FIXED((-64)  );
	V1.X = INT_TO_FIXED(1700 ); V1.Z = INT_TO_FIXED((-64) );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);


	// Linia 3 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1700 ); V0.Z = INT_TO_FIXED((-64)  );
	V1.X = INT_TO_FIXED(1700 ); V1.Z = INT_TO_FIXED((-74)  );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,8,2,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);


	//////////////////////////////////////////////////
	// Construcci de 2a  barana (S18) : 4 lnies //
	//////////////////////////////////////////////////

	
	Parametres_Sector.iluminacio = -130;
	Parametres_Sector.Textura_Sostre = 25;
	Parametres_Sector.Textura_Terra = 8;
	Parametres_Sector.AlturaTerra = 117;
	Parametres_Sector.AlturaSostre = 512;
	
	
	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 (portal a la 1era barana -S16-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(2048 ); V0.Z = INT_TO_FIXED((-64) );
	V1.X = INT_TO_FIXED(2058 ); V1.Z = INT_TO_FIXED((-74) );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);

	// Linia 1 (paisatge).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(2058 ); V0.Z = INT_TO_FIXED((-74) );
	V1.X = INT_TO_FIXED(2058 ); V1.Z = INT_TO_FIXED(130 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,25,2,Propietats,&Nou_Sector);

	// Linia 2 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(2058 ); V0.Z = INT_TO_FIXED(130 );
	V1.X = INT_TO_FIXED(2048 ); V1.Z = INT_TO_FIXED(130 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,8,2,Propietats,&Nou_Sector);


	// Linia 3 (portal al pati -S15-).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(2048 ); V0.Z = INT_TO_FIXED(130 );
	V1.X = INT_TO_FIXED(2048 ); V1.Z = INT_TO_FIXED((-64) );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);

	///////////////////////////////////////////
	// Construcci de repla (S19) : 4 lnies //
	///////////////////////////////////////////

	
	Parametres_Sector.iluminacio = -130;
	Parametres_Sector.Textura_Sostre = 25;
	Parametres_Sector.Textura_Terra = 5;
	Parametres_Sector.AlturaTerra = 80;
	Parametres_Sector.AlturaSostre = 512;
	
	
	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 (portal al portal amb pendent...).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1536 ); V0.Z = INT_TO_FIXED((33) );
	V1.X = INT_TO_FIXED(1700 ); V1.Z = INT_TO_FIXED((33) );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,8,0,8,Propietats,&Nou_Sector);

	// Linia 1 (portal al pati).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1700 ); V0.Z = INT_TO_FIXED((33) );
	V1.X = INT_TO_FIXED(1700 ); V1.Z = INT_TO_FIXED(120 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);

	// Linia 2 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1700 ); V0.Z = INT_TO_FIXED(120 );
	V1.X = INT_TO_FIXED(1536 ); V1.Z = INT_TO_FIXED(120 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,8,2,Propietats,&Nou_Sector);


	// Linia 3 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1536 ); V0.Z = INT_TO_FIXED(120 );
	V1.X = INT_TO_FIXED(1536 ); V1.Z = INT_TO_FIXED((33) );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,8,2,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);


    /////////////////////////////////////////////
	// Construcci de pendent (S20) : 4 lnies //
	/////////////////////////////////////////////

	
	Parametres_Sector.iluminacio = -130;
	Parametres_Sector.Textura_Sostre = 25;
	Parametres_Sector.Textura_Terra = -2;
	Parametres_Sector.AlturaTerra = 80;
	Parametres_Sector.AlturaSostre = 512;
	
	
	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 (paret...).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1536 ); V0.Z = INT_TO_FIXED((-54) );
	V1.X = INT_TO_FIXED(1700 ); V1.Z = INT_TO_FIXED((-54) );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = INT_TO_FIXED(140);
    V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,8,2,Propietats,&Nou_Sector);

	// Linia 1 (portal al pati).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1700 ); V0.Z = INT_TO_FIXED((-54) );
	V1.X = INT_TO_FIXED(1700 ); V1.Z = INT_TO_FIXED(33 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);

	// Linia 2 (portal repla).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1700 ); V0.Z = INT_TO_FIXED(33 );
	V1.X = INT_TO_FIXED(1536 ); V1.Z = INT_TO_FIXED(33 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra); 
    V1.Y_INF = INT_TO_FIXED(140);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);


	// Linia 3 (portal sector tunel).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1536 ); V0.Z = INT_TO_FIXED(33 );
	V1.X = INT_TO_FIXED(1536 ); V1.Z = INT_TO_FIXED((-54) );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(140);
	SECTOR_AfegirLinia(V0,V1,8,0,8,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);


    /////////////////////////////////////////////
	// Construcci de tunel (S21) : 4 lnies //
	/////////////////////////////////////////////

	
	Parametres_Sector.iluminacio = -60;
	Parametres_Sector.Textura_Sostre = 8;
	Parametres_Sector.Textura_Terra = 8;
	Parametres_Sector.AlturaTerra = 140;
	Parametres_Sector.AlturaSostre = 240;
	
	
	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 (paret...).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1414 ); V0.Z = INT_TO_FIXED((40) );
	V1.X = INT_TO_FIXED(1536 ); V1.Z = INT_TO_FIXED((-54) );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,8,2,Propietats,&Nou_Sector);

	// Linia 1 (portal pendent).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1536 ); V0.Z = INT_TO_FIXED((-54) );
	V1.X = INT_TO_FIXED(1536 ); V1.Z = INT_TO_FIXED(33 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);

	// Linia 2 (paret).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1536 ); V0.Z = INT_TO_FIXED(33 );
	V1.X = INT_TO_FIXED(1496 ); V1.Z = INT_TO_FIXED(122 );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,8,2,Propietats,&Nou_Sector);


	// Linia 3 (portal al sector hexagonal).
	//V0.ID_Vertex = n_vertex; V1.ID_Vertex = ++n_vertex;
	V0.X = INT_TO_FIXED(1496 ); V0.Z = INT_TO_FIXED(122 );
	V1.X = INT_TO_FIXED(1414 ); V1.Z = INT_TO_FIXED((40) );
    V0.Y_SUP = V1.Y_SUP = INT_TO_FIXED(Parametres_Sector.AlturaSostre);
    V0.Y_INF = V1.Y_INF = INT_TO_FIXED(Parametres_Sector.AlturaTerra);
	SECTOR_AfegirLinia(V0,V1,2,0,2,Propietats,&Nou_Sector);

	MAPA_AfegirSector(Nou_Sector,&MapaMon->Mapa2D[NumeroDeMapa]);

////////////////////////////////////////////////////////////////////////////////////////////////////////////

	
/*
	/////////////////////////////////////////////////////////////
	// Construcci del 1er sector amb pendent (S21) : 4 lnies //
	/////////////////////////////////////////////////////////////

	
	
	
	

	
	Parametres_Sector.iluminacio = -100;
	Parametres_Sector.Textura_Sostre = 6;
	Parametres_Sector.Textura_Terra = 10;
	Parametres_Sector.AlturaTerra = 0;
	Parametres_Sector.AlturaSostre = 64;
	Parametres_Sector.NumeroDeLinies = 4;	

Parametres_Sector.Init_Quadrat_Sector.y1_sostre =  Parametres_Sector.Init_Quadrat_Sector.y2_sostre = 64;
Parametres_Sector.Init_Quadrat_Sector.y1_terra =  Parametres_Sector.Init_Quadrat_Sector.y2_terra = 0 ;

	Parametres_Sector.Pendent_X_Terra = FALSE;

	

	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 (portal al repla -entre conecta els dos pendents -S22-)

	V0.X = INT_TO_FIXED(400 ); V0.Z = INT_TO_FIXED(-64);
	V1.X = INT_TO_FIXED(490 ); V1.Z = INT_TO_FIXED(-64);
	

	SECTOR_AfegirLinia(V0,V1,2,0,2,&Inicialitzacio_Mapa.Sector[22],Propietats,&Nou_Sector);

	// Linia 1

	V0.X = INT_TO_FIXED(490 ); V0.Z = INT_TO_FIXED(-64);
	V1.X = INT_TO_FIXED(690 ); V1.Z = INT_TO_FIXED(478);
	

	SECTOR_AfegirLinia(V0,V1,2,19,2,NULL,Propietats,&Nou_Sector);

	// Linia 2 ( Portal al sector -S4-)

	V0.X = INT_TO_FIXED(690 ); V0.Z = INT_TO_FIXED(478 );
	V1.X = INT_TO_FIXED(600 ); V1.Z = INT_TO_FIXED(478 );
	

	SECTOR_AfegirLinia(V0,V1,2,0,2,&Inicialitzacio_Mapa.Sector[4],Propietats,&Nou_Sector);


	// Linia 3 (paret).

	V0.X = INT_TO_FIXED(600); V0.Z = INT_TO_FIXED(478);
	V1.X = INT_TO_FIXED(400 ); V1.Z = INT_TO_FIXED(-64);
	

	SECTOR_AfegirLinia(V0,V1,6,18,6,NULL,Propietats,&Nou_Sector);


	///////////////////////////////////////////////////////////////////////////////
	// Construcci del sector repla conectant dels dos pendents (S22) : 4 lnies //
	///////////////////////////////////////////////////////////////////////////////

	
	
	
	

	
	Parametres_Sector.iluminacio = -100;
	Parametres_Sector.Textura_Sostre = 6;
	Parametres_Sector.Textura_Terra = 10;
	Parametres_Sector.AlturaTerra = 80;
	Parametres_Sector.AlturaSostre = 200;
	Parametres_Sector.NumeroDeLinies = 4;	
Parametres_Sector.Init_Quadrat_Sector.y1_sostre =  Parametres_Sector.Init_Quadrat_Sector.y2_sostre = 200;
Parametres_Sector.Init_Quadrat_Sector.y1_terra =  Parametres_Sector.Init_Quadrat_Sector.y2_terra = 80 ;
	

	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 (portal al repla -entre conecta els dos pendents -S22-)

	V0.X = INT_TO_FIXED(400 ); V0.Z = INT_TO_FIXED(-128);
	V1.X = INT_TO_FIXED(490 ); V1.Z = INT_TO_FIXED(-128);
	

	SECTOR_AfegirLinia(V0,V1,1,19,1,NULL,Propietats,&Nou_Sector);

	// Linia 1  (portal al mapa 2 sector -s1-)

	V0.X = INT_TO_FIXED(490 ); V0.Z = INT_TO_FIXED(-128);
	V1.X = INT_TO_FIXED(490 ); V1.Z = INT_TO_FIXED(-64);
	

	SECTOR_AfegirLinia(V0,V1,1,19,1,&Inicialitzacio_Mapa.Sector[23],Propietats,&Nou_Sector);

	// Linia 2 ( Portal al sector -S21-)

	V0.X = INT_TO_FIXED(490 ); V0.Z = INT_TO_FIXED(-64 );
	V1.X = INT_TO_FIXED(400 ); V1.Z = INT_TO_FIXED(-64 );
	

	SECTOR_AfegirLinia(V0,V1,1,19,1,&Inicialitzacio_Mapa.Sector[21],Propietats,&Nou_Sector);


	// Linia 3 (paret).

	V0.X = INT_TO_FIXED(400); V0.Z = INT_TO_FIXED(-64);
	V1.X = INT_TO_FIXED(400 ); V1.Z = INT_TO_FIXED(-128);
	

	SECTOR_AfegirLinia(V0,V1,6,18,6,NULL,Propietats,&Nou_Sector);

	/////////////////////////////////////////////////////////////////
	// Construcci tunel pendent-sector hexagonal (S23) : 4 lnies //
	/////////////////////////////////////////////////////////////////

	

	
	Parametres_Sector.iluminacio = -100;
	Parametres_Sector.Textura_Sostre = 6;
	Parametres_Sector.Textura_Terra = 10;
	Parametres_Sector.AlturaTerra = 0;
	Parametres_Sector.AlturaSostre = 80;
	Parametres_Sector.NumeroDeLinies = 4;	
	Parametres_Sector.Init_Quadrat_Sector.y1_sostre =  Parametres_Sector.Init_Quadrat_Sector.y2_sostre = 80;
	Parametres_Sector.Init_Quadrat_Sector.y1_terra =  Parametres_Sector.Init_Quadrat_Sector.y2_terra = 0 ;
	

	Sector_NouSector(Parametres_Sector,&Nou_Sector);

	// Linia 0 (portal al repla -entre conecta els dos pendents -S22-)

	V0.X = INT_TO_FIXED(490 ); V0.Z = INT_TO_FIXED(-128);
	V1.X = INT_TO_FIXED(700 ); V1.Z = INT_TO_FIXED(-128);
	

	SECTOR_AfegirLinia(V0,V1,2,20,2,NULL,Propietats,&Nou_Sector);

	// Linia 1  (portal al mapa 2 sector -s1-)

	V0.X = INT_TO_FIXED(700 ); V0.Z = INT_TO_FIXED(-128);
	V1.X = INT_TO_FIXED(700 ); V1.Z = INT_TO_FIXED(-64);
	

	SECTOR_AfegirLinia(V0,V1,2,20,2,NULL,Propietats,&Nou_Sector);

	// Linia 2 ( Portal al sector -S21-)

	V0.X = INT_TO_FIXED(700 ); V0.Z = INT_TO_FIXED(-64 );
	V1.X = INT_TO_FIXED(490 ); V1.Z = INT_TO_FIXED(-64 );
	

	SECTOR_AfegirLinia(V0,V1,2,20,2,NULL,Propietats,&Nou_Sector);


	// Linia 3 (paret).

	V0.X = INT_TO_FIXED(490); V0.Z = INT_TO_FIXED(-64);
	V1.X = INT_TO_FIXED(490 ); V1.Z = INT_TO_FIXED(-128);
	

	SECTOR_AfegirLinia(V0,V1,6,18,6,&Inicialitzacio_Mapa.Sector[22],Propietats,&Nou_Sector);

	*/

	//////////////////////////////////
	//
	// Ms sectors si us plau :)
	//
	//////////////////////////////////


	// Incrementem el contador del numero de mapes actualment passats...
	MapaMon->N_Mapes2D++;

	
}
