//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA

#include "Mon.h"
#include "Llista_Dinamica.h"
#include "geometria.h"




#if defined(__UTILITZAR_EL_MON_PREGUARDAT) && defined(__ARITMETICA_FIXA__) // Utilitzarem l'ed d'un mapa per inicialitzar-lo...
#include "generated_world_map.raw.c"
#else
//extern const *Map2D;
//tMapa Inicialitzacio_Mapa;

//int n_vertex;

#include "Mapa2D_1.cc"
#include "Mapa2D_2.cc"



void Init_Mapa2D(int m,tMapaMon *MapaMon)
{
	switch(m)
	{
		case 0:Init_Mapa2D_1(MapaMon);break;
		case 1:Init_Mapa2D_2(MapaMon);break;
	}
}

#endif




//#include "Mapa2D_3.cc"

//----------------------------// 
//							  //
//	VARIABLES GLOBALS...	  //
//							  //
//----------------------------//

tMapaMon *MapaMon
#ifdef __HAM__
MEM_IN_EWRAM
#endif
;





///////////////////////////////////////////////////
//
// Construcci d'un mapa de proba. :)
//



void MON_Demo()
{


	
	
#if defined(__UTILITZAR_EL_MON_PREGUARDAT)&& defined(__ARITMETICA_FIXA__)

	MapaMon = (tMapaMon *)&Mapa_Mon_Demo;

#else
	int m;
	tMapaMon Mapa_Mon_Demo;

	Mapa_Mon_Demo.N_Mapes2D = 0;
//	n_vertex = 0;

	// Inicialitzaci dels mapes 2D...

	for(m = 0; m < MAX_MAPES_2D; m++)
	{
		Init_Mapa2D(m,&Mapa_Mon_Demo);
		//Init_Mapa2D(&Mapa_Mon_Demo);
	}
//	Init_Mapa2D_3(&Mapa_Mon_Demo);
//	Init_Mapa2D_4(&Mapa_Mon_Demo);

//	Mapa_Mon_Demo.NVertexs = n_vertex;
	
	MON_ConfiguracioAutomaticaMon(&Mapa_Mon_Demo);

#if defined(__VULL_CREAR_MON_EN_FORMAT_CRU) && defined(__ARITMETICA_FIXA__)
	// Doncs crearem el mapa en format cru ( mira que es caprichos el noiet...)

	MON_CrearMapaMonEnFormatCru(&Mapa_Mon_Demo);
#endif


	// Autoconfiguraci del mapa en base l'ed bsica que s'ha entrat...

//	MAPA_Configurar_Linies_Sectors(&Inicialitzacio_Mapa);	

	MapaMon = &Mapa_Mon_Demo;

#endif


	// Inicialitzaci de vertexs...


	// Assignacio informaci a Inicialitzacio_Mapa.


/*
    Punter_Numero_Sectors = INT_TO_FIXED(&(MapaMon).NumeroSectors;
	*Punter_Numero_Sectors = INT_TO_FIXED(Inicialitzacio_Mapa.NumeroSectors;


	Punter_Sectors  = INT_TO_FIXED(&(MapaMon).Sector;
	*Punter_Sectors = INT_TO_FIXED(Inicialitzacio_Mapa.Sector;
*/

 
}

#ifndef __UTILITZAR_EL_MON_PREGUARDAT

void MON_CrearMapaMonEnFormatCru(const tMapaMon *MapaMon)
{
	int n_sector_actual,size_in_bytes,/*z_actual,n_x,n_z,actual_half_word,x_actual,*/actual_word,m;
	u32  raw_string_sector[sizeof(tSector)];
//	u16  raw_string_grid[sizeof(tQuadricula_Sectors_Intersectants)];
	FILE *fp_raw_map;
	
	fp_raw_map = fopen("../3DEngine/generated_world_map.raw.c","wt");
	
	
	if(fp_raw_map == NULL)
	{
		fprintf(stderr," Cannot open \"generated_world_map.raw.c\"!");
	}
	else
	{
		
		
		fprintf(fp_raw_map,"\n#include \"Mon.h\"\n\n");
		fprintf(fp_raw_map,"//This word has %i 2D maps...\n\n",MapaMon->N_Mapes2D+1);
		fprintf(fp_raw_map,"const tMapaMon Mapa_Mon_Demo = {\n\t\t");
		fprintf(fp_raw_map,"\n\n\n\n\t\t0x%04x, // Number of Maps...\n",MapaMon->N_Mapes2D);
		fprintf(fp_raw_map,"//This word has %i vertexs...\n\n",MapaMon->NVertexs);
		fprintf(fp_raw_map,"\n\n\n\n\t\t0x%04x, // Number of vertexs...\n",MapaMon->NVertexs);
		
		// For all maps...
		
		for(m = 0; m < MAX_MAPES_2D; m++)
		{
			fprintf(fp_raw_map,"\n// Map %i...\n",m,MapaMon->Mapa2D[m].NSectors);
			
			// ID of this map...
			
			fprintf(fp_raw_map,"\n\n\t\t%i,\t\t\t// ID Map in hex format,\n\n",MapaMon->Mapa2D[m].ID_Mapa);
			
			// Min height of this map...
			fprintf(fp_raw_map,"\n\n\t\t%i,\t\t\t// Min height int hex format,\n\n",MapaMon->Mapa2D[m].Min_Altura);
			
			// Max height of this map...
			fprintf(fp_raw_map,"\n\n\t\t%i,\t\t\t// Max height int hex format,\n\n",MapaMon->Mapa2D[m].Max_Altura);
			
			// Number of sectors of this map...
			fprintf(fp_raw_map,"\n\n\t\t%i,\t\t\t// Number of sectors in hex format,\n\n",MapaMon->Mapa2D[m].NSectors);			
			
			// Grid map in raw format...
			fprintf(fp_raw_map,"\n\t\t// Info grid of map %i...\n",m);
			
#ifdef __SUPORT_CERCA_RAPIDA__ // Cerca rpida...

            size_in_bytes = sizeof(tQuadricula_Sectors_Intersectants);
			
			for( z_actual = DIMENSIO_MINIMA_MON_Z; z_actual < DIMENSIO_MAXIMA_MON_Z; z_actual+=DIMENSIO_QUADRAT_QUADRICULA_Z)
			{
				for( x_actual = DIMENSIO_MINIMA_MON_X; x_actual < DIMENSIO_MAXIMA_MON_X; x_actual+=DIMENSIO_QUADRAT_QUADRICULA_X)
				{
					
					
					n_z = (z_actual - DIMENSIO_MINIMA_MON_Z) >> LOG2_QUADRICULA_Z;
					n_x = (x_actual - DIMENSIO_MINIMA_MON_X) >> LOG2_QUADRICULA_X;
					
					fprintf(fp_raw_map,"\n\n\t\t// Info intersect sectors in grid ((%i,%i),(%i,%i))...\n\n\t\t",x_actual,z_actual,x_actual+DIMENSIO_QUADRAT_QUADRICULA_X-1,z_actual+DIMENSIO_QUADRAT_QUADRICULA_Z-1);
					
					memcpy(raw_string_grid,&MapaMon->Mapa2D[m].Quadricula_Sectors_Intersectants[n_z][n_x],size_in_bytes*sizeof(s16));
					
					for(actual_half_word = 0; actual_half_word < (size_in_bytes >> 1); actual_half_word++)
					{
						if(((actual_half_word+1) % 100) == 0) fprintf(fp_raw_map,"\n\t\t");
						fprintf(fp_raw_map,"0x%x,",raw_string_grid[actual_half_word]);
						
					}
					
					
				}
			}
#endif
				
								
			
			for(n_sector_actual = 0; n_sector_actual < MAX_SECTORS_MAPA; n_sector_actual++) // Atencio !!! No tocar MAX_SECTORS_MAPA !!!!
			{
				fprintf(fp_raw_map,"\n\n\t\t// Info entry for sector %i of map %i...\n\n\t\t",n_sector_actual,m);
				
				// Sector in raw format...
				
				size_in_bytes = sizeof(tSector);
				
				
								
                memcpy(raw_string_sector,&MapaMon->Mapa2D[m].Sector[n_sector_actual].ID_Sector,size_in_bytes);
				
				for(actual_word = 0; actual_word < (size_in_bytes>>2); actual_word++)
				{
					if(((actual_word+1) % 100) == 0) fprintf(fp_raw_map,"\n\t\t");
					fprintf(fp_raw_map,"0x%x,",raw_string_sector[actual_word]);
					
				}
				
			}
		}
		
		
		fprintf(fp_raw_map,"\n};\n");
		
		fclose(fp_raw_map);
	}
	
}



int LD_CercaVertex(tVertex *VertexACercar, PLlistaNodes LlistaVertexs)
{
	int NNodes,trobat;
	PNode	LD_actual;
	tVertex	*VertexActual;

	NNodes = LlistaVertexs->n_nodes;
	trobat = FALS;
	LD_actual = LlistaVertexs->Primer;

	while((NNodes--) && !trobat)
	{
		VertexActual = LD_actual->InfoNode;

		if((VertexActual->X == VertexACercar->X) &&
		   (VertexActual->Z == VertexACercar->Z)
			)
		{
			trobat = TRUE;
		}
		else
		{
			LD_actual = LD_actual->Seguent;
		}
	}

	if(!trobat) return -1;
	else return LD_actual->ID_Node;

}

void MON_ConfiguracioAutomaticaMon(tMapaMon *MapaMon)
{
	int m1,m2,s,l;
	tLlistaNodes LlistaVertexs;
	tVertex *InfoMemVertex,V1,V0;
//	PNode	NodeVertex;
	int id_vertex_trobat;
	int n_vertex;
	int Sector_es_quadrat;
	
	
	n_vertex = 0;
	

	
	for(m1 = 0; m1 < MapaMon->N_Mapes2D; m1++)
	{

		LD_InitLlista(&LlistaVertexs);
		// Interconecci de portals de paret...
		MAPA_InterconectarPortalsParet(&MapaMon->Mapa2D[m1]);

		// Creaci de quadricula...
#ifdef __SUPORT_CERCA_RAPIDA__
		MAPA_CrearQuadricula(&MapaMon->Mapa2D[m1]);
#endif

		for(m2 = m1+1; m2 < MapaMon->N_Mapes2D; m2++)
		{
			MAPA_InterconectarPortalsSostreTerra(&MapaMon->Mapa2D[m1],&MapaMon->Mapa2D[m2]);
		}

		

		// Identificaci de vertexs XYZ del mon...

		for(s = 0;s < MapaMon->Mapa2D[m1].NSectors;s++) // Per cada sector d'aquest mapa fer....
		{
			Sector_es_quadrat = CERT;

			for(l = 0; l < MapaMon->Mapa2D[m1].Sector[s].NumeroLinies; l++)// Per cada linia d'aquest sector fer....
			{

				// Obtenci vertex primer...
				V0 = MapaMon->Mapa2D[m1].Sector[s].LiniaSector[l].Linia.V0;

				if((id_vertex_trobat = LD_CercaVertex( &V0, &LlistaVertexs)) != -1) // ok, el vertex ja existia...
				{
					MapaMon->Mapa2D[m1].Sector[s].LiniaSector[l].Linia.V0.ID_Vertex = id_vertex_trobat;
				}
				else // S'empila nou vertex...
				{
					 
					V0.ID_Vertex = MapaMon->Mapa2D[m1].Sector[s].LiniaSector[l].Linia.V0.ID_Vertex = n_vertex;
					Reservar_Memoria(InfoMemVertex,tVertex,1);
					*InfoMemVertex = V0;
					LD_Empilar(n_vertex,InfoMemVertex,&LlistaVertexs,FIFO);
					n_vertex++;
				}
				
				
				// Segon vertex de lnia...
				V1 = MapaMon->Mapa2D[m1].Sector[s].LiniaSector[l].Linia.V1;

				if((id_vertex_trobat = LD_CercaVertex(&V1, &LlistaVertexs)) != -1) // ok, el vertex ja existia...
				{
					MapaMon->Mapa2D[m1].Sector[s].LiniaSector[l].Linia.V1.ID_Vertex = id_vertex_trobat;
				}
				else // S'empila la nou vertex...
				{
					V1.ID_Vertex = MapaMon->Mapa2D[m1].Sector[s].LiniaSector[l].Linia.V1.ID_Vertex = n_vertex;

					Reservar_Memoria(InfoMemVertex,tVertex,1);
					*InfoMemVertex = V1;

					LD_Empilar(n_vertex,InfoMemVertex,&LlistaVertexs,FIFO);
					n_vertex++;
				}
				//
				//int LD_Empilar(int ID_Node, tGeneric Info, tLlistaNodes *LlistaNodes, int tipus_empilatge)
				
				/*si vertex de llista trobat l->V0 llavors l->V0.id = NodeTrobat.ID;
				altrament 
				{
					empilar_nou_vertex
						id_vertex++;
				}*/
				if(!LiniaRecta(MapaMon->Mapa2D[m1].Sector[s].LiniaSector[l].Linia)) Sector_es_quadrat = FALS;
			}
			
			if(Sector_es_quadrat) SET_SQUARE_SECTOR(MapaMon->Mapa2D[m1].Sector[s].Propietats);



		
		}

		
		



		//BorraLlista(LlistaVertexs);
		LD_Borrar_tots_els_nodes(&LlistaVertexs);


	}


	MapaMon->NVertexs = n_vertex;

	

	



/*	// Interconecci de portals de sostre/terra...

	for(m1 = 0; m1 < (MapaMon->N_Mapes2D-1); m1++)
	{

	}*/

}

#endif
//	MON_Interconectar_Portals(&Mapa_Mon_Demo);
//	MAPA_Crear_quadricula(&Mapa_Mon_Demo);

// { Donada la posici de jugador, aquesta funci troba el sector on resideix el jugador.
//   Donar que el jugador pot intersectar els extrems de sector, s'ha d'evitar per tal
//   de poder fer correctament la renderitzaci. Si passa aquest cas, es corregir les coordenades
//   a un dels punts adjacents i unitaris per la finalitat de que no intersecti cap lnia o vrtex }
//   CERT altrament.
PSector MON_SectorJugador(tJugador *Jugador)
{

	int NumeroSector = 0, intersecta_linia, trobat, j,mapa; 
	FIXED32 X = Jugador->X,Z = Jugador->Z;
//	short x_quadricula,z_quadricula
    short MaxSectors;
	PSector   SectorActual = NULL, Punter_Sector_Actual;
//	s16		  *Llista_ID_Sectors_Intersectants;


	// Cerca del mapa on es troba el jugador...

	mapa = 0;
	trobat = FALS;

	while((mapa < MapaMon->N_Mapes2D) && !trobat)
	{
		if((MapaMon->Mapa2D[mapa].Min_Altura < Jugador->Altura) && (Jugador->Altura < MapaMon->Mapa2D[mapa].Max_Altura))
		{
			trobat = CERT;
		}
		else mapa++;	
	}
	

	if(!trobat) return NULL;

	
	trobat = FALS;

#ifdef __SUPORT_CERCA_RAPIDA__ // Cerca rpida
	z_quadricula = COORDENADA_Z_QUADRAT_QUADRICULA(Jugador->Z);
	x_quadricula = COORDENADA_X_QUADRAT_QUADRICULA(Jugador->X);
	Llista_ID_Sectors_Intersectants = MapaMon->Mapa2D[mapa].Quadricula_Sectors_Intersectants[z_quadricula][x_quadricula].Llista_Sectors_Intersectants;	
	MaxSectors = MapaMon->Mapa2D[mapa].Quadricula_Sectors_Intersectants[z_quadricula][x_quadricula].NSectorsIntersectants;
#else // Cerca lineal...
    MaxSectors = MapaMon->Mapa2D[mapa].NSectors;
#endif


	if(MaxSectors < 1) return NULL;

	while((NumeroSector < MaxSectors) && (!trobat))
	{
#ifdef __SUPORT_CERCA_RAPIDA__ // Cerca rpida
		Punter_Sector_Actual = &MapaMon->Mapa2D[mapa].Sector[Llista_ID_Sectors_Intersectants[NumeroSector]];
#else
        Punter_Sector_Actual = &MapaMon->Mapa2D[mapa].Sector[NumeroSector];
#endif

		if(Punt_Pertany_A_Sector(X,Z,Punter_Sector_Actual,&intersecta_linia)) 
		{
			trobat = CERT;

			// Afegim l'identificador a la regio on es troba el jugador...
			Jugador->ID_MapaSector = ENCODE_ID_MAP_SECTOR(mapa,MapaMon->Mapa2D[mapa].Sector[NumeroSector].ID_Sector);
		}
		else
		{

			NumeroSector ++;
		}
	
	}

	if(trobat)
	{
		
		if(intersecta_linia) // Excepci, jugador intersecta lnia --> cal buscar una posici entre les seves adjacents, tal que resideixi sense intersectar lnia.
		{
			trobat = FALS;
			j = 0;

			while(j < 8 && !(trobat && (!intersecta_linia)))		// Busquem a les 8 posicions una que pertanyi al sector i no intersecti cap lnia... 
			{
				switch(j)
				{
					case 0: X=Jugador->X;
							Z=Jugador->Z - ONE_FX;
							trobat = Punt_Pertany_A_Sector(X,Z,Punter_Sector_Actual,&intersecta_linia);
							break;
					case 1: X=Jugador->X + ONE_FX;
							Z=Jugador->Z - ONE_FX;
							trobat = Punt_Pertany_A_Sector(X,Z,Punter_Sector_Actual,&intersecta_linia);
							break;
					case 2: X=Jugador->X + ONE_FX;
							Z=Jugador->Z ;
							trobat = Punt_Pertany_A_Sector(X,Z,Punter_Sector_Actual,&intersecta_linia);
							break;
					case 3: X=Jugador->X + ONE_FX;
							Z=Jugador->Z + ONE_FX;
							trobat = Punt_Pertany_A_Sector(X,Z,Punter_Sector_Actual,&intersecta_linia);
							break;
					case 4: X=Jugador->X;
							Z=Jugador->Z + ONE_FX;
							trobat = Punt_Pertany_A_Sector(X,Z,Punter_Sector_Actual,&intersecta_linia);
							break;
					case 5: X=Jugador->X - ONE_FX;
							Z=Jugador->Z + ONE_FX;
							trobat = Punt_Pertany_A_Sector(X,Z,Punter_Sector_Actual,&intersecta_linia);
							break;
					case 6: X=Jugador->X - ONE_FX;
							Z=Jugador->Z;
							trobat = Punt_Pertany_A_Sector(X,Z,Punter_Sector_Actual,&intersecta_linia);
							break;
					case 7: X=Jugador->X - ONE_FX;
							Z=Jugador->Z - ONE_FX;
							trobat = Punt_Pertany_A_Sector(X,Z,Punter_Sector_Actual,&intersecta_linia);
							break;
					default: trobat = FALS;
							break;
				
								

				}

				j++;			
			
			
			}
			
			if(trobat & (!intersecta_linia))
			{
				Jugador->X = X;
				Jugador->Z = Z;
			}
			else return NULL;
		}
		else return Punter_Sector_Actual;		
			
	}
	else
	{
		return NULL;
	}

	return Punter_Sector_Actual;

}


// { Donada la posici de jugador, aquesta funci retorna el punter on resideix el jugador
//   retorna FALS, en cas de que no s'hagi trobat en els sectors convexes que formen el MapaMon->
//   CERT altrament.
PSector MON_SectorPunt(FIXED32 PosicioX,FIXED32 PosicioZ,FIXED32 PosicioY, int *linia_intersecta)
{

	int NumeroSector = 0,m;
	short MaxSectors;
	tSector *Punter_Sector_Actual;
	short x_quadricula = COORDENADA_X_QUADRAT_QUADRICULA(PosicioX);
	short z_quadricula = COORDENADA_Z_QUADRAT_QUADRICULA(PosicioZ);
//	s16	  *Llista_ID_Sectors_Intersectants;
    short trobat;



	m = 0;
	trobat = FALS;

	while((m < MapaMon->N_Mapes2D) && !trobat)
	{
		if(MapaMon->Mapa2D[m].Min_Altura < FIXED_TO_INT(PosicioY) < MapaMon->Mapa2D[m].Max_Altura)
		{
			trobat = CERT;
		}
		else m++;	
	}
	

	if(!trobat) return NULL;

	//trobat = FALS;
#ifdef __SUPORT_CERCA_RAPIDA__ // Cerca rpida
	Llista_ID_Sectors_Intersectants = MapaMon->Mapa2D[m].Quadricula_Sectors_Intersectants[z_quadricula][x_quadricula].Llista_Sectors_Intersectants;	
	MaxSectors = MapaMon->Mapa2D[m].Quadricula_Sectors_Intersectants[z_quadricula][x_quadricula].NSectorsIntersectants;
#else
    MaxSectors = MapaMon->Mapa2D[m].NSectors;
#endif

	if(MaxSectors < 1) return NULL;

	while(NumeroSector < MaxSectors)
	{
#ifdef __SUPORT_CERCA_RAPIDA__ // Cerca rpida
		Punter_Sector_Actual = &MapaMon->Mapa2D[m].Sector[Llista_ID_Sectors_Intersectants[NumeroSector]];
#else
        Punter_Sector_Actual = &MapaMon->Mapa2D[m].Sector[NumeroSector];
#endif

		if(Punt_Pertany_A_Sector(PosicioX,PosicioZ,Punter_Sector_Actual, linia_intersecta)) return Punter_Sector_Actual;
		else NumeroSector ++;
	
	}

	return NULL;

}






