//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA

#include "Objecte3D.h"
#include "Mon.h"
#include "render.h"
#include "geometria.h"
#include "info_objectes.c"
#include "jugador.h"



tObjecte_Mon					*Llista_Objectes_Mon
#ifdef __HAM__
MEM_IN_EWRAM
#endif
;
tObjecte_Render					*Llista_Objectes_Render
#ifdef __HAM__
MEM_IN_EWRAM
#endif
;
PLlista_Objectes_Sector_Render	*Llista_Objectes_Sector_Render
#ifdef __HAM__
MEM_IN_EWRAM
#endif
; // Llista de objectes a renderitzar...




//////////////////////////////////////////////////////////////////////////////////////////////////////////////

int Crea_Nou_Objecte_Mon(short ID_Objecte,FIXED32 x, FIXED32 z, tTextura **Animacio, u32 Propietats, int Altura3D)
{
	// Emmgatzarem els objectes que hi ha al mon amb una simple cadena...
	int linia_intersecta,Propietats_Textura;
	PObjecte_Mon  Nou_Node;
//	PLlista_Objectes_Sector_Render llista_sector;
	tImatge	MipMap;
	tSector *Sector;

#ifdef __RENDER_OBJECTES__
	Sector   = MON_SectorPunt(x,z, INT_TO_FIXED(Altura3D),&linia_intersecta);	
	

	if(Sector == NULL)
	{
	    PRINT_ERROR("\n No s'ha trobat sector per l'objecte que es troba a la posici (%f, %f).",(FIXED_TO_DOUBLE(x), FIXED_TO_DOUBLE(z)));
/*#ifdef __SDL__
			fprintf(stderr,"\n No s'ha trobat sector per l'objecte que es troba a la posici (%f, %f).",FIXED_TO_DOUBLE(x), FIXED_TO_DOUBLE(z));
#endif*/
			//return FALSE;
	}

//	Nou_Node = (PObjecte_Mon)malloc(sizeof(tObjecte_Mon));
	Reservar_Memoria(Nou_Node,tObjecte_Mon,1);

	if(Nou_Node == NULL)
	{

		PRINT_ERROR("\n Memoria insuficient alhora de resrvar memoria per %i bytes a la funci Nou_Objecte",sizeof(tObjecte_Mon));


		return FALSE;
	}
	else
	{

		// Cerca del sector inicial on es troba l'objecte (es imprescindible que l'ed del mapa ja estigui inicialitzada)




		// Inicialitzaci de la info...

		Nou_Node->Dades_Objecte_Mon.ID_Objecte = ID_Objecte;
		Nou_Node->Dades_Objecte_Mon.Sector = Sector;
		Nou_Node->Dades_Objecte_Mon.Frame_Animacio =  Animacio;
		Nou_Node->Dades_Objecte_Mon.X = x;
		Nou_Node->Dades_Objecte_Mon.Z = z;
		Nou_Node->Dades_Objecte_Mon.Propietats = Propietats;

		MipMap = *((*Animacio)->GFX_MipMap);    // Primer mipmap...
        Propietats_Textura = (*Animacio)->Propietats;
		Nou_Node->Dades_Objecte_Mon.Altura  = TST_BIT(Propietats_Textura,BIT_IS_VPOW2)? (1 << MipMap.Log2V):MipMap.DimY;
		Nou_Node->Dades_Objecte_Mon.Amplada = TST_BIT(Propietats_Textura,BIT_IS_UPOW2)? (1 << MipMap.Log2U):MipMap.DimX;

		Nou_Node->Dades_Objecte_Mon.Altura3D = Altura3D;
		
		

		Nou_Node->Dades_Objecte_Mon.Quadrat_Colisio.x1 = 0;
		Nou_Node->Dades_Objecte_Mon.Quadrat_Colisio.x2 = (*Animacio)->GFX_MipMap->DimX;
		Nou_Node->Dades_Objecte_Mon.Quadrat_Colisio.y2 = (*Animacio)->GFX_MipMap->DimY;

		if(	Llista_Objectes_Mon == NULL) // Permier node...
		{
			Nou_Node->PSeguent = NULL;
			Llista_Objectes_Mon = Nou_Node;
										
		}
		else // Mes d'un node...
		{

			Nou_Node->PSeguent = Llista_Objectes_Mon;
			Llista_Objectes_Mon = Nou_Node;
			
		
		}
	}
#endif

	return TRUE;

}

/////pppppp//////
/////pppppp//////


/*	int						ID_ObjecteRender;
	
	tObjecte_Mon			*Info_Objecte;
	
	FIXED32					escale;
	
	tQuadrat_Fixa_2D_2D				Quadrat_Projeccio;
	
	// Variables destinades al retallat...
	short					*ymin, ymax;
	short					 x1,x2;
	
	PObjecte_Render			PSeguent;*/
int  OBJECTE_Afegir_EfectePortalRender(int x1, int x2, const tInfo_Portal *IRP, const tComponentsParetSector *CPS, const tSector *Sector)
{
   PObjecte_Render  New_Node, Actual_Node, Previus_Node;
   tDades_Objecte_Render D_O_R;
   PLlista_Objectes_Sector_Render llista_objectes_sector, New_Node_Sector;
   int x2d, End, Distancia;
   short *ymin, *ymax;

#ifdef __RENDER_OBJECTES__

   x2d = IRP->x_final + IRP->x_inicial + 1;

	Reservar_Memoria(New_Node, tObjecte_Render, 1);
    Reservar_Memoria(ymin, short, x2d);
    Reservar_Memoria(ymax, short, x2d);
    Reservar_Memoria(New_Node_Sector, tLlista_Objectes_Sector_Render,1);

    if(New_Node == NULL || ymin == NULL || ymax == NULL || New_Node_Sector == NULL) // Error..
    {
        PRINT_ERROR("\nError no 'sha pogut reservar memoria a la funci OBJECTE_Afegir_EfectePortalRender()",0);
        if(New_Node) Alliberar_Punter(New_Node);
        if(ymin) Alliberar_Punter(ymin);
        if(ymax) Alliberar_Punter(ymax);
        if(New_Node_Sector) Alliberar_Punter(New_Node_Sector);

        return FALSE;
    }


	D_O_R.ID_Tipus = EFFECTE_PORTAL;
    //D_O_R.Info_Objecte = Info_Objecte;
	//D_O_R.Quadrat_Projeccio = Quadrat;
	//D_O_R.escale = escale;
	//D_O_R.x1 = AMPLADA_PANTALLA-1;
	//D_O_R.x2 = 0;
    memcpy(&D_O_R.CPS,CPS,sizeof(tComponentsParetSector));

	D_O_R.Retallat_Actualitzat = TRUE;
    D_O_R.x1 = x1;
    D_O_R.x2 = x2;
    D_O_R.x_ini_portal = IRP->x_inicial;
    D_O_R.ymin = ymin;
    D_O_R.ymax = ymax;
    CopyMem_16bit(D_O_R.ymin,IRP->ymin,x2d);
    CopyMem_16bit(D_O_R.ymax,IRP->ymax,x2d);

    
    



	Distancia = New_Node->ID_Node = FIXED_TO_INT(CPS->Z_Med);  // La distancia es l'element d'ordenaci. El primer node ser l'objecte ms llunyar i s'anir ordenant ascendenment del ms petit al ms gran.
	memcpy(&New_Node->Dades_Objecte_Render,&D_O_R,sizeof(tDades_Objecte_Render));
	New_Node_Sector->Dades_Objecte_Render	= &New_Node->Dades_Objecte_Render;
	
	if(Llista_Objectes_Render == NULL) // The node be will first...
	{
		Llista_Objectes_Render = New_Node;
		Llista_Objectes_Render->PSeguent = NULL;
		Llista_Objectes_Render->PAnterior = NULL;
	}
	else
	{
		Previus_Node = Actual_Node = Llista_Objectes_Render;
		End = FALSE;
		
		while(Actual_Node != NULL && !End)
		{
			if(Distancia  > Actual_Node->ID_Node  )
			{
				End = TRUE;			
			}
			else
			{
				Previus_Node = Actual_Node;
				Actual_Node = Actual_Node->PSeguent;				
			
			}
		
		
		}

		if(Previus_Node == Llista_Objectes_Render && Actual_Node == Llista_Objectes_Render) // The new node will be the first of list nodes...
		{
			New_Node->PAnterior  = NULL;
			New_Node->PSeguent   = Llista_Objectes_Render;
			Llista_Objectes_Render->PAnterior = New_Node;
			Llista_Objectes_Render = New_Node;
		}
		else
		{
			Previus_Node->PSeguent = New_Node;
			New_Node->PSeguent = Actual_Node;
			New_Node->PAnterior = Previus_Node;

		}
	
	}

	// Add list to sector...
	New_Node->Dades_Objecte_Render.Referencia_Al_Node_Objecte_Llista_Render_Sector = llista_objectes_sector = Llista_Objectes_Sector_Render[Sector->ID_Sector];//Llista_Objectes_Sector_Render;
	New_Node_Sector->PAnterior = NULL;


	if(llista_objectes_sector == NULL) // Is the first object...
	{
		New_Node_Sector->PSeguent = NULL;
		Llista_Objectes_Sector_Render[Sector->ID_Sector] = New_Node_Sector;
		//(Info_Objecte)->Sector->Llista_Objectes_Sector_Render->PAnterior = NULL;
	}
	else
	{
		llista_objectes_sector->PAnterior = New_Node_Sector;
		
		New_Node_Sector->PSeguent = llista_objectes_sector;
		llista_objectes_sector->PAnterior = New_Node_Sector;
		Llista_Objectes_Sector_Render[Sector->ID_Sector] = New_Node_Sector;

	
	}



	New_Node->Dades_Objecte_Render.Referencia_Al_Node_Objecte_Llista_Render_Sector = New_Node_Sector;

	
#endif

	return TRUE;
}

/*int Crea_Nou_EfectePortal_Render(int Distancia,tParametresvoid *Info_Objecte)
{
    
    PObjecte_Render New_Node, Actual_Node, Previus_Node;
	PLlista_Objectes_Sector_Render llista_objectes_sector, New_Node_Sector;
	tDades_Objecte_Render D_O_R;

	int End;

	
	//New_Node		= (PObjecte_Render)malloc(sizeof(tObjecte_Render));
	
	Reservar_Memoria(New_Node, tObjecte_Render, 1);

	//New_Node_Sector = (PLlista_Objectes_Sector_Render)malloc(sizeof(tLlista_Objectes_Sector_Render));
	Reservar_Memoria(New_Node_Sector, tLlista_Objectes_Sector_Render,1);


	if(New_Node == NULL || New_Node_Sector == NULL)
	{

		PRINT_ERROR("\nNot enought memory in function \"AddNodeList_Sort_To_Ascendent()\" for reserve %d bytes !!!",sizeof(tObjecte_Render));

		return FALSE;
	}

	// Add dthe info...
	D_O_R.ID_Tipus = EFFECTE_PORTAL;
    D_O_R.Info_Objecte = Info_Objecte;
	//D_O_R.Quadrat_Projeccio = Quadrat;
	//D_O_R.escale = escale;
	//D_O_R.x1 = AMPLADA_PANTALLA-1;
	//D_O_R.x2 = 0;
	D_O_R.Retallat_Actualitzat = FALSE;
	D_O_R.ysostre_sector = ysostre_sector;
	D_O_R.yterra_sector = yterra_sector;
	D_O_R.distancia = Distancia;

	New_Node->ID_Node = Distancia;  // La distancia es l'element d'ordenaci. El primer node ser l'objecte ms llunyar i s'anir ordenant ascendenment del ms petit al ms gran.
	New_Node->Dades_Objecte_Render			= D_O_R;
	New_Node_Sector->Dades_Objecte_Render	= &New_Node->Dades_Objecte_Render;
	
	if(Llista_Objectes_Render == NULL) // The node be will first...
	{
		Llista_Objectes_Render = New_Node;
		Llista_Objectes_Render->PSeguent = NULL;
		Llista_Objectes_Render->PAnterior = NULL;
	}
	else
	{
		Previus_Node = Actual_Node = Llista_Objectes_Render;
		End = FALSE;
		
		while(Actual_Node != NULL && !End)
		{
			if(Distancia  > Actual_Node->ID_Node  )
			{
				End = TRUE;			
			}
			else
			{
				Previus_Node = Actual_Node;
				Actual_Node = Actual_Node->PSeguent;				
			
			}
		
		
		}

		if(Previus_Node == Llista_Objectes_Render && Actual_Node == Llista_Objectes_Render) // The new node will be the first of list nodes...
		{
			New_Node->PAnterior  = NULL;
			New_Node->PSeguent   = Llista_Objectes_Render;
			Llista_Objectes_Render->PAnterior = New_Node;
			Llista_Objectes_Render = New_Node;
		}
		else
		{
			Previus_Node->PSeguent = New_Node;
			New_Node->PSeguent = Actual_Node;
			New_Node->PAnterior = Previus_Node;

		}
	
	}

	// Add list to sector...


	
	New_Node->Dades_Objecte_Render.Referencia_Al_Node_Objecte_Llista_Render_Sector = llista_objectes_sector = Llista_Objectes_Sector_Render[(Info_Objecte)->Sector->ID_Sector];//Llista_Objectes_Sector_Render;
	New_Node_Sector->PAnterior = NULL;


	if(llista_objectes_sector == NULL) // Is the first object...
	{
		New_Node_Sector->PSeguent = NULL;
		Llista_Objectes_Sector_Render[(Info_Objecte)->Sector->ID_Sector] = New_Node_Sector;
		//(Info_Objecte)->Sector->Llista_Objectes_Sector_Render->PAnterior = NULL;
	}
	else
	{
		llista_objectes_sector->PAnterior = New_Node_Sector;
		
		New_Node_Sector->PSeguent = llista_objectes_sector;
		llista_objectes_sector->PAnterior = New_Node_Sector;
		Llista_Objectes_Sector_Render[(Info_Objecte)->Sector->ID_Sector] = New_Node_Sector;

	
	}



	New_Node->Dades_Objecte_Render.Referencia_Al_Node_Objecte_Llista_Render_Sector = New_Node_Sector;

	



	return TRUE;

}*/

// Nou objecte....
int Crea_Nou_Objecte_Render(int Distancia,tDades_Objecte_Mon *Info_Objecte, FIXED32 escale, tQuadrat_2D Quadrat, int ysostre_sector, int yterra_sector)
{

	PObjecte_Render New_Node, Actual_Node, Previus_Node;
	PLlista_Objectes_Sector_Render llista_objectes_sector, New_Node_Sector;
	tDades_Objecte_Render D_O_R;

	int End;

#ifdef __RENDER_OBJECTES__

	
	//New_Node		= (PObjecte_Render)malloc(sizeof(tObjecte_Render));
	
	Reservar_Memoria(New_Node, tObjecte_Render, 1);

	//New_Node_Sector = (PLlista_Objectes_Sector_Render)malloc(sizeof(tLlista_Objectes_Sector_Render));
	Reservar_Memoria(New_Node_Sector, tLlista_Objectes_Sector_Render,1);


	if(New_Node == NULL || New_Node_Sector == NULL)
	{

		PRINT_ERROR("\nNot enought memory in function \"AddNodeList_Sort_To_Ascendent()\" for reserve %d bytes !!!",sizeof(tObjecte_Render));

		return FALSE;
	}

	// Add dthe info...
	D_O_R.ID_Tipus = OBJECTE_2D;
    D_O_R.Info_Objecte = Info_Objecte;
	D_O_R.Quadrat_Projeccio = Quadrat;
	D_O_R.escale = escale;
	D_O_R.x1 = AMPLADA_PANTALLA-1;
	D_O_R.x2 = 0;
	D_O_R.Retallat_Actualitzat = FALSE;
	D_O_R.ysostre_sector = ysostre_sector;
	D_O_R.yterra_sector = yterra_sector;
	D_O_R.distancia = Distancia;

	New_Node->ID_Node = Distancia;  // La distancia es l'element d'ordenaci. El primer node ser l'objecte ms llunyar i s'anir ordenant ascendenment del ms petit al ms gran.
	memcpy(&New_Node->Dades_Objecte_Render, &D_O_R, sizeof(tDades_Objecte_Render));
	New_Node_Sector->Dades_Objecte_Render	= &New_Node->Dades_Objecte_Render;
	
	if(Llista_Objectes_Render == NULL) // The node be will first...
	{
		Llista_Objectes_Render = New_Node;
		Llista_Objectes_Render->PSeguent = NULL;
		Llista_Objectes_Render->PAnterior = NULL;
	}
	else
	{
		Previus_Node = Actual_Node = Llista_Objectes_Render;
		End = FALSE;
		
		while(Actual_Node != NULL && !End)
		{
			if(Distancia  > Actual_Node->ID_Node  )
			{
				End = TRUE;			
			}
			else
			{
				Previus_Node = Actual_Node;
				Actual_Node = Actual_Node->PSeguent;				
			
			}
		
		
		}

		if(Previus_Node == Llista_Objectes_Render && Actual_Node == Llista_Objectes_Render) // The new node will be the first of list nodes...
		{
			New_Node->PAnterior  = NULL;
			New_Node->PSeguent   = Llista_Objectes_Render;
			Llista_Objectes_Render->PAnterior = New_Node;
			Llista_Objectes_Render = New_Node;
		}
		else
		{
			Previus_Node->PSeguent = New_Node;
			New_Node->PSeguent = Actual_Node;
			New_Node->PAnterior = Previus_Node;

		}
	
	}

	// Add list to sector...


	
	New_Node->Dades_Objecte_Render.Referencia_Al_Node_Objecte_Llista_Render_Sector = llista_objectes_sector = Llista_Objectes_Sector_Render[(Info_Objecte)->Sector->ID_Sector];//Llista_Objectes_Sector_Render;
	New_Node_Sector->PAnterior = NULL;


	if(llista_objectes_sector == NULL) // Is the first object...
	{
		New_Node_Sector->PSeguent = NULL;
		Llista_Objectes_Sector_Render[(Info_Objecte)->Sector->ID_Sector] = New_Node_Sector;
		//(Info_Objecte)->Sector->Llista_Objectes_Sector_Render->PAnterior = NULL;
	}
	else
	{
		llista_objectes_sector->PAnterior = New_Node_Sector;
		
		New_Node_Sector->PSeguent = llista_objectes_sector;
		llista_objectes_sector->PAnterior = New_Node_Sector;
		Llista_Objectes_Sector_Render[(Info_Objecte)->Sector->ID_Sector] = New_Node_Sector;

	
	}



	New_Node->Dades_Objecte_Render.Referencia_Al_Node_Objecte_Llista_Render_Sector = New_Node_Sector;

#endif	

	return TRUE;


}

//void OBJECTE_Afegir(int x1, int x2,short *ymin, short *ymax, void *info, int tipus);


//////////////////////////////////////////////////////////////////////////////////////////////////////////////

int Ini_Objectes()
{
	u32 i;

#ifdef __RENDER_OBJECTES__
	for( i = 0; i < MAX_OBJECTES_MON; i++)
	{




//		if(Info_Objectes[i].Es_colisionable) SET_COLISIONABLE(Propietats);
//		if(Info_Objectes[i].Es_recolectable) SET_RECOLECTABLE(Propietats);
		

		if(!Crea_Nou_Objecte_Mon(i, Info_Objectes[i].X, Info_Objectes[i].Z, &TaulaAnimacions[Info_Objectes[i].ID_Animacio]->Textura,Info_Objectes[i].Propietats_Objecte,Info_Objectes[i].Altura3D))
		{
			return FALSE;
		}
		
	
	}

	Reservar_Memoria(Llista_Objectes_Sector_Render,PLlista_Objectes_Sector_Render,NUMERO_SECTORS);

	if(Llista_Objectes_Sector_Render == NULL)
	{
			return FALSE;
	}

	// Inicialitzaci de la taula d'objectes-sector...

	for( i = 0; i < NUMERO_SECTORS; i++)
	{
		Llista_Objectes_Sector_Render[i] = NULL;
	}

#endif

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////

void Capturar_Objectes_Al_FOV(const tJugador *Jugador) 
{
	PObjecte_Mon  Llista_Objectes_Mon_Actual;
	short		  z3d;
	FIXED32		  escale, z_inversa;
	tPunt_Fixa_2D	 Posicio_FOV_Objecte;
	tQuadrat_2D	 Quadrat;
	int ysostre_sector,yterra_sector;
	
#ifdef __RENDER_OBJECTES__	
	// Per cada objecte del mon...
	Llista_Objectes_Mon_Actual = Llista_Objectes_Mon;

	while(Llista_Objectes_Mon_Actual != NULL)
	{
		// Es calcular la distancia objecte-jugador...

		z3d = FIXED_TO_INT(Distancia(Jugador->X, Jugador->Z, Jugador->AngleDireccio,Llista_Objectes_Mon_Actual->Dades_Objecte_Mon.X,Llista_Objectes_Mon_Actual->Dades_Objecte_Mon.Z ));

		if((z3d >= 1) && (Llista_Objectes_Mon_Actual->Dades_Objecte_Mon.Sector != NULL))
		{
			
			if(z3d >= MAX_DIST_RENDER) z3d = MAX_DIST_RENDER-1;
			
			// Escalat...
			
			
			z_inversa = _reciprocal_div[z3d];

#ifdef __HAM__	    // rpida divis entre 60...
					escale = FIXED_MUL_256(INT_TO_FIXED(z3d));
					FIXED_DIV_120(escale);
					escale <<= DETALL_GRAFIC_Y;
#else
					escale = FIXED_MUL_256(INT_TO_FIXED(z3d))/d;//altura_paret_16_16/(Yterra_actual - Ysostre_actual);// no tant rpida per s ms precisa...
#endif
			//escale = FIXED_MUL_256(INT_TO_FIXED(z3d))/d;
			// Objecte respecte jugador...
			
			punt_mon_A_pla_projeccio(Jugador,Llista_Objectes_Mon_Actual->Dades_Objecte_Mon.X , Llista_Objectes_Mon_Actual->Dades_Objecte_Mon.Z,  &Posicio_FOV_Objecte);
			
			// Centre projecci objecte...
			
			//x_centre = CENTRE_X2D_EFECTIU + dX*escale*Posicio_FOV_Objecte.X;
			
			// Quadrat de projecci...
			
			ysostre_sector = (CENTRE_Y2D_EFECTIU-Jugador->Horitzo)  + CEIL_FX(dY*FIXED_DIV_256(z_inversa*(Jugador->Altura - Llista_Objectes_Mon_Actual->Dades_Objecte_Mon.Sector->AlturaSostre)));
			yterra_sector = (CENTRE_Y2D_EFECTIU-Jugador->Horitzo)  + CEIL_FX(dY*FIXED_DIV_256(z_inversa*(Jugador->Altura  - Llista_Objectes_Mon_Actual->Dades_Objecte_Mon.Sector->AlturaTerra )));
			
			Quadrat.y1 = (s16)((CENTRE_Y2D_EFECTIU - Jugador->Horitzo)  + FLOOR_FX(dY*FIXED_DIV_256(z_inversa*(Jugador->Altura - (Llista_Objectes_Mon_Actual->Dades_Objecte_Mon.Altura3D + (Llista_Objectes_Mon_Actual->Dades_Objecte_Mon.Altura >> 1))))));
			Quadrat.y2 = (s16)((CENTRE_Y2D_EFECTIU - Jugador->Horitzo)  + FLOOR_FX(dY*FIXED_DIV_256(z_inversa*(Jugador->Altura - (Llista_Objectes_Mon_Actual->Dades_Objecte_Mon.Altura3D - (Llista_Objectes_Mon_Actual->Dades_Objecte_Mon.Altura >> 1))))));
			Quadrat.x1 = (s16)(CENTRE_X2D_EFECTIU                       + FLOOR_FX(MulFx(FIXED_DIV_256(dX*z_inversa),((Posicio_FOV_Objecte.X - INT_TO_FIXED(Llista_Objectes_Mon_Actual->Dades_Objecte_Mon.Amplada >> 1))))));
			Quadrat.x2 = (s16)(CENTRE_X2D_EFECTIU                       + FLOOR_FX(MulFx(FIXED_DIV_256(dX*z_inversa),((Posicio_FOV_Objecte.X + INT_TO_FIXED(Llista_Objectes_Mon_Actual->Dades_Objecte_Mon.Amplada >> 1))))));

			//escale = _reciprocal_div[z3d];
			
			
			// Si l'objecte pertany al pla de projeccio l'emplilem al buffer per ordre de distancia...
			if( ! (Quadrat.x1 >= AMPLADA_PANTALLA_EFECTIVA || Quadrat.x2 < 0 || Quadrat.y1 >= ALTURA_PANTALLA_EFECTIVA || Quadrat.y2  < 0) )
			{
				Crea_Nou_Objecte_Render(z3d,&Llista_Objectes_Mon_Actual->Dades_Objecte_Mon, escale, Quadrat, ysostre_sector, yterra_sector);
				
			}
		}

		

		Llista_Objectes_Mon_Actual = Llista_Objectes_Mon_Actual->PSeguent;
	
	}
	
#endif

}

/*
void Eliminar_Objectes_Opacs()
{
	PObjecte_Render	llista_1, llista_2,Node_A_Borrar;
	tQuadrat_2D		Quadrat_Projeccio1, Quadrat_Projeccio2;
	PLlista_Objectes_Sector_Render Node_Sector_Render_A_Borrar;

		
	llista_1 = Llista_Objectes_Render;

	if(Llista_Objectes_Render == NULL) return;
//	if(Llista_Objectes_Render->PSeguent != NULL)
//	{
//		if(Llista_Objectes_Render->PSeguent->PSeguent != NULL)
//		{
//			i++;i--;
//		}
//	}

	// Anem cap l'ultim objecte a renderitzar...
	while(llista_1->PSeguent != NULL) {llista_1 = llista_1->PSeguent;}

	// ok. Ara comprovem dimensions de cada objecte respecte als que estan ms lluny. Si qualsevol 
	// objecte tapa qualsevol altre, ser borrat de la llista...

	// per i desde llista1 al primer node fer
	while(llista_1 != Llista_Objectes_Render)
	{

		llista_2 = llista_1->PAnterior;

				
		while(llista_2 != NULL)
		{
			Quadrat_Projeccio1 = llista_1->Dades_Objecte_Render.Quadrat_Projeccio;
			Quadrat_Projeccio2 = llista_2->Dades_Objecte_Render.Quadrat_Projeccio;

			if(Quadrat_Projeccio2.x1 >= Quadrat_Projeccio1.x1 && Quadrat_Projeccio2.x2 <= Quadrat_Projeccio1.x2 &&
			   Quadrat_Projeccio2.y1 >= Quadrat_Projeccio1.y1 && Quadrat_Projeccio2.y2 <= Quadrat_Projeccio1.y2) // El borrem de la llista...
			{
				
				// Borrat de la llsita d'objectes...
				Node_A_Borrar				= llista_2;
				Node_Sector_Render_A_Borrar = llista_2->Dades_Objecte_Render.Referencia_Al_Node_Objecte_Llista_Render_Sector;

					// Borrat de la llista d'objectes agfegits a la clase sector...

				

				



				// Si es el primer de la llista, llavors actualitzem llista_d'objectes...

				if(Node_Sector_Render_A_Borrar == Llista_Objectes_Sector_Render[llista_2->Dades_Objecte_Render.Info_Objecte->Sector->ID_Sector])
				{
					Llista_Objectes_Sector_Render[llista_2->Dades_Objecte_Render.Info_Objecte->Sector->ID_Sector]->PAnterior = NULL;
					Llista_Objectes_Sector_Render[llista_2->Dades_Objecte_Render.Info_Objecte->Sector->ID_Sector] = Node_Sector_Render_A_Borrar->PSeguent;
					// Llista_Objectes_Render = llista_2 ->PSeguent;
				}
				else
				{
					// Interconnectem nodes...
					if(Node_Sector_Render_A_Borrar->PAnterior!= NULL)
					{
						Node_Sector_Render_A_Borrar->PAnterior->PSeguent = Node_Sector_Render_A_Borrar->PSeguent;
					}
					else
					{
					
					}

					if(Node_Sector_Render_A_Borrar->PSeguent!= NULL)
					{
						Node_Sector_Render_A_Borrar->PSeguent->PAnterior = Node_Sector_Render_A_Borrar->PAnterior;
					
					}
					else
					{
					
					}
				
				}

				
				// Borrem node de llista de sector.
				Alliberar_Punter(Node_Sector_Render_A_Borrar);


				// BORRAT DEL NODE DE LA LLISTA DE RENDER...

				// Llavors cal el seguent tractament especial...

				
				if(llista_2 == Llista_Objectes_Render) 
				{
					if(llista_1->PAnterior == Llista_Objectes_Render) 
					{
						llista_1->PAnterior = llista_2->PSeguent;
					}

					llista_2 ->PAnterior = NULL;
					Llista_Objectes_Render = llista_2->PSeguent;
					llista_2 = Llista_Objectes_Render->PAnterior = NULL;
					

				//	if(llista_1->PAnterior == Llista_Objectes_Render)
				//	{
				//	
				//	}
					
				}
				else	// Al mitg...
				{
					// Interconnectem nodes...

					if(llista_2->PAnterior!= NULL) llista_2->PAnterior->PSeguent = llista_2->PSeguent;
					if(llista_2->PSeguent!= NULL)  llista_2->PSeguent->PAnterior = llista_2->PAnterior;
					llista_2 = llista_2->PAnterior;
				}

				
				
				// .. i el borrem...
				Alliberar_Punter(Node_A_Borrar);

			}
			else
			{
						
				llista_2 = llista_2->PAnterior;
			}
		}


		if(llista_1 != Llista_Objectes_Render) llista_1 = llista_1->PAnterior;
	
	}
		
}*/

//////////////////////////////////////////////////////////////////////////////////////////////////////////////

void Renderitzar_Objectes()
{
	PObjecte_Render llista;
	short x;//,Mascara_u_Sprite;
	short y1,y2,x1,x2,ymin,ymax,xmin,xmax,intensitat_total,intensitat_llinterna,intensitat_sector,propietats;
	int	  escale,u,distancia;//,Propietats_Textura;
	tParametresPintarParet2 PPP;
	PDades_Objecte_Mon Dades_Objecte_Mon;
//	tImatge MipMap;
    int ID_Textura;
	tDades_Objecte_Render D_O_R;

#ifdef __RENDER_OBJECTES__
 	
	llista = Llista_Objectes_Render;
	
    while(llista != NULL)
    {
        D_O_R = llista->Dades_Objecte_Render;
        
        
        if(D_O_R.Retallat_Actualitzat)
        {
            
            switch(D_O_R.ID_Tipus)
            {
case OBJECTE_2D :
            xmin = D_O_R.x1;
            xmax = D_O_R.x2;
            
            y1 = D_O_R.Quadrat_Projeccio.y1;
            y2 = D_O_R.Quadrat_Projeccio.y2;
            x1 = D_O_R.Quadrat_Projeccio.x1;
            x2 = D_O_R.Quadrat_Projeccio.x2;
            Dades_Objecte_Mon = D_O_R.Info_Objecte;
            intensitat_sector = Dades_Objecte_Mon->Sector->Intensitat_Llum_Sector;
            PPP.Propietats_Objecte = Dades_Objecte_Mon->Propietats;
            
            if(intensitat_sector < 0) intensitat_sector = -intensitat_sector;
            else intensitat_sector = fx_llum[intensitat_sector][temps];
            
            distancia = llista->Dades_Objecte_Render.distancia; // Ja que anteriorment estava a aritmetica 16:16
            propietats = Dades_Objecte_Mon->Propietats;
            
            
#ifdef __ARITMETICA_FIXA__
            escale = D_O_R.escale;
#else
            escale = (long)(D_O_R.escale*(1 << PART_FRACCIONAL));
#endif
            
            
            ID_Textura = (*Dades_Objecte_Mon->Frame_Animacio)->ID_Textura;
            //    Propietats_Textura = (*Dades_Objecte_Mon->Frame_Animacio)->Propietats;
            
            //	Mascara_u_Sprite = (1 << (MipMap.Log2U)) - 1;
            
            //			PPP.Color_Mascara = MASK_COLOR;
            
            for(x = xmin, u = (xmin-x1)*escale; x <= xmax ; x++, u += (escale << DETALL_GRAFIC_X))
            {
                ymin = max(D_O_R.ysostre_sector,max(y1,D_O_R.ymin[x-xmin]));
                ymax = min(D_O_R.yterra_sector,min(y2,D_O_R.ymax[x-xmin]));
                
                
                
                // Obtencio de v1...
                
                PPP.v1 = (ymin-y1)*escale;
                
                // Resta de parametres
                
                PPP.Escale_v = (escale << DETALL_GRAFIC_Y);
                PPP.y1 = ymin;
                PPP.y2 = ymax;
                PPP.x  = x;
                PPP.ID_Textura = ID_Textura;
                
                
                if(distancia <= MINIMA_DISTANCIA_LLINTERNA) intensitat_llinterna = MAXIMA_ILUMINACIO_LLINTERNA;
                else
                {
                    intensitat_llinterna = (s16)(((MAXIMA_ILUMINACIO_LLINTERNA << 8) - (llista->Dades_Objecte_Render.distancia >> 4)) >> 8);
                    if(intensitat_llinterna < 0) intensitat_llinterna = 0;
                }
                
                
                if((intensitat_sector + intensitat_llinterna) <  MAXIMA_INTENSITAT) intensitat_total = intensitat_sector + intensitat_llinterna;//((-intensitat_sector) + intensitat_llinterna) : (-intensitat_sector);
                else intensitat_total = MAXIMA_INTENSITAT;
                
                
                PPP.Intensitat = intensitat_total;
                
                PPP.u1 = (u >> 8); // u en APF 16.8
                
                //PPP.Intensitat = 128;
                
                // Obtencio de u1..
                /*if(!TST_BIT(Propietats_Textura, BIT_IS_UPOW2))
                {
                PPP.u1 = (u >> 16);
                }
                else
                {
                PPP.u1 = (u >> 16) & Mascara_u_Sprite;
            }*/
                
                PutVerticalSlice(&PPP);
                
                //PintarParet(PPP);
                
                
                
                
            }
            break;
case EFFECTE_PORTAL:
            
            {
                tInfo_Portal IP;
                
                IP.ymin = D_O_R.ymin;
                IP.ymax = D_O_R.ymax;
                IP.x_inicial = D_O_R.x_ini_portal;
                IP.x_final   = D_O_R.x2;
                
                
                RenderitzarPartSector(D_O_R.x1, D_O_R.x2, &Jugador, &D_O_R.CPS, &IP, NULL,NULL,NULL);
            }
            break;
            }
            
        }
        

        
        llista = llista->PSeguent;	
        
    }
#endif	

}


void Renderitzar_Objectes_Recursiu(const tInfo_Portal *Info_Retallat_Portal,const tSector *SectorActual)
{
	PObjecte_Render llista,Anterior,Actual;
	short x;//,Mascara_u_Sprite;
	short y1,y2,x1,x2,ymin,ymax,xmin,xmax,xmin_portal,xmax_portal,intensitat_total,intensitat_llinterna,intensitat_sector,propietats_objecte;
	int	  escale,u,distancia;
	tParametresPintarParet2 PPP;
	PDades_Objecte_Mon Dades_Objecte_Mon;
//	tImatge MipMap;
	tDades_Objecte_Render D_O_R;
    int ID_Textura;
	
#ifdef __RENDER_OBJECTES__

    Anterior = Actual = llista = Llista_Objectes_Render;

	while(llista != NULL)
	{
		D_O_R = llista->Dades_Objecte_Render;
        Dades_Objecte_Mon = D_O_R.Info_Objecte;
		
		if(/*D_O_R.Retallat_Actualitzat*/ Dades_Objecte_Mon->Sector == SectorActual)
		{
			xmin_portal = Info_Retallat_Portal->x_inicial;
			xmax_portal = Info_Retallat_Portal->x_final;
            PPP.Propietats_Objecte = Dades_Objecte_Mon->Propietats;
			
			xmin = max(Info_Retallat_Portal->x_inicial,D_O_R.Quadrat_Projeccio.x1);
            xmax = min(Info_Retallat_Portal->x_final,D_O_R.Quadrat_Projeccio.x2);
			y1 = D_O_R.Quadrat_Projeccio.y1;
			y2 = D_O_R.Quadrat_Projeccio.y2;
			x1 = D_O_R.Quadrat_Projeccio.x1;
			x2 = D_O_R.Quadrat_Projeccio.x2;
			Dades_Objecte_Mon = D_O_R.Info_Objecte;
			intensitat_sector = Dades_Objecte_Mon->Sector->Intensitat_Llum_Sector;

			if(intensitat_sector < 0) intensitat_sector = -intensitat_sector;
			else intensitat_sector = fx_llum[intensitat_sector][temps];

			distancia = llista->Dades_Objecte_Render.distancia; // Ja que anteriorment estava a aritmetica 16:16
			propietats_objecte = Dades_Objecte_Mon->Propietats;
			
			
#ifdef __ARITMETICA_FIXA__
			escale = D_O_R.escale;
#else
			escale = (long)(D_O_R.escale*(1 << PART_FRACCIONAL));
#endif
			
			
           ID_Textura = (*Dades_Objecte_Mon->Frame_Animacio)->ID_Textura;
            //    Propietats_Textura = (*Dades_Objecte_Mon->Frame_Animacio)->Propietats;
            
            //	Mascara_u_Sprite = (1 << (MipMap.Log2U)) - 1;
            
            //			PPP.Color_Mascara = MASK_COLOR;
            
            for(x = xmin, u = (xmin-x1)*escale; x <= xmax ; x++, u += (escale << DETALL_GRAFIC_X))
            {
                ymin = max(D_O_R.ysostre_sector,max(y1,Info_Retallat_Portal->ymin[x-xmin]));
                ymax = min(D_O_R.yterra_sector,min(y2,Info_Retallat_Portal->ymax[x-xmin]));
                
                
                
                // Obtencio de v1...
                
                PPP.v1 = (ymin-y1)*escale;
                
                // Resta de parametres
                
                PPP.Escale_v = (escale << DETALL_GRAFIC_Y);
                PPP.y1 = ymin;
                PPP.y2 = ymax;
                PPP.x  = x;
                PPP.ID_Textura = ID_Textura;
                
                
                if(distancia <= MINIMA_DISTANCIA_LLINTERNA) intensitat_llinterna = MAXIMA_ILUMINACIO_LLINTERNA;
                else
                {
                    intensitat_llinterna = (s16)(((MAXIMA_ILUMINACIO_LLINTERNA << 8) - (llista->Dades_Objecte_Render.distancia >> 4)) >> 8);
                    if(intensitat_llinterna < 0) intensitat_llinterna = 0;
                }
                
                
                if((intensitat_sector + intensitat_llinterna) <  MAXIMA_INTENSITAT) intensitat_total = intensitat_sector + intensitat_llinterna;//((-intensitat_sector) + intensitat_llinterna) : (-intensitat_sector);
                else intensitat_total = MAXIMA_INTENSITAT;
                
                
                PPP.Intensitat = intensitat_total;
                
                PPP.u1 = (u >> 8); // u en APF 16.8
                
                //PPP.Intensitat = 128;
                
                // Obtencio de u1..
                /*if(!TST_BIT(Propietats_Textura, BIT_IS_UPOW2))
                {
                PPP.u1 = (u >> 16);
                }
                else
                {
                PPP.u1 = (u >> 16) & Mascara_u_Sprite;
            }*/
                
                PutVerticalSlice(&PPP);
                
                //PintarParet(PPP);
            }
			
			// Objecte renderitzat --> desempilem ja k no el farem servir ms...
			llista = llista->PSeguent;

			if(Anterior == Actual) // primer de la llista
			{
				
				Alliberar_Punter(Actual);
				Llista_Objectes_Render = Actual = Anterior = llista;
			}
			else
			{
				Anterior->PSeguent = Actual->PSeguent;
				Alliberar_Punter(Actual);
				Actual = llista;
			}

		}
		else
		{
		
			Anterior = Actual;
			Actual = llista = llista->PSeguent;
		}

		
		
		
		

		
	}
	
	
#endif
	
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////

void Gestio_Colisions_Jugador(const tJugador *Jugador) // A la propera versi (propera setaman)....
{


}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////



void Actualitzar_Retallat_Objectes_Render(const tInfo_Portal *Info_Retallat_Portal,PSector Sector)
{
	//
	// Pel model recursiu no cal cridar aquesta funci!!!!, noms caldr passar el punter de les cotes de retallat ymin i ymax. :)
	//
	PLlista_Objectes_Sector_Render llista_objectes_sector;
	PDades_Objecte_Render  punter_dades_objecte;
	int reserva_mem,i;
	tDades_Objecte_Render info_objecte;
	short x1 = Info_Retallat_Portal->x_inicial,
		x2 = Info_Retallat_Portal->x_final,
		*ymin= Info_Retallat_Portal->ymin,
		*ymax= Info_Retallat_Portal->ymax;
    PDades_Objecte_Mon Dades_Objecte_Mon;
	//	short *ptr_dest, *ptr_src;
	
	llista_objectes_sector = Llista_Objectes_Sector_Render[Sector->ID_Sector];
	
#ifdef __RENDER_OBJECTES__
	while(llista_objectes_sector != NULL)
	{

        if(llista_objectes_sector->Dades_Objecte_Render->ID_Tipus == OBJECTE_2D)
        {
            
            Dades_Objecte_Mon = llista_objectes_sector->Dades_Objecte_Render->Info_Objecte;//D_O_R.Info_Objecte;
            
            if((Dades_Objecte_Mon->Sector == Sector) && !(llista_objectes_sector->Dades_Objecte_Render->Retallat_Actualitzat)) // Objecte pertany a sector -> actualitzem...
            {
                // retallat...
                
                
                punter_dades_objecte =  (llista_objectes_sector->Dades_Objecte_Render);
                info_objecte =  *(llista_objectes_sector->Dades_Objecte_Render);
                
                
                
                punter_dades_objecte->x1 = info_objecte.x1 = max(info_objecte.Quadrat_Projeccio.x1,x1);
                punter_dades_objecte->x2 = info_objecte.x2 = min(info_objecte.Quadrat_Projeccio.x2,x2);
                
                if(!(info_objecte.x1 > x2 || info_objecte.x2 < x1 || info_objecte.x1 > info_objecte.x2)) // Fora de rang --> l'objecte no es renderitzar, no fem res...
                {
                    
                    reserva_mem = (info_objecte.x2 - info_objecte.x1 + 1);
                    
                    
                    //punter_dades_objecte->ymin = (short *)malloc(reserva_mem*sizeof(short));
                    Reservar_Memoria(punter_dades_objecte->ymin, s16, reserva_mem);
                    //punter_dades_objecte->ymax = (short *)malloc(reserva_mem*sizeof(short));
                    Reservar_Memoria(punter_dades_objecte->ymax, s16, reserva_mem);
                    
                    if(	punter_dades_objecte->ymin == NULL || punter_dades_objecte->ymax == NULL)
                    {
                        
                        PRINT_ERROR("\nError al reservar %i bytes de memoria dins la funci Actualitzar_Retallat_Objectes_Render()",reserva_mem);
                        
                        return;
                    }
                    
                    // Copia del retallat...
                    
#ifdef __HAM__ // treurem partit al copiat rapid DMA !
                    
                    if(((reserva_mem) & 0x1) == 0) //--> Multiple de 2, treiem partit al copiat rpid via DMA de la GBA...
                    {
                        TOOL_DMA3_SET(&ymin[info_objecte.x1-Info_Retallat_Portal->x_inicial],punter_dades_objecte->ymin,reserva_mem >> 1,DMA_TRANSFER_32BIT,DMA_STARTAT_NOW);
                        TOOL_DMA3_SET(&ymax[info_objecte.x1-Info_Retallat_Portal->x_inicial],punter_dades_objecte->ymax,reserva_mem >> 1,DMA_TRANSFER_32BIT,DMA_STARTAT_NOW);
                        
                    }
                    else
                    {
                        TOOL_DMA3_SET(&ymin[info_objecte.x1-Info_Retallat_Portal->x_inicial],punter_dades_objecte->ymin,reserva_mem,DMA_TRANSFER_16BIT,DMA_STARTAT_NOW);
                        TOOL_DMA3_SET(&ymax[info_objecte.x1-Info_Retallat_Portal->x_inicial],punter_dades_objecte->ymax,reserva_mem,DMA_TRANSFER_16BIT,DMA_STARTAT_NOW);
                    }
#else
                    for(i = info_objecte.x1; i <= info_objecte.x2; i++)
                    {
                        punter_dades_objecte->ymin[i-info_objecte.x1]=ymin[i-Info_Retallat_Portal->x_inicial];
                        punter_dades_objecte->ymax[i-info_objecte.x1]=ymax[i-Info_Retallat_Portal->x_inicial];
                        
                    }
#endif
                    
                    
                    
                    
                    punter_dades_objecte->Retallat_Actualitzat = TRUE;
                    
                    
                    //anterior = llista;
                    //llista_objectes_sector = llista_objectes_sector->PSeguent;
                }
                
                
                
                
            }
        }
        
        llista_objectes_sector = llista_objectes_sector->PSeguent;
		
	}
	
#endif	
	
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////

void Eliminar_Objecte(short ID_Objecte)
{
	PObjecte_Mon Actual, Anterior;
	int Trobat;

#ifdef __RENDER_OBJECTES__

	Anterior = Actual = Llista_Objectes_Mon;
	Trobat = FALSE;

	while(!Trobat && Actual != NULL)
	{
		
		if(Actual->Dades_Objecte_Mon.ID_Objecte == ID_Objecte)
		{
			Trobat = TRUE;
		}
		else
		{
			Actual = Actual->PSeguent;
		}
			
	}

	if(Trobat)
	{
		if(Anterior == Actual)
		{
			Llista_Objectes_Mon = Llista_Objectes_Mon->PSeguent;
			Alliberar_Punter(Actual);
		}
		else
		{
			Anterior->PSeguent = Actual->PSeguent;
			Alliberar_Punter(Actual);
		}
		
	}
	else
	{

		PRINT_ERROR("\nID Objecte, no trobat.",0);

	}
#endif

}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////


void Eliminar_tots_els_objectes_render()
{
	PObjecte_Render Actual;
	PLlista_Objectes_Sector_Render Node_Actual_Sector, Llista_Nodes_Sector;
	int i;

#ifdef __RENDER_OBJECTES__

	while(Llista_Objectes_Render != NULL)
	{
		
		if(Llista_Objectes_Render->Dades_Objecte_Render.Retallat_Actualitzat)
		{
			Alliberar_Punter(Llista_Objectes_Render->Dades_Objecte_Render.ymin);
			Alliberar_Punter(Llista_Objectes_Render->Dades_Objecte_Render.ymax);
		}

		Actual = Llista_Objectes_Render;

		Llista_Objectes_Render = Llista_Objectes_Render->PSeguent;

		Alliberar_Punter(Actual);
	
	}

	Llista_Objectes_Render = NULL;

	// Desempilem totes les llistes de objectes/sector que s'han afegit les d'objectes a renderuitzar-se...

	for(i = 0; i < NUMERO_SECTORS;i++)
	{
		Llista_Nodes_Sector = /*MapaMon->Sector[i].*/Llista_Objectes_Sector_Render[i];
		
		while(Llista_Nodes_Sector != NULL)
		{
			Node_Actual_Sector = Llista_Nodes_Sector;
			Llista_Nodes_Sector = Llista_Nodes_Sector->PSeguent;
			Alliberar_Punter(Node_Actual_Sector);
		
		
		}
		
		
		/*MapaMon->Sector[i].*/Llista_Objectes_Sector_Render[i] = NULL;
	
	}
#endif

}




void  DeInit_Objectes()
{
	PObjecte_Mon Actual;

#ifdef __RENDER_OBJECTES__

	while(Llista_Objectes_Mon != NULL)
	{
		Actual = Llista_Objectes_Mon;

		Llista_Objectes_Mon = Llista_Objectes_Mon->PSeguent;

		Alliberar_Punter(Actual);
	
	}

	Alliberar_Punter(Llista_Objectes_Sector_Render);

#endif
}



