//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA



#ifndef __OBJECTE3D_H__
#define __OBJECTE3D_H__

#include "Tipus.h"
#include "Animacio.h"
#include "Textura.h"
#include "Sector.h"
#include "render.h"
#include "mapa.h"
#include "definicions.h"

/************\
| DEFINCIONS |
\************/


enum{

    //RES = 0,
    OBJECTE_2D=0,
    EFFECTE_PORTAL,
    OBJECTE_3D,

};


/************\
| PROTOTIPUS |
\************/


typedef struct    _tObjecte_Mon						*PObjecte_Mon;
typedef struct    _tObjecte_Render					*PObjecte_Render;
typedef struct	  _tDades_Objecte_Mon				*PDades_Objecte_Mon;

//typedef struct    _tLlista_Objectes_Sector_Render	*PLlista_Objectes_Sector_Render;

//////////////////////////
//	 			        //
// LA CLASSE OBJECTE 3D //
// ____________________ //
//				        //
//////////////////////////

#define MAX_STRUCT_DATA_OBJECT      2

typedef struct _tDades_Objecte_Mon{

    short               ID_Objecte;
	FIXED32				X,Z;
//	unsigned char		AngleDireccio;
	
	short				Altura; // { Altura del objecte, associada al tamany de imatge }
	short				Amplada;
	short				Altura3D; // { offset y 3D relatiu }
	tQuadrat_2D			Quadrat_Colisio; //{ Dimensions que ocupa l'objecte asl mapa 2D}

	PSector				Sector;
	
	
	tTextura				**Frame_Animacio; // Punter al punter de frame...

	u32 				Propietats;

	//  Registre "propietats"
	//  ---------------------
	//
	// [...E|T|C|R]
	// 
	// 
	// W: Amb llum
	// E: Estatic.
	// T: Terrestre.
	// C: Collisionable.
	// R: recolectable (item)


}tDades_Objecte_Mon;


typedef struct{
    tComponentsParetSector CPS;
}tDades_Objecte_Portal;



typedef struct _tObjecte_Mon{		// Info objectes al mon...

	tDades_Objecte_Mon  Dades_Objecte_Mon;
	PObjecte_Mon		PSeguent;
		

}tObjecte_Mon;



/*#define ES_RECOLECTABLE(n)     ((n)& 0x1)
#define SET_RECOLECTABLE(n)    ((n)|=0x1)
#define ES_COLISIONABLE(n)    ((n)&0x2)
#define SET_COLISIONABLE(n)    ((n)|=0x2)
#define ES_TERRESTRE    (n)    ((n)&0x3)
#define SET_TERRESTRE   (n)    ((n)|=0x3)
#define ES_ESTATIC      (n)    ((n)&0x4)
#define SET_ESTATIC     (n)    ((n)|=0x4)*/



typedef struct _tDades_Objecte_Render
{
    int                     ID_Tipus; // Imatge, portal, objecte 3d,...

	//tDades_Objecte_Mon		*Info_Objecte;
    void                    *Info_Objecte;

	short					distancia; // Distancia en aritmetica 16:16...
	FIXED32					escale; // Per objectes 2D...
    int                     tipus; // Imatge, portal, objecte 3d,...
	
	tQuadrat_2D				Quadrat_Projeccio;
	
	// Variables destinades al retallat...
	short					*ymin, *ymax;
	int						 x1,x2;
    
	char					Retallat_Actualitzat; // TRUE or FALSE...
	int ysostre_sector;
	int yterra_sector;
    
///////////////////---- PER EFECTES DE PORTAL ---///////////////////////////
    int                    x_ini_portal;
    tComponentsParetSector CPS; // Noms per renderitzaci de efectes de portals...
////////////////////////////////////////////////////////////////////////////

	PLlista_Objectes_Sector_Render		Referencia_Al_Node_Objecte_Llista_Render_Sector;

}tDades_Objecte_Render,*PDades_Objecte_Render;

//typedef struct    _tDades_Objecte_Render			;
/*
typedef struct _tLlista_Objectes_Sector_Render{		// objectes per renderitzar...


//	int								ID_Node;
	PDades_Objecte_Render			Dades_Objecte_Render; // Nomes si posa la referencia del la info original...
	
	PLlista_Objectes_Sector_Render	PSeguent;
		
}tLlista_Objectes_Sector_Render;
*/

typedef struct _tObjecte_Render{		// objectes per renderitzar...


	int						ID_Node;
	tDades_Objecte_Render	Dades_Objecte_Render;
	
	PObjecte_Render			PSeguent;
	PObjecte_Render			PAnterior;

		
}tObjecte_Render;




/////////////////////////////////////////////////////////////////////////////
//
// Estructura definida per accelerar cerca d'objectes en sectors...
//
typedef struct _tLlista_Objectes_Sector_Render{		// objectes per renderitzar...


//	int								ID_Node;
	PDades_Objecte_Render			Dades_Objecte_Render; // Nomes si posa la referencia del la info original...
	
	PLlista_Objectes_Sector_Render	PSeguent;
	PLlista_Objectes_Sector_Render	PAnterior;
		
}tLlista_Objectes_Sector_Render;

/*************\
| VAR. GLOBAL |
\*************/

extern PLlista_Objectes_Sector_Render	*Llista_Objectes_Sector_Render;
extern const int Check_Data_Struct[MAX_STRUCT_DATA_OBJECT];

/************\
| PROTOTIPUS |
\************/


int Ini_Objectes();
void Capturar_Objectes();
void Renderitzar_Objectes();
void Renderitzar_Objectes_Recursiu(const tInfo_Portal *Info_Retallat_Portal,const tSector *SectorActual);

void Gestio_Colisions_Jugador(const tJugador *Jugador);
void Actualitzar_Retallat_Objectes_Render(const tInfo_Portal *Info_Retallat_Portal,PSector Sector);
void Capturar_Objectes_Al_FOV(const tJugador *Jugador); 

void OBJECTE_Afegir(int x1, int x2,short *ymin, short *ymax, void *info, int tipus);
int  OBJECTE_Afegir_EfectePortalRender(int x1, int x2, const tInfo_Portal *IRP, const tComponentsParetSector *CPS, const tSector *Sector);

//int Crea_Nou_Objecte_Render(int ID_Objecte,tDades_Objecte_Mon *Info_Objecte, FIXED32 escale, tQuadrat_2D Quadrat);
void Eliminar_Objecte(short ID_Objecte);
void Eliminar_tots_els_objectes_render();
void DeInit_Objectes();
void Eliminar_Objectes_Opacs();


#endif

