//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA


#include "Render.h"
#include "main.h"

#ifdef __HAM__
#include "mygba.h"
TOOL_PROFILER_INIT
#endif







/*******************\
| VARIABLES GLOBALS |
\*******************/

#include "LUTS.raw.c"
#include "light_functions.raw.c"

const int SizeOf_tComponentsPlaSector = sizeof(tComponentsPlaSector);

#ifdef __HAM__

extern const short ymin_init[240];
extern const short BAIX_DETALL_ymax_init[240];
extern const short ALT_DETALL_ymax_init[240];

#ifdef __BAIX_DETALL_Y
#define ymax_init BAIX_DETALL_ymax_init
#else
#define ymax_init ALT_DETALL_ymax_init
#endif


#else

FIXED32 _Tangent_Pla[AMPLADA_PANTALLA_EFECTIVA];
FIXED32 _Sinus[TAMANY_LUT];
FIXED32 _Cosinus[TAMANY_LUT];
FIXED32 _reciprocal_div[MAX_RECIPROCAL_DIV];

FIXED32 _CosRaig[AMPLADA_PANTALLA_EFECTIVA];
FIXED32 _SinRaig[AMPLADA_PANTALLA_EFECTIVA];


#endif



#ifndef __RENDER_RECURSIU__

/*short   *_ymin, *_ymax
       // _ymin_sostre, _ymax_sostre,	_ymin_terra, _ymax_terra,
        //_xmin_portal, _xmax_portal,_ymin_portal,_ymax_portal
        //_y_sostre_actual, _y_retallat_sostre_actual, _y_sostre_anterior, _y_retallat_sostre_anterior,
        //_y_terra_actual, _y_retallat_terra_actual, _y_terra_anterior, _y_retallat_terra_anterior
        #ifdef __HAM__
			MEM_IN_EWRAM
		#endif
		;*/

tLlistaNodes  LlistaSectors
			#ifdef __HAM__
				MEM_IN_EWRAM
			#endif
			;

 
/*		PNode  LlistaSectors
			#ifdef __HAM__
				MEM_IN_EWRAM
			#endif
			;*/

		#include "NodesSector.cc"
#endif

float FPS=0.0,
      total_time=0.0,
      total_time_render_1=0.0,
      total_time_render_2=0.0,
      total_time_render_3=0.0,
      total_time_render_4
#ifdef __HAM__
MEM_IN_EWRAM
#endif
;


short      _x1[ALTURA_PANTALLA_EFECTIVA], VertexsPrecalculats
#ifdef __HAM__
MEM_IN_EWRAM
#endif
;

tComponentsPlaSector _CPS[ALTURA_PANTALLA_EFECTIVA]
#ifdef __HAM__
MEM_IN_EWRAM
#endif
;

/*u16  _CPS_Calculat[ALTURA_PANTALLA_EFECTIVA] // Cert o Fals.
#ifdef __HAM__
MEM_IN_EWRAM
#endif
;*/


// Cotes retallat portal...


//   ymin  [][][][][][][]
//
//
//
//
//
//
//
//
//	 ymax  [][][][][][][]
//

// Cotes pel renderitzat de plans (terra-sostre)....


//
//   x1					x2
//
//   [0] ------------------	[0]
//   [1] ------------------	[1]
//   [2] ||			     ||	[2]
//   [3] |||		   |||| [3]
//   [4] ||||||||||||||||||	[4]
//    	 ||||||||||||||||||	 
//    	 ||||		   ||||	 
//    	 ||--------------||	 
//   [n] ------------------	[n]


short sectors_renderitzats=0,
      sectors_prerenderitzats=0,
      id_ordre
#ifdef __HAM__
MEM_IN_EWRAM
#endif
;

unsigned char	temps
#ifdef __HAM__
MEM_IN_EWRAM
#endif
;



tLlistaNodes  LlistaMapes
#ifdef __HAM__
MEM_IN_EWRAM
#endif
;


tCachedVertex *CachedVertexs
#ifdef __HAM__
MEM_IN_EWRAM
#endif
;




//#include "RenderitzacioPlans.cc"




//------------------------------------------------------------------------
//------------------------ ALGORISME DE RENDER ---------------------------
//------------------------------------------------------------------------


tLlistaNodes *
RENDER_LlistaNodesOrganitzats
(int x_inicia1, 
 int x_final,
 const tJugador  *Jugador, 
 const tSector   *SectorJugador)
{
	tLlistaNodes		*LlistaSectorsAProcessar;
    int mem;



	if((SectorJugador == NULL) || (Jugador == NULL))// || mapa < 0)// || mapa >= MAX_MAPES)
	{
		PRINT_ERROR("\n Error!, Entrades erronees a \"RENDER_LlistaNodesOrganitzats()\"!",0);
		return NULL;
	}


	mem = mem_total_used;

	Reservar_Memoria(LlistaSectorsAProcessar,tLlistaNodes,1);
	MemSet(LlistaSectorsAProcessar,0,sizeof(tLlistaNodes));

	// NUMERO DE SECTORS A DE SER VARIABLE EN FUNCIO DEL NUMERO DE SECTORS DE MAPA (MAXIM QUE NI POT HAVER)
	LD_SetSuportLlista(NUMERO_SECTORS,LlistaSectorsAProcessar);

	id_ordre = sectors_prerenderitzats = 0;
	
	// 1.- Recolectar informaci + empilar nodes dependents a l'ED ja definidia....
	if(!RENDER_RecolectaInfoSector(x_inicia1,
		x_final,
		Jugador,
		SectorJugador,
		NULL,
		LlistaSectorsAProcessar)
		)
	{
		return NULL;
	}

	sectors_prerenderitzats++;



	return LlistaSectorsAProcessar;

}






void RENDER_Renderitzar(const tJugador *Jugador, const tSector *SectorJugador)
{
	tInfo_Portal			Info_Retallat;
	tInfoNodeSector			*PInfoNodeSector = NULL;
	tLlistaNodes			*LlistaSectors2;
	int NNodes,NNodesParcials;//,Maps_to_render;//,mem1,mem2,memt;
	PNode SectorActual,SectorParcial,NodeMapaActual;
	tInfoNodeSectorParcial	*InfoNode;
//	tCachedVertex			*CachedVertex;
	tSectorParcial			*InfoBaseParcial;
	tInfoMapa				*InfoMapa;
	//PLlistaNodes Ptr_LlistaSectors;

	if(SectorJugador == NULL) return;

//	if(AngleAnterior != Jugador->AngleDireccio)
	//
	// Init cached vertexs...
	//

//	_CachedVertex = CachedVertexs;

//	MemSet(CachedVertexs,0,sizeof(tCachedVertex)*MapaMon->NVertexs);

/*	if(!VertexsPrecalculats)
	{
		memset(CachedVertexs,0,MapaMon->NVertexs*sizeof(tCachedVertex));
		VertexsPrecalculats = TRUE;
	}
	else // Actualitzaci de vertexs (si cal)...
	{
		i =  MapaMon->NVertexs;	
		CachedVertex = CachedVertexs;
		
		while(i--)
		{
			CachedVertex->Projected = FALSE;
			
			if(CachedVertex->VertexToViewSpace)
			{
			//	if((Jugador->DesplacamentX_EspaiUll != 0) || (Jugador->DesplacamentZ_EspaiUll != 0))
			//	{
					CachedVertex->TransformedVertex.X += Jugador->DesplacamentX_EspaiUll;
					CachedVertex->TransformedVertex.Z += Jugador->DesplacamentZ_EspaiUll;
					
				

			}

			CachedVertex++;
		}
	
	}*/

	
	// Informaci inicial de retallat...

	Info_Retallat.x_inicial = 0;
//	Info_Retallat.y_inicial = 0;
	Info_Retallat.x_final = AMPLADA_PANTALLA_EFECTIVA-1;
//	Info_Retallat.y_final = ALTURA_PANTALLA_EFECTIVA -1;

	Reservar_Memoria(Info_Retallat.base_ptr_ymin,s16,AMPLADA_PANTALLA_EFECTIVA);
	Reservar_Memoria(Info_Retallat.base_ptr_ymax,s16,AMPLADA_PANTALLA_EFECTIVA);

	Info_Retallat.ymin = Info_Retallat.base_ptr_ymin;
	Info_Retallat.ymax = Info_Retallat.base_ptr_ymax;

/*	MemSet(Info_Retallat.ymin,0,(AMPLADA_PANTALLA_EFECTIVA << 1));
	MemSet(Info_Retallat.ymax,(AMPLADA_PANTALLA_EFECTIVA-1),(AMPLADA_PANTALLA_EFECTIVA << 1));*/
//#ifdef __HAM__
	MemSet16(Info_Retallat.ymin,0,AMPLADA_PANTALLA_EFECTIVA);
	MemSet16(Info_Retallat.ymax,(ALTURA_PANTALLA_EFECTIVA-1),AMPLADA_PANTALLA_EFECTIVA);
//#else
/*	{
		int   i;
		for(i=0;i<AMPLADA_PANTALLA_EFECTIVA;i++) {Info_Retallat.ymin[i] = 0; Info_Retallat.ymax[i] = ALTURA_PANTALLA_EFECTIVA-1;}
	}
#endif*/
	/*
#ifdef __HAM__ // rapida assiganci de memoria...
	CopyMem_16bit(Info_Retallat.ymin,ymin_init,AMPLADA_PANTALLA_EFECTIVA);
	CopyMem_16bit(Info_Retallat.ymax,ymax_init,AMPLADA_PANTALLA_EFECTIVA);
#else
	{
		int   i;
		for(i=0;i<AMPLADA_PANTALLA_EFECTIVA;i++) {Info_Retallat.ymin[i] = 0; Info_Retallat.ymax[i] = ALTURA_PANTALLA_EFECTIVA-1;}
	}
#endif

*/


#ifdef __RENDER_RECURSIU__ // Render recursiu, reservar memoria per retallat + assignaci inicial de cotes...
//	{
//		tNodeMapa   *Mapa_A_Renderitzar;

		Capturar_Objectes_Al_FOV(Jugador);
		
		//Es comena des de 1 pk el primer portal tamb es compta...
		sectors_renderitzats = 1;
		
		// I comena la renderitzaci... :)
		
//		LlistaMapes = NULL;
		
		//portals_renderitzats = 0;
		
//		if(!EncuarSector(&Info_Retallat,(tSector *)SectorJugador,&LlistaMapes)) return ;
		
//		while(LlistaMapes != NULL)
//		{
			
//			Mapa_A_Renderitzar = LlistaMapes;
			
#ifdef __HAM__
	TOOL_PROFILER_START
#endif		
			
			if(!RenderitzarSector(&Info_Retallat, Jugador, SectorJugador))
			{
				PRINT_ERROR(" ---> Error!, no s'ha pogut renderitzar correctament el sector on s'ubica el JUGADOR (ID Sector = n %i). Info Jugador[%i,%i,%f]\n",(SectorJugador->ID_Sector,FIXED_TO_INT(Jugador->X),FIXED_TO_INT(Jugador->Z),(Jugador->AngleDireccio)*INCREMENT_ANGLE_JUGADOR));
			}
			
#ifdef __HAM__
	TOOL_PROFILER_END
	total_time_render_1 = total_time;
#endif
			
//			portals_renderitzats++;			
			Alliberar_Punter(Info_Retallat.base_ptr_ymin);
			Alliberar_Punter(Info_Retallat.base_ptr_ymax);
//			DesencuarSector(Mapa_A_Renderitzar, &LlistaMapes);
//		}
//	}

	Eliminar_tots_els_objectes_render();


#else
	
	sectors_renderitzats = 0;
//	mem1 = mem_total_used;
//	Info_Retallat.ymin = &_ymin[0];
//	Info_Retallat.ymax = &_ymax[0];

	Capturar_Objectes_Al_FOV(Jugador);
	
	// Inicialitzaci dels vectors que expliquen el retallat...
#ifdef __HAM__
	TOOL_PROFILER_START
#endif

	LD_InitLlista(&LlistaMapes);

	// Init primera info...
	Reservar_Memoria(InfoMapa,tInfoMapa,1);
	InfoMapa->Sector = (tSector *)SectorJugador;
	InfoMapa->Info_Retallat_Portal = Info_Retallat;

	LD_Empilar(0,InfoMapa,&LlistaMapes,FIFO);

//	Maps_to_render = LlistaMapes.n_nodes;


	while(LlistaMapes.n_nodes) // Encara hi ha nodes de mapa per renderitzar...
	{
		
		// Agadem info, retallat...
		NodeMapaActual = LD_ExtraurePrimer(&LlistaMapes);
		InfoMapa       = NodeMapaActual->InfoNode;
		
		
		if((LlistaSectors2 = RENDER_LlistaNodesOrganitzats(InfoMapa->Info_Retallat_Portal.x_inicial,InfoMapa->Info_Retallat_Portal.x_final,Jugador, InfoMapa->Sector) ) == NULL) return;//FUNCIO_A_MEMORIA_INTERNA;
		
		
		
		NNodes = LlistaSectors2->n_nodes;
		sectors_renderitzats += NNodes;
		
		
		
		//	node_actual = LlistaSectors2->InfoLlistaEstatica;
		SectorActual = LlistaSectors2->Ultim;
		
		
		/*#ifdef __HAM__
		TOOL_PROFILER_START
#endif*/
		while(NNodes--)
		{
			
			InfoBaseParcial = SectorActual->InfoNode;
			NNodesParcials  = InfoBaseParcial->LlistaSectorsParcials.n_nodes;
			SectorParcial   = InfoBaseParcial->LlistaSectorsParcials.Primer;
			
			
			
			while(NNodesParcials--)
			{
				//InfoNode = (*node_actual);
				InfoNode = SectorParcial->InfoNode;
				
				Info_Retallat.x_inicial			= InfoNode->x1;
				Info_Retallat.x_final			= InfoNode->x2;
//				Info_Retallat.y_inicial			= InfoMapa->Info_Retallat_Portal.y_inicial;
//				Info_Retallat.y_final			= InfoMapa->Info_Retallat_Portal.y_final;
				
				Info_Retallat.ymin				= &InfoMapa->Info_Retallat_Portal.ymin[InfoNode->x1-InfoMapa->Info_Retallat_Portal.x_inicial];
				Info_Retallat.ymax				= &InfoMapa->Info_Retallat_Portal.ymax[InfoNode->x1-InfoMapa->Info_Retallat_Portal.x_inicial];
				Info_Retallat.LiniaInterseccio	= InfoNode->primera_linia_sector;
				Info_Retallat.Interseccio   	= InfoNode->Interseccio;
				
				
				
				
				//PInfoNodeSector = SectorActual->InfoNode;//Sector_A_Renderitzar = LlistaSectors->Primer;
				
				if(!RenderitzarSector(&Info_Retallat, Jugador, InfoNode->Sector))
				{
					
					PRINT_ERROR(" ---> Error!, no s'ha pogut renderitzar correctament el sector on s'ubica el JUGADOR (ID Sector = n %i). Info Jugador[%i,%i,%f]\n",(SectorJugador->ID_Sector,FIXED_TO_INT(Jugador->X),FIXED_TO_INT(Jugador->Z),(Jugador->AngleDireccio)*INCREMENT_ANGLE_JUGADOR));
					
					
				}
				SectorParcial = SectorParcial->Seguent;
			}
			
			//			portals_renderitzats++;
			
			//			NodeABorrar = SectorActual;
			
			//			NODE_BorrarNodeRef(Sector_A_Renderitzar, &LlistaSectors);
			
			//			node_actual++;
			
			LD_Borrar_tots_els_nodes(&InfoBaseParcial->LlistaSectorsParcials);
			
			//		Alliberar_Punter(InfoBaseParcial);
			
			
			SectorActual = SectorActual->Anterior;
			
		}
		
		
		
		/*#ifdef __HAM__
		TOOL_PROFILER_END
		total_time_render_2 = total_time;
#endif*/
		
		
		LD_Borrar_tots_els_nodes(LlistaSectors2);
		
		Alliberar_Punter(LlistaSectors2);
		
		//	mem2 = mem_total_used;
		
		//	memt = mem2 - mem1;
		
		Alliberar_Punter(InfoMapa->Info_Retallat_Portal.base_ptr_ymin);
		Alliberar_Punter(InfoMapa->Info_Retallat_Portal.base_ptr_ymax);
		
		// Alliber-ho la info!
		Alliberar_Punter(InfoMapa);
		// Alliber-ho node mapa!
		Alliberar_Punter(NodeMapaActual);
		
	}

#ifdef 	__RENDER_OBJECTES__
		Renderitzar_Objectes();
#endif
	
	
	Eliminar_tots_els_objectes_render();
	


#ifdef __HAM__
	TOOL_PROFILER_END
	total_time_render_1 = total_time;
#endif




//	LE_BorrarLlista(LlistaSectors2);
	
			
	/*{
		PNode Sector_A_Renderitzar;
		PNode Mapa_A_Renderitzar;
		
		LlistaMapes.Primer = LlistaMapes.Ultim = NULL;
		LlistaSectors.Primer = LlistaSectors.Ultim = NULL;
		
		portals_renderitzats = 0;
		
		//if(!EncuarSector(&Info_Retallat,(tSector *)SectorJugador,&LlistaMapes)) return ;


		Reservar_Memoria(PInfoNodeSector,tInfoNodeSector,1);

		if(PInfoNodeSector == NULL) 
		{
			PRINT_ERROR("\nError no s'ha pogut resevar memoria per la info de sector!!!",0);
			return;
		}

		//
		// Omplenat de info...
		//

		PInfoNodeSector->Info_Retallat_Portal = Info_Retallat;
		PInfoNodeSector->Sector = (tSector *)SectorJugador;

		if(!NODE_Empilar(SectorJugador->ID_Sector,PInfoNodeSector,&LlistaMapes,FILO))
		{
			PRINT_ERROR("\nError no s'ha pogut empilar sector!!!",0);
			return;	
		}

		*/
	/*	
		while(LlistaMapes.Primer != NULL)
		{

			Mapa_A_Renderitzar = LlistaMapes.Primer;

			Reservar_Memoria(PInfoNodeSector,tInfoNodeSector,1);

			if(PInfoNodeSector == NULL) 
			{
				PRINT_ERROR("\nError no s'ha pogut resevar memoria per la info de sector!!!",0);
				return;
			}
			
			if(!NODE_Empilar(Mapa_A_Renderitzar->ID_Node,PInfoNodeSector,&LlistaSectors,FIFO))//&Mapa_A_Renderitzar->Info_Retallat_Portal,Mapa_A_Renderitzar->Sector,&LlistaSectors))
			{
					PRINT_ERROR("\nError no s'ha pogut empilar sector!!!",0);
					return;	
			}
			
			while((Sector_A_Renderitzar = LlistaSectors.Primer) != NULL)
			{
				
				PInfoNodeSector = Sector_A_Renderitzar->InfoNode;//Sector_A_Renderitzar = LlistaSectors->Primer;
				
				if(!RenderitzarSector(&PInfoNodeSector->Info_Retallat_Portal, Jugador, PInfoNodeSector->Sector))
				{
					
					PRINT_ERROR(" ---> Error!, no s'ha pogut renderitzar correctament el sector on s'ubica el JUGADOR (ID Sector = n %i). Info Jugador[%i,%i,%f]\n",(SectorJugador->ID_Sector,FIXED_TO_INT(Jugador->X),FIXED_TO_INT(Jugador->Z),(Jugador->AngleDireccio)*INCREMENT_ANGLE_JUGADOR));
					
					
				}
				
				portals_renderitzats++;
				
				NODE_BorrarNodeRef(Sector_A_Renderitzar, &LlistaSectors);
				
			}

			PInfoNodeSector =Mapa_A_Renderitzar->InfoNode;//Sector_A_Renderitzar = LlistaSectors->Primer;

			Alliberar_Punter(PInfoNodeSector->Info_Retallat_Portal.base_ptr_ymin);
			Alliberar_Punter(PInfoNodeSector->Info_Retallat_Portal.base_ptr_ymax);
			NODE_BorrarNodeRef(Mapa_A_Renderitzar, &LlistaMapes);
		}

		
	}*/
	

	//Renderitzar_Objectes();
	//Eliminar_tots_els_objectes_render();
	
#endif
	//AngleAnterior = Jugador->AngleDireccio;
	
}

//--------------------------------------------------------------------
//--------------------- CONSTRUCCI DE LUTS --------------------------
//--------------------------------------------------------------------


#ifdef __SDL__

void CreacioLUTS()
{
	int i;
	double d_real = (((AMPLADA_PANTALLA_EFECTIVA >> 1)/tan(RADIANTS(FOV/2))));
	double pendent, radiants;
	//	double proba;
	
	Inicialitzacio_De_Constants_LUTS();
	
	
	for(i = 0; i < AMPLADA_PANTALLA_EFECTIVA ; i++) 
	{
		pendent = (double)(i-(AMPLADA_PANTALLA_EFECTIVA>>1) + 0.5)/d_real;
		
		radiants = atan(pendent);
		
		_Tangent_Pla[i] = DOUBLE_TO_FIXED(pendent*256.0f);

        _SinRaig[i] = DOUBLE_TO_FIXED(sin(radiants)*256.0);

        _CosRaig[i] = DOUBLE_TO_FIXED(cos(radiants)*256.0);
		
	}
	
	
	
	for( i = 0; i < TAMANY_LUT ; i++)
	{
		
		
		_Sinus[i] = DOUBLE_TO_FIXED(sin(RADIANTS(i*INCREMENT_ANGLE_JUGADOR))*256.0f);
		_Cosinus[i] = DOUBLE_TO_FIXED(cos(RADIANTS(i*INCREMENT_ANGLE_JUGADOR))*256.0f);
		
		/*	if(i == 112)
		{
		proba = sin((i*1.40625*3.1415926535897932384626433832795)/180);
		proba = cos(RADIANTS(i*INCREMENT_ANGLE_JUGADOR));
		
	}*/
	}
	
	_Cosinus[0] = _Sinus[GRAU_90] = FIXED_MUL_256(ONE_FX);
	_Cosinus[GRAU_180] = _Sinus[GRAU_270] = -FIXED_MUL_256(ONE_FX);
	_Cosinus[GRAU_90] = _Sinus[0] = _Cosinus[GRAU_270] = _Sinus[GRAU_180] = 0;
	
	_reciprocal_div[0] = 0;//-123456789.0f; // { No es pot dividir per 0! }
	
	for( i = 1; i < MAX_RECIPROCAL_DIV; i++) 
	{
		
		_reciprocal_div[i] = DOUBLE_TO_FIXED(256.0f/i);
		
	}
	
	//	for(i=0;i<AMPLADA_PANTALLA_EFECTIVA;i++) {ymin_init[i] = 0; ymax_init[i] = ALTURA_PANTALLA_EFECTIVA-1;}
	
}

#endif




//--------------------------------------------------------------------------------------
//-------------------------- FUNCIONS PEL PINTAT DE PLANS ------------------------
//--------------------------------------------------------------------------------------




#ifndef __RENDER_RECURSIU__
FUNCIO_A_MEMORIA_INTERNA
#endif
unsigned Component_U(const tPunt_Fixa_2D *Interseccio,const tLinia *Linia)
{
	FIXED32 x_diff = Interseccio->X - Linia->V0.X;
	FIXED32 z_diff = Interseccio->Z - Linia->V0.Z;
	
	if(x_diff == 0)	return abs(CEIL_FX(z_diff));
	else if(z_diff == 0) return abs(CEIL_FX(x_diff));
	else
	{
		return abs(CEIL_FX(MulFx(Linia->sinus_reciproc,z_diff)));
	}
	
}





/*fndef __RENDER_RECURSIU__
FUNCIO_A_MEMORIA_INTERNA
#endif*/
int EncuarSector(const tInfo_Portal *Info_Retallat_Portal, tSector *Sector,PNodeSector *llista)
{
	PNodeSector NouSector, llista_aux = (*llista);
	
	if((NouSector = (PNodeSector)malloc(sizeof(tNodeSector))) == NULL) return FALS;
	
	
	
	NouSector->Sector = Sector;
	NouSector->Info_Retallat_Portal = *Info_Retallat_Portal;
	
	if(llista_aux == NULL) // Primer Node...
	{
		NouSector->PSeguent = NULL;
		NouSector->PAnterior = NULL;
		llista_aux = NouSector;
	}
	else // Encuem node...
	{
		NouSector->PSeguent = llista_aux;
		llista_aux->PAnterior = NouSector;
		NouSector->PAnterior = NULL;
	
		llista_aux = NouSector;
		
	}
	
	(*llista) = llista_aux;
	return CERT;
	
}


int DesencuarSector(PNodeSector Sector_A_Desencuar, PNodeSector *LlistaSector)
{
	// Interconectem node anterior i node segent...


	if(*LlistaSector != NULL)
	{

		if(*LlistaSector == Sector_A_Desencuar) // Es el node capdavanter...
		{
			if((*LlistaSector)->PSeguent == NULL) // ... i ultim.
			{
				*LlistaSector = NULL;
			}
			else
			{
				(*LlistaSector) = (*LlistaSector)->PSeguent;
				(*LlistaSector)->PAnterior = NULL;
			}

			
			
		}
		else 
		{
			if(Sector_A_Desencuar->PSeguent == NULL) // Ultim node...
			{
				((PNodeSector)Sector_A_Desencuar->PAnterior)->PSeguent = NULL;
			
			}
			else // Algun node del mitg...
			{

				((PNodeSector)Sector_A_Desencuar->PAnterior)->PSeguent = Sector_A_Desencuar->PSeguent;
				((PNodeSector)Sector_A_Desencuar->PSeguent)->PAnterior = Sector_A_Desencuar->PAnterior;
						
			}

			
		}	
		
		// Podem lliurar node sense temor ;)
		free(Sector_A_Desencuar);

		return CERT;
	}

	return FALS;
}





#ifndef __RENDER_RECURSIU__
FUNCIO_A_MEMORIA_INTERNA
#endif
int RenderitzarSector
(const tInfo_Portal *Info_Retallat_Portal, 
 const tJugador *Jugador, 
 const tSector *SectorActual)
{
	
	int x_actual, 
		x_proj, 
		fi, 
		u1, 
		u2, 
		LiniaActual, 
//		y_retallat_sostre_final, 
//		y_retallat_terra_final,
	//	id_mapa,id_sector,
		NumeroLinies;
//		y;
//		NTextura,
//	intensitat_sector = SectorActual->Intensitat_Llum_Sector, intensitat_llinterna, intensitat_total;
	u32 id_portal_codificat;
	
	
	s16 x_inicial,
		x_final,
		x,
		tamany_reserva,
//		*vector_xmin;//,*vector_xmax,
//		id_vertex,
		*ymin,
		*ymax;

	tCachedVertex *_CachedVertex = CachedVertexs,*CachedVertex; 
	tInfoMapa	  *InfoMapa;
	
	
	tPunt_Fixa_2D V0_ull, 
				  V1_ull,
                  *V0_ull_connectant,
                  *V1_ull_connectant;

//	tParametresAssignacioCotes PAC_Terra, 
//							   PAC_Sostre;

	tInfo_Retallat_Vertical		RV_Terra,RV_Sostre;
//	tInfo_Retallat_Horitzontal	RH_Terra,RH_Sostre;

	//tComponentsPla  ComponentsPla[ALTURA_PANTALLA_EFECTIVA];
	//tParametres_PreGuardat_Components_Pla  Parametres_PreGuardat_Components_Sostre, Parametres_PreGuardat_Components_Terra;
	//tParametresPintarPla	ParametresPintarPla;

	FIXED32   *Sinus = (FIXED32 *)_Sinus, *Cosinus = (FIXED32 *) _Cosinus;
	FIXED32   *reciprocal_div = (FIXED32 *)_reciprocal_div, Part_Fraccional;
	
	
	tInfoNodeSector *PInfoNodeSector = NULL;
	tComponentsParetSector CPS;
	FIXED32 z3d, Pendent_V1, y1_sostre, y2_sostre, y1_terra, y2_terra;//, pendent_y_x, pendent_y_z;
	tVertex		*V0_mon, *V1_mon, *V0_mon_connectant, *V1_mon_connectant;
	u8			AngleDireccioJugador;
	tCachedVertex	*_CachedVertexs = CachedVertexs;
    int             primer;
	
	
	tLiniaSector *LiniaSector, *LiniaSectorConnectant;
	tPunt_Fixa_2D Interseccio, PuntXZ_Mon_Inicial, PuntXZ_Mon_Final;
	tSector  *SectorAdjacent;
	//tInfo_Retallat_Terra_Sostre_Sector Info_Retallat_Terra_Sostre;
	tInfo_Portal Info_Retallat_Post_Portal;

	x_inicial = Info_Retallat_Portal->x_inicial;
	x_final   = Info_Retallat_Portal->x_final;

	if((x_inicial > x_final) || SectorActual == NULL) 
	{
		PRINT_ERROR("\nIntervals x invalids o sector nul a \"RenderitzarSector()\"",0);
		return FALS;
	}
	
	// 1).- Cerca de la lnia de intersecci...
#ifdef __RENDER_RECURSIU__	
	LiniaActual = LiniaInterseccio(x_inicial, Jugador,SectorActual,&Interseccio,TRUE);
#else
	
	x = x_inicial;
	ymin = Info_Retallat_Portal->ymin;
	ymax = Info_Retallat_Portal->ymax;

	while(*ymax++ < *ymin++ && (x++ <= x_final));

    if(x > x_final) return FALS;




	if(x > x_inicial)
	{
		LiniaActual = LiniaInterseccio(x_inicial, Jugador,SectorActual,&Interseccio,TRUE);

	}
	else
	{
		LiniaActual = Info_Retallat_Portal->LiniaInterseccio;
		Interseccio = Info_Retallat_Portal->Interseccio;
	}
#endif
	
	
	if(LiniaActual < 0) // Error, no s'ha pogut determinar la lnia d'intersecci!!!
	{
		return FALS;
	}
//	else // Es possible la renderitzaci de sector...
//	{
		
		LiniaSector  = (tLiniaSector *)&SectorActual->LiniaSector[LiniaActual];
		NumeroLinies = SectorActual->NumeroLinies;
		V0_mon = &LiniaSector->Linia.V0;
		V1_mon = &LiniaSector->Linia.V1;
		AngleDireccioJugador = Jugador->AngleDireccio;
		
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		////
		////	ACTUALITZAT DE RETALLAT D'OBJECTES PER LA VERSI NO RECURSIVA...
		////

#if !defined(__RENDER_RECURSIU__) && defined(__RENDER_OBJECTES__)
       Actualitzar_Retallat_Objectes_Render(Info_Retallat_Portal,(tSector *)SectorActual);
#endif

		////
		////
		////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////

		// Transformaci del primer vertex a l'espai d'ull...
		
		
		// Es calcula els components de paret per primera lnia...

        //punt_mon_A_pla_projeccio(Jugador, Interseccio.X, Interseccio.Z, &PuntXZ_Ull_Inicial);

        //z3d = PuntXZ_Mon_Inicial.Z;
   		z3d = Distancia(Jugador->X, Jugador->Z, Jugador->AngleDireccio,Interseccio.X,Interseccio.Z ); 

		
		if(z3d < ONE_FX) 
		{
			z3d = ONE_FX;
		}
		
		u1 = Component_U(&Interseccio,&LiniaSector->Linia);


        CachedVertex = &_CachedVertexs[V0_mon->ID_Vertex];

		if(!CachedVertex->Rotated) // El vertex transformat no el tenim guardat...
		{
			punt_mon_A_pla_projeccio(Jugador, V0_mon->X, V0_mon->Z, &V0_ull);
			CachedVertex->TransformedVertex = V0_ull;
			CachedVertex->Projected = FALSE;
			CachedVertex->Rotated = TRUE;
		}
		else // caldria modificar posicio resepcte jugador vertex...
		{

			V0_ull = CachedVertex->TransformedVertex;
			
		}
	
		CPS.dz1 = DivFx(FIXED_MUL_16384(ONE_FX),z3d ); // dz1 en APF 2.30
		CPS.du1 = u1*FIXED_DIV_64(CPS.dz1); // du1 en APF 8.24

        

	
		////////////////////////////////////////////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////////////////////////////
		////
		//// DETERMINACI INICIAL PER LA RENDERITZACI DE TERRA I SOSTRE...
		////
		////
		////
		////
		////
		//// Determinaci de sostre !
		////
		////

/*		PAC_Terra.Retallat_Horitzontal  = PAC_Sostre.Retallat_Horitzontal	= NULL;
		PAC_Terra.Retallat_Vertical		= PAC_Sostre.Retallat_Vertical	    = NULL;

		if(SectorActual->ID_Animacio_Sostre >= 0)
			PAC_Sostre.MipMap = TaulaAnimacions[SectorActual->ID_Animacio_Sostre]->Textura->GFX_MipMap;


	if((SectorActual->Portal_Sostre != SOLID) && (SectorActual->AlturaTerra < Jugador->Altura) && (Jugador->Altura < SectorActual->AlturaSostre ))
	{
				PAC_Sostre.Retallat_Horitzontal = NULL;
				PAC_Sostre.Retallat_Vertical = &RV_Sostre;

				tamany_reserva = Info_Retallat_Portal->x_final - Info_Retallat_Portal->x_inicial + 1;

				Reservar_Memoria(PAC_Sostre.Retallat_Vertical->base_ptr_ymin,s16,tamany_reserva);
				Reservar_Memoria(PAC_Sostre.Retallat_Vertical->base_ptr_ymax,s16,tamany_reserva);
				PAC_Sostre.Retallat_Vertical->ymin = PAC_Sostre.Retallat_Vertical->base_ptr_ymin;
				PAC_Sostre.Retallat_Vertical->ymax = PAC_Sostre.Retallat_Vertical->base_ptr_ymax;

				PAC_Sostre.Retallat_Vertical->y_inicial  = ALTURA_PANTALLA_EFECTIVA;
				PAC_Sostre.Retallat_Vertical->y_final	= -1;
				PAC_Sostre.Retallat_Vertical->x_inicial	= AMPLADA_PANTALLA_EFECTIVA;
				PAC_Sostre.Retallat_Vertical->x_final  = -1;
				
			
		}

		////
		////
		//// Determinaci del terra !
		////
		////

		if(SectorActual->ID_Animacio_Terra >= 0)
			PAC_Terra.MipMap = TaulaAnimacions[SectorActual->ID_Animacio_Terra]->Textura->GFX_MipMap;


		if((SectorActual->Portal_Terra != SOLID) && (SectorActual->AlturaTerra < Jugador->Altura) && (Jugador->Altura < SectorActual->AlturaSostre ))
		{

				PAC_Terra.Retallat_Horitzontal = NULL;
				PAC_Terra.Retallat_Vertical = &RV_Terra;

				tamany_reserva = Info_Retallat_Portal->x_final - Info_Retallat_Portal->x_inicial + 1;

				Reservar_Memoria(PAC_Terra.Retallat_Vertical->base_ptr_ymin,s16,tamany_reserva);
				Reservar_Memoria(PAC_Terra.Retallat_Vertical->base_ptr_ymax,s16,tamany_reserva);
				PAC_Terra.Retallat_Vertical->ymin = PAC_Terra.Retallat_Vertical->base_ptr_ymin;
				PAC_Terra.Retallat_Vertical->ymax = PAC_Terra.Retallat_Vertical->base_ptr_ymax;

				PAC_Terra.Retallat_Vertical->y_inicial  = ALTURA_PANTALLA_EFECTIVA;
				PAC_Terra.Retallat_Vertical->y_final	= -1;
				PAC_Terra.Retallat_Vertical->x_inicial	= AMPLADA_PANTALLA_EFECTIVA;
				PAC_Terra.Retallat_Vertical->x_final  = -1;
				//PAC_Terra.Retallat_Vertical->ymin = 0;
			}
		}*/

		// reservar memoria per retallat terra/sostre (portal o solid)

        tamany_reserva = Info_Retallat_Portal->x_final - Info_Retallat_Portal->x_inicial + 1;

		// Terra...
		Reservar_Memoria(RV_Terra.base_ptr_ymin,s16,tamany_reserva);
		Reservar_Memoria(RV_Terra.base_ptr_ymax,s16,tamany_reserva);

        // Inicialitzaci...
        MemSet16(RV_Terra.base_ptr_ymin,ALTURA_PANTALLA_EFECTIVA,tamany_reserva);
        MemSet16(RV_Terra.base_ptr_ymax,-1,tamany_reserva);
		RV_Terra.ymin = RV_Terra.base_ptr_ymin;
		RV_Terra.ymax = RV_Terra.base_ptr_ymax;

//		RV_Terra.y_inicial  = ALTURA_PANTALLA_EFECTIVA;
//		RV_Terra.y_final	= -1;
		RV_Terra.x_inicial	= AMPLADA_PANTALLA_EFECTIVA;
		RV_Terra.x_final	= -1;
   		RV_Terra.y_inicial	= ALTURA_PANTALLA_EFECTIVA;
		RV_Terra.y_final	= -1;


		// Sostre...
		Reservar_Memoria(RV_Sostre.base_ptr_ymin,s16,tamany_reserva);
		Reservar_Memoria(RV_Sostre.base_ptr_ymax,s16,tamany_reserva);

        // Inicialitzaci...
        MemSet16(RV_Sostre.base_ptr_ymin,ALTURA_PANTALLA_EFECTIVA,tamany_reserva);
        MemSet16(RV_Sostre.base_ptr_ymax,-1,tamany_reserva);

		RV_Sostre.ymin = RV_Sostre.base_ptr_ymin;
		RV_Sostre.ymax = RV_Sostre.base_ptr_ymax;

//		RV_Sostre.y_inicial  = ALTURA_PANTALLA_EFECTIVA;
//		RV_Sostre.y_final	= -1;
		RV_Sostre.x_inicial	= AMPLADA_PANTALLA_EFECTIVA;
		RV_Sostre.x_final  = -1;
        RV_Sostre.y_inicial	= ALTURA_PANTALLA_EFECTIVA;
		RV_Sostre.y_final  = -1;
		
		////
		////
		//// FI DETERMINACIO!!!!!
		////
		//////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////
		
		

	// id_vertex = LiniaSector->Linia.V0.ID_Vertex;


	 		
	//	punt_mon_A_pla_projeccio(Jugador, LiniaSector->Linia.V0.X,LiniaSector->Linia.V0.Z, &V0_ull);
		
		
		x_actual = x_inicial;


		fi = FALS;
        primer = CERT;
        PuntXZ_Mon_Inicial = Interseccio;
		
		
		//////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////
		////
		//// Bucle principal de renderitzat...
		////

		while(!fi)
		{
			// Si es portal, llavors carreguem punter del sector adjacent...
			
			if((id_portal_codificat = LiniaSector->Portal) != PARET)	
			{
//				id_mapa   = DECODE_ID_MAP(id_portal_codificat);
//				id_sector = DECODE_ID_SECTOR(id_portal_codificat);
				

				//SectorAdjacent = &MapaMon->Mapa2D[DECODE_ID_MAP(id_portal_codificat)].Sector[DECODE_ID_SECTOR(id_portal_codificat)];
				SectorAdjacent = RETURN_SECTOR_POINTER(id_portal_codificat);//&MapaMon->Mapa2D[id_mapa].Sector[id_sector];
                LiniaSectorConnectant  = RETURN_LINE_SECTOR_POINTER(id_portal_codificat);
			}
			else
            {
                SectorAdjacent = NULL;
                LiniaSectorConnectant = NULL;
            }
			

			V1_mon = &LiniaSector->Linia.V1;
		
			// Projecci del l'ultim vrtex de lnia...


            if(x_actual == 304)
            {
                int kk = 0;
            }
//	 id_vertex = LiniaSector->Linia.V1.ID_Vertex;

			CachedVertex = &_CachedVertexs[V1_mon->ID_Vertex];

			if(!CachedVertex->Rotated) // El vertex transformat no el tenim guardat...
			{
				punt_mon_A_pla_projeccio(Jugador, V1_mon->X, V1_mon->Z, &V1_ull);
				CachedVertex->TransformedVertex = V1_ull;
				CachedVertex->Projected = FALSE;
				CachedVertex->Rotated = TRUE;
			}
			else // caldria modificar posicio resepcte jugador vertex...
			{
			
				
				V1_ull = CachedVertex->TransformedVertex;
				
			}

	 
	//		punt_mon_A_pla_projeccio(Jugador, LiniaSector->Linia.V1.X,LiniaSector->Linia.V1.Z, &V1_ull);
/*if(x_actual == 289)
{
    int kk = 0;
}	

if(x_proj == 288)
{
    int kk = 0;
}	

if(x_proj == 303)
{
    int kk = 0;
}*/	


			
			// Calcul de components de paret segons l'ultim vrtex de lnia...
	 if(V1_ull.Z > 0)	
	 {
		 
		 
		 //if(Z1_Pla_Precis < 0) return FALS;
		 if(ABS_FX(V1_ull.Z) < ONE_FX)
		 {
			 
			 V1_ull.Z = ONE_FX;
		 }
		 
		 
		// if(!_CachedVertex[id_vertex].ReciprocalDist)
		// {
		 CPS.dz2 = DivFx(FIXED_MUL_16384(ONE_FX),V1_ull.Z); // dz2 en APF 8.16


	//	 if(!CachedVertex->Projected)
		 {
			 //FIXED32 aux = V1_ull.X*d_efectiva;
			 
			 
             // Divisi a la mxima presici..
      /*       if(FIXED_SIGN(aux) ==  FIXED_SIGN(V1_ull.X) && aux > FIXED_MUL_256(V1_ull.Z)) // No hi ha overflow...
             {
			    Pendent_V1 = DivFx_16_16(aux, FIXED_MUL_256(V1_ull.Z));
             }
             else // Hi ha overflow per el que no podem premultiplicar...
             {*/
//             Pendent_V1 = DivFx_16_16(FIXED_MUL_256(V1_ull.X), FIXED_MUL_256(V1_ull.Z))
                 

			 Pendent_V1 = DivFx_16_16(FIXED_MUL_256(V1_ull.X), FIXED_MUL_256(V1_ull.Z));
             

             // Si el pendent no pertany [-1,...,1) --> Error perqu no esta al FOV!!! j
             if(Pendent_V1 > ONE_FX_16_16) Pendent_V1 = MAX_FX;
             else if(Pendent_V1 < (-ONE_FX_16_16)) Pendent_V1 = MIN_FX;
             else Pendent_V1*=d_efectiva;
                 
             
             //}
			 
			 // Per evitar que el raig surti fora de portal (si la actual lnia ho s) es mira
			 // la part fraccional. Segons el seu valor realitzarem una correci de projecci per
			 // assegurar que el futur raig entri al portal.
			 Part_Fraccional = RETORNA_PART_FRACCIONAL_FX_16_16(Pendent_V1);
			 
			 if(Part_Fraccional < 0)  // Negativa...
			 {
#ifdef __ARITMETICA_FIXA__
				 if(Part_Fraccional < -(0x8100))
#else
					 if(Part_Fraccional < -(0.50390625f))
#endif
					 {
						 x_proj = FLOOR_FX_16_16(Pendent_V1) + CENTRE_X2D_EFECTIU - 1;
					 }
					 else x_proj = FLOOR_FX_16_16(Pendent_V1) + CENTRE_X2D_EFECTIU;
					 
			 }
			 else // Positiu...
			 {
#ifdef __ARITMETICA_FIXA__
				 if(Part_Fraccional < 0x7F00)
#else
					 if(Part_Fraccional < 0.49609375f)
#endif
					 {
						 x_proj = FLOOR_FX_16_16(Pendent_V1) + CENTRE_X2D_EFECTIU - 1;
					 }
					 else x_proj = FLOOR_FX_16_16(Pendent_V1) + CENTRE_X2D_EFECTIU;
					 
					 
			 }
			 
			 CachedVertex->Projected = TRUE;
			 CachedVertex->x = x_proj;
			 
			 
		 }

         
		/* else
		 {
			 x_proj = CachedVertex->x; // dz2 en APF 8.16
		 }*/
	 }
	 else
	 {
		 x_proj = -1; // Vertex surt fora del pla --> improjectable.	
	 }
	 
	 
        
			
			if((x_proj < 0) || (x_proj >= x_final)) // Cal calcular la intersecci de la lnia actual, segons el raig corresponen a la columa "x_final"...
			{
				if(!Interseccio_Raig_Linia(_Tangent_Pla[x_final], &V0_ull, &V1_ull, &Interseccio)) return FALS;
				else
				{
					
                    
                    
                    punt_pla_projeccio_A_mon(Jugador, Interseccio.X, Interseccio.Z, &Interseccio);
					
					// Si la lnia s recta, s'ha de forar que la intersecci ho sigui perqu funcioni la funci Component_U (a l'arxiu "render.c")
					
					if(LiniaSector->Linia.V0.X == LiniaSector->Linia.V1.X) Interseccio.X = LiniaSector->Linia.V0.X;
					if(LiniaSector->Linia.V0.Z == LiniaSector->Linia.V1.Z) Interseccio.Z = LiniaSector->Linia.V0.Z;
					
					if((z3d = Distancia(Jugador->X, Jugador->Z, Jugador->AngleDireccio,Interseccio.X,Interseccio.Z )) < ONE_FX) z3d = ONE_FX;
					
					u2 = Component_U(&Interseccio,&LiniaSector->Linia);
					
					CPS.dz2 = DivFx((FIXED_MUL_16384(ONE_FX)),z3d); // dz2 en APF 2.30
					CPS.du2 = u2*FIXED_DIV_64(CPS.dz2); // du2 en APF 8.24
					
					x_proj = x_final;

					PuntXZ_Mon_Final = Interseccio;

					fi = CERT;
					
				}
				
			}
			else // Calculem components segons vrtex...
			{
				
				u2 = CEIL_FX(LiniaSector->Linia.distancia);
				CPS.du2 = u2*FIXED_DIV_64(CPS.dz2); // du2 en APF 8.24
                PuntXZ_Mon_Final.X = V1_mon->X;
                PuntXZ_Mon_Final.Z = V1_mon->Z;
                
				//CPS.du2 = LiniaSector->Linia.distancia);
				//0;// // du2 en APF 8.16
				
			}

            if(x_proj == 303)
            {
                int kk = 0;            
            }
            

            // Altures inicials...
            if(primer) // Calculem altures inicials
            {
                    //pendent_y_x = V1_ull.X-V0_ull.X == 0 ? 0: DivFx(V1_mon->Y_SUP-V0_mon->Y_SUP, PuntXZ_Mon_Final..X-PuntXZ_Mon_Inicial.X);
                    //pendent_y_z = V1_ull.Z-V0_ull.Z == 0 ? 0: DivFx(V1_mon->Y_SUP-V0_mon->Y_SUP, PuntXZ_Mon_Final..Z-PuntXZ_Mon_Inicial.Z);
                    //y1_sostre = ALTURA_SOSTRE_ESPAI_ULL_XZ(PuntXZ_Mon_Final..X,PuntXZ_Mon_Final..Z,pendent_y_x,pendent_y_z,V0_mon);


                    y1_sostre  = ALTURA_SOSTRE_MON_XZ(PuntXZ_Mon_Inicial.X ,PuntXZ_Mon_Inicial.Z, LiniaSector->Linia);



                    //pendent_y_x = V1_ull.X-V0_ull.X == 0 ? 0: DivFx(V1_mon->Y_INF-V0_mon->Y_INF, PuntXZ_Mon_Final..X-PuntXZ_Mon_Inicial.X);
                    //pendent_y_z = V1_ull.Z-V0_ull.Z == 0 ? 0: DivFx(V1_mon->Y_INF-V0_mon->Y_INF, PuntXZ_Mon_Final..Z-PuntXZ_Mon_Inicial.Z);
                    //y1_terra  = ALTURA_TERRA_ESPAI_ULL_XZ(PuntXZ_Mon_Final..X ,PuntXZ_Mon_Final..Z,pendent_y_x,pendent_y_z,V0_mon);		
                    y1_terra  = ALTURA_TERRA_MON_XZ(PuntXZ_Mon_Inicial.X ,PuntXZ_Mon_Inicial.Z , LiniaSector->Linia);

                    CPS.y1_sostre  = (CENTRE_Y2D_EFECTIU-Jugador->Horitzo) + CEIL_FX((Jugador->Altura - FIXED_TO_INT(y1_sostre))*FIXED_DIV_128(dY*FIXED_DIV_128(CPS.dz1)));

                    CPS.y1_terra   = (CENTRE_Y2D_EFECTIU-Jugador->Horitzo) + CEIL_FX((Jugador->Altura - FIXED_TO_INT(y1_terra))*FIXED_DIV_128(dY*FIXED_DIV_128(CPS.dz1)));


                    //primer = FALS;
            }
          /*  else
            {
                y1_sostre = V0_mon->Y_SUP;
                y1_terra  = V0_mon->Y_INF;            
            }*/



            // Altures finals...
            if(fi)//Cal calcular altura segons intersecci final...
            {
                //pendent_y_x = V1_ull.X-V0_ull.X == 0 ? 0: DivFx(V1_mon->Y_SUP-V0_mon->Y_SUP, V1_ull.X-V0_ull.X);
                //pendent_y_z = V1_ull.Z-V0_ull.Z == 0 ? 0: DivFx(V1_mon->Y_SUP-V0_mon->Y_SUP, V1_ull.Z-V0_ull.Z);
                y2_sostre  = ALTURA_SOSTRE_MON_XZ(PuntXZ_Mon_Final.X ,PuntXZ_Mon_Final.Z, LiniaSector->Linia);
                //y2_sostre = ALTURA_SOSTRE_ESPAI_ULL_XZ(PuntXZ_Mon_Final..X,PuntXZ_Mon_Final..Z,pendent_y_x,pendent_y_z,V0_mon);

                //pendent_y_x = V1_ull.X-V0_ull.X == 0 ? 0: DivFx(V1_mon->Y_INF-V0_mon->Y_INF, V1_ull.X-V0_ull.X);
                //pendent_y_z = V1_ull.Z-V0_ull.Z == 0 ? 0: DivFx(V1_mon->Y_INF-V0_mon->Y_INF, V1_ull.Z-V0_ull.Z);
                //y2_terra  = ALTURA_TERRA_ESPAI_ULL_XZ(PuntXZ_Mon_Final..X ,PuntXZ_Mon_Final..Z,pendent_y_x,pendent_y_z,V0_mon);
                y2_terra  = ALTURA_TERRA_MON_XZ(PuntXZ_Mon_Final.X ,PuntXZ_Mon_Final.Z, LiniaSector->Linia);
            }
            else
            {
                y2_sostre = V1_mon->Y_SUP;
                y2_terra  = V1_mon->Y_INF;
            }

            // Calculem la distancia mitja...
            CPS.Z_Med = (V0_ull.Z + V1_ull.Z) >> 1;


			
			CPS.y2_sostre  = (CENTRE_Y2D_EFECTIU-Jugador->Horitzo) + CEIL_FX((Jugador->Altura - FIXED_TO_INT(y2_sostre))*FIXED_DIV_128(dY*FIXED_DIV_128(CPS.dz2)));
			CPS.y2_terra   = (CENTRE_Y2D_EFECTIU-Jugador->Horitzo) + CEIL_FX((Jugador->Altura - FIXED_TO_INT(y2_terra))*FIXED_DIV_128(dY*FIXED_DIV_128(CPS.dz2)));

			CPS.SectorAdjacent = NULL;
			CPS.LiniaAdjacent = NULL;
			CPS.SectorActual = (tSector *)SectorActual;
			CPS.LiniaSector = (tLiniaSector *)LiniaSector;
			
			
			if(x_actual <= x_proj) // Podem renderitzar la paret actual, altrament passem a la segent...
			{
				
				if((LiniaSector->Portal) != PARET) // Portal...
				{
                    V1_mon_connectant = &LiniaSectorConnectant->Linia.V0;
                    V1_ull_connectant = &V1_ull;
                    V0_mon_connectant = &LiniaSectorConnectant->Linia.V1;
                    V0_ull_connectant = &V0_ull;

					CPS.Calcul_Perspectiva = (
                        // Comprovaci sostre....
                        //(SectorAdjacent->AlturaSostre < SectorActual->AlturaSostre) || 
                        ((V0_mon_connectant->Y_SUP < V0_mon->Y_SUP) || (V1_mon_connectant->Y_SUP < V1_mon->Y_SUP)) ||
                        // Comprobaci terra
                        //(SectorAdjacent->AlturaTerra > SectorActual->AlturaTerra));
                        ((V0_mon_connectant->Y_INF > V0_mon->Y_INF) || (V1_mon_connectant->Y_INF > V1_mon->Y_INF))
                        );

					//					CPS.LiniaAdjacent  = LiniaAdjacent;
					CPS.SectorAdjacent = SectorAdjacent;

#ifdef __RENDER_RECURSIU__

					tamany_reserva = x_proj - x_actual + 1;

					Reservar_Memoria(Info_Retallat_Post_Portal.base_ptr_ymin,s16,tamany_reserva);
					Reservar_Memoria(Info_Retallat_Post_Portal.base_ptr_ymax,s16,tamany_reserva);

					Info_Retallat_Post_Portal.x_final = -1;
					Info_Retallat_Post_Portal.x_inicial = AMPLADA_PANTALLA_EFECTIVA;

//					Info_Retallat_Post_Portal.y_final = -1;
//					Info_Retallat_Post_Portal.y_inicial = ALTURA_PANTALLA_EFECTIVA;



				//	Info_Retallat_Post_Portal.ymin = Info_Retallat_Post_Portal.base_ptr_ymin;
				//	Info_Retallat_Post_Portal.ymax = Info_Retallat_Post_Portal.base_ptr_ymax;
					
					if(Info_Retallat_Post_Portal.base_ptr_ymin == NULL || Info_Retallat_Post_Portal.base_ptr_ymin == NULL)
					{
						PRINT_ERROR("\nMemoria insuficient per reservar de cotes y de portal!!!\n\n",0);
						return FALS;
					}
#endif
					
				}
				else // Per renmderitzar una paret calen calculs de perspectiva..., O POTSER NO!
				{
					CPS.Calcul_Perspectiva = CERT;

				}

//                V0_linia_connectant = LiniaSector->Portal
				
				if(CPS.Calcul_Perspectiva && (SectorAdjacent != NULL)) // S'ha de calcular les projecci de les tires ...
                {

                    if(primer)
                    {
                        //pendent_y_x = V1_ull_connectant->X-V0_ull_connectant->X == 0 ? 0: DivFx(V1_mon_connectant->Y_SUP-V0_mon_connectant->Y_SUP, V1_ull_connectant->X-V0_ull_connectant->X);
                        //pendent_y_z = V1_ull_connectant->Z-V0_ull_connectant->Z == 0 ? 0: DivFx(V1_mon_connectant->Y_SUP-V0_mon_connectant->Y_SUP, V1_ull_connectant->Z-V0_ull_connectant->Z);
                        y1_sostre  = ALTURA_SOSTRE_MON_XZ(PuntXZ_Mon_Inicial.X ,PuntXZ_Mon_Inicial.Z, LiniaSectorConnectant->Linia);	


                        //pendent_y_x = V1_ull_connectant->X-V0_ull_connectant->X == 0 ? 0: DivFx(V1_mon_connectant->Y_INF-V0_mon_connectant->Y_INF, V1_ull_connectant->X-V0_ull_connectant->X);
                        //pendent_y_z = V1_ull_connectant->Z-V0_ull_connectant->Z == 0 ? 0: DivFx(V1_mon_connectant->Y_INF-V0_mon_connectant->Y_INF, V1_ull_connectant->Z-V0_ull_connectant->Z);
                        y1_terra  = ALTURA_TERRA_MON_XZ(PuntXZ_Mon_Inicial.X ,PuntXZ_Mon_Inicial.Z, LiniaSectorConnectant->Linia);	
                    }
                    else
                    {
                        y1_sostre =  V0_mon_connectant->Y_SUP;   
                        

                        y1_terra  =  V0_mon_connectant->Y_INF;
                    }

                    CPS.y1_sostre_connectant = (CENTRE_Y2D_EFECTIU-Jugador->Horitzo) + CEIL_FX((Jugador->Altura - FIXED_TO_INT(y1_sostre))*FIXED_DIV_128(dY*FIXED_DIV_128(CPS.dz1)));
					CPS.y1_terra_connectant = (CENTRE_Y2D_EFECTIU-Jugador->Horitzo) + CEIL_FX((Jugador->Altura - FIXED_TO_INT(y1_terra))*FIXED_DIV_128(dY*FIXED_DIV_128(CPS.dz1)));

                
                    if(fi)
                    {

                        //pendent_y_x = V1_ull_connectant->X-V0_ull_connectant->X == 0 ? 0: DivFx(V1_mon_connectant->Y_SUP-V0_mon_connectant->Y_SUP, V1_ull_connectant->X-V0_ull_connectant->X);
                        //pendent_y_z = V1_ull_connectant->Z-V0_ull_connectant->Z == 0 ? 0: DivFx(V1_mon_connectant->Y_SUP-V0_mon_connectant->Y_SUP, V1_ull_connectant->Z-V0_ull_connectant->Z);
                        //y2_sostre = ALTURA_SOSTRE_ESPAI_ULL_XZ(PuntXZ_Mon_Final..X,PuntXZ_Mon_Final..Z,pendent_y_x,pendent_y_z,V0_mon_connectant);
                        y2_sostre  = ALTURA_SOSTRE_MON_XZ(PuntXZ_Mon_Final.X ,PuntXZ_Mon_Final.Z, LiniaSectorConnectant->Linia);		

                        //pendent_y_x = V1_ull_connectant->X-V0_ull_connectant->X == 0 ? 0: DivFx(V1_mon_connectant->Y_INF-V0_mon_connectant->Y_INF, V1_ull_connectant->X-V0_ull_connectant->X);
                        //pendent_y_z = V1_ull_connectant->Z-V0_ull_connectant->Z == 0 ? 0: DivFx(V1_mon_connectant->Y_INF-V0_mon_connectant->Y_INF, V1_ull_connectant->Z-V0_ull_connectant->Z);
                        //y2_terra  = ALTURA_TERRA_ESPAI_ULL_XZ(PuntXZ_Mon_Final..X ,PuntXZ_Mon_Final..Z,pendent_y_x,pendent_y_z,V0_mon_connectant);		
                        y2_terra  = ALTURA_TERRA_MON_XZ(PuntXZ_Mon_Final.X ,PuntXZ_Mon_Final.Z, LiniaSectorConnectant->Linia);
                    }
                    else
                    {
                        y2_sostre =  V1_mon_connectant->Y_SUP;                   
                        y2_terra  =  V1_mon_connectant->Y_INF;
                    }

                                        
					
					CPS.y2_sostre_connectant = (CENTRE_Y2D_EFECTIU-Jugador->Horitzo) + CEIL_FX((Jugador->Altura - FIXED_TO_INT(y2_sostre))*FIXED_DIV_128(dY*FIXED_DIV_128(CPS.dz2)));
                    CPS.y2_terra_connectant = (CENTRE_Y2D_EFECTIU-Jugador->Horitzo) + CEIL_FX((Jugador->Altura - FIXED_TO_INT(y2_terra))*FIXED_DIV_128(dY*FIXED_DIV_128(CPS.dz2)));
					
				}
				else // Fem que els nivells projectats coincidexin amb el del sector, aix ja vol dir que no s pintar res...
				{
					CPS.y1_sostre_connectant = CPS.y1_sostre;
					CPS.y2_sostre_connectant = CPS.y2_sostre;
					
					CPS.y1_terra_connectant = CPS.y1_terra;
					CPS.y2_terra_connectant = CPS.y2_terra;
				}
				
				// Renderitzaci de la paret...
				
				RenderitzarPartSector(x_actual, x_proj, Jugador,&CPS, Info_Retallat_Portal,
					&Info_Retallat_Post_Portal,
					&RV_Sostre, &RV_Terra);
				
				//SectorAdjacent = NULL;
			
				if(SectorAdjacent != NULL) // Es renderitza recursivament...
				{	
					if(Info_Retallat_Post_Portal.x_inicial <= Info_Retallat_Post_Portal.x_final)
					{
#ifdef __RENDER_RECURSIU__

                        // Renderitza sector recursivament...
					    RenderitzarSector(&Info_Retallat_Post_Portal,Jugador,SectorAdjacent);

						// Renderitzaci del portal...
						if(LiniaSector->Textura_Paret != 0) // Renderitzaci del efecte de portal, yeaaaaah...
						{
							CPS.SectorAdjacent = NULL;
							CPS.LiniaAdjacent = NULL;
							CPS.Calcul_Perspectiva = TRUE;
							RenderitzarPartSector(x_actual, x_proj, Jugador,&CPS, Info_Retallat_Portal, NULL,NULL,NULL);
						}
						
						sectors_renderitzats++;
					}

					Alliberar_Punter(Info_Retallat_Post_Portal.base_ptr_ymin);
					Alliberar_Punter(Info_Retallat_Post_Portal.base_ptr_ymax);

					Info_Retallat_Post_Portal.ymin = Info_Retallat_Post_Portal.ymax = NULL;

#else // NO fem res, yeeeeaaa!!!

					// Renderitzaci del portal...
					if(LiniaSector->Textura_Paret != 0) // Renderitzaci del efecte de portal, yeaaaaah...
					{
							CPS.SectorAdjacent = NULL;
							CPS.LiniaAdjacent = NULL;
							CPS.Calcul_Perspectiva = TRUE;
                            

                            // Afegim a la llista de objectes 3D...
                            OBJECTE_Afegir_EfectePortalRender(x_actual, x_proj, Info_Retallat_Portal, &CPS, SectorActual);//tParametresvoid *Info_Objecte);
							//RenderitzarPartSector(x_actual, x_proj, Jugador,&CPS, Info_Retallat_Portal, NULL,NULL,NULL);
					}
/*					PInfoNodeSector->Info_Retallat_Portal.ymin = &Info_Retallat_Portal->ymin[Info_Retallat_Post_Portal.x_inicial-x_inicial];
					PInfoNodeSector->Info_Retallat_Portal.ymax = &Info_Retallat_Portal->ymax[Info_Retallat_Post_Portal.x_inicial-x_inicial];

					PInfoNodeSector->Info_Retallat_Portal.base_ptr_ymin = Info_Retallat_Portal->base_ptr_ymin;
					PInfoNodeSector->Info_Retallat_Portal.base_ptr_ymax = Info_Retallat_Portal->base_ptr_ymax;

				//	if(!EncuarSector(	&Info_Retallat_Post_Portal, 
				//						SectorAdjacent,
				//						&LlistaSectors))
					if(!NODE_Empilar(SectorAdjacent->ID_Sector, 
						PInfoNodeSector, 
						&LlistaSectors, FIFO))
					{
						PRINT_ERROR(" ---> MEMORIA INSUFICIENT !!!",0);
						return FALS;
					}*/
				}
			
#endif					
				}
				
				
			}
			
				
				
			// Linia segent...
			
			x_actual = x_proj + 1;
			LiniaActual++;
			LiniaSector++;

            PuntXZ_Mon_Inicial = PuntXZ_Mon_Final;

			if(LiniaActual >= NumeroLinies)
			{
				LiniaActual =  0;
				LiniaSector =  (tLiniaSector *)SectorActual->LiniaSector;
			}
			
			CPS.dz1 = CPS.dz2;
			u1 = 0;
			CPS.du1 = 0;
			
			CPS.y1_sostre = CPS.y2_sostre;
			CPS.y1_terra  = CPS.y2_terra;

			V0_mon = V1_mon;
            if(primer) primer = FALS;
			
			V0_ull = V1_ull;
				
				
		}
			
		

		////
		////
		//// FI bucle principal de renderitzat...
		////
		//////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////
	
			
		// Assignaci de cotes finals...
		
		
		//	PAC_Sostre.y_retallat_paret_actual = y_retallat_sostre_final;
		//	PAC_Terra.y_retallat_paret_actual = y_retallat_terra_final;
		
		
		//	ActualitzarCotes( x_final + 1,&PAC_Sostre, &PAC_Terra);
	
		// S'empila la info del portal de terra i/o sostre...
		
		if(RV_Sostre.x_inicial <= RV_Sostre.x_final)
		{
			if((SectorActual->Portal_Sostre != SOLID))// Renderitzaci recursiva...
			{
				
	//			id_mapa   = DECODE_ID_MAP(SectorActual->Portal_Sostre);
	//			id_sector = DECODE_ID_SECTOR(SectorActual->Portal_Sostre);
				
				//	Alliberar_Punter(PAC_Sostre.Retallat_Vertical->base_ptr_ymin);
				//	Alliberar_Punter(PAC_Sostre.Retallat_Vertical->base_ptr_ymax);
#ifdef __RENDER_RECURSIU__
//				RV_Sostre.ymin = &RV_Sostre.base_ptr_ymin[RV_Sostre.x_inicial-Info_Retallat_Portal->x_inicial];
//				RV_Sostre.ymax = &RV_Sostre.base_ptr_ymax[RV_Sostre.x_inicial-Info_Retallat_Portal->x_inicial];
				
				RenderitzarSector(&RV_Sostre,Jugador,RETURN_SECTOR_POINTER(SectorActual->Portal_Sostre));
				
				Alliberar_Punter(RV_Sostre.base_ptr_ymin);
				Alliberar_Punter(RV_Sostre.base_ptr_ymax);
#else
				Reservar_Memoria(InfoMapa,tInfoMapa,1);
				InfoMapa->Info_Retallat_Portal = RV_Sostre;
				InfoMapa->Sector = RETURN_SECTOR_POINTER(SectorActual->Portal_Sostre);

		
//				PInfoNodeSector->Info_Retallat_Portal.ymin = &RV_Sostre.base_ptr_ymin[RV_Sostre.x_inicial-Info_Retallat_Portal->x_inicial];
//				PInfoNodeSector->Info_Retallat_Portal.ymax = &RV_Sostre.base_ptr_ymax[RV_Sostre.x_inicial-Info_Retallat_Portal->x_inicial];
//				
				if(!LD_Empilar(0, 
					InfoMapa, 
					&LlistaMapes, 
					FIFO))
				{
					PRINT_ERROR("\n----> MEMORIA INSUFICIENT!!!",0);
				}
//				//				EncuarSector(PAC_Sostre.Retallat_Vertical,&MapaMon->Mapa2D[id_mapa].Sector[id_sector],&LlistaMapes);

//				Alliberar_Punter(RV_Sostre.base_ptr_ymin);
//				Alliberar_Punter(RV_Sostre.base_ptr_ymax);
#endif	
			}
			else // Mapeig de sostre...
			{
#ifdef __RENDER_CEIL__
				Renderitzar_Pla(Jugador, SectorActual, ES_SOSTRE, &RV_Sostre);//_Terra->y_renderitzacio_inicial)
#endif
               
                
            /*    // Versi per tires verticals, a que s fcil ? :) --> Per s lent :_(
                 {
                    tParametresPintarParet2 PPP;
                    short *ymin = RV_Sostre.ymin;
                    short *ymax = RV_Sostre.ymax;
                    
                    for(x = RV_Sostre.x_inicial; x <= RV_Sostre.x_final; x++,ymin++,ymax++) 
                    {
                        PPP.x = x;
                        PPP.y1 = *ymin;
                        PPP.y2 = *ymax;
                        PPP.ID_Textura = -5;
                        PutVerticalSlice(&PPP);
                    }
                }*/

				Alliberar_Punter(RV_Sostre.base_ptr_ymin);
				Alliberar_Punter(RV_Sostre.base_ptr_ymax);

			}
		}
		else // Irenderitzable...
		{
			Alliberar_Punter(RV_Sostre.base_ptr_ymin);
			Alliberar_Punter(RV_Sostre.base_ptr_ymax);
		}
			

		

	
		if(RV_Terra.x_inicial <= RV_Terra.x_final)
		{		
			
			if((SectorActual->Portal_Terra != SOLID))// Es portal !!!
			{
				//id_mapa   = DECODE_ID_MAP(SectorActual->Portal_Terra);
				//id_sector = DECODE_ID_SECTOR(SectorActual->Portal_Terra);
				
				
				//Alliberar_Punter(PAC_Terra.Retallat_Vertical->base_ptr_ymin);
				//Alliberar_Punter(PAC_Terra.Retallat_Vertical->base_ptr_ymax);
#ifdef __RENDER_RECURSIU__				
				
//				RV_Terra.ymin = &RV_Terra.base_ptr_ymin[RV_Terra.x_inicial-Info_Retallat_Portal->x_inicial];
//				RV_Terra.ymax = &RV_Terra.base_ptr_ymax[RV_Terra.x_inicial-Info_Retallat_Portal->x_inicial];
				
				//(....)
				RenderitzarSector(&RV_Terra,Jugador,RETURN_SECTOR_POINTER(SectorActual->Portal_Terra));
				Alliberar_Punter(RV_Terra.base_ptr_ymin);
				Alliberar_Punter(RV_Terra.base_ptr_ymax);
#else
				Reservar_Memoria(InfoMapa,tInfoMapa,1);
				InfoMapa->Info_Retallat_Portal = RV_Terra;
				InfoMapa->Sector = RETURN_SECTOR_POINTER(SectorActual->Portal_Terra);
//				
				if(!LD_Empilar(0, 
					InfoMapa, 
					&LlistaMapes, 
					FIFO))
				{
					PRINT_ERROR("\n----> MEMORIA INSUFICIENT!!!",0);
				}
//				//				EncuarSector(PAC_Terra.Retallat_Vertical,&MapaMon->Mapa2D[id_mapa].Sector[id_sector],&LlistaMapes);

//				Alliberar_Punter(RV_Terra.base_ptr_ymin);
//				Alliberar_Punter(RV_Terra.base_ptr_ymax);
#endif			
			}
			else // Es slid --> Mapeig terra...
			{

#ifdef	__RENDER_FLOOR__
        Renderitzar_Pla(Jugador, SectorActual, ES_TERRA,&RV_Terra);//_Terra->y_renderitzacio_inicial)
#endif

                /* {
                    tParametresPintarParet2 PPP;
                    short *ymin = RV_Terra.ymin;
                    short *ymax = RV_Terra.ymax;
                    
                    for(x = RV_Terra.x_inicial; x <= RV_Terra.x_final; x++,ymin++,ymax++) 
                    {
                        PPP.x = x;
                        PPP.y1 = *ymin;
                        PPP.y2 = *ymax;
                        PPP.ID_Textura = -5;
                        PutVerticalSlice(&PPP);
                    }
                }*/

				Alliberar_Punter(RV_Terra.base_ptr_ymin);
				Alliberar_Punter(RV_Terra.base_ptr_ymax);
			}
			
		}
		else
		{
			Alliberar_Punter(RV_Terra.base_ptr_ymin);
			Alliberar_Punter(RV_Terra.base_ptr_ymax);
		}

//#endif

#if defined(__RENDER_RECURSIU__) && defined(__RENDER_OBJECTES__)



		// Es l'hora de renderitzar els objectes, en versi recursiva yeeeaaaahhh...

		Renderitzar_Objectes_Recursiu(Info_Retallat_Portal,SectorActual);

		
		// Alliberem punters...

//		if(PAC_Terra.Retallat_Horitzontal != NULL || PAC_Sostre.Retallat_Horitzontal != NULL)
//		{
//			Alliberar_Punter(vector_xmin);
//			Alliberar_Punter(vector_xmax);
//		}
#endif


		// ... whala !, ja hem renderitzat un sector. Ha costat, eh? :)
		
		
		return CERT;
						
}




#include "Renderitzar_C_Affine_Wall.cc"


FUNCIO_A_MEMORIA_INTERNA
void RenderitzarPartSector(int x1, 
						   int x2,
						   const tJugador *Jugador, 
						   const tComponentsParetSector *CPS, 
						   const tInfo_Portal *Info_Retallat_Portal,
						   tInfo_Portal *Info_Retallat_Post_Portal,
						   tInfo_Retallat_Vertical *RV_Sostre, 
						   tInfo_Retallat_Vertical *RV_Terra)
{
	
	FIXED32 inc_dudX, du,
		    inc_dzdX,dz,	
//			inc_dYdX_Sostre_FX,	inc_dYdX_Sostre_Connectant_FX,
/*			inc_dYdX_Terra_FX, 	inc_dYdX_Terra_Connectant_FX,*/
/*			Ysostre_actual_FX, 	Ysostre_connectant_FX, */
//			Yterra_actual_FX,   Yterra_connectant_FX,
//			Escale_v, 
			*reciprocal_div = (FIXED32 *)_reciprocal_div
//			altura_paret_16_16
;

	
int
	/*	Ysostre_actual,	Ysostre_connectant, */
//	Yterra_actual, 	7Yterra_connectant, 
	/*	y_retallat_sostre_actual, 	y_retallat_terra_actual,*/
		
//		Ysostre_anterior, 	Yterra_anterior , 
	/*	y_retallat_sostre_anterior , y_retallat_terra_anterior,*/
		intensitat_sector /*intensitat_llinterna,intensitat_total,*/
//		v_med,
//		Escale_v_FX,
//		du_paisatge,
//		dv_paisatge
//		u_paisatge
        ;
	
	u16 mascara_u_paret = 0xFFFF, 
		mascara_u_paret_superior = 0xFFFF,
		mascara_u_paret_inferior = 0xFFFF
//		mascara_u_paisatge
        ;
	
	
	s16 
        //x,
//		u_paret, 
		
//		MIPmap_Seleccionat, 
//		MIPmap_Adequat, 
//		xmin_portal, 
//		xmax_portal,
//		xmin_sostre, 
//		xmax_sostre,
//		xmin_terra, 
//		xmax_terra,
//		ymin_sostre, 
//		ymax_sostre,
//		ymin_terra, 
//		ymax_terra,


		/*	    *ymin = _ymin,
		*ymax = _ymax,*/
//		n_mipmaps_paret,
//		n_mipmaps_paret_inferior,
//		n_mipmaps_paret_superior,
//		ymin_portal,ymax_portal,
		*ymin, *ymax,/*,*ymin_portal_ptr,*ymax_portal_ptr,*/
//		*ymin_sostre_ptr,*ymax_sostre_ptr,
//		*ymin_terra_ptr,*ymax_terra_ptr,
		x_inicial_portal
//x_inicial_post_portal,amplada_imatge, altura_imatge,
//		*ymin_retallat_vertical_sostre,*ymin_retallat_vertical_terra,*ymax_retallat_vertical_sostre,*ymax_retallat_vertical_terra,
//		Actualitzar_Retallat_Vertical_Terra,Actualitzar_Retallat_Vertical_Sostre,
//		y_inicial_retallat_vertical_sostre,y_final_retallat_vertical_sostre,
//		x_inicial_retallat_vertical_sostre,x_final_retallat_vertical_sostre,
//		y_inicial_retallat_vertical_terra,y_final_retallat_vertical_terra,
//		x_inicial_retallat_vertical_terra,x_final_retallat_vertical_terra,
//		Avalua_Sostre,
//     Avalua_Terra
;
	

	
	tTextura *Textura_Inferior = NULL,
			 *Textura_Superior = NULL, 
			 *Textura_Paret = NULL;
		
	tSector *SectorAdjacent = CPS->SectorAdjacent,
			*SectorActual   = CPS->SectorActual;

	tLiniaSector *LiniaAdjacent = CPS->LiniaAdjacent,
				 *LiniaSector = CPS->LiniaSector;
	
//	tParametresPintarParet PPP;
	PAnimacio *Ref_TaulaAnimacions = TaulaAnimacions;
	tParametresRenderAffineWall   PRAW;
	
    
	
	//
	// 25-01-05 
	//
	// Declaraci de les segents variables per accelerar els calculs de perspectiva, per aix, subdividint-la els calculs Z i U en particions lineals d'una determinada longitud...
	//
	
	FIXED32 DeltaZ,Z,ZLeft,ZRight,dzLeft,dzRight,IncAffine_DzDx,
		DeltaU,U,ULeft,URight,duRight,duLeft,IncAffine_DuDx;
//		u1_paisatge,
//		v1_paisatge,
		
		
		//	long du_paisatge, dv_paisatge;
		
		
		
	s16		NumeroSubdivisions,RestaSubdivisions,/* contador,*/ NColumnes;
	//	char    ParetAmbLlum;
	//tImatge *MipMap;
//	tTextura *Textura;
//	tImatge  *MipMap;

//	tParametresRenderAffineWall PRAW;//     Parameter
//	char He_Pintat_Textura_Superior;
	
	//
	
	//	inc_dudX = inc_dzdX = Escale_v = v_med = MIPmap_Seleccionat = Ysostre_actual = Yterra_actual = y_retallat_sostre_actual = y_retallat_terra_actual = DeltaZ = Z = (FIXED32)(0);
	//    ZLeft = ZRight = dzRight = IncAffine_DzDx = DeltaU = U = ULeft = URight = duRight = IncAffine_DuDx = (FIXED32)(0);
	
	
    
	
	NColumnes = x2 - x1 + 1;
	
	if(NColumnes < 1) return; // Impossible renderitzar...
	
	
	
//	PRAW.ymin_portal = ALTURA_PANTALLA_EFECTIVA;
//	PRAW.ymax_portal = -1;

	PRAW.xmin_portal = AMPLADA_PANTALLA_EFECTIVA;
	PRAW.xmax_portal = -1;
	
	
	//	if(LiniaSector->Portal != NULL) CPS->Calcul_Perspectiva = FALS;
	
	
	if(CPS->Calcul_Perspectiva)
	{
		//		Textura_Paret = LiniaSector->Textura;
		//		Textura_Inferior= LiniaSector->Textura_Inferior;
		//		Textura_Superior= LiniaSector->Textura_Superior;
		
		if(LiniaSector->Textura_Paret > 0)
		{
			PRAW.ID_Textura_Paret    = Ref_TaulaAnimacions[LiniaSector->Textura_Paret]->Textura->ID_Textura;
			
		/*	if(IS_PANORAMA(Textura_Paret->GFX_MipMap->Propietats))
			{
			*/	
			/*	if(U_POWER_OF_2(Textura_Paret->GFX_MipMap->Propietats))
				{
					amplada_imatge = (0x1 << Textura_Paret->GFX_MipMap->DimX);
					mascara_u_paisatge = amplada_imatge-1;
				}
				else
				{
					amplada_imatge = Textura_Paret->GFX_MipMap->DimX;
					mascara_u_paisatge = 0xFFFF;
				}
				
							
				altura_imatge = V_POWER_OF_2(Textura_Paret->GFX_MipMap->Propietats)? (0x1 << Textura_Paret->GFX_MipMap->DimY):Textura_Paret->GFX_MipMap->DimY;
				
				GET_DU_PAISATGE(du_paisatge,amplada_imatge);
				GET_DV_PAISATGE(dv_paisatge,altura_imatge);
				
				u_paisatge = ((Jugador->AngleDireccio << 2) << 16) + (x1-CENTRE_X2D_EFECTIU)*du_paisatge;
				*/
		/*	}
			else
			{
			
				if(U_POWER_OF_2(Textura_Paret->GFX_MipMap->Propietats))
				{
					mascara_u_paret = ((0x1) << Textura_Paret->GFX_MipMap->DimX)-1;
				}
				
				
				n_mipmaps_paret = Textura_Paret->N_MipMaps;	*/
		//	}
		}
		else
		{
			PRAW.ID_Textura_Paret = LiniaSector->Textura_Paret;//NULL o color;
		}
		
		if(LiniaSector->Textura_Inferior > 0)
		{
			PRAW.ID_Textura_Inferior = Ref_TaulaAnimacions[LiniaSector->Textura_Inferior]->Textura->ID_Textura;
			
		/*	if(U_POWER_OF_2(Textura_Inferior->GFX_MipMap->Propietats))
			{
				mascara_u_paret_inferior = ((0x1) << Textura_Inferior->GFX_MipMap->DimX)-1;
				
			}
			
			n_mipmaps_paret_inferior = Textura_Inferior->N_MipMaps;*/
		}
		else
		{
			PRAW.ID_Textura_Inferior = 0;
		}
		
		if(LiniaSector->Textura_Superior > 0) 
		{
			PRAW.ID_Textura_Superior = Ref_TaulaAnimacions[LiniaSector->Textura_Superior]->Textura->ID_Textura;
			
			/*if(U_POWER_OF_2(Textura_Superior->GFX_MipMap->Propietats))
			{
				mascara_u_paret_superior = ((0x1) << Textura_Superior->GFX_MipMap->DimX)-1;
				
			}
			
			n_mipmaps_paret_superior = Textura_Superior->N_MipMaps;*/
		}
		else
		{
			PRAW.ID_Textura_Superior = 0;
		}
		
		
		
		
		//if(Textura_Paret > 0)    MipMap_Paret    = &->GFX_MipMaps;
		//if(Textura > 0) MipMap_Paret    = &Ref_TaulaAnimacions[Textura_Inferior]->GFX_MipMaps;
		//if(Textura > 0) MipMap_Inferior = &Ref_TaulaAnimacions[Textura_Superior]->GFX_MipMaps; 
		
		// Clcul de derivades per interpolacions lineals...
		
		dz = dzLeft = CPS->dz1;
		du = duLeft = CPS->du1;
		
		
		
	//	altura_paret_16_16 = FIXED_MUL_256(INT_TO_FIXED(SectorActual->AlturaSostre - SectorActual->AlturaTerra));
		
#ifdef __ARITMETICA_FIXA__
		
		inc_dudX = MulFx_16_16(CPS->du2 - CPS->du1,reciprocal_div[NColumnes]);//NColumnes;
		inc_dzdX = MulFx_16_16(CPS->dz2 - CPS->dz1,reciprocal_div[NColumnes]);
		
		// Configuraci d'increments gradients per particiona la super rapida subdivisi af (AFFINE SUBDIVIDE)...
		
		IncAffine_DzDx =  inc_dzdX << LOG2_SUBDIVISIO_PERSPECTIVA;
		IncAffine_DuDx =  inc_dudX << LOG2_SUBDIVISIO_PERSPECTIVA;
#else
		
		inc_dudX = FIXED_DIV_256(MulFx_16_16(CPS->du2 - CPS->du1,reciprocal_div[NColumnes]));//NColumnes;
		inc_dzdX = FIXED_DIV_256(MulFx_16_16(CPS->dz2 - CPS->dz1,reciprocal_div[NColumnes]));
		
		// Configuraci d'increments gradients per particiona la super rapida subdivisi af (AFFINE SUBDIVIDE)...
		
		IncAffine_DzDx =  (inc_dzdX)*(1 << LOG2_SUBDIVISIO_PERSPECTIVA);
		IncAffine_DuDx =  (inc_dudX)*(1 << LOG2_SUBDIVISIO_PERSPECTIVA);
		
#endif
		
		
		dzRight = CPS->dz1 + IncAffine_DzDx; // Proxim punt dzdx subdivide afine.
		duRight = CPS->du1 + IncAffine_DuDx; // Proxim punt dwdx subdivide afine.
		
		// // Inicio la Z i U esquerres de paret...
		
		
		
		if(dzLeft > ONE_FX) // No perdrem precisi...
			ZLeft = DivFx(FIXED_MUL_16384(ONE_FX), dzLeft);
		else // Tampoc hi perdrem...
			ZLeft = FIXED_MUL_256(DivFx(FIXED_MUL_16384(ONE_FX), FIXED_MUL_256(dzLeft)));
		
		ULeft = FIXED_DIV_16(MulFx(ZLeft,FIXED_DIV_16(duLeft)));
		
		
		
		
	}
	

				
	// DDAs retallats...
	
	
	PRAW.inc_dYdX_Sostre_FX				= FIXED_DIV_256((CPS->y2_sostre - CPS->y1_sostre)*reciprocal_div[NColumnes]);
	PRAW.inc_dYdX_Sostre_Connectant_FX	= FIXED_DIV_256((CPS->y2_sostre_connectant - CPS->y1_sostre_connectant)*reciprocal_div[NColumnes]);
	
	PRAW.inc_dYdX_Terra_FX				= FIXED_DIV_256((CPS->y2_terra - CPS->y1_terra)*reciprocal_div[NColumnes]);
	PRAW.inc_dYdX_Terra_Connectant_FX	= FIXED_DIV_256((CPS->y2_terra_connectant - CPS->y1_terra_connectant)*reciprocal_div[NColumnes]);
	
	// Inicialitzacions previes al bucle pruincipal de renderitzat...
	
	NumeroSubdivisions = NColumnes >> LOG2_SUBDIVISIO_PERSPECTIVA;     // Numero de subdivisions...
	RestaSubdivisions =  NColumnes &  (s16)((1 << LOG2_SUBDIVISIO_PERSPECTIVA)-1); // Resta de les subdivisions...
	
	
	PRAW.Ysostre_actual_FX = INT_TO_FIXED(CPS->y1_sostre);
	PRAW.Yterra_actual_FX = INT_TO_FIXED(CPS->y1_terra);
	
	PRAW.Ysostre_connectant_FX = INT_TO_FIXED(CPS->y1_sostre_connectant);
	PRAW.Yterra_connectant_FX = INT_TO_FIXED(CPS->y1_terra_connectant);
	
	//	x = x1;
	
	x_inicial_portal = Info_Retallat_Portal->x_inicial;
	
	ymin = &Info_Retallat_Portal->ymin[x1-x_inicial_portal];
	ymax = &Info_Retallat_Portal->ymax[x1-x_inicial_portal];

	PRAW.ymin = ymin;
	PRAW.ymax = ymax;
	

	
#ifdef __RENDER_RECURSIU__	

//	x_inicial_post_portal = Info_Retallat_Post_Portal->x_inicial;

	if(Info_Retallat_Post_Portal != NULL && SectorAdjacent != NULL) // Portal --> cal actualitzar vectors d'alada...
	{
		PRAW.ymin_portal_ptr = Info_Retallat_Post_Portal->base_ptr_ymin;//[x1-Info_Retallat->xmin_portal];
		PRAW.ymax_portal_ptr = Info_Retallat_Post_Portal->base_ptr_ymax;//[x1-Info_Retallat->xmin_portal];
	}
	else
	{
		PRAW.ymin_portal_ptr = NULL;
		PRAW.ymax_portal_ptr = NULL;
	}

#else
		PRAW.ymin_portal_ptr			= ymin;
		PRAW.ymax_portal_ptr			= ymax;
#endif	
	
//	ymin_portal_ptr			= ymin;
//	ymax_portal_ptr			= ymax;


	if(RV_Sostre)
	{
		
		PRAW.xmin_sostre     = RV_Sostre->x_inicial;
		PRAW.xmax_sostre     = RV_Sostre->x_final;
   		PRAW.ymin_sostre     = RV_Sostre->y_inicial;
		PRAW.ymax_sostre     = RV_Sostre->y_final;

//		PRAW.ymin_sostre     = RV_Sostre->y_inicial;
//		PRAW.ymax_sostre     = RV_Sostre->y_final;
		PRAW.ymin_sostre_ptr = &RV_Sostre->base_ptr_ymin[x1-x_inicial_portal];
		PRAW.ymax_sostre_ptr = &RV_Sostre->base_ptr_ymax[x1-x_inicial_portal];

		PRAW.TractarSostre = TRUE;
		
	}
	else
	{
		PRAW.TractarSostre = FALS;
	}


	if(RV_Terra)
	{
		PRAW.xmin_terra     = RV_Terra->x_inicial;
		PRAW.xmax_terra     = RV_Terra->x_final;
   		PRAW.ymin_terra     = RV_Terra->y_inicial;
		PRAW.ymax_terra     = RV_Terra->y_final;

//		PRAW.ymin_terra     = RV_Terra->y_inicial;
//		PRAW.ymax_terra     = RV_Terra->y_final;	
		
		PRAW.ymin_terra_ptr = &RV_Terra->base_ptr_ymin[x1-x_inicial_portal];
		PRAW.ymax_terra_ptr = &RV_Terra->base_ptr_ymax[x1-x_inicial_portal];
		
		PRAW.TractarTerra   = TRUE;
	}
	else
	{
		PRAW.TractarTerra   = FALS;
	}





	// INIT_COTES_SOSTRE
	// INI_COTES_TERRA
/*	if(PAC_Sostre != NULL)
	{
		
		if(PAC_Sostre->Retallat_Vertical != NULL)
		{
			y_inicial_retallat_vertical_sostre	=	PAC_Sostre->Retallat_Vertical->y_inicial;
			y_final_retallat_vertical_sostre	=	PAC_Sostre->Retallat_Vertical->y_final;
			x_inicial_retallat_vertical_sostre	=	PAC_Sostre->Retallat_Vertical->x_inicial;
			x_final_retallat_vertical_sostre	=	PAC_Sostre->Retallat_Vertical->x_final;
			ymin_retallat_vertical_sostre		=	PAC_Sostre->Retallat_Vertical->ymin;
			ymax_retallat_vertical_sostre		=	PAC_Sostre->Retallat_Vertical->ymax;
			
			
		}
		
//		Ysostre_anterior = PAC_Sostre->y_retallat_paret_anterior; 
//		y_retallat_sostre_anterior = PAC_Sostre->y_retallat_portal_anterior;
		
		if(IS_PANORAMA(PAC_Sostre->MipMap->Propietats))
		{
			
			if(U_POWER_OF_2(PAC_Sostre->MipMap->Propietats))
			{
				amplada_imatge = (0x1 << PAC_Sostre->MipMap->DimX);
				mascara_u_paisatge = amplada_imatge-1;
			}
			else
			{
				amplada_imatge = PAC_Sostre->MipMap->DimX;
				mascara_u_paisatge = 0xFFFF;
			}
			
			altura_imatge = V_POWER_OF_2(PAC_Sostre->MipMap->Propietats)? (0x1 << PAC_Sostre->MipMap->DimY):PAC_Sostre->MipMap->DimY;
			
			GET_DU_PAISATGE(du_paisatge,amplada_imatge);
			GET_DV_PAISATGE(dv_paisatge,altura_imatge);
			
			u_paisatge = ((Jugador->AngleDireccio << 2) << 16) + (x1-CENTRE_X2D_EFECTIU)*du_paisatge;
		}
		
		
			Avalua_Sostre = TRUE;
	}
	
	else
	{
		Avalua_Sostre = FALSE;
	}*/
	
/*	if(PAC_Terra != NULL)
	{
		if(PAC_Terra->Retallat_Vertical != NULL)
		{
			y_inicial_retallat_vertical_terra	=	PAC_Terra->Retallat_Vertical->y_inicial;
			y_final_retallat_vertical_terra		=	PAC_Terra->Retallat_Vertical->y_final;
			x_inicial_retallat_vertical_terra	=	PAC_Terra->Retallat_Vertical->x_inicial;
			x_final_retallat_vertical_terra		=	PAC_Terra->Retallat_Vertical->x_final;
			ymin_retallat_vertical_terra		=	PAC_Terra->Retallat_Vertical->ymin;
			ymax_retallat_vertical_terra		=	PAC_Terra->Retallat_Vertical->ymax;
			
			
		}
		
		Yterra_anterior				=	PAC_Terra->y_retallat_paret_anterior;
		y_retallat_terra_anterior	=	PAC_Terra->y_retallat_portal_anterior;

		if(IS_PANORAMA(PAC_Terra->MipMap->Propietats))
		{
			
			if(U_POWER_OF_2(PAC_Terra->MipMap->Propietats))
			{
				amplada_imatge = (0x1 << PAC_Terra->MipMap->DimX);
				mascara_u_paisatge = amplada_imatge-1;
			}
			else
			{
				amplada_imatge = PAC_Terra->MipMap->DimX;
				mascara_u_paisatge = 0xFFFF;
			}
			
			altura_imatge = V_POWER_OF_2(PAC_Terra->MipMap->Propietats)? (0x1 << PAC_Terra->MipMap->DimY):PAC_Terra->MipMap->DimY;
			
			GET_DU_PAISATGE(du_paisatge,amplada_imatge);
			GET_DV_PAISATGE(dv_paisatge,altura_imatge);
			
			u_paisatge = ((Jugador->AngleDireccio << 2) << 16) + (x1-CENTRE_X2D_EFECTIU)*du_paisatge;
		}
		Avalua_Terra = TRUE;
	}
	else
	{
		Avalua_Terra = FALSE;
	}
	*/
	
	

	
	// Assignacions parametres paret inicials...
	
	
	//x = &PPP.x;
//	PPP.Color_Mascara = MASK_COLOR;

	PRAW.x = x1;
	PRAW.centre_projeccio_y = CENTRE_Y2D_EFECTIU - Jugador->Horitzo;
	PRAW.vmed = (SectorActual->AlturaTerra - Jugador->Altura) << 16;
	PRAW.SectorAdjacent = SectorAdjacent;


	intensitat_sector = SectorActual->Intensitat_Llum_Sector;
	if(intensitat_sector < 0) PRAW.intensitat_sector = (-intensitat_sector);
	else PRAW.intensitat_sector = (fx_llum[intensitat_sector][temps]);

	//
	//
	//
	//
	


	
	
	////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////////////
	////
	////
	//// Bucle principal de la renderitzaci de part de sector...
	////
	////
	
	
	do{
		//
		// Configuracions partici valors perspectiva
		//
		
		if(NumeroSubdivisions == 0) // Hem de renderitza el resta
		{
			if( RestaSubdivisions != 0)
			{
				NColumnes = RestaSubdivisions;

				
				
				// Configuraci perspectiva...
				
				if(CPS->Calcul_Perspectiva)
				{
					if((CPS->dz2 - inc_dzdX) > ONE_FX) // No perdrem precisi...
						ZRight = DivFx(FIXED_MUL_16384(ONE_FX), CPS->dz2 - inc_dzdX);
					else // Tampoc hi perdrem...
						ZRight = FIXED_MUL_256(DivFx(FIXED_MUL_16384(ONE_FX), FIXED_MUL_256(CPS->dz2 - inc_dzdX)));
					
					
					URight = FIXED_DIV_16(MulFx(ZRight,FIXED_DIV_16(CPS->du2 - inc_dudX)));
					
					Z = ZLeft;
					U = ULeft;
					
#ifdef __ARITMETICA_FIXA__
					DeltaZ = MulFx_16_16(ZRight-ZLeft,reciprocal_div[RestaSubdivisions]);
					DeltaU = MulFx_16_16(URight-ULeft,reciprocal_div[RestaSubdivisions]);
#else
					DeltaZ = FIXED_DIV_256(MulFx_16_16(ZRight-ZLeft,reciprocal_div[RestaSubdivisions]));
					DeltaU = FIXED_DIV_256(MulFx_16_16(URight-ULeft,reciprocal_div[RestaSubdivisions]));
#endif
					
					
				}


				
			}
			else
			{
				NColumnes = -1;
			}
			
		}
		else
		{
			NColumnes = 1 << LOG2_SUBDIVISIO_PERSPECTIVA;
			
			// Configuraci perspectiva...
			
			// Valor-Z dret
			if(CPS->Calcul_Perspectiva)
			{
				if(dzRight > ONE_FX) // No perdrem precisi...
					ZRight = DivFx(FIXED_MUL_16384(ONE_FX), dzRight);
				else // Tampoc hi perdrem...
					ZRight = FIXED_MUL_256(DivFx(FIXED_MUL_16384(ONE_FX), FIXED_MUL_256(dzRight)));
				
				// Obtenci de l'escalat esquerra a alta precisi (16.16)...
				
				URight = FIXED_DIV_16(MulFx(FIXED_DIV_16(duRight),ZRight));
				
				
				
#ifdef __ARITMETICA_FIXA__
				DeltaZ = (ZRight-ZLeft) >> LOG2_SUBDIVISIO_PERSPECTIVA;
				DeltaU = (URight-ULeft) >> LOG2_SUBDIVISIO_PERSPECTIVA;
				
				
#else 
				DeltaZ = (ZRight - ZLeft)/(1 << LOG2_SUBDIVISIO_PERSPECTIVA);
				DeltaU = (URight - ULeft)/(1 << LOG2_SUBDIVISIO_PERSPECTIVA);
				
#endif
				
				
				Z = ZLeft;
				U = ULeft;
				
			}
		}
		

        ////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////
		////
		////  Benvinguts al...
		////
		////
		////                                                                              
		////	    _/      _/  _/    _/    _/_/_/  _/        _/_/_/ 
		////	   _/_/    _/  _/    _/  _/        _/          _/    
		////	  _/  _/  _/  _/    _/  _/        _/          _/     
		////	 _/    _/_/  _/    _/  _/        _/          _/      
		////	_/      _/    _/_/      _/_/_/  _/_/_/_/  _/_/_/     
		////
		////
		////

		if(NColumnes > 0)
		{
			PRAW.interacions      = NColumnes;
			PRAW.Z			      = Z;
			PRAW.U			      = U;
			PRAW.DeltaU		      = DeltaU;
			PRAW.DeltaZ		      = DeltaZ;
            PRAW.Propietats_Linia = LiniaSector->Linia.Propietats_Mapeig;

#ifdef __HAM__

            
            ARM_RenderAffineWall(&PRAW);


			// Imprimici

		/*	{


			int j;
			
			ham_VBAText("\nxmin_portal:%i",PRAW.xmin_portal);
			ham_VBAText("\nxmax_portal:%i",PRAW.xmax_portal);

            ham_VBAText("\nymin_proba:%i",PRAW.ymin_proba);
			ham_VBAText("\nymax_proba:%i",PRAW.ymax_proba);

			if(PRAW.xmin_portal < PRAW.xmax_portal)
			{	

				ham_VBAText("\nxmin_sostre:%i",PRAW.xmin_sostre);
				ham_VBAText("\nxmax_sostre:%i",PRAW.xmax_sostre);
				ham_VBAText("\nxmin_terra:%i",PRAW.xmin_terra);
				ham_VBAText("\nxmax_terra:%i",PRAW.xmax_terra);





				for(j = PRAW.xmin_portal; j < PRAW.xmax_portal;j++)
				{
					ham_VBAText("\nymin[%i]:%i   ymax[%i]:%i",j,Info_Retallat_Portal->ymin[j - Info_Retallat_Portal->x_inicial],j,Info_Retallat_Portal->ymax[j - Info_Retallat_Portal->x_inicial]);
				}	
			}

			}
*/


#else
			C_RenderAffineWall(&PRAW);

			{


	/*		int j;

			//if(PRAW.xmin_portal < PRAW.xmax_portal)
			{
				printf("\nxmin_portal:%i",PRAW.xmin_portal);
				printf("\nxmax_portal:%i",PRAW.xmax_portal);
				printf("\nxmin_sostre:%i",PRAW.xmin_sostre);
				printf("\nxmax_sostre:%i",PRAW.xmax_sostre);
				printf("\nxmin_terra:%i",PRAW.xmin_terra);
				printf("\nxmax_terra:%i",PRAW.xmax_terra);
				for(j = PRAW.xmin_portal; j < PRAW.xmax_portal;j++)
				{
					printf("\nymin[%i]:%i   ymax[%i]:%i",Info_Retallat_Portal->ymin[j - Info_Retallat_Portal->x_inicial],Info_Retallat_Portal->ymax[j - Info_Retallat_Portal->x_inicial]);
				}	
			}*/

			}

#endif


		}

		////
		////
		////
		////
        ////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////

		//for(contador = 0; contador < NColumnes ; contador ++){
	
		
 		ZLeft = ZRight;
		ULeft = URight;
		
		
		dzRight = dzRight + IncAffine_DzDx;
		duRight = duRight + IncAffine_DuDx;
		
		
		
//        NumeroSubdivisions--;
        
	}while(((--NumeroSubdivisions) >= 0));
	
	
	if(RV_Sostre && (PRAW.xmax_sostre != -1)) // ok! modificat!!!
	{
		if((RV_Sostre->x_final == -1) ) // Primera inicialitzaci...
		{
            RV_Sostre->x_inicial = PRAW.xmin_sostre;

			RV_Sostre->ymin = &RV_Sostre->base_ptr_ymin[PRAW.xmin_sostre-x_inicial_portal];
			RV_Sostre->ymax = &RV_Sostre->base_ptr_ymax[PRAW.xmin_sostre-x_inicial_portal];

		}
		
		RV_Sostre->x_final   = PRAW.xmax_sostre;

        RV_Sostre->y_inicial  = PRAW.ymin_sostre;
        RV_Sostre->y_final    = PRAW.ymax_sostre;

	}
	
	
	if(RV_Terra && (PRAW.xmax_terra != -1))
	{
		if((RV_Terra->x_final == -1) ) // Primera inicialitzaci...
		{
			
			RV_Terra->x_inicial  = PRAW.xmin_terra;

			RV_Terra->ymin = &RV_Terra->base_ptr_ymin[PRAW.xmin_terra-x_inicial_portal];
			RV_Terra->ymax = &RV_Terra->base_ptr_ymax[PRAW.xmin_terra-x_inicial_portal];
		}


		
		RV_Terra->x_final    = PRAW.xmax_terra;

        RV_Terra->y_inicial  = PRAW.ymin_terra;
        RV_Terra->y_final    = PRAW.ymax_terra;

	}




	
	
	// Actualitzo les variables de portal...
	
	if((Info_Retallat_Post_Portal != NULL) && (PRAW.xmax_portal != -1))
	{
		//if(Info_Retallat_Post_Portal->x_final == -1)
		//{
		
		Info_Retallat_Post_Portal->ymin = &Info_Retallat_Post_Portal->base_ptr_ymin[PRAW.xmin_portal-x1];
		Info_Retallat_Post_Portal->ymax = &Info_Retallat_Post_Portal->base_ptr_ymax[PRAW.xmin_portal-x1];
		//}

		Info_Retallat_Post_Portal->x_inicial = PRAW.xmin_portal;
		Info_Retallat_Post_Portal->x_final   = PRAW.xmax_portal;

		
//		Info_Retallat_Post_Portal->y_inicial = ymin_portal;
//		Info_Retallat_Post_Portal->y_final = ymax_portal;




	}

	
}




////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//
//

typedef struct{
	
	short   x,y;
	FIXED32 U,V;
	FIXED32 x3d, z3d, y3d;
	
	
}tInfoVertexPendent;


#include "Renderitzar_C_CalculComponentsPlaSector.cc"

FUNCIO_A_MEMORIA_INTERNA
void Renderitzar_Pla(const tJugador *Jugador, const tSector *SectorActual, int Tipus,const tInfo_Retallat_Vertical *RV_Pla)//_Terra->y_renderitzacio_inicial)
{
    short *x1_ptr = _x1, actual_valid, anterior_valid;
    short *y1,*y2,y1_actual,y2_actual, y1_anterior, y2_anterior, x_actual, x_final,y;
    tComponentsPlaSector *CPS = _CPS;
    tParametresCalculComponentsPlaSector PCCPS;
    tParametresPintarTiraPla    PPTP;
    tParametresPintarParet2     PPP;
//    short *CPS_Calculat = _CPS_Calculat;

    if((RV_Pla->y_inicial > RV_Pla->y_final)) return;






    
    PCCPS.y1                = RV_Pla->y_inicial;
    PCCPS.y2                = RV_Pla->y_final;
    PCCPS.xj                = Jugador->X;
    PCCPS.zj                = Jugador->Z;

    PCCPS.ValorCosinus      = _Cosinus[Jugador->AngleDireccio];
    PCCPS.ValorSinus        = _Sinus[Jugador->AngleDireccio];

    PCCPS.horitzo_jugador   = Jugador->Horitzo;

    PCCPS.light_sector      = DECODE_LIGHT(SectorActual->Intensitat_Llum_Sector);
    PCCPS.tipus             = Tipus;
    PCCPS.ptr_CPS           = _CPS;

    
    if(Tipus == ES_SOSTRE)
    {
        PCCPS.diff_altura       = SectorActual->AlturaSostre - Jugador->Altura;
        PPTP.ID_Textura         = SectorActual->ID_Animacio_Sostre > 0 ? TaulaAnimacions[SectorActual->ID_Animacio_Sostre]->Textura->ID_Textura:SectorActual->ID_Animacio_Sostre;
    }
    else
    {
        PCCPS.diff_altura       = Jugador->Altura - SectorActual->AlturaTerra;
        PPTP.ID_Textura         = SectorActual->ID_Animacio_Terra > 0 ? TaulaAnimacions[SectorActual->ID_Animacio_Terra]->Textura->ID_Textura:SectorActual->ID_Animacio_Terra;
    }


    if((PPTP.ID_Textura > 0 )&&
       (IS_PANORAMA(Textura[PPTP.ID_Textura].Propietats))) // Es renderitza per franges horitzontals...
    {
        PPP.ID_Textura = PPTP.ID_Textura;
        PPP.Propietats_Objecte = 0;
        PPP.Intensitat = DECODE_LIGHT(SectorActual->Intensitat_Llum_Sector);
        SET_BIT(PPP.Propietats_Objecte, BIT_RENDER_WITH_BRIGHT);

        for(x_actual = RV_Pla->x_inicial, y1 = RV_Pla->ymin,y2 = RV_Pla->ymax; x_actual <= RV_Pla->x_final; x_actual++, y1++, y2++)
        {
            if(*y1 <= *y2)
            {
                PPP.x  = x_actual;
                PPP.y1 = *y1;
                PPP.y2 = *y2;

                PutVerticalSlice(&PPP);      
            }
        }
    
    }
    else
    {

    // Calcul parametres sector...
       //if(PPTP.ID_Textura > 0 )
            RENDER_C_CalculParametresPlaSector(&PCCPS);
 

    //
    // Llegir primer...
    //
    
    // Init vectors de retallat mnims, mxims...
    y1       = RV_Pla->ymin;
    y2       = RV_Pla->ymax;

    MemSet16(&x1_ptr[RV_Pla->y_inicial],ALTURA_PANTALLA_EFECTIVA,RV_Pla->y_final-RV_Pla->y_inicial+1);
  

    x_actual  = RV_Pla->x_inicial;
    x_final   = RV_Pla->x_final;
    y1_actual = *y1;
    y2_actual = *y2;

    //init_xs = FALSE;
    // Inicialitzaci...
    actual_valid     = ((y1_actual   <= y2_actual) && (y2_actual   >= 0)  && (y1_actual   >= 0) && (y2_actual < ALTURA_PANTALLA_EFECTIVA  )&& (y1_actual < ALTURA_PANTALLA_EFECTIVA  ));
    anterior_valid   = FALSE;

 
    // Bucle general de pintat sostre/terra...

    while(x_actual <= x_final)
    {
        
        if(actual_valid && !anterior_valid) // Cal inicialitzar cotes x1...
        {
            MemSet16((&x1_ptr[y1_actual]),x_actual,((y2_actual)-(y1_actual)+1));
        }
        else // Actualitzem o mapejem...
        {
            if(!actual_valid && anterior_valid) // Cal fer el mapeig...
            {
                for(y = y1_anterior; y <= y2_anterior; y++) // Mapeig ultra rpid...
                {
                    //MemSet16(((short *)(((char *)WORK_VRAM+ ((y<< DETALL_GRAFIC_Y)*AMPLADA_PANTALLA) +(x1_ptr[y] << DETALL_GRAFIC_X)))),0x0F0F,(((x_actual-1)-x1_ptr[y]+1)));
                    PPTP.x1  = x1_ptr[y];
                    PPTP.x2  = x_actual-1;
                    PPTP.y   = y;
                    PPTP.CPS = &PCCPS.ptr_CPS[y];
                    PutHorizontalSlice(&PPTP);
                }
            }
            else // ok, avaluem si i noms si, l' actual s vlid
            {
                if(actual_valid)
                {


                    if(y1_actual < y1_anterior) // Assignaci inicial cotes...
                    {
                        MemSet16((&x1_ptr[y1_actual]),x_actual,((y1_anterior)-(y1_actual)));
                    }
                    else // Mapeig...
                    {
                        if(y1_anterior < y1_actual) 
                        {
                            for(y = y1_anterior; y <= y1_actual; y++) // Mapeig ultra rpid...
                            {
                               //MemSet16(((short *)(((char *)WORK_VRAM+((y<< DETALL_GRAFIC_Y)*AMPLADA_PANTALLA)+(x1_ptr[y] << DETALL_GRAFIC_X)))),0x0F0F,(x_actual-x1_ptr[y]+1));
                                PPTP.x1  = x1_ptr[y];
                                PPTP.x2  = x_actual;
                                PPTP.y   = y;
                                PPTP.CPS = &PCCPS.ptr_CPS[y];
                                PutHorizontalSlice(&PPTP);
                            }
                            
                        }
                        
                    }
                    
                    
                    if(y2_anterior < y2_actual) // Assignaci inicial cotes...
                    {
                        MemSet16((&x1_ptr[y2_anterior + 1]),x_actual,((y2_actual)-(y2_anterior+1)+1));
                    }
                    else // Mapeig...
                    {
                        if(y2_actual < y2_anterior)
                        {
                            for(y = y2_actual; y <= y2_anterior; y++) 
                            {
                                PPTP.x1  = x1_ptr[y];
                                PPTP.x2  = x_actual;
                                PPTP.y   = y;
                                PPTP.CPS = &PCCPS.ptr_CPS[y];
                                PutHorizontalSlice(&PPTP);
                               //MemSet16(((short *)((char *)WORK_VRAM+ ((y<< DETALL_GRAFIC_Y)*AMPLADA_PANTALLA) +(x1_ptr[y] << DETALL_GRAFIC_X))),0x0F0F,((x_actual-x1_ptr[y]+1)));
                            }
                        }
                    }

                }
            }
            
            
        }
        
        // Actualitzem cotes anteriors...
        y1_anterior = y1_actual;
        y2_anterior = y2_actual;
        anterior_valid = actual_valid;
        
        
        // Actualitzem variables proxima iteraci...
        x_actual++;

        if(x_actual <= x_final)
        {
            y1_actual = *(++y1);
            y2_actual = *(++y2);
            actual_valid = ((y1_actual   <= y2_actual) && (y2_actual   >= 0)  && (y1_actual   >= 0) && (y2_actual < ALTURA_PANTALLA_EFECTIVA  )&& (y1_actual < ALTURA_PANTALLA_EFECTIVA  ));
        }
        
        
    }
    
    // Cal pintar ultima tira, en cas que y1_anterior <= y2_anterior...
    if(anterior_valid)
    {
        for(y = y1_anterior; y <= y2_anterior; y++) // Mapeig ultra rpid...
        {
            //MemSet16(((short *)(((char *)WORK_VRAM+ ((y<< DETALL_GRAFIC_Y)*AMPLADA_PANTALLA) +(x1_ptr[y] << DETALL_GRAFIC_X)))),0x0F0F,(((x_actual-1)-x1_ptr[y]+1)));
            PPTP.x1  = x1_ptr[y];
            PPTP.x2  = x_actual-1;
            PPTP.y   = y;
            PPTP.CPS = &PCCPS.ptr_CPS[y];
            PutHorizontalSlice(&PPTP);
        }
    }

    }
    
    

}


#ifndef __RENDER_RECURSIU__
FUNCIO_A_MEMORIA_INTERNA
#endif
void
RENDER_NouSectorParcial
(int ID_Sector,
 int ID_Sector_Depenent,
 tInfoNodeSectorParcial  *InfoNodeSectorParcial,
 tLlistaNodes			 *LlistaSectorsAProcessar)
{
//	tSectorParcial			*llista_sector_parcials;
	tSectorParcial			*info_base;
	PNode					NouNode,NodeDepenent,node;
	void					**ptr_llista;
//	tInfoSectorParcial		*ptr_info_sector_parcial;
//	PNode NodeBase;

	NodeDepenent = NULL;

	if(ID_Sector == 16)
	{
		int caca = 0;

		caca = 1;
	
	}

	if((ptr_llista = LlistaSectorsAProcessar->LE.InfoLlistaEstatica))
	{
		if((node = ptr_llista[ID_Sector])) // OK! Node ja estava empilat. I ordenat !!!
		{
			// Agafem la llista parcial de sectors no conectats...
			info_base = node->InfoNode;

			LD_Empilar(0,InfoNodeSectorParcial,&info_base->LlistaSectorsParcials,FIFO);	// S'empilar a l'ultim...

//			IDSectorEmpilat = ID_Sector;
			
		}
		else // Nou node, ull!!! cal mira si exiteix node depenent ...
		{
			// Llista base de sectors parcials no-conectables...
			Reservar_Memoria(info_base,tSectorParcial,1);

			LD_InitLlista(&info_base->LlistaSectorsParcials);

			info_base->ID_Ordre = id_ordre++;
			
			// LLista de nodes a processar...
			LD_Empilar(0,InfoNodeSectorParcial,&info_base->LlistaSectorsParcials,FIFO);



			if(ID_Sector_Depenent >= 0)    NodeDepenent = ptr_llista[ID_Sector_Depenent];

			if(NodeDepenent) // Ja s'havia empilat... Cal empilar el nou node darrera seu...
			{

			
				 //LD_EmpilarInfoAbansDe(ID_NODE,info_node,node_depenent,LN,FIFO)
				 //{

				Reservar_Memoria(NouNode,tNode,1);
				
				if(NouNode == NULL) return;
				
				NouNode->ID_Node = ID_Sector;
				NouNode->InfoNode = info_base;
				
				ptr_llista[ID_Sector] = NouNode;

				 if(NodeDepenent == LlistaSectorsAProcessar->Primer)
				 {
					LlistaSectorsAProcessar->Primer = NouNode;
					NouNode->Anterior = LlistaSectorsAProcessar->Ultim;
					LlistaSectorsAProcessar->Ultim->Seguent = NouNode;

				 }
				 else
				 {
				 	NouNode->Anterior = NodeDepenent->Anterior;
				 }
	
				 NodeDepenent->Anterior->Seguent = NouNode;
				 NodeDepenent->Anterior = NouNode;
				 NouNode->Seguent = NodeDepenent;

				 LlistaSectorsAProcessar->n_nodes++;



//				 id_ordre = id_actual;

			//	 IDSectorEmpilat = -1;		
								
			
			}
			else // Ens lliurem per ara !!! :)
			{
			
				LD_Empilar(ID_Sector,info_base,LlistaSectorsAProcessar,FIFO);
			}

			//IDSectorEmpilat = ID_Sector;
		}


	
	}
	else // Es requereix suport de llista estatica!
	{
		PRINT_ERROR("\nError!, cal disposar de llista esttica!!!",0);	
	}


	




}




#ifndef __RENDER_RECURSIU__
FUNCIO_A_MEMORIA_INTERNA
#endif
tInfoNodeSectorParcial *
RENDER_CercaNodeParcialConectable
(int x_inicial,
 int ID_Sector_Actual,
 int ID_Sector_Depenent,
 tLlistaNodes *LN)
{
	 int i,trobat;
	 
         //,id_actual;
	 tInfoNodeSectorParcial *info_actual = NULL;
	 tSectorParcial			*info_sector_parcial/*,*sector_parcial_cercat,*sector_parcial_dependent*/;
	 

	 PNode /*node_actual,*/node_sector_parcial;
	 PNode node_dependent = NULL;
	 PNode node_a_cercar = NULL;
	 void **ptr_llista = NULL;
	 tLlistaNodes    *ptr_llista_sectors_parcials;


	 if(LN!=NULL)
	 {
		 // Comprobem si tenim suport de llista...
		 if((ptr_llista = LN->LE.InfoLlistaEstatica) != NULL) // Veus ? Noms un sol accs i ja tenim la info.
		 {
			if(ID_Sector_Actual   >= 0) node_a_cercar	= ptr_llista[ID_Sector_Actual];
			if(ID_Sector_Depenent >= 0) node_dependent	= ptr_llista[ID_Sector_Depenent];
			

			if(node_a_cercar) // Cerquem la conexi (x_inicial+1)...
			{
				info_sector_parcial			= node_a_cercar->InfoNode;
				ptr_llista_sectors_parcials = &info_sector_parcial->LlistaSectorsParcials;
				node_sector_parcial			= ptr_llista_sectors_parcials->Primer;
				i							= ptr_llista_sectors_parcials->n_nodes;
				trobat = FALSE;

				while(i-- && !trobat)
				{
					info_actual = node_sector_parcial->InfoNode;

					if((info_actual->x2+1) == (x_inicial))
					{
						trobat = CERT;
					}

					node_sector_parcial = node_sector_parcial->Seguent;
				}

				if(!trobat) info_actual = NULL;

			}


		 }
		 else
		 {
			PRINT_ERROR("\n Error! cal tenir suport de llista!!!",0);		 
		 }
	 }


	/*	 if(info_actual != NULL) // Hem trobat el node conectant
	 {
		 if(node_dependent != NULL) // Mirem ID de ordenaci....
		 {
			 sector_parcial_cercat		= node_a_cercar->InfoNode;
			 sector_parcial_dependent	= node_dependent->InfoNode;

			 //if(sector_parcial_cercat->ID_Ordre < sector_parcial_dependent->ID_Ordre) // Cal actualitzar els IDs dels nodes desde id_actual al dependent !!!!
			 if(node_dependent->ID_Node == IDSectorEmpilat)
			 {
				 node_actual   = node_a_cercar;
				 id_actual     = id_ordre;//sector_parcial_dependent->ID_Ordre + 1;

			 if(node_actual->Seguent == NULL) 
				 {

				 }
				 
				// NNodes = LN->n_nodes;

			//	 while((node_actual != node_dependent))
			//	 {
			//		 ((tSectorParcial *)(node_actual->InfoNode))->ID_Ordre	= id_actual++;
			//		 node_actual											= node_actual->Seguent;
			//	 }

				 node_dependent = LD_Extraure(node_dependent->ID_Node,LN);
				 LN->n_nodes++;
				 //LD_EmpilarNodeAbansDe(node_cercat,node_depenent,LN,FIFO)
				 //{

				 if(node_a_cercar == LN->Primer)
				 {
					LN->Primer = node_dependent;
					node_dependent->Anterior = LN->Ultim;
				 }
				 else
				 {
					 node_dependent->Anterior = node_a_cercar->Anterior;
				 }

				 node_a_cercar->Anterior->Seguent = node_dependent;
				 node_a_cercar->Anterior = node_dependent;
				 node_dependent->Seguent = node_a_cercar;

				 id_ordre = id_actual;

			//	 IDSectorEmpilat = -1;
				 

				 //}

				 
				 
				 // ok!, nodes actualitzats !!!
 

			 }
		 
		 }
	 }*/
 

	 return info_actual;
}


#ifndef __RENDER_RECURSIU__
FUNCIO_A_MEMORIA_INTERNA
#endif
int RENDER_RecolectaInfoSector
(int x_inicial,
 int x_final,
 const tJugador *Jugador, 
 const tSector *SectorActual,   // A canviar!, millor que posi l'ID codificat.
 const tSector *SectorDepenent, // A canviar!, millor que posi l'ID codificat.
 tLlistaNodes	 *LlistaSectorsAProcessar
 )
{
	
	int x_actual, 
		x_proj,
		fi, 
		LiniaActual, 
		id_mapa,id_sector_actual,id_sector_depenent,id_sector_adjacent,
//		id_adjacent_sector_encoded,id_mapa_depenent,
//		id_actual_sector_encoded,
		NumeroLinies,
		LI;
	
	u32				id_portal_codificat;//,ID_SectorAdjacentCodificat;
	tCachedVertex	*_CachedVertexs = CachedVertexs, *CachedVertex;
	tVertex			*V0,*V1;
		
	
	
	tPunt_Fixa_2D	V0_ull, 
					V1_ull,
					Interseccio;
	
//	FIXED32   *Sinus = (FIXED32 *)_Sinus, *Cosinus = (FIXED32 *) _Cosinus;
//	FIXED32   *reciprocal_div = (FIXED32 *)_reciprocal_div, Part_Fraccional;
	
	FIXED32			Pendent_V1,Part_Fraccional;
	
	
	tLiniaSector			*LiniaSector;
	tSector					*SectorAdjacent;
	tInfoNodeSectorParcial  *InfoNodeSectorParcial = NULL;
	u8						AngleDireccioJugador;


	if(SectorActual == NULL)	return FALS;	
	
	
	if(x_inicial > x_final) return FALS;

	// 0).- Obtenci punter sector a partir del seu ID codificat...
if(SectorActual->ID_Sector == 10)
{
    int kk;

    kk = 0;
}

	id_sector_actual = SectorActual->ID_Sector;
	AngleDireccioJugador = Jugador->AngleDireccio;
	
	if(SectorDepenent == NULL) //No te sector depenent !
	{
		id_sector_depenent = -1;
	}
	else
	{
		id_sector_depenent = SectorDepenent->ID_Sector;
	}

//	SectorActual =  &MapaMon->Mapa2D[id_mapa].Sector[id_sector];

	
	// 1).- Cerca sector parcial si ja s'havia renderitzat...


	if((InfoNodeSectorParcial = RENDER_CercaNodeParcialConectable(x_inicial,id_sector_actual,id_sector_depenent,LlistaSectorsAProcessar)) != NULL)
	{
		LiniaActual = InfoNodeSectorParcial->ultima_linia_sector;

	}
	else // Cal fer l'ampilaci de informaci, :_(
	{
			// Linia intersecci...
			LI = LiniaActual = LiniaInterseccio(x_inicial, Jugador,SectorActual,&Interseccio,TRUE);

			
		// Nou sector a renderitzar :_(...

//		NODE_Empilar(LlistaSectorsAProcessar->n_nodes,InfoNodeSectorParcial,LlistaSectorsAProcessar,FIFO);

						//////////////////////////////////////////////////////////////////////
				//////////////////////////////////////////////////////////////////////
				////
				//// S'acaba i cal guardar/actualitzar sector a la llista...
				////
				
			//	if(InfoNodeSectorParcial == NULL) // Vol dir que s'ha trobat un sector parcial conectable
			//	{
					
					Reservar_Memoria(InfoNodeSectorParcial,tInfoNodeSectorParcial,1);
					if(InfoNodeSectorParcial == NULL) return FALS;
					
					
					InfoNodeSectorParcial->x1 = x_inicial;
					InfoNodeSectorParcial->Sector = (tSector *)SectorActual;
					InfoNodeSectorParcial->ID_Sector = id_sector_actual;
					InfoNodeSectorParcial->primera_linia_sector = LI;
					InfoNodeSectorParcial->Interseccio = Interseccio;
					
					
					//		RENDER_EmpilarSectorParcialNOConectable

					RENDER_NouSectorParcial(id_sector_actual,id_sector_depenent,InfoNodeSectorParcial,LlistaSectorsAProcessar);
			//	}
				
				
				
				
				
				
				////
				////
				////////////////////////////////////////////////////////////////////////////////
				////////////////////////////////////////////////////////////////////////////////


	}
	
	
	NumeroLinies =    SectorActual->NumeroLinies;

	
	if(LiniaActual < 0) // Error, no s'ha pogut determinar la lnia d'intersecci!!!
	{
		return FALS;
	}
	else // Es possible la renderitzaci de sector...
	{
		
		LiniaSector = (tLiniaSector *)&SectorActual->LiniaSector[LiniaActual];
		V0          = &LiniaSector->Linia.V0;
		
		// Transformaci intersecci a l'espai d'ull...
		CachedVertex = &_CachedVertexs[V0->ID_Vertex];


		if(!CachedVertex->Rotated)
		{			 
			punt_mon_A_pla_projeccio(Jugador, V0->X,V0->Z, &V0_ull);
			CachedVertex->TransformedVertex = V0_ull;
			CachedVertex->Projected = FALSE;
			CachedVertex->Rotated = TRUE;
			
		}
		else
		{
		
			V0_ull = CachedVertex->TransformedVertex;
		}
		
		//punt_mon_A_pla_projeccio(Jugador, LiniaSector->Linia.V0.X,LiniaSector->Linia.V0.Z, &V0_ull);
		
		
		x_actual = x_inicial;
		fi = FALS;
		
		
		//////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////
		////
		//// Bucle principal...
		////
		
		while(!fi)
		{

			// Si es portal, llavors carreguem punter del sector adjacent...
			V1 = &LiniaSector->Linia.V1;
			
			if((id_portal_codificat = LiniaSector->Portal) != PARET)	
			{
				id_mapa				= DECODE_ID_MAP(id_portal_codificat);
				id_sector_adjacent	= DECODE_ID_SECTOR(id_portal_codificat);
				
				
				SectorAdjacent = &MapaMon->Mapa2D[id_mapa].Sector[id_sector_adjacent];
			}
			else	SectorAdjacent = NULL;
			
			
			// Projecci del l'ultim vrtex de lnia...
			
			
			CachedVertex = &_CachedVertexs[V1->ID_Vertex];
			if(!CachedVertex->Rotated)
			{			 
				punt_mon_A_pla_projeccio(Jugador, V1->X,V1->Z, &V1_ull);
				CachedVertex->TransformedVertex = V1_ull;
				CachedVertex->x = CachedVertex->Projected = FALSE;
				CachedVertex->Rotated = TRUE;
			}
			else
			{
	
				V1_ull = CachedVertex->TransformedVertex;
			}

			//punt_mon_A_pla_projeccio(Jugador, LiniaSector->Linia.V1.X,LiniaSector->Linia.V1.Z, &V1_ull);
			
			
			// Calcul de components de paret segons l'ultim vrtex de lnia...
			
	 if(V1_ull.Z > 0)	
	 {
		 
		 
		 //if(Z1_Pla_Precis < 0) return FALS;
		 if(ABS_FX(V1_ull.Z) < ONE_FX)
		 {
			 
			 V1_ull.Z = ONE_FX;
		 }
		 
		 
	 
		 if(!CachedVertex->Projected)
		 {

			 Pendent_V1 = DivFx_16_16(FIXED_MUL_256(V1_ull.X), FIXED_MUL_256(V1_ull.Z));
             

             // Si el pendent no pertany [-1,...,1) --> Error perqu no esta al FOV!!! j
             if(Pendent_V1 > ONE_FX_16_16) Pendent_V1 = MAX_FX;
             else if(Pendent_V1 < (-ONE_FX_16_16)) Pendent_V1 = MIN_FX;
             else Pendent_V1*=d_efectiva;
            
			 
			 // Per evitar que el raig surti fora de portal (si la actual lnia ho s) es mira
			 // la part fraccional. Segons el seu valor realitzarem una correci de projecci per
			 // assegurar que el futur raig entri al portal.
			 Part_Fraccional = RETORNA_PART_FRACCIONAL_FX_16_16(Pendent_V1);

			 
			 if(Part_Fraccional < 0)  // Negativa...
			 {


					 if(Part_Fraccional < -DOUBLE_TO_FIXED_16_16(0.5039062))

					 {
						 x_proj = FLOOR_FX_16_16(Pendent_V1) + CENTRE_X2D_EFECTIU - 1;
					 }
					 else x_proj = FLOOR_FX_16_16(Pendent_V1) + CENTRE_X2D_EFECTIU;
					 
			 }
			 else // Positiu...
			 {
					if(Part_Fraccional < DOUBLE_TO_FIXED_16_16(0.49609375))
					 {
						 x_proj = FLOOR_FX_16_16(Pendent_V1) + CENTRE_X2D_EFECTIU - 1;
					 }
					 else x_proj = FLOOR_FX_16_16(Pendent_V1) + CENTRE_X2D_EFECTIU;
			 
			 }
			 
			 CachedVertex->Projected = TRUE;
			 CachedVertex->x = x_proj;
			 
			 
		 }
		 else
		 {
			 x_proj = CachedVertex->x; 
		 }
	 }
	 else
	 {
		 x_proj = -1; // Vertex surt fora del pla --> improjectable.	
	 }
	 
	 
			
			if((x_proj < 0) || (x_proj >= x_final)) // Fi de la renderitzaci...
			{
				x_proj	= x_final;

				InfoNodeSectorParcial->ultima_linia_sector = LiniaActual;
				InfoNodeSectorParcial->x2 = x_final;

				fi		= CERT;
			}
			
			
			if(x_actual <= x_proj) // Podem renderitzar la paret actual, altrament passem a la segent...
			{
				
				if(SectorAdjacent != NULL) // Es renderitzar recursivament...
				{	


//					id_adjacent_sector_encoded	= ENCODE_ID_MAP_SECTOR(id_mapa,SectorAdjacent->ID_Sector);
//					id_actual_sector_encoded	= ENCODE_ID_MAP_SECTOR(id_mapa,id_sector_actual)



					// Recolecta informacio recursivament...
					RENDER_RecolectaInfoSector(x_actual, 
											     x_proj, 
												 Jugador, 
												 SectorAdjacent,
												 SectorActual,
												 LlistaSectorsAProcessar
												 );
					sectors_prerenderitzats++;
					
				}
			}


			
			// Linia segent...
			
			x_actual = x_proj + 1;
			V0_ull = V1_ull;

			LiniaActual++;
			LiniaSector++;
			
		
			if(LiniaActual >= NumeroLinies)
			{
				LiniaActual = 0;
				LiniaSector = (tLiniaSector *)SectorActual->LiniaSector;
			}
			
			
			}
		}
		
		////
		////
		//// FI bucle principal de renderitzat...
		////
		//////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////
		
	
		// Per ultim cal evaluar els sostre/terra. Si el sostre i/o terra no es
		// NUL, llavors s'entra a recursivament a fer el tractament...

		
		// ... wuala !!!, ja hem tractat un sector. NO ha costat gaire, eh? :)
		return CERT;
		
		
}





