//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA

#ifndef __RENDER_H
 #define __RENDER_H

#include "Tipus.h"
#include "Sector.h"
#include "Grafics.h"
#include "Mapa.h"
#include "geometria.h"
#include "definicions.h"
#include "Mates.h"
#include "Scanlines.h"
#include "Llista_Dinamica.h"

/*************\
| DEFINICIONS |
\*************/

#define ERROR  -1

#define BAIX_NIVELL   0
#define LOG2_SUBDIVISIO_PERSPECTIVA 0

#define ES_SOSTRE	1
#define ES_TERRA	0

//#ifdef __SDL__
// RENDER EFFECTS...
//#define __RENDER_RECURSIU__
#define __RENDER_OBJECTES__
#define __RENDER_CEIL__
#define __RENDER_FLOOR__
#define __WITH_MIPMAPS__

#ifdef __SDL__

//#define __WITH_EFFECTS__

#endif

//#endif


 // Opcions efectes pel mapeig de imatge...
#define DECODE_LIGHT(x) ((x) < 0 ? -(x):fx_llum[x][temps])

/********************\
| DEFINICIO DE TIPUS |
\********************/


typedef struct _tComponentsParetSector{

	FIXED32 du1, du2, inc_dudX;
	FIXED32 dz1, dz2, inc_dzdX;

	int y1_sostre,y1_terra,y2_sostre,y2_terra;
	int y1_sostre_connectant, y1_terra_connectant, y2_sostre_connectant, y2_terra_connectant;

	int             Calcul_Perspectiva;
    FIXED32         Z_Med;

	tSector		 *SectorActual,*SectorAdjacent;
	tLiniaSector *LiniaSector,*LiniaAdjacent;


}tComponentsParetSector;











typedef struct{

	short			*ymin,*ymax,*base_ptr_ymin,*base_ptr_ymax;
	s16				x_inicial,x_final;//,y_inicial,y_final;
    s16             y_inicial,y_final;
	short			LiniaInterseccio;
	tPunt_Fixa_2D	Interseccio;
			
}tInfo_Portal,tInfo_Retallat_Vertical;

typedef struct{

	short	*x1,*x2;
	s16		x_inicial,x_final;//,y_inicial,y_final;
			
}tInfo_Retallat_Horitzontal;


/*
typedef struct{

	short	*ymin,*ymax,*base_ptr_ymin,*base_ptr_ymax;
	s16		x_inicial,x_final,y_inicial,y_final;
			
}tInfo_Retallat_Vertical;*/



typedef struct{


	// Informaci de retallat...

	s16		ymin_retallat, ymax_retallat;
    s16 	*x1,		*x2;

	
	short	  ymin_sostre, ymax_sostre, ymin_terra, ymax_terra;

	tInfo_Portal *Retallat_Vertical;
/*	
	short	  y_sostre_actual, y_retallat_sostre_actual, y_sostre_anterior, y_retallat_sostre_anterior,
			  y_terra_actual, y_retallat_terra_actual, y_terra_anterior, y_retallat_terra_anterior;
*/		
}tInfo_Retallat_Terra_Sostre_Sector;

typedef struct _tParametresAssignacioCotes{

	int y_retallat_paret_actual,
		y_retallat_paret_anterior, 
		y_retallat_portal_actual,
		y_retallat_portal_anterior;

	// Informaci de retallat...

	// Retallat horitzontal...
//	s16		ymin_retallat, ymax_retallat;
//    s16 	*x1,		*x2;
		
	short	  y_renderitzacio_inicial,y_renderitzacio_final;//ymin_sostre, ymax_sostre, ymin_terra, ymax_terra;

	tInfo_Retallat_Horitzontal	*Retallat_Horitzontal;
	tInfo_Retallat_Vertical		*Retallat_Vertical;

	tImatge *MipMap;

}tParametresAssignacioCotes;



//typedef struct _tNodeSector ;
typedef struct _tNodeSector *PNodeSector,*PNodeMapa;

typedef struct _tNodeSector{


	tInfo_Portal Info_Retallat_Portal;

	tSector *Sector;

	PNodeSector PAnterior;
	PNodeSector PSeguent;

}tNodeSector,tNodeMapa;


typedef struct{

	tInfo_Portal Info_Retallat_Portal;
	tSector      *Sector;

}tInfoMapa;

typedef struct _tInfoNodeSector{


	tInfo_Portal Info_Retallat_Portal;

	tSector *Sector;

//	PNodeSector PAnterior;
//	PNodeSector PSeguent;

}tInfoNodeSector;//,tNodeMapa;





//typedef struct _tNodeSectorParcialDependent *PNodeSectorParcialDependent;

typedef struct _tInfoNodeSectorParcial{
	int ID_Sector;
	tSector *Sector;
	int x1,x2,primera_linia_sector,ultima_linia_sector;
	tPunt_Fixa_2D Interseccio;
}tInfoNodeSectorParcial;

typedef struct{	
	int			 ID_Ordre; // Ordenat per ordre de dependencia...
	tLlistaNodes LlistaSectorsParcials;
}tSectorParcial;

//
// llista [ ]->[ ]->[ ]->->[]
//         |    |    |
//        [ ]  [ ]  [ ]
//         |   _|_  _|_
//        [ ]
//        _|_
//



/*
typedef struct _tInfoNodeSector2{
	int ID_Sector;
	int x1,x2,Linia_sector_inicial;
	tPunt_Fixa_2D Interseccio_inicial;
}tInfoNodeSector2;*/
/*
typedef struct _tNodeSectorParcialDependent{
	int ID_Sector;
	tInfoNodeSectorParcial InfoNodeSectorParcial;
	PNodeSectorParcialDependent Seguent;
}_tNodeSectorParcialDependent;*/


typedef struct{
	char			Rotated;
	tPunt_Fixa_2D	TransformedVertex;
	char			Projected; // TRUE or FALSE...
	short			x;
//	u8				AngleDireccio;
	FIXED32			dz,XJ,ZJ;

}tCachedVertex;

/*
typedef struct{
	int ID_Sector;
	tInfoNodeSectorParcial *punter_info;
}tSectorParcial;*/



/*
typedef struct _tNodeSectorBase *PNodeSectorBase;

typedef struct _tNodeSectorBase{
	int ID_Sector;
	PNodeSectorParcialDependent LlistaSectorsParcialsDependents;
	PNodeSectorBase				Seguent;
}tNodeSectorBase;*/


/*
typedef struct _tNodeMapa2D *PNodeMapa2D;

typedef struct _tNodeMapa2D{


	tInfo_Portal Info_Retallat_Portal;

	tMapa2D *Mapa2D;

	PNodeMapa2D PAnterior;
	PNodeMapa2D PSeguent;

}tNodeMapa2D;*/

///////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*******************\
| VARIABLES GLOBALS |
\*******************/

//#ifndef __RENDER_RECURSIU__
//extern short   *_ymin, *_ymax;
//#endif
//extern u32 *_ymin, *_ymax, *_x1, *_x2;
extern unsigned char	  temps;
extern tCachedVertex	   *CachedVertexs; // Per tots els vertexs de mapa...
//extern short *_ymin, *_ymax;
//extern short *_x1,   *_x2;
extern const unsigned char fx_llum[3][256];
extern const FIXED32	   div_inversa[MAX_DIST_RENDER];
extern const unsigned char fx_llum[3][256];
extern s16	 VertexsPrecalculats;
extern const int SizeOf_tComponentsPlaSector;





/********\
| MACROS |
\********/


#define Distancia(Xo,Zo,AngleDireccioJugador, Xi, Zi )  (MulFx((Xi) - (Xo),FIXED_DIV_256(_Cosinus[AngleDireccioJugador])) + MulFx(((Zi) - (Zo)),FIXED_DIV_256(_Sinus[AngleDireccioJugador])))

#define Determinar_u1(Linia) (Linia.V0.X == Linia.V1.X) ? (Linia.V0.Z < Linia.V1.Z) ? 0 : Linia.distancia : (Linia.V0.Z == Linia.V1.Z) ? (Linia.V0.X < Linia.V1.X) ? 0 : Linia.distancia : ((Linia.V0.X < Linia.V1.X) && (Linia.V0.Z < Linia.V1.Z)) ? 0 : Linia.distancia

#define Determinar_u2(Linia) (Linia.V0.X == Linia.V1.X) ? (Linia.V0.Z < Linia.V1.Z) ? Linia.distancia : 0 : (Linia.V0.Z == Linia.V1.Z) ? (Linia.V0.X < Linia.V1.X) ? Linia.distancia : 0 : ((Linia.V0.X < Linia.V1.X) && (Linia.V0.Z < Linia.V1.Z)) ? Linia.distancia : 0

#define Seleccio_MIPMAP(mipmap,EscalatX)\
	mipmap = 0;\
	while((EscalatX >> (mipmap+1)) > (1 << PART_FRACCIONAL)) mipmap++;\


//#include "Macros_Assignacio_Cotes.h"
// Minim/Maxim entre dos cotes y sense passar-se de la pantalla...
//#define MIN_RETALLAT(y1,y2) min(min(y1,y2),(s16)(ALTURA_PANTALLA_EFECTIVA-1));
//#define MAX_RETALLAT(y1,y2) max(min((y1),(y2)),0);


//#define SET_RENDER_WITH_BRIGHT(x)   ((x) = (x) | MASK_RENDER_WITH_BRIGHT)
//#define SET_RENDER_WITH_GLENZING(x) ((x) = (x) | MASK_RENDER_WITH_GLENZING)

//#define RENDER_WITH_BRIGHT(x)   ((x) & MASK_RENDER_WITH_BRIGHT)
//#define RENDER_WITH_GLENZING(x) ((x) & MASK_RENDER_WITH_GLENZING)
// More effects...



/**********************************\
| PROTOTIPUS DE FUNCIONS I ACCIONS |
\**********************************/

void CreacioLUTS();

void RENDER_Renderitzar(const tJugador *Jugador, const tSector *Sector);




unsigned Component_U(const tPunt_Fixa_2D *Interseccio,const tLinia *Linia)
#ifndef __RENDER_RECURSIU__
FUNCIO_A_MEMORIA_INTERNA
#endif
;

int EncuarSector(const tInfo_Portal *Info_Retallat_Portal, tSector *Sector,PNodeSector *llista)
/*#ifndef __RENDER_RECURSIU__
FUNCIO_A_MEMORIA_INTERNA
#endif*/
;

int DesencuarSector(PNodeSector Sector_A_Desencuar, PNodeSector *LlistaSector);

int RenderitzarSector(const tInfo_Portal *Info_Retallat, const tJugador *Jugador, const tSector *SectorActual)
#ifndef __RENDER_RECURSIU__
FUNCIO_A_MEMORIA_INTERNA
#endif
;


//void ActualitzarCotesSostre(int x,int y_retallat_sostre,int  y_retallat_sostre_anterior, int y_sostre_actual,int  y_sostre_anterior,tParametresAssignacioCotes *PAC_Sostre) FUNCIO_A_MEMORIA_INTERNA;


//void ActualitzarCotesTerra(int x,int  y_retallat_terra,int  y_retallat_terra_anterior,int  y_terra_actual,int  y_terra_anterior,tParametresAssignacioCotes *PAC_Terra) FUNCIO_A_MEMORIA_INTERNA;

//void LE_Guardar(int ID_Element,void *Info,tLlistaEstatica *Llista) FUNCIO_A_MEMORIA_INTERNA;

void RenderitzarPartSector(int x1, 
						   int x2,
						   const tJugador *Jugador, 
						   const tComponentsParetSector *CPS, 
						   const tInfo_Portal *Info_Retallat_Portal,
						   tInfo_Portal *Info_Retallat_Post_Portal_Paret,
						   tInfo_Retallat_Vertical *RV_Sostre, 
						   tInfo_Retallat_Vertical *RV_Terra) FUNCIO_A_MEMORIA_INTERNA;

void Renderitzar_Pla(const tJugador *Jugador, const tSector *SectorActual, int Tipus,const tInfo_Retallat_Vertical *PAC) 
FUNCIO_A_MEMORIA_INTERNA
;

int RENDER_RecolectaInfoSector
(int x_inicial,
 int x_final,
 const tJugador *Jugador, 
 const tSector *ID_SectorActualCodificat,
 const tSector * ID_SectorAdjacentCodificat,
 tLlistaNodes *LlistaSectorBase) 
#ifndef __RENDER_RECURSIU__
FUNCIO_A_MEMORIA_INTERNA
#endif
;
//(int ID_Sector,int ID_SectorDependent,tInfoNodeSectorParcial  *InfoNodeSectorParcial,tLlistaNodes *LlistaSectorBase) FUNCIO_A_MEMORIA_INTERNA;
void RENDER_EmpilarNodeParcial(int ID_Sector, 
							   tInfoNodeSectorParcial  *InfoNodeSectorParcial, 
							   tLlistaNodes			   *LlistaSectorsAProcessar)
#ifndef __RENDER_RECURSIU__
FUNCIO_A_MEMORIA_INTERNA
#endif
;

//tLlistaEstatica *LE_NovaLlista(int MaxElements) FUNCIO_A_MEMORIA_INTERNA;

//tLlistaNodes *RENDER_LlistaNodesOrganitzats() FUNCIO_A_MEMORIA_INTERNA;





#endif
