////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


#define OFFSET_PRAW_YMIN								0
#define OFFSET_PRAW_YMAX								4
#define OFFSET_PRAW_YMIN_PORTAL_PTR						8
#define OFFSET_PRAW_YMAX_PORTAL_PTR						12
#define OFFSET_PRAW_YMIN_SOSTRE_PTR						16
#define OFFSET_PRAW_YMAX_SOSTRE_PTR						20
#define OFFSET_PRAW_YMIN_TERRA_PTR						24
#define OFFSET_PRAW_YMAX_TERRA_PTR						28
#define OFFSET_PRAW_X									32
#define OFFSET_PRAW_ITERACIONS							36	
#define OFFSET_PRAW_XMIN_PORTAL							40
#define OFFSET_PRAW_XMAX_PORTAL							44	
#define OFFSET_PRAW_XMIN_SOSTRE							48
#define OFFSET_PRAW_YMIN_SOSTRE							52
#define OFFSET_PRAW_XMAX_SOSTRE							56
#define OFFSET_PRAW_YMAX_SOSTRE							60
#define OFFSET_PRAW_XMIN_TERRA							64
#define OFFSET_PRAW_YMIN_TERRA							68
#define OFFSET_PRAW_XMAX_TERRA							72
#define OFFSET_PRAW_YMAX_TERRA							76
#define OFFSET_PRAW_INTENSITAT_SECTOR					80
#define OFFSET_PRAW_TEXTURA_SUPERIOR					84
#define OFFSET_PRAW_TEXTURA_INFERIOR					88
#define OFFSET_PRAW_TEXTURA_PARET						92
#define OFFSET_PRAW_TRACTAR_TERRA						96
#define OFFSET_PRAW_TRACTAR_SOSTRE						100
#define OFFSET_PRAW_VMED								104
#define OFFSET_PRAW_CENTRE_PROJECCIO_Y					108
#define OFFSET_PRAW_SECTOR_ADJACENT						112
#define OFFSET_PRAW_Z									116
#define OFFSET_PRAW_U									120
#define OFFSET_PRAW_YSOSTRE_ACTUAL_FX					124
#define OFFSET_PRAW_YSOSTRE_CONNECTANT_FX				128
#define OFFSET_PRAW_YTERRA_ACTUAL_FX					132
#define OFFSET_PRAW_YTERRA_CONNECTANT_FX				136
#define OFFSET_PRAW_DELTA_Z								140
#define OFFSET_PRAW_DELTA_U								144
#define OFFSET_PRAW_INC_DYDX_SOSTRE_FX					148
#define OFFSET_PRAW_INC_DYDX_SOSTRE_CONNECTANT_FX		152
#define OFFSET_PRAW_INC_DYDX_TERRA_FX					156
#define OFFSET_PRAW_INC_DYDX_TERRA_CONNECTANT_FX		160	
#define OFFSET_PRAW_PROPIETATS_LINIA             		164


#define PTR_PRAW(x)		ptr_PRAW[(x) >> 2]		



//(...)

typedef struct{

	short  *ymin,							// offset 0
		   *ymax,							// offset 4
		   *ymin_portal_ptr,				// offset 8
		   *ymax_portal_ptr,				// offset 12
		   *ymin_sostre_ptr,				// offset 16
		   *ymax_sostre_ptr,				// offset 20
	       *ymin_terra_ptr,					// offset 24
		   *ymax_terra_ptr;					// offset 28
	int		x,								// offset 32
			interacions;					// offset 36
	int		xmin_portal,					// offset 40
			xmax_portal,					// offset 44
            xmin_sostre,					// offset 48
            ymin_sostre,					// offset 52
			xmax_sostre,					// offset 56
            ymax_sostre,					// offset 60
			xmin_terra,						// offset 64
            ymin_terra,						// offset 68
			xmax_terra,						// offset 72
            ymax_terra;						// offset 76
	int     intensitat_sector;				// offset 80
	int     ID_Textura_Superior,			// offset 84
			ID_Textura_Inferior,			// offset 88
			ID_Textura_Paret;				// offset 92
	int		 TractarTerra,					// offset 96
			 TractarSostre;					// offset 100
	FIXED32  vmed,							// offset 104
			 centre_projeccio_y;			// offset 108
	tSector *SectorAdjacent;				// offset 112
	FIXED32  Z,								// offset 116
			 U,                             // offset 120
			 Ysostre_actual_FX,				// offset 124
		     Ysostre_connectant_FX,			// offset 128
		     Yterra_actual_FX,				// offset 132
			 Yterra_connectant_FX;			// offset 136
	FIXED32	 DeltaZ,						// offset 140
			 DeltaU,						// offset 144
			 inc_dYdX_Sostre_FX,			// offset 148
			 inc_dYdX_Sostre_Connectant_FX,	// offset 152
			 inc_dYdX_Terra_FX,				// offset 156
		     inc_dYdX_Terra_Connectant_FX;	// offset 160
	int		 Propietats_Linia,              // offset 164
             ymin_proba,                    // offset 168
             ymax_proba;                    // offset 172




	
	
}tParametresRenderAffineWall;

#ifdef __HAM__
inline extern void ARM_RenderAffineWall(tParametresRenderAffineWall *PRAW);
#endif


#ifdef __RENDER_RECURSIU__
FUNCIO_A_MEMORIA_INTERNA
#endif
void C_RenderAffineWall(tParametresRenderAffineWall *PRAW)
{
	// Parametres
	// ----------
	//
	// r0 : Punter a l'estructura PRAW (ParametresRenderAffineWall)
	//

	int		y_retallat_sostre_actual,							// r1
			y_retallat_terra_actual,							// r2
			intensitat_llinterna,intensitat_total,				// r3
			y1,Ysostre_actual,Yterra_connectant,ymin_portal,	// r4 (Ysostre_actual o Yterra_connectant)
			y2,Ysostre_connectant,Yterra_actual,ymax_portal;	// r5 (Ysostre_connectant o Yterra_actual)

	FIXED32	Z,Escale_v_FX;										// r6

	int		x, Propietats;//,    									// r7
//			ID_Textura;											// r8

	int		u1,/*,xmin_portalxmin_sostre,*/xmax_sostre,ymin_sostre,ymax_sostre,	// r9
			v1,xmax_portal/*,xmin_terra */,xmax_terra ,ymin_terra ,ymax_terra;	// r10

	void	*void_ptr;											 // r11 (MipMap, ymin_portal_ptr, ymax_portal_ptr, SectorAdjacent, etc)
	int		 aux1,												 // r12 
			 aux2;												 // r14 

	tParametresPintarParet2  PPP;
	int						 *ptr_PRAW	= (int *)PRAW; // Es tractar PRAW com un vector lineal.
//	tParametresRenderAffineWall *Local_PRAW = PRAW;

	
//	
	
	

	// preservaci del registre r0 durant tot el tractament!!!
	// r0 : ED punter de parametres affine.

	    
//		if(PRAW->interacions > 0)
//		{
			
			do
			{
				
				// +2 registres (retallat sostre/actual)
				// +2 registres de carrega + actualitzat retallat...
				void_ptr					= (short *)PTR_PRAW(OFFSET_PRAW_YMIN);// >> 2];
				y_retallat_sostre_actual	=*((short *)void_ptr);
//				PTR_PRAW(OFFSET_PRAW_YMIN)	= ((short *)void_ptr)+1;
				
				//y_retallat_sostre_actual  =  *((short *)void_ptr);
				
				//y_retallat_terra_actual   =  *(PRAW->ymax++);
				void_ptr					= (short *)PTR_PRAW(OFFSET_PRAW_YMAX);// >> 2];//->ymax;
				y_retallat_terra_actual		=*((short *)void_ptr);
//				PTR_PRAW(OFFSET_PRAW_YMAX)	= ((short *)void_ptr)+1;
				// -2 registres --> Total registres: utilitzats 3!
				
				if(y_retallat_sostre_actual <= y_retallat_terra_actual) // ok! Es pot pintar alguna cosa :)
				{
						
										
					// Necessito Z, per obtenir escalat i iluminaci (+2  registres)....
										
					// Escalat (+1 reg.)...

					Z = PTR_PRAW(OFFSET_PRAW_Z);//->Z;
//					
//#ifdef __ARITMETICA_FIXA__
//					
//#ifdef __HAM__	    // rpida divis entre 60...
//					Escale_v_FX = FIXED_MUL_256(Z);
//					FIXED_DIV_120(Escale_v_FX);
//					//				Escale_v_FX = Escale_v;
//#else
//					Escale_v_FX = FIXED_MUL_256(Z)/(d);//altura_paret_16_16/(Yterra_actual - Ysostre_actual);// no tant rpida per s ms precisa...
//					
//#endif
//					Escale_v_FX <<= DETALL_GRAFIC_Y;
//					
//					//				Escale_v_FX = Escale_v;
//					
//#else
//					Escale_v = FIXED_MUL_256(Z)/(d) *(1 << DETALL_GRAFIC_Y);//altura_paret_16_16/(Yterra_actual - Ysostre_actual);
//					Escale_v_FX = (long)(Escale_v*(1 << PART_FRACCIONAL));
//					
//#endif
					
					
					// op. per illumianci (necessari +1 reg aux)...
					intensitat_llinterna = INT_TO_FIXED(MAXIMA_ILUMINACIO_LLINTERNA);
					intensitat_llinterna = intensitat_llinterna - FIXED_DIV_16(Z);
					intensitat_llinterna = FIXED_TO_INT(intensitat_llinterna);
					 
					if(intensitat_llinterna < 0) intensitat_llinterna = 0;
					if(intensitat_llinterna > MINIMA_DISTANCIA_LLINTERNA) intensitat_llinterna = MAXIMA_ILUMINACIO_LLINTERNA;


					aux1 = PTR_PRAW(OFFSET_PRAW_INTENSITAT_SECTOR);//->intensitat_sector;
					intensitat_total = intensitat_llinterna + aux1;
					
					if(intensitat_total >  MAXIMA_INTENSITAT) intensitat_total = MAXIMA_INTENSITAT;
					//else intensitat_total = intensitat_llinterna;
					
					
					
					// Ja no necessito ms Z (-1 registre)!!!
					
					// Total registres utilitzats = 5!
					
					// Carregar dels quatre tipus de cotes Y + actualitzaci + guardat i sector adjacent (+1 registres)!!!!
					void_ptr			= (tSector *)PTR_PRAW(OFFSET_PRAW_SECTOR_ADJACENT);//->SectorAdjacent;

			
					if(void_ptr != NULL)	// s portal --> renderitzem tires de paret inferior/superior
					{

						// ok ja no necessito SectorAdjacent (-1 reg).
						// Total registres utilitzats: 5!

						// Necessito +2 reg.
						Ysostre_actual		    = PTR_PRAW(OFFSET_PRAW_YSOSTRE_ACTUAL_FX);//->Ysostre_actual_FX);					
						Ysostre_connectant		= PTR_PRAW(OFFSET_PRAW_YSOSTRE_CONNECTANT_FX);//->Ysostre_connectant_FX);
						Ysostre_actual			= CEIL_FX(Ysostre_actual);
						Ysostre_connectant		= CEIL_FX(Ysostre_connectant);						// Total registres utilitzats: 7!


						//if(((Ysostre_connectant >= y_retallat_sostre_actual) && (Ysostre_connectant > Ysostre_actual))) // { Renderitzem tira superior }
						if(Ysostre_actual < Ysostre_connectant)//((Ysostre_connectant >= y_retallat_sostre_actual) && (Ysostre_connectant > Ysostre_actual))) // { Renderitzem tira superior }
						{
							// Puc utilitzar els registres de sostre_actual + connectant per determinar cotes...
							y1 = max(Ysostre_actual,y_retallat_sostre_actual);
							y2 = min(Ysostre_connectant-1,y_retallat_terra_actual);

							
							if(y1 <= y2)
							{
								
										Z = PTR_PRAW(OFFSET_PRAW_Z);//PRAW->Z;

#ifdef __HAM__	    // rpida divis entre 60...
										Escale_v_FX = FIXED_MUL_256(Z);
										FIXED_DIV_120(Escale_v_FX);
										//				Escale_v_FX = Escale_v;
#else
										Escale_v_FX = FIXED_MUL_256(Z)/(d);//altura_paret_16_16/(Yterra_actual - Ysostre_actual);// no tant rpida per s ms precisa...
										
#endif
	                                   void_ptr = (char *)Textura;
                                       aux1 = PTR_PRAW(OFFSET_PRAW_TEXTURA_SUPERIOR);
                                       
                                       if(aux1 >= 0)
                                       {

                                        aux2 = Sizeof_tTextura;
                                        aux1 = aux1*aux2;
                                        void_ptr = ((char *)void_ptr + aux1);
                                        Propietats =  (int)((char *)void_ptr)[0x4*2]; // Lectura de les propietats d'imatge;
                                       


																													
										// Total registres utilitzats: 11! --> (recorda que no pots utilitzar r15, r13, r14)


											//v1   = v_med;		// Ja no necessito v_med! (-1 reg)
											 // Ja no necessites centre_y_proj
											//centre_y = centre_y*Escale_v_FX;

											// carrega de vmed ! (+1 reg: op. load + add)
											aux1       = PTR_PRAW(OFFSET_PRAW_VMED);//PRAW->vmed;
											v1         = aux1;
										
                                            if(TST_BIT(Propietats,BIT_IS_VPOW2))  // Necessari per evitar els problemes de perspectiva.
                                            {
                                                aux1  = PTR_PRAW(OFFSET_PRAW_CENTRE_PROJECCIO_Y);//PRAW->centre_projeccio_y;
                                                aux1		= (y1 - aux1); 
                                                aux1        = aux1*Escale_v_FX; // ok --> no necessito centre_y (-1 reg), per aix v1 utilitzar el mateix registre que centre_y !!!

                                                v1		    = v1 + aux1; // ok --> no necessito centre_y (-1 reg), per aix v1 utilitzar el mateix registre que centre_y !!!
                                                
                                                
                                                //	v1   = *(y1 - CENTRE_Y2D_EFECTIU + Jugador->Horitzo)); // Ja no necessito centre_y_projeccio!!!
                                                //	v1		>>= MIPmap_Adequat;
                                            }
									//	else
									//	{
									//		//v1 = 
									//		//v1   = (Escale_v_FX*(y1 - centre_y_projeccio
//
//											v1 =  centre_y;
//										}
//
										

										// Ja no necessito centre_y_projeccio + vmed! (-2 reg.)

										// Total registres utilitzats: 11!

										// Carrega de + enmascarat U (1 reg. +1 reg auxiliar)
										
										u1	= PTR_PRAW(OFFSET_PRAW_U);//PRAW->U;

                                       }
//										}
//
										

										// Ja no necessito masc_u, ni propietats (-2 regs.)

										// Total registres utilitzats: 11!

										// +1 reg per obtenir escalat!!!
										//
										// Ja no necessito MIPmap_Adequat!!!
										// Carrega de x!!!
										// Total registres utilitzats: 12!
										// x = PRAW->x;

//typedef struct _tParametresPintarParet{  // Cal canviar el nom per un de ms generic, pintar_tira, per exemple, ja que la funci pinta paisatges, sprites i blocks...
//
//	int				x,y1,y2,u1;
//	long			v1, Escale_v;
//	tImatge			*MipMap;
//	unsigned int	Intensitat;
//	unsigned int    Color_Mascara; --> Global!!!
//
//}tParametresPintarParet;
										
										//u1			= u1 >> MIPmap_Adequat;
										x		    = PTR_PRAW(OFFSET_PRAW_X);//PRAW->x;

										// Preguardar registres r0-r12,r14 !!!!!
										// Empilar segents variables a r0!!!

										PPP.x          = x;
										PPP.y1         = y1;
										PPP.y2         = y2;
										PPP.v1         = v1 << DETALL_GRAFIC_Y;
										PPP.u1         = u1;
										PPP.Escale_v   = Escale_v_FX << DETALL_GRAFIC_Y;
										PPP.ID_Textura         = PTR_PRAW(OFFSET_PRAW_TEXTURA_SUPERIOR);
                                        PPP.Propietats_Objecte = PTR_PRAW(OFFSET_PRAW_PROPIETATS_LINIA);
										PPP.Intensitat = intensitat_total;

										// Total registres utilitzats: 11!
										
										// ok!, ja disposo de tots els parametres --> GUARDAT ALS PARAMETRES A L'ED!!!!!
										
										// Empilar registres r0-r12, r14, i guardar parametres empilats per r0!!!

										
										

										//Escale_v = (Escale_v_FX >> MIPmap_Adequat);
										//u_paret = CEIL_FX(PRAW->U);// & Mascara_u_Paret;
										
										//								PPP.Intensitat = RENDER_WITH_BRIGHT(MipMap->Propietats) ? intensitat_total : MAXIMA_INTENSITAT;
										//PPP.MipMap = MipMap;
										
										//PintarParet(PPP);
										PutVerticalSlice(&PPP);
									
								}

								void_ptr = (short *)PTR_PRAW(OFFSET_PRAW_YMIN_PORTAL_PTR);//PRAW->ymin_portal_ptr;
								//aux2 = (Ysostre_connectant+1);
								aux1 = max(Ysostre_connectant,y_retallat_sostre_actual);
								*((short *)void_ptr) = aux1;
								// Actualitzem retallats!!!!

							//}
						}
						else // No renderitza tira superior --> noms actualitzem retallats!!!
						{

							void_ptr = (void *)PTR_PRAW(OFFSET_PRAW_YMIN_PORTAL_PTR);//PRAW->ymin_portal_ptr;
							aux1 = max(Ysostre_actual,y_retallat_sostre_actual);
							*((short *)void_ptr) = aux1;
						}

						


						//Yterra_actual			= CEIL_FX(PRAW->Yterra_actual_FX);	
						//Yterra_connectant		= CEIL_FX(PRAW->Yterra_connectant_FX);

					
						Yterra_connectant	= PTR_PRAW(OFFSET_PRAW_YTERRA_CONNECTANT_FX);//PRAW->Yterra_connectant_FX);		
						Yterra_actual		= PTR_PRAW(OFFSET_PRAW_YTERRA_ACTUAL_FX);//PRAW->Yterra_actual_FX);	

						Yterra_connectant	= CEIL_FX(Yterra_connectant);//PRAW->Yterra_connectant_FX);		
						Yterra_actual		= CEIL_FX(Yterra_actual);//PRAW->Yterra_actual_FX);	


						

						if(Yterra_connectant < Yterra_actual)//(Yterra_actual <= y_retallat_terra_actual && (Yterra_actual > Yterra_connectant))) // { Renderitzem tira inferior }
						{
							
							y1 = max((Yterra_connectant+1),y_retallat_sostre_actual);
							y2 = min(Yterra_actual,y_retallat_terra_actual);

				
							if(y1 <= y2)
							{
								
										Z = PTR_PRAW(OFFSET_PRAW_Z);//PRAW->Z;

#ifdef __HAM__	    // rpida divis entre 60...
										Escale_v_FX = FIXED_MUL_256(Z);
										FIXED_DIV_120(Escale_v_FX);
										//				Escale_v_FX = Escale_v;
#else
										Escale_v_FX = FIXED_MUL_256(Z)/(d);//altura_paret_16_16/(Yterra_actual - Ysostre_actual);// no tant rpida per s ms precisa...
										
#endif
	                                   void_ptr = (char *)Textura;
                                       aux1 = PTR_PRAW(OFFSET_PRAW_TEXTURA_INFERIOR);
                                       
                                       if(aux1 >= 0)
                                       {

                                        aux2 = Sizeof_tTextura;
                                        aux1 = aux1*aux2;
                                        void_ptr = ((char *)void_ptr + aux1);
                                        Propietats =  (int)((char *)void_ptr)[0x4*2]; // Lectura de les propietats d'imatge;
                                       


																													
										// Total registres utilitzats: 11! --> (recorda que no pots utilitzar r15, r13, r14)


											//v1   = v_med;		// Ja no necessito v_med! (-1 reg)
											 // Ja no necessites centre_y_proj
											//centre_y = centre_y*Escale_v_FX;

											// carrega de vmed ! (+1 reg: op. load + add)
											aux1       = PTR_PRAW(OFFSET_PRAW_VMED);//PRAW->vmed;
											v1         = aux1;
										
                                            if(TST_BIT(Propietats,BIT_IS_VPOW2))  // Necessari per evitar els problemes de perspectiva.
                                            {
                                                aux1  = PTR_PRAW(OFFSET_PRAW_CENTRE_PROJECCIO_Y);//PRAW->centre_projeccio_y;
                                                aux1		= (y1 - aux1); 
                                                aux1        = aux1*Escale_v_FX; // ok --> no necessito centre_y (-1 reg), per aix v1 utilitzar el mateix registre que centre_y !!!

                                                v1		    = v1 + aux1; // ok --> no necessito centre_y (-1 reg), per aix v1 utilitzar el mateix registre que centre_y !!!
                                                
                                                
                                                //	v1   = *(y1 - CENTRE_Y2D_EFECTIU + Jugador->Horitzo)); // Ja no necessito centre_y_projeccio!!!
                                                //	v1		>>= MIPmap_Adequat;
                                            }
									//	else
									//	{
									//		//v1 = 
									//		//v1   = (Escale_v_FX*(y1 - centre_y_projeccio
//
//											v1 =  centre_y;
//										}
//
										

										// Ja no necessito centre_y_projeccio + vmed! (-2 reg.)

										// Total registres utilitzats: 11!

										// Carrega de + enmascarat U (1 reg. +1 reg auxiliar)
										
										u1	= PTR_PRAW(OFFSET_PRAW_U);//PRAW->U;

                                       }
//										}
//
										

										// Ja no necessito masc_u, ni propietats (-2 regs.)

										// Total registres utilitzats: 11!

										// +1 reg per obtenir escalat!!!
										//
										// Ja no necessito MIPmap_Adequat!!!
										// Carrega de x!!!
										// Total registres utilitzats: 12!
										// x = PRAW->x;

//typedef struct _tParametresPintarParet{  // Cal canviar el nom per un de ms generic, pintar_tira, per exemple, ja que la funci pinta paisatges, sprites i blocks...
//
//	int				x,y1,y2,u1;
//	long			v1, Escale_v;
//	tImatge			*MipMap;
//	unsigned int	Intensitat;
//	unsigned int    Color_Mascara; --> Global!!!
//
//}tParametresPintarParet;
										
										//u1			= u1 >> MIPmap_Adequat;
										x		    = PTR_PRAW(OFFSET_PRAW_X);//PRAW->x;

										// Preguardar registres r0-r12,r14 !!!!!
										// Empilar segents variables a r0!!!

										PPP.x          = x;
										PPP.y1         = y1;
										PPP.y2         = y2;
										PPP.v1         = v1 << DETALL_GRAFIC_Y;
										PPP.u1         = u1;
										PPP.Escale_v   = Escale_v_FX << DETALL_GRAFIC_Y;
										PPP.ID_Textura         = PTR_PRAW(OFFSET_PRAW_TEXTURA_INFERIOR);
                                        PPP.Propietats_Objecte = PTR_PRAW(OFFSET_PRAW_PROPIETATS_LINIA);
										PPP.Intensitat = intensitat_total;

										// Total registres utilitzats: 11!
										
										// ok!, ja disposo de tots els parametres --> GUARDAT ALS PARAMETRES A L'ED!!!!!
										
										// Empilar registres r0-r12, r14, i guardar parametres empilats per r0!!!

										
										

										//Escale_v = (Escale_v_FX >> MIPmap_Adequat);
										//u_paret = CEIL_FX(PRAW->U);// & Mascara_u_Paret;
										
										//								PPP.Intensitat = RENDER_WITH_BRIGHT(MipMap->Propietats) ? intensitat_total : MAXIMA_INTENSITAT;
										//PPP.MipMap = MipMap;
										
										//PintarParet(PPP);
										PutVerticalSlice(&PPP);
							}
					
							void_ptr = (short *)PTR_PRAW(OFFSET_PRAW_YMAX_PORTAL_PTR);//PRAW->ymax_portal_ptr;
							//aux2 = y1-1;
							aux1 = min(Yterra_connectant,y_retallat_terra_actual);
							*((short *)void_ptr) = aux1;
						
						}
						else // Noms cal guardar retallat mxim...
						{	
							
							void_ptr = (short *)PTR_PRAW(OFFSET_PRAW_YMAX_PORTAL_PTR);//PRAW->ymax_portal_ptr;
							aux1 = min(Yterra_actual,y_retallat_terra_actual);
							*((short *)void_ptr) = aux1;
														
						}


//						goto Evaluar_Terra_Sostre;
						
						
//						*ymin_portal_ptr = min(max(max(Ysostre_actual, Ysostre_connectant),y_retallat_sostre_actual),(s16)(ALTURA_PANTALLA_EFECTIVA-1));
//						*ymax_portal_ptr = max(min(min(Yterra_actual, Yterra_connectant)  ,y_retallat_terra_actual),0);
						
						// Info de portal retallat recursiu...
						
						void_ptr    = (short *)PTR_PRAW(OFFSET_PRAW_YMIN_PORTAL_PTR);//PRAW->ymin_portal_ptr;
						ymin_portal	= *((short *)void_ptr);

						void_ptr    = (short *)PTR_PRAW(OFFSET_PRAW_YMAX_PORTAL_PTR);//PRAW->ymax_portal_ptr;
						ymax_portal	= *((short *)void_ptr);//*PRAW->ymax_portal_ptr;
						
						
						
						if(ymin_portal <= ymax_portal) // Existeix portal...
						{	
							xmax_portal	= PTR_PRAW(OFFSET_PRAW_XMAX_PORTAL);//PRAW->xmax_portal;
//							xmax_portal = 
							x = PTR_PRAW(OFFSET_PRAW_X);//PRAW->x;
							
							if(xmax_portal == -1)
							{// Cal inicialitzar cotes x ...
								
								//PRAW->xmin_portal = x;
								//PRAW->xmax_portal = x;
								PTR_PRAW(OFFSET_PRAW_XMIN_PORTAL) = x;
								PTR_PRAW(OFFSET_PRAW_XMAX_PORTAL) = x;

							}
							else
							{
								// Actualitzem cota final
								//PRAW->xmax_portal = x;
								PTR_PRAW(OFFSET_PRAW_XMAX_PORTAL) = x;
							}
						}
						
						// Seguent actualitzaci punter per segent valor...
					}
					else // Renderitzem noms paret...
					{

						Ysostre_actual		= PTR_PRAW(OFFSET_PRAW_YSOSTRE_ACTUAL_FX);//CEIL_FX(PRAW->Ysostre_actual_FX);		
						Yterra_actual		= PTR_PRAW(OFFSET_PRAW_YTERRA_ACTUAL_FX);//CEIL_FX(PRAW->Yterra_actual_FX);	

						Ysostre_actual = CEIL_FX(Ysostre_actual); 
						Yterra_actual  = CEIL_FX(Yterra_actual);
												
					
						y1 = max(y_retallat_sostre_actual,Ysostre_actual);
						y2 = min(y_retallat_terra_actual,Yterra_actual);
						
						
						if(y1 <= y2)
						{
							
						//	if(LiniaSector->Textura_Paret < 0)
						//	{
						//		PintarTiraParet_amb_un_color(x,PPP.y1,PPP.y2,Shade[((abs(LiniaSector->Textura_Paret)&0xFF)<< 8) + intensitat_total]);
						//	}
						//	else
						//	{

								
								//if(void_ptr != NULL)
								//{
									//if(void_ptr != NULL) // Vol dir que podem pintar!!! 
									{
										// Total registres utilitzats: 8!
										//
										// Carrega de parametres Textura!!!!
										//
										
										// Necessito 1 registre (+1 reg auxiliar) !!!
										Z = PTR_PRAW(OFFSET_PRAW_Z);//PRAW->Z;

#ifdef __HAM__	    // rpida divis entre 60...
										Escale_v_FX = FIXED_MUL_256(Z);
										FIXED_DIV_120(Escale_v_FX);
										//				Escale_v_FX = Escale_v;
#else
										Escale_v_FX = FIXED_MUL_256(Z)/(d);//altura_paret_16_16/(Yterra_actual - Ysostre_actual);// no tant rpida per s ms precisa...
										
#endif
	                                   void_ptr = (char *)Textura;
                                       aux1 = PTR_PRAW(OFFSET_PRAW_TEXTURA_PARET);
                                       
                                       if(aux1 >= 0)
                                       {

                                        aux2 = Sizeof_tTextura;
                                        aux1 = aux1*aux2;
                                        void_ptr = ((char *)void_ptr + aux1);
                                        Propietats =  (int)((char *)void_ptr)[0x4*2]; // Lectura de les propietats d'imatge;
                                       


																													
										// Total registres utilitzats: 11! --> (recorda que no pots utilitzar r15, r13, r14)


											//v1   = v_med;		// Ja no necessito v_med! (-1 reg)
											 // Ja no necessites centre_y_proj
											//centre_y = centre_y*Escale_v_FX;

											// carrega de vmed ! (+1 reg: op. load + add)
											aux1       = PTR_PRAW(OFFSET_PRAW_VMED);//PRAW->vmed;
											v1         = aux1;
										
                                            if(TST_BIT(Propietats,BIT_IS_VPOW2))  // Necessari per evitar els problemes de perspectiva.
                                            {
                                                aux1  = PTR_PRAW(OFFSET_PRAW_CENTRE_PROJECCIO_Y);//PRAW->centre_projeccio_y;
                                                aux1		= (y1 - aux1); 
                                                aux1        = aux1*Escale_v_FX; // ok --> no necessito centre_y (-1 reg), per aix v1 utilitzar el mateix registre que centre_y !!!
                                                v1          = aux1 + v1;
                                                
                                                
                                                //	v1   = *(y1 - CENTRE_Y2D_EFECTIU + Jugador->Horitzo)); // Ja no necessito centre_y_projeccio!!!
                                                //	v1		>>= MIPmap_Adequat;
                                            }
									//	else
									//	{
									//		//v1 = 
									//		//v1   = (Escale_v_FX*(y1 - centre_y_projeccio
//
//											v1 =  centre_y;
//										}
//
										

										// Ja no necessito centre_y_projeccio + vmed! (-2 reg.)

										// Total registres utilitzats: 11!

										// Carrega de + enmascarat U (1 reg. +1 reg auxiliar)
										
										u1	= PTR_PRAW(OFFSET_PRAW_U);//PRAW->U;

                                       }
//										}
//
										

										// Ja no necessito masc_u, ni propietats (-2 regs.)

										// Total registres utilitzats: 11!

										// +1 reg per obtenir escalat!!!
										//
										// Ja no necessito MIPmap_Adequat!!!
										// Carrega de x!!!
										// Total registres utilitzats: 12!
										// x = PRAW->x;

//typedef struct _tParametresPintarParet{  // Cal canviar el nom per un de ms generic, pintar_tira, per exemple, ja que la funci pinta paisatges, sprites i blocks...
//
//	int				x,y1,y2,u1;
//	long			v1, Escale_v;
//	tImatge			*MipMap;
//	unsigned int	Intensitat;
//	unsigned int    Color_Mascara; --> Global!!!
//
//}tParametresPintarParet;
										
										//u1			= u1 >> MIPmap_Adequat;
										x		    = PTR_PRAW(OFFSET_PRAW_X);//PRAW->x;

										// Preguardar registres r0-r12,r14 !!!!!
										// Empilar segents variables a r0!!!

										PPP.x          = x;
										PPP.y1         = y1;
										PPP.y2         = y2;
										PPP.v1         = v1 << DETALL_GRAFIC_Y;
										PPP.u1         = u1;
										PPP.Escale_v   = Escale_v_FX << DETALL_GRAFIC_Y;
										PPP.ID_Textura         = PTR_PRAW(OFFSET_PRAW_TEXTURA_PARET);
                                        PPP.Propietats_Objecte = PTR_PRAW(OFFSET_PRAW_PROPIETATS_LINIA);
										PPP.Intensitat = intensitat_total;

										// Total registres utilitzats: 11!
										
										// ok!, ja disposo de tots els parametres --> GUARDAT ALS PARAMETRES A L'ED!!!!!
										
										// Empilar registres r0-r12, r14, i guardar parametres empilats per r0!!!

										
										

										//Escale_v = (Escale_v_FX >> MIPmap_Adequat);
										//u_paret = CEIL_FX(PRAW->U);// & Mascara_u_Paret;
										
										//								PPP.Intensitat = RENDER_WITH_BRIGHT(MipMap->Propietats) ? intensitat_total : MAXIMA_INTENSITAT;
										//PPP.MipMap = MipMap;
										
										//PintarParet(PPP);
										PutVerticalSlice(&PPP);
										}
									}
									
								//}
						//	}
						}
					}

//Evaluar_Terra_Sostre:
					
					aux1 = PTR_PRAW(OFFSET_PRAW_TRACTAR_SOSTRE);//PRAW->TractarSostre;
				
					if(aux1) // punter_retallat != NULL --> tractem sostre
					{
						//
						// Carrega de registres!!!!
						//

						Ysostre_actual	= PTR_PRAW(OFFSET_PRAW_YSOSTRE_ACTUAL_FX);//CEIL_FX(PRAW->Ysostre_actual_FX);
						Ysostre_actual  = CEIL_FX(Ysostre_actual);
						
						
						//y2		= CEIL_FX(PRAW->Yterra_actual_FX);
						
						
						if(y_retallat_sostre_actual < Ysostre_actual) // retallat vlid...
						{
							x               = PTR_PRAW(OFFSET_PRAW_X);//PRAW->x;

							// Actualitzaci buffer...

							
							//if(*ymin_portal_ptr <= *ymax_portal_ptr) // Existeix portal...
							xmax_sostre = PTR_PRAW(OFFSET_PRAW_XMAX_SOSTRE);
							
							if(xmax_sostre == -1)
							{// Cal inicialitzar cotes x ...
								//PRAW->xmin_sostre = PRAW->xmax_sostre = x;
								PTR_PRAW(OFFSET_PRAW_XMIN_SOSTRE) = x;
								PTR_PRAW(OFFSET_PRAW_XMAX_SOSTRE) = x;
								

							}
							else
							{// Actualitzem cota final
								//PRAW->xmax_sostre = x;
								PTR_PRAW(OFFSET_PRAW_XMAX_SOSTRE) = x;
							}
							

							void_ptr = (short *)PTR_PRAW(OFFSET_PRAW_YMIN_SOSTRE_PTR);//PRAW->ymin_sostre_ptr;
							*((short *)void_ptr) = y_retallat_sostre_actual;

							//if(y_retallat_sostre_actual < Ysostre_actual && Ysostre_actual <= y_retallat_terra_actual)
							void_ptr = (short *)PTR_PRAW(OFFSET_PRAW_YMAX_SOSTRE_PTR);//(PRAW->ymax_sostre_ptr);
							aux2     = (Ysostre_actual-1);
							aux1     = min(aux2,y_retallat_terra_actual);
							*((short *)void_ptr) = aux1;

                            // Actualitzem y1 quadrat retallat ...
                            
                            ymin_sostre = PTR_PRAW(OFFSET_PRAW_YMIN_SOSTRE);
                            ymax_sostre = PTR_PRAW(OFFSET_PRAW_YMAX_SOSTRE);

                            if(ymax_sostre == -1) // Cal inicialitzar...
                            {
                                // ymin & ymax
                                PTR_PRAW(OFFSET_PRAW_YMIN_SOSTRE) = y_retallat_sostre_actual;//PRAW->ymin_sostre_ptr;
							    PTR_PRAW(OFFSET_PRAW_YMAX_SOSTRE) = aux1;

                            }
                            else // actualitzem...
                            {                            
                                y1 = min(ymin_sostre,y_retallat_sostre_actual);
                                y2 = max(ymax_sostre,aux1);

                                PTR_PRAW(OFFSET_PRAW_YMIN_SOSTRE) = y1;
                                PTR_PRAW(OFFSET_PRAW_YMAX_SOSTRE) = y2;


                            }


							//else
							//	*ymax_sostre_ptr = y_retallat_terra_actual;
							
							

						}
						else // Invlid...
						{

						  //(PRAW->ymin_sostre_ptr) = ALTURA_PANTALLA_EFECTIVA;
						  //(PRAW->ymax_sostre_ptr) = -1;
							void_ptr = (short *)PTR_PRAW(OFFSET_PRAW_YMIN_SOSTRE_PTR);//(PRAW->ymin_sostre_ptr);
							aux1	 = ALTURA_PANTALLA_EFECTIVA;
							*((short *)void_ptr) = aux1;//y_retallat_sostre_actual - 1;

							void_ptr = (short *)PTR_PRAW(OFFSET_PRAW_YMAX_SOSTRE_PTR);//(PRAW->ymax_sostre_ptr);
							aux1 = -1;
							*((short *)void_ptr) = aux1;//y_retallat_sostre_actual - 1;

							
						}
						

					}
				
				
					aux1 = PTR_PRAW(OFFSET_PRAW_TRACTAR_TERRA);//PRAW->TractarTerra;

					if(aux1)
					{
						//
						// Una altre carrega de registres!!!!
						//
						Yterra_actual	= PTR_PRAW(OFFSET_PRAW_YTERRA_ACTUAL_FX);//CEIL_FX(PRAW->Yterra_actual_FX);
						Yterra_actual   = CEIL_FX(Yterra_actual); 
						
											
						// Actualitzaci buffer...
						
						if(Yterra_actual < y_retallat_terra_actual) // retallat vlid...
						{
							x               = PTR_PRAW(OFFSET_PRAW_X);//PRAW->x;
							xmax_terra      = PTR_PRAW(OFFSET_PRAW_XMAX_TERRA);
							
							if(xmax_terra == -1)
							{// Cal inicialitzar cotes x ...
								
								PTR_PRAW(OFFSET_PRAW_XMIN_TERRA) = x;
								PTR_PRAW(OFFSET_PRAW_XMAX_TERRA) = x;
								//PRAW->xmin_terra = PRAW->xmax_terra = x;
							}
							else
							{// Actualitzem cota final
								
								//PRAW->xmax_terra = x;
								PTR_PRAW(OFFSET_PRAW_XMAX_TERRA) = x;
							}
							
							
							//if( y_retallat_sostre_actual <= Yterra_actual)

							aux2 = (Yterra_actual+1);
							aux1 = max(aux2,y_retallat_sostre_actual);

							void_ptr = (short *)PTR_PRAW(OFFSET_PRAW_YMIN_TERRA_PTR);//PRAW->ymin_terra_ptr;
							*((short *)void_ptr) = aux1;

							void_ptr = (short *)PTR_PRAW(OFFSET_PRAW_YMAX_TERRA_PTR);//PRAW->ymax_terra_ptr;
							*((short *)void_ptr) = y_retallat_terra_actual;


                           // Actualitzem y1 quadrat retallat ...
                            
                            ymin_terra = PTR_PRAW(OFFSET_PRAW_YMIN_TERRA);
                            ymax_terra = PTR_PRAW(OFFSET_PRAW_YMAX_TERRA);

                            if(ymax_terra == -1) // Cal inicialitzar...
                            {
                                // ymin & ymax
                                PTR_PRAW(OFFSET_PRAW_YMIN_TERRA) = aux1;//PRAW->ymin_sostre_ptr;
							    PTR_PRAW(OFFSET_PRAW_YMAX_TERRA) = y_retallat_terra_actual;

                            }
                            else // actualitzem...
                            {                            
                                y1 = min(ymin_terra,aux1);
                                y2 = max(ymax_terra,y_retallat_terra_actual);

                                PTR_PRAW(OFFSET_PRAW_YMIN_TERRA) = y1;
                                PTR_PRAW(OFFSET_PRAW_YMAX_TERRA) = y2;

                            }

							
							
					
							
							
							
						}
						else // el fem invlid !
						{
						//	if(xmax_terra != -1 && x == 99)
						//	{

//								*PRAW->ymin_terra_ptr = ALTURA_PANTALLA_EFECTIVA;//y_retallat_terra_actual + 1;
//								*PRAW->ymax_terra_ptr = -1;//y_retallat_terra_actual + 1;

							void_ptr = (short *)PTR_PRAW(OFFSET_PRAW_YMIN_TERRA_PTR);//(PRAW->ymin_terra_ptr);
							aux1 = ALTURA_PANTALLA_EFECTIVA;
							*((short *)void_ptr) = aux1;//y_retallat_sostre_actual - 1;

							void_ptr = (short *)PTR_PRAW(OFFSET_PRAW_YMAX_TERRA_PTR);//(PRAW->ymax_terra_ptr);
							aux1 = -1;
							*((short *)void_ptr) = aux1;//y_retallat_sostre_actual - 1;

						//	}
							
						}
						

					}
	
				//}
                //}
				
				// Actualitzat de vectors y pel retallat vertical en cas que terra/sostre siguin un portal...
			


				// 1era MEGA CARREGA + INCREMENTS CONSTANTS + GUARDAT DE REGISTRES (es necessari 12 registres) !!!!
				/*PRAW->Ysostre_actual_FX     = PRAW->Ysostre_actual_FX		+ PRAW->inc_dYdX_Sostre_FX;
				PRAW->Yterra_actual_FX      = PRAW->Yterra_actual_FX		+ PRAW->inc_dYdX_Terra_FX;
				PRAW->Ysostre_connectant_FX = PRAW->Ysostre_connectant_FX	+ PRAW->inc_dYdX_Sostre_Connectant_FX;
				PRAW->Yterra_connectant_FX  = PRAW->Yterra_connectant_FX	+ PRAW->inc_dYdX_Terra_Connectant_FX;
				PRAW->Z						= PRAW->Z						+ PRAW->DeltaZ;
				PRAW->U						= PRAW->U						+ PRAW->DeltaU;*/

				PTR_PRAW(OFFSET_PRAW_YSOSTRE_ACTUAL_FX)		= PTR_PRAW(OFFSET_PRAW_YSOSTRE_ACTUAL_FX)			+ PTR_PRAW(OFFSET_PRAW_INC_DYDX_SOSTRE_FX);
				PTR_PRAW(OFFSET_PRAW_YTERRA_ACTUAL_FX)		= PTR_PRAW(OFFSET_PRAW_YTERRA_ACTUAL_FX)			+ PTR_PRAW(OFFSET_PRAW_INC_DYDX_TERRA_FX);
				PTR_PRAW(OFFSET_PRAW_YSOSTRE_CONNECTANT_FX)	= PTR_PRAW(OFFSET_PRAW_YSOSTRE_CONNECTANT_FX)		+ PTR_PRAW(OFFSET_PRAW_INC_DYDX_SOSTRE_CONNECTANT_FX);
				PTR_PRAW(OFFSET_PRAW_YTERRA_CONNECTANT_FX)	= PTR_PRAW(OFFSET_PRAW_YTERRA_CONNECTANT_FX)		+ PTR_PRAW(OFFSET_PRAW_INC_DYDX_TERRA_CONNECTANT_FX);
				PTR_PRAW(OFFSET_PRAW_Z)						= PTR_PRAW(OFFSET_PRAW_Z)							+ PTR_PRAW(OFFSET_PRAW_DELTA_Z);
				PTR_PRAW(OFFSET_PRAW_U)						= PTR_PRAW(OFFSET_PRAW_U)							+ PTR_PRAW(OFFSET_PRAW_DELTA_U);
				
				// 2ona MEGA CARREGA + INCREMENTS UNITARIS + GUARDAT DE REGISTRES (8 registres) !!!!
				/*PRAW->ymin_portal_ptr		= PRAW->ymin_portal_ptr			+ 1;
				PRAW->ymax_portal_ptr		= PRAW->ymax_portal_ptr			+ 1;
				PRAW->ymin_sostre_ptr		= PRAW->ymin_sostre_ptr			+ 1;
				PRAW->ymax_sostre_ptr   	= PRAW->ymax_sostre_ptr			+ 1;
				PRAW->ymin_terra_ptr		= PRAW->ymin_terra_ptr			+ 1;
				PRAW->ymax_terra_ptr		= PRAW->ymax_terra_ptr			+ 1;
				PRAW->x						= PRAW->x						+ 1;
				PRAW->interacions			= PRAW->interacions				- 1;*/
				PTR_PRAW(OFFSET_PRAW_YMIN)				= PTR_PRAW(OFFSET_PRAW_YMIN)				+ 2;//PRAW->ymin_portal_ptr		+ 1;
				PTR_PRAW(OFFSET_PRAW_YMAX)				= PTR_PRAW(OFFSET_PRAW_YMAX)				+ 2;//PRAW->ymax_portal_ptr		+ 1;
				PTR_PRAW(OFFSET_PRAW_YMIN_PORTAL_PTR)	= PTR_PRAW(OFFSET_PRAW_YMIN_PORTAL_PTR)		+ 2;//PRAW->ymin_portal_ptr		+ 1;
				PTR_PRAW(OFFSET_PRAW_YMAX_PORTAL_PTR)	= PTR_PRAW(OFFSET_PRAW_YMAX_PORTAL_PTR)		+ 2;//PRAW->ymax_portal_ptr		+ 1;
				PTR_PRAW(OFFSET_PRAW_YMIN_SOSTRE_PTR)	= PTR_PRAW(OFFSET_PRAW_YMIN_SOSTRE_PTR)		+ 2;//->ymin_sostre_ptr			+ 1;
				PTR_PRAW(OFFSET_PRAW_YMAX_SOSTRE_PTR)	= PTR_PRAW(OFFSET_PRAW_YMAX_SOSTRE_PTR)		+ 2;//->ymax_sostre_ptr			+ 1;
				PTR_PRAW(OFFSET_PRAW_YMIN_TERRA_PTR)	= PTR_PRAW(OFFSET_PRAW_YMIN_TERRA_PTR)		+ 2;//;->ymin_terra_ptr			+ 1;
				PTR_PRAW(OFFSET_PRAW_YMAX_TERRA_PTR)	= PTR_PRAW(OFFSET_PRAW_YMAX_TERRA_PTR)		+ 2;//;->ymax_terra_ptr			+ 1;
				PTR_PRAW(OFFSET_PRAW_X)					= PTR_PRAW(OFFSET_PRAW_X)					+ 1;//->x						+ 1;
				PTR_PRAW(OFFSET_PRAW_ITERACIONS)		= PTR_PRAW(OFFSET_PRAW_ITERACIONS)			- 1;//;->interacions				- 1;
				
				aux1 = PTR_PRAW(OFFSET_PRAW_ITERACIONS);//PRAW->interacions;
				
				aux1 = PTR_PRAW(OFFSET_PRAW_ITERACIONS);//PRAW->interacions;
				
				//u_paisatge += du_paisatge;

				//aux = PRAW->interacions;
				//aux--;
				
				
			}while(aux1 > 0);
	//	}


}

