//@typedef struct{
//@
//@	   int du;     // derivada increment u.
//@	   int dv;     // derivada increment v.
//@    int light;  // Intensitat de llum segons la distancia...
//@    int Escale; // Per, ms tard, alhora de fer el mapeig, saber el mipmap.
//@    int centre_u;// centre projecci u.
//@    int centre_v;// centre projecci v.
//@    int u1;     // Reservats pel mapeig
//@    int v1;     // Reservats pel mapeig
//@    
//@
//@}tComponentsPlaSector;

#define     OFFSET_PCCPS_Y1                                   0
#define     OFFSET_PCCPS_Y2                                   4
#define     OFFSET_PCCPS_XJ                                   8
#define     OFFSET_PCCPS_ZJ                                   12
#define     OFFSET_PCCPS_DIFF_ALTURA                          16
#define     OFFSET_PCCPS_VALOR_COS_ANGLE_JUGADOR              20
#define     OFFSET_PCCPS_VALOR_SIN_ANGLE_JUGADOR              24
#define     OFFSET_PCCPS_HORITZO_JUGADOR                      28
#define     OFFSET_PCCPS_LIGHT_SECTOR                         32
#define     OFFSET_PCCPS_TIPUS                                36
#define     OFFSET_PCCPS_PTR_CPS                              40

// Per comptabilitzar amb ARM...
#define     LDR(ptr, offset)  (*((int *)(ptr) + ((offset) >> 2)))


//@typedef struct{
//@
//@int y1,                             // 0
//@     y2;                            // 4
//@ int xj,                            // 8
//@     zj,                            // 12
//@     diff_altura,                // 16
//@     ValorCosinus,                 // 20
//@     ValorSinus,                   // 24
//@     horitzo_jugador;               // 28
//@     int light_sector;              // 32
//@     int tipus;                     // 36
//@     tComponentsPlaSector *ptr_CPS; // 40
//@
//@}tParametresCalculComponentsPlaSector;
//@
FUNCIO_A_MEMORIA_INTERNA
void RENDER_C_CalculParametresPlaSector(tParametresCalculComponentsPlaSector *PCCPS)
{
    // tParametresCalculComponentsPlaSector *PCCPS     r0. (reservat)
    int y1, Z, intensitat_llinterna, ValorCosinus, xj,// r1.          
        y2,y2d;                                       // r2. 
    tComponentsPlaSector    *ptr_CPS;             // r3.
    int aux1;                                     // r4.
    int *ptr_div_inversa;                         // r5.
    int diff_altura;                              // r6.
    int dx_mapa,        /*  altura_jugador, */        // r7.
        dz_mapa,/*          altura_pla_sector,*/      // r8.
        intensitat_total, horitzo_jugador,        // r9.
        escale,                                  // r10
        centre_x,                                 // r11
        centre_z,                                 // r12
        /*aux2,*/ ValorSinus, zj;                      // r14


        
/*        zj,                                           // r3.
        angle,                                        //
        *ptr_div_inversa,                             // r4.
        altura_jugador,diff_altura;                   // r5.

    int light_sector,                                 // r6.
        altura_pla_sector, *ptr_SIN, Valor_Sinus;      // r7.

              
    int  tipus;                                       // r8.
    tComponentsPlaSector  *ptr_CPS;                   // r9.

    int aux_prebucle1,dx_mapa,                        // r10.
        aux_prebucle2,dz_mapa,                        // r11.
        aux_prebucle3,light,                          // r12.
        aux_prebucle4,escale;                         // r14.*/

    y1 = (LDR(PCCPS, OFFSET_PCCPS_Y1));
    y2 = (LDR(PCCPS, OFFSET_PCCPS_Y2));

    y2d = y2 - y1;
    y2d = y2d + 1;

    // punter + offset CPS...
    ptr_CPS = (tComponentsPlaSector    *)LDR(PCCPS, OFFSET_PCCPS_PTR_CPS);

    aux1 = SizeOf_tComponentsPlaSector;
    aux1 = aux1*y1;
    ptr_CPS = (tComponentsPlaSector    *)((char *)ptr_CPS + aux1);



    // Calcul diferencia jugador-pla...
    aux1 = LDR(PCCPS, OFFSET_PCCPS_TIPUS);
//    LDR(altura_jugador, PCCPS, OFFSET_PCCPS_YJ);
    horitzo_jugador = LDR(PCCPS, OFFSET_PCCPS_HORITZO_JUGADOR);
//    LDR(altura_pla_sector, PCCPS, OFFSET_PCCPS_ALTURA_SECTOR);

    if(aux1 == ES_SOSTRE)
    {
        //diff_altura = altura_jugador - altura_pla_sector;
        // Calculem offset y div inversa...
        //(CENTRE_Y2D_EFECTIU + Jugador->Horitzo) - ymin_sostre
        aux1 = CENTRE_Y2D_EFECTIU - horitzo_jugador;
        aux1 = aux1 - y1;

    }
    else // Es terra...
    {
        //diff_altura = altura_pla_sector - altura_jugador;
        // Calculem offset y div inversa...

        //(y1 - (CENTRE_Y2D_EFECTIU + Jugador->Horitzo - 1))
        aux1 = CENTRE_Y2D_EFECTIU - horitzo_jugador;
        aux1 = aux1 - 1;
        aux1 = y1 - aux1;

    }

    // Punter divisio inversa + offset + inc_div_inversa...
    ptr_div_inversa = _reciprocal_div;
    ptr_div_inversa = (int *)((char *)ptr_div_inversa+(aux1*4)); 

    diff_altura = (int)LDR(PCCPS, OFFSET_PCCPS_DIFF_ALTURA);

    if(y2d > 0)
    {
        do{
            
            //escale = (((diff_altura*(*ptr_div_inversa))) << DETALL_GRAFIC_X) >> DETALL_GRAFIC_Y;
            escale = (*ptr_div_inversa);

            escale = diff_altura*escale;
            escale = escale << DETALL_GRAFIC_X;
            escale = escale >> DETALL_GRAFIC_Y;

            //Z      = escale*dX >> 8;
            Z      = escale*dX;
            Z      = Z >> 8;

            // illuminaci segons sector i distancia...
            aux1 = INT_TO_FIXED(MAXIMA_ILUMINACIO_LLINTERNA);
    		intensitat_llinterna = aux1 - FIXED_DIV_16(Z);
	    	intensitat_llinterna = FIXED_TO_INT(intensitat_llinterna);
					 
			if(intensitat_llinterna < 0) intensitat_llinterna = 0;
			if(intensitat_llinterna > MINIMA_DISTANCIA_LLINTERNA) intensitat_llinterna = MAXIMA_ILUMINACIO_LLINTERNA;


            aux1 = (int)LDR(PCCPS, OFFSET_PCCPS_LIGHT_SECTOR);
			//aux1 = PTR_PRAW(OFFSET_PRAW_INTENSITAT_SECTOR);//->intensitat_sector;
			intensitat_total = intensitat_llinterna + aux1;
					
			if(intensitat_total >  MAXIMA_INTENSITAT) intensitat_total = MAXIMA_INTENSITAT;

            // Clcul dels pendents de mapa (dx_mapa,dz_mapa)
			
            
            ValorCosinus = (int)LDR(PCCPS, OFFSET_PCCPS_VALOR_COS_ANGLE_JUGADOR);
            ValorSinus   = (int)LDR(PCCPS, OFFSET_PCCPS_VALOR_SIN_ANGLE_JUGADOR);
            
            //dx_mapa = - WIN_MulFx_16_16(Valor_Sinus,escale);
            dx_mapa = C_MulFx_16_16(ValorSinus, escale);
            dx_mapa = -dx_mapa;
            
            //dz_mapa =   WIN_MulFx_16_16(Valor_Cosinus,escale); 
            dz_mapa = C_MulFx_16_16(ValorCosinus,escale); 

		    // Centre de mapa...
			
            xj  = (int)LDR(PCCPS, OFFSET_PCCPS_XJ);
            zj  = (int)LDR(PCCPS, OFFSET_PCCPS_ZJ);
            
            //centre_x = WIN_MulFx_16_16(Valor_Cosinus,escale)*dX + (Xj << 8);
            centre_x = dz_mapa;
            centre_x = centre_x*dX;
            centre_x = centre_x + (xj << 8); // recorda que... xj estava en APF 16.8 --> cal passar a APF 16.16


			//centre_z = WIN_MulFx_16_16(Valor_Sinus,escale)*dX + (Zj << 8);
            centre_z = -dx_mapa;
            centre_z = centre_z*dX;
            centre_z = centre_z + (zj << 8);// recorda que... zj estava en APF 16.8 --> cal passar a APF 16.16

             ptr_CPS->dx_mapa = dx_mapa;
             ptr_CPS->dz_mapa = dz_mapa;
             ptr_CPS->intensitat = intensitat_total, horitzo_jugador;
             ptr_CPS->escale = escale;
             ptr_CPS->centre_x = centre_x;
             ptr_CPS->centre_z = centre_z;
            
            
               
            aux1 = (int)LDR(PCCPS, OFFSET_PCCPS_TIPUS);
            
            if(aux1 == ES_SOSTRE) ptr_div_inversa--;
            else ptr_div_inversa++;
 
            ptr_CPS++;

        }while(--y2d);
    
    }



   /* // Carrega de registres....
    y1                  = PCCPS->y1;
    y2                  = PCCPS->y2;
    xj                  = PCCPS->xj;   // APF 16.8
    zj                  = PCCPS->zj;   // APF 16.8
    angle               = PCCPS->angle;
    altura_jugador      = PCCPS->altura_jugador; // s enter, no APF
    horitzo_jugador     = PCCPS->horitzo_jugador;
    light_sector        = PCCPS->light_sector;
    altura_pla_sector   = PCCPS->altura_sector;  // s enter , no APF
    tipus               = PCCPS->tipus;
    ptr_CPS             = PCCPS->ptr_CPS;
    
    aux_prebucle        = 4;
    
    if(tipus == ES_SOSTRE)
    {
        diff_altura = altura_jugador - altura_pla_sector;
        // Calculem offset y div inversa...
        aux_prebucle1 = CENTRE_Y2D_EFECTIU + horitzo_jugador;
        aux_prebucle1 = aux_prebucle1 - y1;

    }
    else // Es terra...
    {
        diff_altura = altura_pla_sector - altura_jugador;
        // Calculem offset y div inversa...
        aux_prebucle1 = CENTRE_Y2D_EFECTIU + horitzo_jugador;
        aux_prebucle1 = aux_prebucle1 - 1;
        aux_prebucle1 = y1 - aux_prebucle1;

    }


    // Punter CPS + offset...
    aux_prebucle2    = SizeOf_tComponentsPlaSector;
    aux_prebucle2    = aux_prebucle2*y1;
    ptr_CPS = (tComponentsPlaSector *)((char *)ptr_CPS + aux_prebucle2);


    // y2d...
    y2d = y2 - y1 + 1;
    
    // valor sin[alhpa]...
    ptr_SIN   = _Sinus;
    Valor_Sinus = *((int *)((char *)ptr_SIN + angle*4));
    

    // valor cos[alpha]...
    ptr_COS = _Cosinus;
    Valor_Cosinus = *((int *)((char *)ptr_COS + angle*4));

    
    // Punter vector div. inversa + offset...
    ptr_div_inversa = reciprocal_div;
    ptr_div_inversa = (int *)((char *)ptr_div_inversa+aux_prebucle1*4); 

    if(tipus == ES_SOSTRE)
        inc_ptr_div_inversa = -4;
    else
        inc_ptr_div_inversa = 4;
        
       

    // ok, ja podem comenar a calcular derivades...
    if(y2d > 0)
    {
        do{
 
				escale = (((diff_altura*(*ptr_div_inversa))) << DETALL_GRAFIC_X) >> DETALL_GRAFIC_Y;
				Z      = escale*dX >> 8;




                
                

                                
                ptr_CPS         +=  inc_ptr_CPS;
                ptr_div_inversa +=  inc_ptr_div_inversa;
        
        }while(--y2d != 0);
    
    
    
    }


*/



    //ptr_reciprocal_div = (FIXED32 *)&reciprocal_div[(CENTRE_Y2D_EFECTIU + Jugador->Horitzo) - PreGuardat_Cotes_Sostre->Ymin];
	//ptr_reciprocal_div = (FIXED32 *)&reciprocal_div[PreGuardat_Cotes_Terra->Ymin - (CENTRE_Y2D_EFECTIU + Jugador->Horitzo - 1)];


    


    

}
