//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA

#ifndef __SCANLINES_H__
#define __SCANLINES_H__

//#include "render.h"
#include "Textura.h"
#include "render.h"

/********************\
| DEFINICIO DE TIPUS |
\********************/

typedef struct{  // Cal canviar el nom per un de ms generic, pintar_tira, per exemple, ja que la funci pinta paisatges, sprites i blocks...

	int		    x,y1,y2;
    int         u1,v1,Escale_v;
	tImatge		*MipMap;
//    int         ID_Textura;
	int         Intensitat;
//    int     Transparencia;
//	unsigned int    Color_Mascara;  // Ja no cal desde que l'eina JespaGFX inserta el index paleta de mascara en ensamblador ARM

}tParametresPintarParet;


typedef struct{  // Cal canviar el nom per un de ms generic, pintar_tira, per exemple, ja que la funci pinta paisatges, sprites i blocks...

	int		    x,                      // Columna a on es pinta la tira.
                y1,                     // Inici y pintat de tira. 
                y2;                     // Fi    y pintat de tira
    int         u1,                     // u1 en format APF 16.16 a l'espai 3D d'ull.
                v1,                     // v1 en format APF 16.16 a l'espai 3D d'ull.
                Escale_v;               // Escala en format 16.16.
    int         ID_Textura;             // < 0 --> Pintat amb color [0,..256). == 0 no pinta. > 0 representa l'ID de textura a pintar.
	int         Intensitat;             // Es pinta amb efecte de illuminaci. Si no hi consta a les propietats no es pintar.
    int         Transparencia;          // Es pinta amb efecte de transparencia. Si no hi consta a les propietats no es pintar.
    int         Propietats_Objecte;     // 16 bits de ms pes s'hi guarden les propietats de objecte. 16 bits de menys pes les de textura. (veure textura.h i objecte.h)
//    int     Transparencia;
//	unsigned int    Color_Mascara;  // Ja no cal desde que l'eina JespaGFX inserta el index paleta de mascara en ensamblador ARM

}tParametresPintarParet2;

typedef struct{

	int dx_mapa;     // derivada increment u.
	int dz_mapa;     // derivada increment v.
    int intensitat;  // Intensitat de llum segons la distancia...
    int escale; // Per, ms tard, alhora de fer el mapeig, saber el mipmap.
    int centre_x;// centre projecci u.
    int centre_z;// centre projecci v.

}tComponentsPlaSector;

typedef struct{

int y1,                             // 0
     y2;                            // 4
 int xj,                            // 8
     zj,                            // 12
     diff_altura,                // 16
     ValorCosinus,                 // 20
     ValorSinus,                   // 24
     horitzo_jugador;               // 28
     int light_sector;              // 32
     int tipus;                     // 36
     tComponentsPlaSector *ptr_CPS; // 40

}tParametresCalculComponentsPlaSector;

typedef struct{

        int x1;
        int x2;
        int y;
        int ID_Textura;
        tComponentsPlaSector  *CPS;
        int Propietats_Objecte;

}tParametresPintarTiraPla;



typedef struct{

    int  u0, v0, dx_mapa, dz_mapa, Z;

}tComponentsPla;


/*typedef struct _tParametresPintarPla{

    int			        x1,x2,y;
	long				 u0, v0, du, dv; // Coordenades de mapeig
	char                *ptr_textura;
	unsigned int		Intensitat;
	

}tParametresPintarPla;	*/






typedef struct _tParametres_PreGuardat_Components_Pla{

	int			y1,y2,diff_altura;
	FIXED32       *ptr_reciprocal_div;
	long	    Valor_Cosinus, Valor_Sinus, Xj, Zj;
	char        *ptr_textura;

}tParametres_PreGuardat_Components_Pla;

/*typedef struct _tParametresPintarPla{

	int			x,y1,y2,diff_altura;
	FIXED32     *ptr_reciprocal_div;
	long	    Valor_Cosinus, Valor_Sinus, Xj, Zj;
	char        *ptr_textura;

}tParametresPintarPla;*/



///////////////- Estructures per la renderitzaci de sostre-terra- ///////////////////////////////////////////


/*typedef struct _tInformacioCotesPla{

	int  x1[ALTURA_PANTALLA_EFECTIVA],  x2[ALTURA_PANTALLA_EFECTIVA];
	int  ymin_sostre, ymax_sostre, ymin_terra, ymax_terra;

	int  y_retallat_sostre_anterior, y_retallat_terra_anterior;

}tInformacioCotesPla;*/



typedef struct _tParametresPintarFranjaHoritzontal{
	
	long	    x0, z0, dxmapa, dzmapa;
	tImatge     Textura;

}tParametresFranjaHoritzontal;

// Per HAM






/**********************************\
| PROTOTIPUS DE FUNCIONS I ACCIONS |
\**********************************/



#ifdef __HAM__	// S'utilitzar funcions de pintat per plataforma HAM (implementades en ensamblador a ARM_scanlines.s)...

    extern inline void ARM_PutBlockSlice(const tParametresPintarParet *PPP);
    extern inline void ARM_PutVerticalSlice(const tParametresPintarParet *PPP);
    extern inline void ARM_PutHorizontalSlice(tParametresPintarTiraPla *PPTP);

    //extern inline void ARM_PutBlockSlice_With_V_POW_2(const tParametresPintarParet *PPP);
    //extern inline void ARM_PutBlockSlice_Fast(int x, int y1, int y2, int info_color);

    /*extern inline void ARM_PintarSostre_HIGH(const tParametresPintarPla *PPS);
    extern inline void ARM_PintarTerra_HIGH(const tParametresPintarPla *PPT);*/

	//extern inline void ARM_PintarTiraPla(const tParametresPintarPla *PPP);
	//extern inline void ARM_Preguardar_Components_Sostre(tComponentsPla *ComponentsPla, const tParametres_PreGuardat_Components_Pla *PPS);
    //extern inline void ARM_Preguardar_Components_Terra( tComponentsPla *ComponentsPla, const tParametres_PreGuardat_Components_Pla *PPT);
    
//    extern inline void ARM_ActualitzarCotes(int x, const tParametresAssignacioCotes *PAC_Sostre, const tParametresAssignacioCotes *PAC_Terra);
  
//	#define			PutBlockSlice_Fast						ARM_PutBlockSlice_Fast	
//	#define			PutBlockSlice							ARM_PutBlockSlice
//	#define			PutBlockSlice_With_V_POW_2				ARM_PutBlockSlice_With_V_POW_2
    #define         PutVerticalSlice                        ARM_PutVerticalSlice
    #define         PutHorizontalSlice                      ARM_PutHorizontalSlice
 //   #define         PintarTiraPla							ARM_PintarTiraPla
    
//	#define        Preguardar_Components_Sostre				ARM_Preguardar_Components_Sostre
//	#define        Preguardar_Components_Terra				ARM_Preguardar_Components_Terra


//	#define        ActualitzarCotes                     ARM_ActualitzarCotes


#endif

#ifdef __SDL__	// S'utilitzar funcions de pintat per plataforma SDL (implementades a scanlines.c)...

//	void SDL_PutBlockSlice_Fast(int x, int y1, int y2, int info_color);
    void SDL_PutVerticalSlice(const tParametresPintarParet2	*PPP);
    void SDL_PutHorizontalSlice(tParametresPintarTiraPla *PPTP);

//	void SDL_PutBlockSlice_With_V_POW_2(const tParametresPintarParet *PPP); // Fast paint algorithm...
//	void SDL_PutBlockSlice(const tParametresPintarParet *PPP);
//	void SDL_PintarTiraPla(const tParametresPintarPla	*ParametresPintarPla);
//	void SDL_Preguardar_Components_Pla(tComponentsPla  *ComponentsPla , const tParametres_PreGuardat_Components_Pla *PPC,short EsTerra);
	//void SDL_Preguardar_Components_Terra(tComponentsPla  *ComponentsPla , const tParametres_PreGuardat_Components_Pla *PHC);

//	#define     PutBlockSlice_Fast						SDL_PutBlockSlice_Fast
//	#define		PutBlockSlice							SDL_PutBlockSlice
//	#define     PutBlockSlice_With_V_POW_2				SDL_PutBlockSlice_With_V_POW_2
    #define     PutVerticalSlice                        SDL_PutVerticalSlice
    #define     PutHorizontalSlice                      SDL_PutHorizontalSlice
	
	
//	#define    PintarTerra								SDL_PintarTerra
//	#define    PintarSostre								SDL_PintarSostre
//	#define	   Preguardar_Components_Sostre				SDL_Preguardar_Components_Sostre
//	#define	   Preguardar_Components_Pla				SDL_Preguardar_Components_Pla
//	#define    PintarTiraPla							SDL_PintarTiraPla

    
//	#define        ActualitzarCotes                         SDL_ActualitzarCotes



#endif


//void SDL_PutHorizontalSlice(tParametresPintarTiraPla *PPTP);

//#define	  PintarFranjaVertical(PPP)					/*PutBlockSlice_Fast(PPP.x,PPP.y1,PPP.y2,0)//*/(!V_POWER_OF_2(PPP.MipMap->Propietats) || !U_POWER_OF_2(PPP.MipMap->Propietats))  ? PutBlockSlice(&PPP) : PutBlockSlice_With_V_POW_2(&PPP)
//#define   PintarParet								PintarFranjaVertical
//#define   PintarTiraParet_amb_un_color				PutBlockSlice_Fast
//#define   PutVerticalSlice

#endif

