//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA



////////////////////////////////////////
//									  //
// INCLUSI DE CAPALERES NECESSARIES //
// __________________________________ //
//									  //
////////////////////////////////////////


#include "Sector.h"
#include "geometria.h"


///////////////////////////////////////////////////////////////////////////////////////////////////
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::://
///////////////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////
//								  	           //
// IMPLEMENTACI PRIVADA D' ACCIONS I FUNCIONS //
// ___________________________________________ //
//									           //
/////////////////////////////////////////////////


//--------------------------------------------------------------------------------------------------------------//
//--------------------------------------------------------------------------------------------------------------//
//
//
//
//








/////////////////////////////////////////////////
//								  	           //
// IMPLEMENTACI PUBLICA D' ACCIONS I FUNCIONS //
// ___________________________________________ //
//									           //
/////////////////////////////////////////////////



//////////////////////////////////
//								//
// FUNCIONS I ACCIONS PUBLIQUES //
// ____________________________ //
//								//
//////////////////////////////////




//--------------------------------------------------------------------------------------------------------------//
//--------------------------------------------------------------------------------------------------------------//
//
// Constructor amb pas de parmetres.
//
//
//

#ifndef __UTILITZAR_EL_MON_PREGUARDAT
void Sector_NouSector(tParametres_Nou_Sector Parametres_Sector,tSector *Sector)
{
	
//	tLiniaSector *MemoriaLiniesSector;
	/*int ID_Sector, int Intensitat_Iluminacio;
	tImatge **Textura_Terra, tImatge **Textura_Sostre, int AlturaTerra, int AlturaSostre,int NumeroDeLinies;
	tSector *Sector;*/
	s16		diff_altura;
	u16		Propietats;


	//tImatge      **n,**n1;
	
	// Reservem memria necessaria per l' emmagatzament de les linies que
	// definirn el nostre.
	
	//MemoriaLiniesSector = (tLiniaSector*) malloc(Parametres_Sector.NumeroDeLinies*sizeof(tLiniaSector));
//	Reservar_Memoria(MemoriaLiniesSector, tLiniaSector, Parametres_Sector.NumeroDeLinies);
/*	n                   = (tImatge **) malloc(sizeof(tImatge *));
	n1                   = (tImatge **) malloc(sizeof(tImatge *));*/

/*	if(MemoriaLiniesSector == NULL)
	{
	 
		#ifdef __SDL__
			fprintf(stderr,"\n Error al intentar reservar %i bytes per assignar %i linies a la classe sector !",sizeof(tLiniaSector)*Parametres_Sector.NumeroDeLinies,Parametres_Sector.NumeroDeLinies);
		#endif
		
		exit(EXIT_FAILURE);
	}*/

	// Assgnem punter a l' inici de l' estructura de linies que definirn el sector.

//	Sector->LiniaSector = MemoriaLiniesSector;


	// Init del quadrat sector 2D...

	Sector->QuadratSector3D.x1 = Sector->QuadratSector3D.z1 =  MAX_FX;
	Sector->QuadratSectorXZ.x1 = DIMENSIO_MAXIMA_MON_X;
	Sector->QuadratSectorXZ.z1 = DIMENSIO_MAXIMA_MON_Z;

	
	Sector->QuadratSector3D.x2 = Sector->QuadratSector3D.z2 =  MIN_FX;
	Sector->QuadratSectorXZ.x2 = DIMENSIO_MINIMA_MON_X;
	Sector->QuadratSectorXZ.z2 = DIMENSIO_MINIMA_MON_Z;


	Sector->QuadratSector3D.y1_sostre = Parametres_Sector.Init_Quadrat_Sector.y1_sostre;
	Sector->QuadratSector3D.y2_sostre = Parametres_Sector.Init_Quadrat_Sector.y2_sostre;
	Sector->QuadratSector3D.y1_terra = Parametres_Sector.Init_Quadrat_Sector.y1_terra;
	Sector->QuadratSector3D.y2_terra = Parametres_Sector.Init_Quadrat_Sector.y2_terra;
	

	// Apliquem nivell de terra i sostre al sector...

	Sector->AlturaSostre = Parametres_Sector.AlturaSostre;
	Sector->AlturaTerra = Parametres_Sector.AlturaTerra;

	// Textures de sostre i terra.


	Sector->ID_Animacio_Sostre = Parametres_Sector.Textura_Sostre;

	Sector->ID_Animacio_Terra = Parametres_Sector.Textura_Terra;

	// Identificador de sector...

	Sector->ID_Sector = Parametres_Sector.ID_Sector;

	// Iluminaci de sector (si < 0 s constant, altrament utilitza una f(x) on x s el temps definit a l'interval [0..256] -veure fitxer "FUNCIONS.raw.c" -)

	Sector->Intensitat_Llum_Sector = Parametres_Sector.iluminacio;

	// Transferencia de altures terra/sostre arestes quadrat engloabant del sector...

	Propietats = 0;
	

	diff_altura = Sector->QuadratSector3D.y2_sostre - Sector->QuadratSector3D.y1_sostre;

//	if((diff_altura != 0) &&  Parametres_Sector.Pendent_X_Sostre)		SET_X_CEIL_WITH_SLOPE(Propietats);
//	if((diff_altura != 0) && !Parametres_Sector.Pendent_X_Sostre)		SET_Z_CEIL_WITH_SLOPE(Propietats);

	diff_altura = Sector->QuadratSector3D.y2_terra - Sector->QuadratSector3D.y1_terra;

//	if((diff_altura != 0) &&  Parametres_Sector.Pendent_X_Terra)		SET_X_FLOOR_WITH_SLOPE(Propietats);
//	if((diff_altura != 0) && !Parametres_Sector.Pendent_X_Terra)		SET_Z_FLOOR_WITH_SLOPE(Propietats);


	Sector->Propietats = Propietats;

	Sector->NumeroLinies = 0;


	// altres inicialitzacions...

	Sector->Portal_Sostre = SOLID;
	Sector->Portal_Terra = SOLID;




		

}



// Gestions de inserir linies i actualitzar les dimensions del sector, el quadrat que engloba el sector.

void SECTOR_AfegirLinia( tVertex V0, tVertex V1, s16 id_textura_inferior, s16 id_textura, s16 id_textura_superior, u32 Propietats, tSector *Sector)
{
//	tImatge **n1, **n2, **n3;
	int NumeroDeLinia;
	tVertex _V0, _V1;


	if((Sector->NumeroLinies + 1) >= MAX_LINIES_SECTOR)
	{
#ifdef __SDL__
		fprintf(stderr,"\n S'ha rebassat el mxim de lnies a afegir!");
#endif
		return;
	}
	else
	{
		if((Sector->NumeroLinies + 1) >= MAX_LINIES_SECTOR)
		{
#ifdef __SDL__
		fprintf(stderr,"\n Advertencia s'ha arribat al mxim de lnies a afegir! Per convenci es tanca el sector amb el vertex V1 de la ultima lnia amb V0 de la primera.");
#endif	
			_V0 = Sector->LiniaSector[MAX_LINIES_SECTOR-1].Linia.V0;	
			_V1 = Sector->LiniaSector[MAX_LINIES_SECTOR-1].Linia.V1;
		}
		else
		{
			_V0 = V0;
			_V1 = V1;
		}

		// ID Linia actual de sector...

		NumeroDeLinia = Sector->NumeroLinies;

		// Assumim que la lnia es paret (ms endavant es cridar una funci que realitzar les interconnexions de portal)

		Sector->LiniaSector[NumeroDeLinia].Portal = PARET;
			
		// Assignem les informacins de vertex de linia. Ms endavant es cridar la funci que configurara els attributs pendents de la lnia.

		LINIA_InicialitzarLinia(NumeroDeLinia,_V0,_V1,Propietats,&Sector->LiniaSector[NumeroDeLinia].Linia);
		//Sector->LiniaSector[NumeroDeLinia].Linia.V0 = V0;
		//Sector->LiniaSector[NumeroDeLinia].Linia.V1 = V1;

		
		////////////////- ACTUALITZACI DEL QUADRAT DE SECTOR-///////////////////////////
		//				
		//	Actualitzem la x1 del quadrat.
				
		Sector->QuadratSector3D.x1 =  min(min(_V0.X,_V1.X),Sector->QuadratSector3D.x1);
		Sector->QuadratSectorXZ.x1 = FIXED_TO_INT(Sector->QuadratSector3D.x1);
				
		// Actualitzem la z1 del quadrat.
					
		Sector->QuadratSector3D.z1  = min(min(_V0.Z,_V1.Z),Sector->QuadratSector3D.z1);
		Sector->QuadratSectorXZ.z1 = FIXED_TO_INT(Sector->QuadratSector3D.z1);

		// Actualitzem la x2 del quadrat.
				
		Sector->QuadratSector3D.x2 = max(max(_V0.X,_V1.X),Sector->QuadratSector3D.x2);
		Sector->QuadratSectorXZ.x2 = FIXED_TO_INT(Sector->QuadratSector3D.x2);
				
		// Actualitzem la z2 del quadrat.
					
		Sector->QuadratSector3D.z2 = max(max(_V0.Z,_V1.Z),Sector->QuadratSector3D.z2);
		Sector->QuadratSectorXZ.z2 = FIXED_TO_INT(Sector->QuadratSector3D.z2);

		//
		///////////////////////////////////////////////////////////////////////////////


		// ID animaci textura superior
		Sector->LiniaSector[NumeroDeLinia].Textura_Superior = id_textura_superior;

		// ID animaci textura de paret
		Sector->LiniaSector[NumeroDeLinia].Textura_Paret = id_textura;

		// ID animaci textura inferior
		Sector->LiniaSector[NumeroDeLinia].Textura_Inferior = id_textura_inferior;

		// Actualitzem el contador de linies entrades fins al moment...
		Sector->NumeroLinies++;

        // Assignem altura de vertex...
	}
	

}
#endif


tLiniaSector *Punt_Intersecta_Linia_Sector(const tPunt_Fixa_2D *punt, const tSector *Sector)
{
	int Trobat = FALS;
	int i = 0;
	
	
	while(i < Sector->NumeroLinies && !Trobat)
	{
		if(	LINIA_PuntIntersectaLinia(punt,&Sector->LiniaSector[i].Linia))
			Trobat = CERT;
		else
			i++;
	}

	if(Trobat) return (tLiniaSector *)&Sector->LiniaSector[i];
	
	
	return NULL;
}


int Punt_Intersecta_Vertex_Portal(FIXED32 X, FIXED32 Z, const tSector *Sector)
{
	int Trobat = FALS;
	int i = 0;
	
	
	while(i < Sector->NumeroLinies && !Trobat)
	{
		if((X == Sector->LiniaSector[i].Linia.V0.X) && 
		   (Z == Sector->LiniaSector[i].Linia.V0.Z))
			Trobat = Sector->LiniaSector[i].Portal != PARET;
		else
			i++;
	}

	return Trobat;

}



//FUNCIO_A_MEMORIA_INTERNA
int Punt_Pertany_A_Sector( FIXED32 X, FIXED32 Z, const tSector *Sector, int *intersecta_linia)
{


	FIXED32 zs[2];
		
	int i,zs_actuals,NumeroLinies,intersecta;
	tLinia *Linia;

	zs_actuals = 0;

	intersecta = FALS;	
	
	
	// Si el punt no pertany al quadrat englobant de polygon retorna fals...
	if( ! Punt_Pertany_A_Quadrat(X,Z,Sector->QuadratSector3D)) return FALS;


	if(SQUARE_SECTOR(Sector->Propietats))
	{		
		*intersecta_linia = Punt_Intersecta_A_Quadrat(X,Z,Sector->QuadratSector3D) ? TRUE : FALS;
		return CERT;
	}

	// Com sabem si un punt es troba en un poligon convexe ?
	//
	// s molt fcil. Si llencem un raig vertical, el punt p (jugador) ha d'esser ms gran que l'intersecci extrem superior
	// i ms petita que l'interseccio extrem inferior, evitant aix, aplicar el mtode convencional que involucra un bucle amb 
	// clcul d'arrels quadrades. El segent dibuix ASCII es mostra el punt i les interseccions extrems del poligon,
	//
	//      ___________.________
	//.    /	 	  /|\	    \         .
	//.   /            |         \        .
	//.  /             |          \        .
	//. /              p           \       .
    //  \              |           /
	//	 \             |          /
	//	  \           \|/        /
	//	   \___________.________/
    //


	NumeroLinies = Sector->NumeroLinies;

//	Clockwise order.

	for ( i = 0; (i < NumeroLinies) && (zs_actuals < 2); i++ )
	{
		Linia = (tLinia *)&Sector->LiniaSector[i].Linia;

		if((Linia->V0.X == Linia->V1.X && Linia->V1.X == X) && (Linia->V0.Z <= Z) && (Z <= Linia->V1.Z)) // Jugador intersecta lnia --> trobem les dues interseccions.
		{
					zs[0] = Linia->QuadratLinia.z1 - Z;
					zs[1] = Linia->QuadratLinia.z2 - Z;
					zs_actuals = 2;

					intersecta = CERT;
		}
		else
		{
					
			if( Linia->QuadratLinia.x1 <= X && X < Linia->QuadratLinia.x2) // Xj pertany a l'interval X de lnia --> intersecci segur.
			{
				
				if(Linia->V0.Z == Linia->V1.Z) // Linia horitzontal --> Cas especial.
				{
					zs[zs_actuals] = Linia->V0.Z - Z;
				}
				else // linia amb pendent...

					zs[zs_actuals] = MulFx(X,Linia->m1) + Linia->b1 - Z; // Interseccio respecte jugador
				
				if(zs[zs_actuals] == 0) (intersecta) = CERT; 
				
				zs_actuals++;
			}
			
		}

	}

	*intersecta_linia = intersecta;

	// Retorna cert si els signes sn diferents...
	
//	return (( zs[0] < 0.0f && zs[1] >= 0.0f) || (zs[0] >= 0.0f && zs[1] < 0.0f)); 
	return ((zs[0] <= 0 && zs[1] >= 0) || (zs[0] >= 0 && zs[1] <= 0)); 
	
	
	
}
