//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA

#include "Textura.h"


//
// Fitxers generats amb l'eina gfx_generate(by jespa).
//
//#include "GFX/IncludeC/info_images.c"

const int Sizeof_tImatge = sizeof(tImatge),Sizeof_tTextura = sizeof(tTextura);

tTextura                     *Textura
#ifdef __HAM__
MEM_IN_EWRAM
#endif
;


#if defined( _WINDOWS) || defined(_LINUX)

 SDL_Color   Paleta[256];

#endif

////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Llista de imatges.
//


int InicialitzarImatges()
{
	int   j,k, tamany_imatge_mipmap, index_actual,DimY,DimX,n_imatges;
	char *ptr_texels;


  // 0.- Init altres infos


  ///////////////////////////////////////////////////////////////////
  //
  // 1.- Comptem el numero de imatges de tipus block i de tipus sprite...

  n_imatges = N_IMAGES;
  

  //
  ///////////////////////////////////////////////////////////////////

  ///////////////////////////////////////////////////////////////////
  //
  // 2.- Reservem memria per les n textures i amb N_MIPMAPS mipmaps per cadascuna...
  //

  //if((Imatge = (tImatge *) malloc(sizeof(tImatge)*(n_imatges)*N_MIPMAPS)) == NULL)
  
  Reservar_Memoria(Textura, tTextura, (n_imatges));
  
  if(Textura == NULL)
  {
		return 0;
  }


  //
  ///////////////////////////////////////////////////////////////////
  
  ///////////////////////////////////////////////////////////////////
  //
  // 3.- Guardem imatges...
  // 


  //
  // 3.1 - Imatges amb predisposici de ser utilitzades pel mapeig de la renderitzaci...  
  //
  
  index_actual = 0;
  ptr_texels = (char *)images; 
    
  // Per cada imatge...
  for(k = 0; k < n_imatges; k++)
  {
	  DimX = Info_Image[k].width;
	  DimY = Info_Image[k].height;

	  Reservar_Memoria(Textura[k].GFX_MipMap, tImatge, Info_Image[k].N_MipMaps+1);

	   if(Textura[k].GFX_MipMap == NULL)
	   {
			return FALS;
	   }

	   Textura[k].N_MipMaps = Info_Image[k].N_MipMaps;
       
       
       Textura[k].Propietats = Info_Image[k].Propietries;


       if(IS_PANORAMA(Textura[k].Propietats)) // Es panorama --> calculem derivades...
       {
#ifdef __ARITMETICA_FIXA__
             Textura[k].GFX_MipMap[0].du_paisatge = (long)((DimX*65536)/TOTAL_INCREMENTS_FOV_EN_360);
             Textura[k].GFX_MipMap[0].dv_paisatge = (long)((DimY*65536)/(ALTURA_PANTALLA_EFECTIVA + 2*CENTRE_Y2D_EFECTIU ));
#endif
       }
       else
       {
           Textura[k].GFX_MipMap[0].du_paisatge = -1;
           Textura[k].GFX_MipMap[0].dv_paisatge = -1;
       }

/*
       if(Es_Potencia_de_2(Info_Image[k].width)) // Ho confirmem a les seves propietats...
       {
           SET_BIT(Textura[k].Propietats, BIT_IS_UPOW2);
           //Textura[k].GFX_MipMap[j].Log2U = __log2(Textura[k].GFX_MipMap[j].DimX);
           //Textura[k].GFX_MipMap[j].MaskU = (0x1 << Textura[k].GFX_MipMap[j].DimX) - 1;
       }
       else
       {
           //			Textura[k].GFX_MipMap[j].MaskU = 0xFFFFFFFF;
       }
       
       if(Es_Potencia_de_2(Info_Image[k].height))// Ho confirmem a les seves propietats...
       {
           SET_BIT(Textura[k].Propietats, BIT_IS_VPOW2);
           //Textura[k].GFX_MipMap[j].Log2V  = __log2(Textura[k].GFX_MipMap[j].DimY);
           //Textura[k].GFX_MipMap[j].MaskV = (0x1 << Textura[k].GFX_MipMap[j].DimY) - 1;
       }
       else
       {
           //			  Textura[k].GFX_MipMap[j].MaskU = 0xFFFFFFFF;
       }*/

            
       
//       if((Info_Image[k].With_Bright)) SET_BIT(Textura[k].Propietats);
//       if((Info_Image[k].Is_Panorama)) SET_BIT(Textura[k].Propietats,BIT_IS_PANORAMA);
//       if((Info_Image[k].Is_Passable)) SET_BIT(Textura[k].Propietats,BIT_IS_);
       
	    
	   Textura[k].ID_Textura = k+1; 

	  // Per cada MIPMAP de textura...
	  for(j = 0; j < Info_Image[k].N_MipMaps; j++)
	  {
		  
		  		  
		  Textura[k].GFX_MipMap[j].ptr_pixels  = ptr_texels;
		  Textura[k].GFX_MipMap[j].DimX = DimX >> j;
		  Textura[k].GFX_MipMap[j].DimY = DimY >> j;
		  
		  


		  if(Es_Potencia_de_2(Textura[k].GFX_MipMap[j].DimX)) // Transformem la seva dimensi X en log2(x).
		  {

			  Textura[k].GFX_MipMap[j].Log2U = __log2(Textura[k].GFX_MipMap[j].DimX);
			  //Textura[k].GFX_MipMap[j].MaskU = (0x1 << Textura[k].GFX_MipMap[j].DimX) - 1;
		  }
		  else
		  {
//			Textura[k].GFX_MipMap[j].MaskU = 0xFFFFFFFF;
		  }
		  
		  if(Es_Potencia_de_2(Textura[k].GFX_MipMap[j].DimY)) // Transforma la dimensi Y a log2(y).
		  {
			  Textura[k].GFX_MipMap[j].Log2V  = __log2(Textura[k].GFX_MipMap[j].DimY);
			  //Textura[k].GFX_MipMap[j].MaskV = (0x1 << Textura[k].GFX_MipMap[j].DimY) - 1;
		  }
		  else
		  {
//			  Textura[k].GFX_MipMap[j].MaskU = 0xFFFFFFFF;
		  }

	  
	//	  if((Info_Image[k].With_Bright)) Propietats_Set_Iluminacio(Textura[k].GFX_MipMap[j].Propietats);
	///	  if((Info_Image[k].Is_Panorama)) Propietats_Set_Panorama(Textura[k].GFX_MipMap[j].Propietats);
	//	  if((Info_Image[k].Is_Passable)) Propietats_Set_Passable(Textura[k].GFX_MipMap[j].Propietats);
		  
		  
		  tamany_imatge_mipmap = (DimX >> j)*(DimY >> j);  
		  ptr_texels += tamany_imatge_mipmap;
		  
		  
	  }
	  
	  
	  
	  
	  
	  
  }



  // Animacions...

  


#if defined( _WINDOWS) || defined(_LINUX)

  for(k = 0 ; k < 256 ; k++)
  {
	   Paleta[k].r = RGB_GET_R_VALUE(Palette[k]);//(paret1_Palette[i] & 0x001F) << 3;
	   Paleta[k].g = RGB_GET_G_VALUE(Palette[k]);
	   Paleta[k].b = RGB_GET_B_VALUE(Palette[k]);//(paret1_Palette[i] & 0x7B00) >> 7;

  }
  
  SDL_SetPalette(Video, SDL_LOGPAL|SDL_PHYSPAL, Paleta, 0, 256);

#endif

#ifdef __HAM__
{
//    extern short *Palette;

  GBA_LoadBGPal((u16 *)Palette,SIZEOF_16BIT(Palette));
  }

#endif

  return 1;

}



 

