//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA


#ifndef __TEXTURA_H
 #define __TEXTURA_H


#include "stdlib.h"
#include "stdio.h"
#include "Tipus.h"
#include "Mates.h"
#include "memoria.h"
#include "definicions.h"
#include "GFX/IncludeC/info_images.h"
#include "grafics.h"

/*#if defined( __arm__) || defined(__thumb__)
#ifndef __HAM__
#define __HAM__
#include "myGBA.h"
#endif
#endif*/


//#if defined( _WINDOWS) || defined(_LINUX)
#ifdef __SDL__

//#include "grafics.h"

 extern SDL_Color Paleta[256];
 
#endif

// Numero de imatges diferents, segons la seva dimensi. Modificar el seu valor si es 
// afagir/treu una dimensi
 
#define NBLOCKS_AMB_LLUM			5
#define NBLOCKS_SENSE_LLUM			0
#define NSPRITES_AMB_LLUM			0
#define NSPRITES_SENSE_LLUM			6

#define N_INFO_IMATGE				4

#define N_IMATGES_DE_DIFERENT_DIMENSIO_AMB_LLUM    (NBLOCKS_AMB_LLUM   + NSPRITES_AMB_LLUM)
#define N_IMATGES_DE_DIFERENT_DIMENSIO_SENSE_LLUM  (NBLOCKS_SENSE_LLUM + NSPRITES_SENSE_LLUM)
 
// Afegir segons convingui...
 
// (...)

 // Atributs de imatge...
/* enum{
    BIT_IS_UPOW2=0,
    BIT_IS_VPOW2,
    BIT_IS_SPRITE,
    BIT_IS_PANORAMA,
    BIT_IS_SQUARE
 };

#define IS_UPOW2(p)   (TST_BIT(p, BIT_IS_UPOW2))
#define IS_VPOW2(p)   (TST_BIT(p, BIT_IS_VPOW2))
#define IS_SQUARE(p)  (TST_BIT(p, BIT_IS_SQUARE))*/



/////////////////////
//	 			   //
// LA CLASSE IMATGE //
// _______________ //
//				   //
/////////////////////
						  
//typedef struct _tTextura *PTextura ;

typedef struct{
     // 
     //   ADVERTENCIA !!! NO AFEGIR NI MODIFICAR INFORMACI A PARTIR D' AQUI !!!
     //
	 char    *ptr_pixels;
	 int     DimX;				// Dimensi en X de la imatge. Si s potencia de dos, el valor de DimX estara en log2. (ex: si amplada s 128 --> potencia de 2 --> log2(128) = 7)
	 int     DimY;				// Dimensi en Y de la imatge. Si s potencia de dos, el valor de DimY estara en log2. (ex: si altura s 128 --> potencia de 2 --> log2(128) = 7)

     int    Log2U;              // En cas que sigui potencia de 2, agafarem el seu log2...
     int    Log2V;              // En cas que sigui potencia de 2, agafarem el seu log2...

     int     du_paisatge;        // En cas que sigui paisatge, afagarem la seva derivada...
     int     dv_paisatge;        // En cas que sigui paisatge, afagarem la seva derivada...

	 // Si es vol afegir ms variables, haur de ser a partir d'aqui...

	 // (...)
	 
 }tImatge;

/*typedef struct{

	 char    *ptr_pixels;
	 int     DimX;				// Dimensi en X de la imatge. Si s potencia de dos, el valor de DimX estara en log2. (ex: si amplada s 128 --> potencia de 2 --> log2(128) = 7)
	 int     DimY;				// Dimensi en Y de la imatge. Si s potencia de dos, el valor de DimY estara en log2. (ex: si altura s 128 --> potencia de 2 --> log2(128) = 7)

     int    Log2U;              // En cas que sigui potencia de 2, agafarem el seu log2...
     int    Log2V;              // En cas que sigui potencia de 2, agafarem el seu log2...

     int    du_paisatge;        // En cas que seigui pasiatge, afagarem la seva derivada...
     int    dv_paisatge;        // En cas que seigui pasiatge, afagarem la seva derivada...

     char    *angle_jugador;    // Punter al angle de jugador...
     int     *horitzo_jugador;  // Punter al horitzo de jugador...

}tInfoPaisatge;*/






 typedef struct _tTextura{
     // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     // !!!---> PROHIBIT AFEGIR INFORMACI I MODIFICAR TAMANY INFORMACI A PARTIR D'AQUI <---!!!
     // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     //
     tImatge	*GFX_MipMap; // Prohibit modificar-se!!!
     //
     // !!!!
     //
	 int    N_MipMaps;         // Prohibit modificar-se!!!
     //
     // !!!!
     //
	 int    Propietats;       // Propietats de la imatge (Coordenada U potencia 2,
     //
	 // El camp 'Propietats' explica el segent:
	 //
	 //  16    7   6   5   4   3   2   1    0
	 // [ X || X | X | X | X | S | I | Y2 | X2 ]
	 //  
	 //
	 //  X: Estat de bit indeferent.
	 //  S: Si activat, es tracta d'un sprite.
	 //  I: Si activat, es renderitza amb illuminaci. (Sense efecte, aquesta passa a ser una propietat del objecte)
	 //  Y2: Dimensi Y s potencia de dos.
	 //  X2: Dimensi X s potencia de dos.
     
     // 
     // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     // !!!---> FI PROHIBICIO <---!!!
     // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!

     int ID_Textura;
 
 }tTextura;

/* typedef struct{
	 tMipMap

	 FIXED32 dv,du;
 
 }tPanorama;*/





// Paisatge...

#define LOG2_AMPLADA_PAISATGE   10    // 1024
#define LOG2_ALTURA_PAISATGE    8     // 256


#define AMPLADA_PAISATGE		(1 << LOG2_AMPLADA_PAISATGE)
#define ALTURA_PAISATGE			(1 << LOG2_ALTURA_PAISATGE)











/*
 typedef struct _tTexturaAnimada{

	 tTextura	*ptr_textura;

	 int		Mascara_NTextures; 

 }tTexturaAnimada;*/



 


 extern tTextura    *Textura; // Seleccio textura en el codi segons el numero de textura n i un MIP_MAP_estriat a l'interval [0,..,3] ---> Textura[n*3 + n_MIP_MAP]
 extern tImatge     Paisatge;
 extern const int	Sizeof_tImatge,Sizeof_tTextura;

 //extern const unsigned char Shade[];
 //extern const unsigned char Glenz[];
 extern char				ID_PAISATGE;



/*******\
| MACROS|
\*******/

//#define   IS_PANORAMA(n)			((n & 0x10))
//#define   IS_PASSABLE(n)			((n & 0x8))
//#define   RENDER_WITH_BRIGHT(n)		((n & 0x4))
//#define   V_POWER_OF_2(n)			((n & 0x2))
//#define   U_POWER_OF_2(n)			((n & 0x1))

//#define   Propietats_Set_X_POWER_OF_2(Propietats)	((Propietats) = ((Propietats) | 0x1))
//#define   Propietats_Set_Y_POWER_OF_2(Propietats)	((Propietats) = ((Propietats) | 0x2))
//#define   Propietats_Set_Iluminacio(Propietats)		((Propietats) = ((Propietats) | 0x4))
//#define   Propietats_Set_Passable(Propietats)		((Propietats) = ((Propietats) | 0x8))
//#define   Propietats_Set_Panorama(Propietats)		((Propietats) = ((Propietats) | 0x10))






//#define Paisatge_Bitmap Paisatge


int InicialitzarImatges();


#endif
