//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA

#ifndef __TIPUS_H
 #define __TIPUS_H



#include "Definicions.h"


/***************************\
| DEFINCICIO DE TIPUS BASICS|
\***************************/

 typedef struct{

	 FIXED32 x1,z1,x2,z2;

 }tQuadrat_Fixa_2D;


 
 typedef struct{

	 FIXED32 x3d,y3d,z3d;

 }tPunt_Fixa_3D;

 
 typedef struct{
	 s32	x1,z1,x2,z2; 
 }tQuadrat_XZ;

 typedef struct{

	FIXED32	 x1,z1,y1_terra,y1_sostre,x2,z2,y2_terra, y2_sostre;
	 

 }tQuadrat_Fixa_3D;

/* typedef struct{

	 tLinia Linia_Quadrat[4];
	 

 }tQuadrat_Englobant_3D;*/

 typedef struct{

	 s32  x,y,z;
 
 }tVertex3D_ENTER;

 typedef struct{

	 tVertex3D_ENTER v[4]; 
 
 }tPoligon_4Vertexs;



  typedef struct{

	 FIXED32 Z,Y; 

 }tPunt_Fixa_ZY;


  typedef struct _tPunt_Fixa_XZ{

	 FIXED32 X,Z; 

 }tPunt_Fixa_2D;


  
  typedef struct _tPunt_ZY_Fixa_2D{

	 FIXED32 Z,Y; 

 }tPunt_ZY_Fixa_2D;


// Tipus punt semi 3D...
 /*typedef struct{

	 FIXED32 X,Z,Y_Sostre, Y_Terra; 

 }tQuadrat[4]; */



typedef tPunt_Fixa_2D					tQuadrat_Fixa_2D_4Punts[4];




  typedef struct _tQuadrat_2D{

	 s16 x1,y1,x2,y2;

 }tQuadrat_2D;


 typedef struct _tVertex{

	 u32         ID_Vertex;
	 FIXED32     X,Z,Y_SUP, Y_INF;

 }tVertex;


  /*typedef struct _tVertex_{

	 FIXED32 X,Z,Y_terra, Y_sostre;

 }tVertex;*/

 //typedef tVertex			tQuadrat_Sector_3D[2];


 typedef struct _tPunt2D{

	 short x,y; // Un punt a l'espai de pantalla.

 }tPunt2D;

 /*typedef struct _tPuntMapa{

	 FIXED32 X,Z; // Un punt a l'espai de mapa amb precisi.

 }tPuntMapa;*/

//#define tVertex tPuntMapa


 typedef struct _tParametres_PintarTiraParet{

	 int y1,y2; // Cotes inferiors/superiors a pantalla pel renderitzat de tira.
	 FIXED32 v_start,v_scale; // Components de comenament i escalat en V a l'espai de textura
	 int  u; // Tira de textura pel renderitzat de tira
	 char *src; // Punter + offset de textura.
	 
 }tParametres_PintarTiraParet;





 typedef struct _tJugador{


	 FIXED32    X,Z;
	 u8         AngleDireccio;
	 u8         AngleDireccioAnterior;
	 s16		Altura; // { Altura del jugador }
	 s16   		Horitzo; // { Determina l'horitzo del jugador [0,..,160] }

	 
	 u8			Estat; // En proces per substituir variables, Sequencia Salt, Sequencia caiguda i Mode vol...

	 //
	 //	 Estat explica el segent:
	 //
	 //  [X|X|X|X|X|V|S|C]
	 //   7 6 5 4 3 2 1 0
	 //
	 //  X : Estat de bit indiferent
	 //  V : Si est activat es que el jugado esta en mode vol.
	 //  S : Si est activat es que el jugado esta en estat de saltar.
	 //  C : Si est activat es que el jugado esta en estat de caiguda.
	 //
	 u8			Sequencia_Salt;    // { Variable que explica si el jugador esta saltant }
	 u16		Temps_Salt;
	 u8			Sequencia_Caiguda; // { Variable que explica si el jugador esta saltant }
	 u16		Temps_Caiguda;
	 u32        ID_MapaSector;
	 FIXED32		 DesplacamentX_EspaiUll;
	 FIXED32		 DesplacamentZ_EspaiUll;
	 

	 u8          ModeVolar;			
	 
	
 }tJugador;


 // TIPUS JUGADOR EN ARITMETICA FIXA PER GRABAR A DISC L'ULTIM ESTAT DEL JUGADORs...
typedef struct{
	 int		X,Z;
	 u8         AngleDireccio;
	 u8         AngleDireccioAnterior;	// Per recalcular vertexs...
	 s16		Altura; // { Altura del jugador }
	 s16   		Horitzo; // { Determina l'horitzo del jugador [0,..,160] }
	 u8			Estat;

	 //
	 //	 Estat explica el segent:
	 //
	 //  [X|X|X|X|X|V|S|C]
	 //   7 6 5 4 3 2 1 0
	 //
	 //  X : Estat de bit indiferent
	 //  V : Si est activat es que el jugado esta en mode vol.
	 //  S : Si est activat es que el jugado esta en estat de saltar.
	 //  C : Si est activat es que el jugado esta en estat de caiguda.
	 //
	 u8			Sequencia_Salt;    // { Variable que explica si el jugador esta saltant }
	 u16		Temps_Salt;
	 u8			Sequencia_Caiguda; // { Variable que explica si el jugador esta saltant }
	 u16		Temps_Caiguda;

	 u32         ID_MapaSector;		// Sector actual de jugador.
	 s32		 DesplacamentX_EspaiUll;
	 s32		 DesplacamentZ_EspaiUll;
//	 short		 centre_projeccio_y;
	 u8          ModeVolar;

}tFixed_Jugador;

 
 
 typedef struct _tInformacioRaig{
	
	tPunt_Fixa_2D	PuntPartida;
	int         AngleRaig;
	int         Altura;
	 
 }tInformacioRaig;



////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct	  _tSector							*PSector;
typedef struct    _tLlista_Objectes_Sector_Render	*PLlista_Objectes_Sector_Render;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



#endif
