//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA

#include "Scanlines.h"


//#define COLOR_MASCARA	108

#ifdef __SDL__


void SDL_PutBlockSlice_Fast(int x, int y1, int y2, int info_color) // Fast paint algorithm...
{
	//
	//  Dels parmetres v i escale_v estn en APF 16.16...
	//

	char *dest_ptr;
	int		y2d;
	

	if(y1 < 0 || y2 >= ALTURA_PANTALLA_EFECTIVA || y2 < 0 || y1 >= ALTURA_PANTALLA_EFECTIVA || y1 > y2) return;

	y2d = y2 - y1 + 1;

	dest_ptr = (char *)(SDL_WORK_VRAM + AMPLADA_PANTALLA*(y1 << DETALL_GRAFIC_Y) + (x << DETALL_GRAFIC_X));
	
	

	
//	Mascara_Altura_Textura = ((1 << PPP->MipMap.LOG2_ALTURA) << 16) - 1;



#ifdef _WINDOWS // Pintat en ensamblador...

	_asm{

		
		push	edi

		mov		edi,dest_ptr
		
		mov		ebx,y2d
		
		


repetir_2:
		
		mov		eax, info_color

#ifdef __BAIX_DETALL_Y		
#ifdef __BAIX_DETALL_X
		
		mov		ah, al
		mov		[edi],ax
		add		edi, AMPLADA_PANTALLA
		mov		[edi],ax
		add		edi, AMPLADA_PANTALLA
#else
		mov		[edi],al
		add		edi, AMPLADA_PANTALLA
		mov		[edi],al
		add		edi, AMPLADA_PANTALLA
#endif
#else
#ifdef __BAIX_DETALL_X
		mov		ah, al
		mov		[edi],ax
		add		edi, AMPLADA_PANTALLA
#else
		mov		[edi],al
		add		edi, AMPLADA_PANTALLA
#endif
#endif

		dec		ebx

		jnz  	repetir_2

		pop		edi
		
	
	}

#else // C, sense optimitzar...

// Verificar...
/*	if(y2d > 0)
	{
		do{

			v_actual = ((v >> PART_FRACCIONAL) & Mascara_Altura_Textura);
			v_actual <<= Textura->LOG2_AMPLADA;


			*dest_ptr = ptr_textura[v_actual];


			v += (Escale_v << DETALL_GRAFIC);
			dest_ptr += (AMPLADA_PANTALLA << DETALL_GRAFIC);
			y2d --;

		
		}while(y2d > 0);
	
	*/
	}
#endif
					 
}


/*
void SDL_PutBlockSlice_With_V_POW_2(const tParametresPintarParet *PPP) // Fast paint algorithm...
{
	//
	//  Dels parmetres v i escale_v estn en APF 16.16...
	//

	int y1, y2, y2d, Mascara_Altura_Textura, Mascara_Amplada_Textura;
	long v = PPP->v1, Escale_v;
	char log2_amplada_textura, *dest_ptr, *ptr_textura, *ptr_intensitat,propietats;
	

	y1 = PPP->y1;
	y2 = PPP->y2;

	if(y1 < 0 || y2 >= ALTURA_PANTALLA_EFECTIVA || y2 < 0 || y1 >= ALTURA_PANTALLA_EFECTIVA || y1 > y2) return;

	y2d = y2 - y1 + 1;

	v =   PPP->v1;
	Escale_v = PPP->Escale_v;
	propietats = PPP->MipMap->Propietats;

	Mascara_Altura_Textura  = ((1 << PPP->MipMap->DimY))  -1;
	Mascara_Amplada_Textura = ((1 << PPP->MipMap->DimX))  -1;
	
	log2_amplada_textura = PPP->MipMap->DimX;
	
	dest_ptr = (char *)(SDL_WORK_VRAM + AMPLADA_PANTALLA*(y1 << DETALL_GRAFIC_Y) + (PPP->x << DETALL_GRAFIC_X));
	ptr_textura    = (char *)(PPP->MipMap->ptr_pixels + (PPP->u1 & Mascara_Amplada_Textura));
	
	
	if(RENDER_WITH_BRIGHT(PPP->MipMap->Propietats)) ptr_intensitat = (char *)(&Shade[PPP->Intensitat]);
	else
	{
		ptr_intensitat = (char *)(&Shade[128]);
	}

//	Mascara_Altura_Textura = ((1 << PPP->MipMap.LOG2_ALTURA) << 16) - 1;



#ifdef _WINDOWS // Pintat en ensamblador...

	_asm{

		push	esi
		push	edi

		mov		edx, v
		mov		ebx, y2d
		mov     cl, log2_amplada_textura


		
		mov     edi, dest_ptr
		mov		esi, ptr_textura

repetir_1:
		
		mov		eax, edx

		shr		eax, 16
		and		eax, Mascara_Altura_Textura

		shl		eax, cl
		
		// Es llegeix el color de textura...
		mov		esi, ptr_textura
		
		mov     al, [esi + eax]
		// Es llegeix el color segons la intensitat passada oer parametre...

		cmp		al,MASK_COLOR
		jnz		continua		// El pixel coicideix amb el de la mascara --> descarta pixel!

#ifdef __BAIX_DETALL_Y
		add		edi, AMPLADA_PANTALLA
#endif
		add		edi, AMPLADA_PANTALLA

		jmp		No_Pinta_Pixel

		

continua:
		mov		ch, al
		xor		eax, eax
		mov		al, ch
		shl		eax, 8
		mov		esi, ptr_intensitat

		mov		al, [esi + eax]


#ifdef __BAIX_DETALL_Y		
#ifdef __BAIX_DETALL_X
		
		mov		ah, al
		mov		[edi],ax
		add		edi, AMPLADA_PANTALLA
		mov		[edi],ax
		add		edi, AMPLADA_PANTALLA
#else
		mov		[edi],al
		add		edi, AMPLADA_PANTALLA
		mov		[edi],al
		add		edi, AMPLADA_PANTALLA
#endif
#else
#ifdef __BAIX_DETALL_X
		mov		ah, al
		mov		[edi],ax
		add		edi, AMPLADA_PANTALLA
#else
		mov		[edi],al
		add		edi, AMPLADA_PANTALLA
#endif
#endif

No_Pinta_Pixel:

		add		edx, Escale_v
		dec		ebx

		jnz  	repetir_1

		pop		edi
		pop		esi
	
	}

#else // C, sense optimitzar...


#endif
					 
}


void SDL_PutBlockSlice(const tParametresPintarParet *PPP)
{
	//
	//  Dels parmetres v i escale_v estn en APF 16.16...
	//

	int y1, y2, y2d;
	short amplada_textura,altura_textura;
	long v = PPP->v1, Escale_v;
	char  *dest_ptr, *ptr_textura, *ptr_intensitat, propietats;;
	

	y1 = PPP->y1;
	y2 = PPP->y2;
	
	if(U_POWER_OF_2(PPP->MipMap->Propietats))
		amplada_textura = (1 << PPP->MipMap->DimX);
	else
		amplada_textura = PPP->MipMap->DimX;

	if(V_POWER_OF_2(PPP->MipMap->Propietats))
		altura_textura = (1 << PPP->MipMap->DimY);
	else
		altura_textura = PPP->MipMap->DimY;

//	altura_textura = PPP->MipMap->DimY;

	if(y1 < 0 || y2 >= ALTURA_PANTALLA_EFECTIVA || y2 < 0 || y1 >= ALTURA_PANTALLA_EFECTIVA || y1 > y2 || (PPP->u1 >= amplada_textura)) return;

	y2d = y2 - y1 + 1;

	v =   PPP->v1;
	Escale_v = PPP->Escale_v;
	propietats = PPP->MipMap->Propietats;

	
	
	dest_ptr = (char *)(SDL_WORK_VRAM + AMPLADA_PANTALLA*(y1 << DETALL_GRAFIC_Y) + (PPP->x << DETALL_GRAFIC_X));
	ptr_textura    = (char *)(PPP->MipMap->ptr_pixels + (PPP->u1));
	//ptr_intensitat = (char *)(&Shade[PPP->Intensitat]);

	if(RENDER_WITH_BRIGHT(PPP->MipMap->Propietats)) ptr_intensitat = (char *)(&Shade[PPP->Intensitat]);
	else
	{
		ptr_intensitat = (char *)(&Shade[128]);
	}

//	Mascara_Altura_Textura = ((1 << PPP->MipMap->LOG2_ALTURA) << 16) - 1;



#ifdef _WINDOWS // Pintat en ensamblador...

	_asm{

		push	esi
		push	edi


		mov		edx, v
		mov		ebx, y2d


		
		mov     edi, dest_ptr
		mov		esi, ptr_textura

repetir_2:
		
		mov		eax, edx
		shr		eax, 16

		cmp     ax, altura_textura
		jge		acaba
				
		push	edx
		mul		amplada_textura
		pop		edx

				
		// Es llegeix el color de textura...
		mov		esi, ptr_textura
		
		mov     al, [esi + eax]


		cmp		al,MASK_COLOR
		jnz		continua_2		// El pixel es diferent de negre, pes pintaran pixels...

#ifdef __BAIX_DETALL_Y
		add		edi, AMPLADA_PANTALLA
#endif
		add		edi, AMPLADA_PANTALLA

		jmp		No_Pinta_Pixel_2

		

continua_2:
		// Es llegeix el color segons la intensitat passada oer parametre...

		mov		ch, al
		xor		eax, eax
		mov		al, ch
		shl		eax, 8
		mov		esi, ptr_intensitat

		mov		al, [esi + eax]


#ifdef __BAIX_DETALL_Y		
#ifdef __BAIX_DETALL_X
		
		mov		ah, al
		mov		[edi],ax
		add		edi, AMPLADA_PANTALLA
		mov		[edi],ax
		add		edi, AMPLADA_PANTALLA
#else
		mov		[edi],al
		add		edi, AMPLADA_PANTALLA
		mov		[edi],al
		add		edi, AMPLADA_PANTALLA
#endif
#else
#ifdef __BAIX_DETALL_X
		mov		ah, al
		mov		[edi],ax
		add		edi, AMPLADA_PANTALLA
#else
		mov		[edi],al
		add		edi, AMPLADA_PANTALLA
#endif
#endif
No_Pinta_Pixel_2:
		add		edx, Escale_v
		
		dec		ebx
		
		jnz  	repetir_2
	
acaba:
	

		pop		edi
		pop		esi
	
	
	}

#else // C, sense optimitzar...


#endif
}
*/

//
// Funcio pintat frnajes verticals amb tots els seus efectes, segons l'identificador de textura
// ms les propietats passades per parametre
//
// ATENCIO !!! Aquesta rutina, noms tracta textures que no siguin potencia de 2. Les que  
// ho siguin cal fer crida la rutina SDL_PutSlicePOW2,que s ms rpida.
//
void SDL_PutSlice_NOT_POW2
(
 const tParametresPintarParet2	*PPP
)
{
// Ho sento, per hem vaig cansar de programar... .Vinga a vera algun voluntari que continui!!!  :)
}

////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////
//
// Funcio pintat franjes verticals amb tots els seus efectes, segons l'identificador de textura
// ms les propietats passades per parametre
//
// ATENCIO !!! Aquesta rutina, noms tracta textures que sigion potencia de 2. Les que no 
// siguin cal fer crida la rutina SDL_PutSliceNOT_POW2,que s ms lenta.
//
//typedef struct{
//
//	int		    x,              // Columna a on es pinta la tira.
//              y1,             // Inici y pintat de tira. 
//              y2;             // Fi    y pintat de tira.
//  int         u1,             // u1 en format APF 16.16 a l'espai 3D d'ull.
//              v1,             // v1 en format APF 16.16 a l'espai 3D d'ull.
//              Escale_v;       // Escala en format 16.16.
//  int         ID_Textura;     // < 0 --> Pintat amb color [0,..256). == 0 no pinta. > 0 representa l'ID de textura a pintar.
//	int         Intensitat;     // Es pinta amb efecte de illuminaci. Si no hi consta a les propietats no es pintar.
//  int         Transparencia;  // Es pinta amb efecte de transparencia. Si no hi consta a les propietats no es pintar.
//  int         Propietats;     // 16 bits de ms pes s'hi guarden les propietats de objecte. 16 bits de menys pes les de textura. (veure textura.h i objecte.h)
//
//}tParametresPintarParet2;
void SDL_PutVerticalSlice_COLOR_WITH_GLENZING(char *ptr_dst, char *ptr_glenz, int y2d, int color)
{
    //char *ptr_transparencia = Glenz;
      _asm{
            
                push	edi
                
                mov		edi,ptr_dst
                mov     esi,ptr_glenz
                
                mov		ebx,y2d

loop_paint_color_with_glenz:


                mov		eax, color
                
                xor     ecx, ecx    
                mov     cl,byte ptr[edi]       // llegim video
                shl     ecx, 8     // offset *256...
                mov     eax,[esi+ecx] // eax cont la barreja...
                
#ifdef __BAIX_DETALL_Y		
#ifdef __BAIX_DETALL_X
                
                mov		ah, al
                mov		[edi],ax
                add		edi, AMPLADA_PANTALLA
                mov		[edi],ax
                add		edi, AMPLADA_PANTALLA
#else
                mov		[edi],al
                add		edi, AMPLADA_PANTALLA
                mov		[edi],al
                add		edi, AMPLADA_PANTALLA
#endif
#else
#ifdef __BAIX_DETALL_X
                mov		ah, al
                mov		[edi],ax
                add		edi, AMPLADA_PANTALLA
#else
                mov		[edi],al
                add		edi, AMPLADA_PANTALLA
#endif
#endif
                dec		ebx
                
                jnz  	loop_paint_color_with_glenz
                
                pop		edi
        }
}

void SDL_PutVerticalSlice_COLOR(char *ptr_dst, int y2d, int color)
{
    //char *ptr_transparencia = Glenz;
      _asm{
            
            push	edi
                
                mov		edi,ptr_dst
                
                mov		ebx,y2d
                
                
loop_paint_color:
            
            mov		eax, color
                
#ifdef __BAIX_DETALL_Y		
#ifdef __BAIX_DETALL_X
                
                mov		ah, al
                mov		[edi],ax
                add		edi, AMPLADA_PANTALLA
                mov		[edi],ax
                add		edi, AMPLADA_PANTALLA
#else
                mov		[edi],al
                add		edi, AMPLADA_PANTALLA
                mov		[edi],al
                add		edi, AMPLADA_PANTALLA
#endif
#else
#ifdef __BAIX_DETALL_X
                mov		ah, al
                mov		[edi],ax
                add		edi, AMPLADA_PANTALLA
#else
                mov		[edi],al
                add		edi, AMPLADA_PANTALLA
#endif
#endif
                dec		ebx
                
                jnz  	loop_paint_color
                
                pop		edi
        }
}



void SDL_PutVerticalSlice_BLOCK_VPOW2_WITHOUT_EFFECT(char *ptr_dst, char *ptr_src, int y2d, int V, int Escale_FX, int mask_v, int log2_U)
{
    _asm{
        
        push	esi
            push	edi
            
            mov		edx, V
            mov		ebx, y2d
            mov     ecx, log2_U
            
            mov     edi, ptr_dst
            
loop_paint_block_without_effect:
        
        mov		eax, edx
            
            shr		eax, 16
            and		eax, mask_v
            
            shl		eax, cl
            
            // Es llegeix el color de textura...
            mov		esi, ptr_src
            mov     al, [esi + eax]
            
#ifdef __BAIX_DETALL_Y		
#ifdef __BAIX_DETALL_X
            
            mov		ah, al
            mov		[edi],ax
            add		edi, AMPLADA_PANTALLA
            mov		[edi],ax
            add		edi, AMPLADA_PANTALLA
#else
            mov		[edi],al
            add		edi, AMPLADA_PANTALLA
            mov		[edi],al
            add		edi, AMPLADA_PANTALLA
#endif
#else
#ifdef __BAIX_DETALL_X
            mov		ah, al
            mov		[edi],ax
            add		edi, AMPLADA_PANTALLA
#else
            mov		[edi],al
            add		edi, AMPLADA_PANTALLA
#endif
#endif
            
            
            add		edx, Escale_FX
            dec		ebx
            
            jnz  	loop_paint_block_without_effect
            
            pop		edi
            pop		esi
            
    }
 
}


void SDL_PutVerticalSlice_SPRITE_VPOW2_WITHOUT_EFFECT(char *ptr_dst, char *ptr_src, int y2d, int V, int Escale_FX, int mask_v, int log2_U)
{
    _asm{
        
        push	esi
            push	edi
            
            mov		edx, V
            mov		ebx, y2d
            mov     ecx, log2_U
            
            mov     edi, ptr_dst
            
loop_paint_sprite_without_effect:
        
            mov		eax, edx
            
            shr		eax, 16
            and		eax, mask_v
            
            shl		eax, cl
            
            // Es llegeix el color de textura...
            mov		esi, ptr_src
            mov     al, [esi + eax]

            cmp     al, MASK_COLOR

            jnz     write_pixel_sprite_without_effect

#ifdef __BAIX_DETALL_Y		
#ifdef __BAIX_DETALL_X
            
            add		edi, AMPLADA_PANTALLA
            add		edi, AMPLADA_PANTALLA
#else
            add		edi, AMPLADA_PANTALLA
            add		edi, AMPLADA_PANTALLA
#endif
#else
#ifdef __BAIX_DETALL_X
            add		edi, AMPLADA_PANTALLA
#else
            add		edi, AMPLADA_PANTALLA
#endif
#endif

            jmp     continue_sprite_without_effect

write_pixel_sprite_without_effect:                     
            
#ifdef __BAIX_DETALL_Y		
#ifdef __BAIX_DETALL_X
            
            mov		ah, al
            mov		[edi],ax
            add		edi, AMPLADA_PANTALLA
            mov		[edi],ax
            add		edi, AMPLADA_PANTALLA
#else
            mov		[edi],al
            add		edi, AMPLADA_PANTALLA
            mov		[edi],al
            add		edi, AMPLADA_PANTALLA
#endif
#else
#ifdef __BAIX_DETALL_X
            mov		ah, al
            mov		[edi],ax
            add		edi, AMPLADA_PANTALLA
#else
            mov		[edi],al
            add		edi, AMPLADA_PANTALLA
#endif
#endif
  
continue_sprite_without_effect:
            
            
            add		edx, Escale_FX
            dec		ebx
            
            jnz  	loop_paint_sprite_without_effect
            
            pop		edi
            pop		esi
            
    }

}

void SDL_PutVerticalSlice_BLOCK_VPOW2_WITH_EFFECT(char *ptr_dst, char *ptr_src, char *ptr_shade,int y2d, int V, int Escale_FX, int mask_v, int log2_U, int Propietats)
{
    _asm{
            push	esi
            push	edi
            
            mov		edx, V
            mov		ebx, y2d
            mov     ecx, log2_U
            
            mov     edi, ptr_dst
            
loop_paint_block_with_effect:
        
            mov		eax, edx
            
            shr		eax, 16
            and		eax, mask_v
            
            mov     ecx,log2_U
            shl		eax,cl
            
            // Es llegeix el color de textura...
            mov		esi, ptr_src
            mov     al, [esi + eax]

            test    Propietats, MASK_RENDER_WITH_BRIGH
            jz      continue_paint_block_with_effect

            // pintem amb lluminositat...

            mov		esi, ptr_shade
            xor     ecx, ecx
            mov     cl, al
            shl     ecx, 8
            mov     al, byte ptr[esi + ecx]


continue_paint_block_with_effect:

#ifdef __BAIX_DETALL_Y		
#ifdef __BAIX_DETALL_X
            
            mov		ah, al
            mov		[edi],ax
            add		edi, AMPLADA_PANTALLA
            mov		[edi],ax
            add		edi, AMPLADA_PANTALLA
#else
            mov		[edi],al
            add		edi, AMPLADA_PANTALLA
            mov		[edi],al
            add		edi, AMPLADA_PANTALLA
#endif
#else
#ifdef __BAIX_DETALL_X
            mov		ah, al
            mov		[edi],ax
            add		edi, AMPLADA_PANTALLA
#else
            mov		[edi],al
            add		edi, AMPLADA_PANTALLA
#endif
#endif

            
            add		edx, Escale_FX
            dec		ebx
            
            jnz  	loop_paint_block_with_effect
            
            pop		edi
            pop		esi
            
    }
}

void SDL_PutVerticalSlice_SPRITE_VPOW2_WITH_EFFECT(char *ptr_dst, char *ptr_src, char *ptr_shade,int y2d, int V, int Escale_FX, int mask_v, int log2_U, int Propietats)
{
    char *ptr_glenz=(char *)Glenz;


    _asm{
            push	esi
            push	edi
            
            mov		edx, V
            mov		ebx, y2d
            mov     ecx, log2_U
            
            mov     edi, ptr_dst
            
loop_paint_sprite_with_effect:
        
            mov     ecx, log2_U
            mov		eax, edx
            
            shr		eax, 16
            and		eax, mask_v
            
            shl		eax, cl
            
            // Es llegeix el color de textura...
            mov		esi, ptr_src
            mov     al, byte ptr[esi + eax]

            cmp     al,MASK_COLOR
            jz      no_putpixel_paint_sprite_with_effect  

            // ok, comprobem si cal pinta amb lluminositat...

            test     Propietats, MASK_RENDER_WITH_BRIGH
            jz      cmp_glenz_paint_sprite_with_effect
//            jz      putpixel_paint_sprite_with_effect

            // pintem amb lluminositat...

            mov		esi, ptr_shade
            xor     ecx, ecx
            mov     cl, al
            shl     ecx, 8
            mov     al, byte ptr[esi + ecx]

    
cmp_glenz_paint_sprite_with_effect:          
            // ok, comprobem si cal pinta amb transparencia...

            test     Propietats, MASK_RENDER_WITH_GLENZING
            jz      putpixel_paint_sprite_with_effect

            // pintem amb transpa...
           
            xor     ah, ah
            xor     ecx, ecx                // llegim video
            mov     cl, [edi]      
            shl     ecx, 8             

            add     eax, ecx
            mov     esi, ptr_glenz
            mov     al, byte ptr[esi + eax]


putpixel_paint_sprite_with_effect:

#ifdef __BAIX_DETALL_Y		
#ifdef __BAIX_DETALL_X
            
            mov		ah, al
            mov		[edi],ax
            add		edi, AMPLADA_PANTALLA
            mov		[edi],ax
            add		edi, AMPLADA_PANTALLA
#else
            mov		[edi],al
            add		edi, AMPLADA_PANTALLA
            mov		[edi],al
            add		edi, AMPLADA_PANTALLA
#endif
#else
#ifdef __BAIX_DETALL_X
            mov		ah, al
            mov		[edi],ax
            add		edi, AMPLADA_PANTALLA
#else
            mov		[edi],al
            add		edi, AMPLADA_PANTALLA
#endif
#endif
            
            jmp continue_paint_sprite_with_effect

no_putpixel_paint_sprite_with_effect:

#ifdef __BAIX_DETALL_Y		
            add		edi, AMPLADA_PANTALLA
            add		edi, AMPLADA_PANTALLA
#else
            add		edi, AMPLADA_PANTALLA
#endif
            
continue_paint_sprite_with_effect:
            
            add		edx, Escale_FX
            dec		ebx
            
            jnz  	loop_paint_sprite_with_effect
            
            pop		edi
            pop		esi
            
    }            
    
}


extern tJugador Jugador;

void SDL_PutVerticalSlice
(
 const tParametresPintarParet2	*PPP
)
{
    int   x;                                                   // r0. (Necessari conservar-lo per si volem pintar a alt detall.)

    int   y1;   char  *ptr_dst;                               // r1. (void_ptr1 agafa el punter desti...)

    int   y2,   y2d;                                          // r2.

    int   U;    char  *ptr_src;                               // r3. (void_ptr2 agafa el punter font...)

    int   V,                                                   // r4.

          Escale_FX,                                          // r5.

          ID_Textura,color; void  *void_ptr;                  // r6. (void_ptr agafa els punters: Textura, &Textura[ID_Textura], &Textura[ID_Textura]->GFX_MipMap[MIPmap_Adequat], punter_shade)

    int   Intensitat;    char  *ptr_intensitat;               // r7.  Punter + offset X (nivell intensitat).

    int   Transparencia; char  *ptr_transparencia; int aux3;  // r8.  Punter + offset X (nivell transparencia).

    int   Propietats;                               // r9.

    int   MIPmap_Adequat,log2_U/*, mask_u*/;            // r10.

    int   log2_V,mask_v, DimY;                      // r11.

    int   aux1;                                     // r12.

    int   aux2,                                     // r14
          Propietats_Imatge;




    //
    // Carrega de informaci...
    //
    x                       = PPP->x;
    y1                      = PPP->y1;
    y2                      = PPP->y2;
    U                       = PPP->u1;
    V                       = PPP->v1;
    Escale_FX               = PPP->Escale_v;
    ID_Textura              = PPP->ID_Textura;
    Intensitat              = PPP->Intensitat;
    Transparencia           = PPP->Transparencia;
    Propietats              = PPP->Propietats_Objecte;

    
    // Filtre per si l' interval a pintar es vlid...
    if(y1 < 0 || y2 >= ALTURA_PANTALLA_EFECTIVA || y2 < 0 || y1 >= ALTURA_PANTALLA_EFECTIVA || y1 > y2) return;
    if(ID_Textura == 0) return;
    
    
    
    
    
    if(ID_Textura < 0) // Pintat d'un sol color...
    {
        color = (-ID_Textura)&0xFF;
        aux1 = Intensitat;
        ptr_intensitat = (char *)Shade;
        ptr_intensitat += aux1 << 8;


        if(TST_BIT(Propietats,BIT_RENDER_WITH_BRIGHT))
        {
            color = ptr_intensitat[color];
        }

        ptr_transparencia = (char *)Shade + color;

        // Punter desti...
        ptr_dst = (char *)(WORK_VRAM + AMPLADA_PANTALLA*(y1 << DETALL_GRAFIC_Y) + (x << DETALL_GRAFIC_X));
    
        y2d = y2 - y1 + 1;

        if(!TST_BIT(Propietats,BIT_RENDER_WITH_GLENZ))     SDL_PutVerticalSlice_COLOR(ptr_dst, y2d,color);
        else                                                  SDL_PutVerticalSlice_COLOR_WITH_GLENZING(ptr_dst, ptr_transparencia, y2d,color);

                      

        
        
    }
    else // Pintat amb textura...
    {       
         // Punter Textura...
        void_ptr = (char *)Textura;
        // Offset en bytes tamany info textura...
        aux1 = Sizeof_tTextura*ID_Textura;
        // Punter + offset a la info de textura...
        void_ptr = ((char *)void_ptr + aux1);

        
        // Llegim propietats de imatge...
        Propietats_Imatge = aux1 = (int)((char *)void_ptr)[0x2*4];

        // Mirem si s potencia de 2...
        if(!TST_BIT(aux1,BIT_IS_UPOW2) || !TST_BIT(aux1,BIT_IS_VPOW2)) return;



        // Determinar si la textura representa un panorama...
        if(TST_BIT(aux1,BIT_IS_PANORAMA)) // En principi no hi ha pintat de efectes (perqu ho vols?)...
        {

//					y1 = y_retallat_sostre_actual;
//					y2 = min(y_retallat_terra_actual,Ysostre_actual-1);

//					PPP.y1 = y1;
//					PPP.y2 = y2;

                    // Obtenim punter mipmap...
                    void_ptr = *((int **)void_ptr);
            
                   // Mascares UV...
                    log2_U = (int)((char *)void_ptr)[0x4*3]; // Lectura del log2 U en format 16.16
                    
                    // Punter pixels de la textura...
                    ptr_src  = (char *)(((int *)void_ptr)[0x4*0]);
                    //  + Offset U.
                        
                    // mascara V
                    DimY = (int)((int *)void_ptr)[2]; // Lectura de la dimensi vertical de la imatge...
                  //  mask_v = mask_v-1;


                    // derivada u...
                    aux1 = (int)((int *)void_ptr)[5];
                    // derivada v...
                    Escale_FX = (int)((int *)void_ptr)[6];

                    
                    // U = ((Jugador.AngleDireccio << 2) + ((x-CENTRE_X2D_EFECTIU)*DU_PAISATGE>> 16 ) ) & (AMPLADA_PAISATGE - 1);

                    // Jugador...
                    void_ptr = &Jugador;

                    // angle
                    aux3     = (unsigned char)((char *)void_ptr)[0x2*4];

                    aux3     =  aux3 << 2;

                    aux2      = x-CENTRE_X2D_EFECTIU;
                    aux2     *= aux1;
                    aux3     += (aux2 >> 16);

                    aux1     =1;
                    aux1     = aux1 << log2_U;
                    aux1     = aux1 - 1;
                    aux3     = aux1 & (aux3);
   

                    ptr_src  = ptr_src + aux3;

				    // V =  ((ALTURA_PAISATGE>> 1) << 16) - DV_PAISATGE*(CENTRE_Y2D_EFECTIU-Jugador.Horitzo - y1);
                    aux3 = DimY << 16;
                    aux3 = aux3 >> 1;

                    // Llegim l' horitzo actual de jugador...
                    aux2 = (int)((char *)void_ptr)[12];
                    aux2 = -aux2;
                    aux2 -= y1;
                    aux2 += CENTRE_Y2D_EFECTIU;
                    V = Escale_FX*aux2;
                    V = aux3 - V;// - V;
                    mask_v    = DimY - 1;


                    goto paint_slice;
                    //SDL_PutVerticalSlice_BLOCK_VPOW2_WITHOUT_EFFECT(ptr_dst, ptr_src, y2d, V, Escale_FX, mask_v, log2_U);



        }
        else // Pintat amb perspectiva, enmascarar UV, calcular mipmap, etc.
        {
            
          //  short Propietats_Objecte = (PPP->Propietats >> 16);
            
            
            // Calculem mipmaps...
            aux1 = Escale_FX >> 16;
            MIPmap_Adequat = 0;
#ifdef __WITH_MIPMAPS__
            while ((aux1 > 1)) {aux1 = aux1 >> 1; MIPmap_Adequat = MIPmap_Adequat+1;}
                        
            // Numero de NMipmaps (+1 reg aux)...
            aux1 = (int)((char *)void_ptr)[0x1*4];
                        
            if(MIPmap_Adequat >= aux1)
            {
                MIPmap_Adequat = aux1-1;
            }
#endif
            
            // Carrega de punter mipmap (al punter textura. Donat que no ja no necessito ms punter Textura_Superior,
            // s'utilitzar void_ptr)...

            // Actualitzem U,V, i Escala...
            U         = (U          >> MIPmap_Adequat);
            V         = (V          >> MIPmap_Adequat);
            Escale_FX = (Escale_FX  >> MIPmap_Adequat);

            // Offset vector GFX_MipMap en bytes...
            aux1 = MIPmap_Adequat*Sizeof_tImatge;

            // Obtenim punter mipmap...
            void_ptr = *((int **)void_ptr);
            
            // Punter mitmap mitjanat offset aux1...
            void_ptr = ((char *)void_ptr + aux1);
            // Mascares UV...
            log2_U = (int)((char *)void_ptr)[0x4*3]; // Lectura del log2 U en format 16.16
            aux1 = (1 << log2_U);
            aux1 = aux1 - 1;
            aux1 = aux1 & (U >> 8); // U esta en APF 16.8

            // Punter pixels de la textura...
            ptr_src  = (char *)(((int *)void_ptr)[0x4*0]);
            //  + Offset U.
            ptr_src  = ptr_src + aux1;

            // mascara V
            log2_V = (int)((char *)void_ptr)[0x4*4]; // Lectura del log2 V en format 16.16         
            mask_v = (1 << log2_V);
            mask_v = mask_v-1;
            // Log2 U 
            //log2_U   =    (int)((char *)void_ptr)[0x4*6];

paint_slice:

            // Punter desti...
            ptr_dst = (char *)(WORK_VRAM + AMPLADA_PANTALLA*(y1 << DETALL_GRAFIC_Y) + (x << DETALL_GRAFIC_X));
    
            y2d = y2 - y1 + 1;

#ifndef __WITH_EFFECTS__
            Propietats = 0;
#endif



            // Mirem si pintem textura amb efecte...
            if(Propietats == 0) // Pintat sense efecte...
            {
                // Mirem si es de tipus sprite...
                if(!TST_BIT(Propietats_Imatge, BIT_IS_SPRITE)) // No ho s..
                {
                    SDL_PutVerticalSlice_BLOCK_VPOW2_WITHOUT_EFFECT(ptr_dst, ptr_src, y2d, V, Escale_FX, mask_v, log2_U);
                }
                else // Ho s...
                {
                    SDL_PutVerticalSlice_SPRITE_VPOW2_WITHOUT_EFFECT(ptr_dst, ptr_src, y2d, V, Escale_FX, mask_v, log2_U);
                }
                
            }
            else // Pintat amb efecte mirem al mateix codi, el color de mascara.
            {
                ptr_intensitat    = ((char *)Shade + Intensitat);
                ptr_transparencia =  (char *)Glenz;// + Transparencia);
          
               // Mirem si la imatge es de tipus sprite...
                if(!TST_BIT(Propietats_Imatge,BIT_IS_SPRITE)) // No ho s...
                {
                    SDL_PutVerticalSlice_BLOCK_VPOW2_WITH_EFFECT(ptr_dst, ptr_src, ptr_intensitat, y2d, V, Escale_FX, mask_v, log2_U,Propietats);
                }
                else // Ho s...
                {
                    SDL_PutVerticalSlice_SPRITE_VPOW2_WITH_EFFECT(ptr_dst, ptr_src, ptr_intensitat, y2d, V, Escale_FX, mask_v, log2_U,Propietats);
 
                }
                
            }
            
        }
    }
    
    
}



/*
void SDL_PintarTiraPla(const tParametresPintarPla	*ParametresPintarPla)
{
	int x2d, Mascara_Altura_Textura, Mascara_Amplada_Textura, u_textura, v_textura;
	
	long color, u_mapa, v_mapa, du_mapa, dv_mapa, amplada_fx, altura_fx;
	char log2_amplada_textura,log2_altura_textura, *dest_ptr, *ptr_textura, *ptr_shade;
		

	if(ParametresPintarPla->y < 0 || ParametresPintarPla->y >= ALTURA_PANTALLA_EFECTIVA) return;
 
	if((ParametresPintarPla->x1 < 0) || (ParametresPintarPla->x2 >= AMPLADA_PANTALLA_EFECTIVA)) 
		return;


	x2d = ParametresPintarPla->x2 - ParametresPintarPla->x1 + 1;

	

	du_mapa =   ParametresPintarPla->du;
	dv_mapa =   ParametresPintarPla->dv;

	u_mapa =   ParametresPintarPla->u0;
	v_mapa =	ParametresPintarPla->v0;
	
	
	Mascara_Altura_Textura  = 63;//(((1 << PFH->Textura.LOG2_ALTURA))  -1) << PART_FRACCIONAL;
	Mascara_Amplada_Textura = 63;//(((1 << PFH->Textura.LOG2_AMPLADA)) -1) << PART_FRACCIONAL;
	
	log2_amplada_textura = 6;//PFH->Textura.LOG2_AMPLADA;
	log2_altura_textura = 6;//PFH->Textura.LOG2_ALTURA;
    amplada_fx = 64 << 16;
    altura_fx  = 64 << 16;
	
	dest_ptr = (char *)(SDL_WORK_VRAM + AMPLADA_PANTALLA*(ParametresPintarPla->y << DETALL_GRAFIC_Y) + (ParametresPintarPla->x1 << DETALL_GRAFIC_X));
	ptr_textura = ParametresPintarPla->ptr_textura;
	ptr_shade = (char *)&Shade[ ParametresPintarPla->Intensitat];
	
	u_textura = (u_mapa >> 16) & Mascara_Amplada_Textura;
	v_textura = (v_mapa >> 16) & Mascara_Altura_Textura ;

	if(x2d > 0)
	{
		do{

			// Determinar color;

			
//			u_textura = (u_mapa >> 16) & Mascara_Amplada_Textura;
//			v_textura = (v_mapa >> 16) & Mascara_Altura_Textura ;


			color = (unsigned char)ptr_textura[((v_mapa << log2_amplada_textura)>>16) + (u_mapa >> 16)];
			color = ptr_shade[color << 8];
			

#ifdef __BAIX_DETALL_Y
#ifdef __BAIX_DETALL_X

			// Carreguem 2 colors de textura...
			color = (color << 8) | color;

			*((short *)dest_ptr) = (short)color;
			*((short *)(dest_ptr + AMPLADA_PANTALLA)) = (short)color;
			dest_ptr+=2;
			
#else
			*dest_ptr = (char)color;
			*(dest_ptr + AMPLADA_PANTALLA) = (char)color;
			dest_ptr++;
#endif
#else
#ifdef __BAIX_DETALL_X
			color = (color << 8) | color;
			*((short *)dest_ptr) = (short)color;
			dest_ptr +=2;
#else
			*dest_ptr = (char) color;
			dest_ptr ++;
#endif
#endif
			
   			u_mapa -= du_mapa;
			v_mapa -= dv_mapa;
            if(u_mapa < 0) u_mapa += amplada_fx;
            if(v_mapa < 0) v_mapa += altura_fx;

	
			x2d --;

		
		}while(x2d > 0);
	
	
	}


}
*/

/*
void SDL_Preguardar_Components_Sostre(tComponentsPla  *ComponentsPla , const tParametres_PreGuardat_Components_Pla *PPC)
{
	short y, y1 ,y2;
	int diff_altura; 
	int escale, Valor_Cosinus, Valor_Sinus, Xj, Zj,centre_x, centre_z;
	FIXED32 *ptr_reciprocal_div;
	extern s16 *_x1,*_x2;


	y1 = PPC->y1;
	y2 = PPC->y2;

	if(y1 < 0 || y2 >= ALTURA_PANTALLA_EFECTIVA) return;



	Valor_Cosinus = PPC->Valor_Cosinus << 8;
	Valor_Sinus = PPC->Valor_Sinus << 8;
	Xj = PPC->Xj;
	Zj = PPC->Zj;
	diff_altura =  PPC->diff_altura;
	ptr_reciprocal_div = PPC->ptr_reciprocal_div;
	

			
	for(y = y1; y <= y2; y++)
	{
				// Clcul dels parmetres z0, x0, dxmapa i dzmapa...


#ifdef __ARITMETICA_FIXA__
				escale = (((diff_altura*(*ptr_reciprocal_div))) << DETALL_GRAFIC_X) >> DETALL_GRAFIC_Y;
#else
				escale = (((diff_altura*((int)(*ptr_reciprocal_div*(1 << 8))))) << DETALL_GRAFIC_X) >> DETALL_GRAFIC_Y;
#endif

				ComponentsPla->Z = escale*dX >> 8;

				// Centre de mapa...
				centre_x = WIN_MulFx_16_16(Valor_Cosinus,escale)*dX + (Xj << 8);
				centre_z = WIN_MulFx_16_16(Valor_Sinus,escale)*dX + (Zj << 8);

				// Clcul dels pendents de mapa (dx_mapa,dz_mapa)

				ComponentsPla->dx_mapa = - WIN_MulFx_16_16(Valor_Sinus,escale);
				ComponentsPla->dz_mapa =   WIN_MulFx_16_16(Valor_Cosinus,escale);

				ComponentsPla->u0 = centre_x + (_x1[y] - CENTRE_X2D_EFECTIU)*ComponentsPla->dx_mapa;
				ComponentsPla->v0 =	centre_z + (_x1[y] - CENTRE_X2D_EFECTIU)*ComponentsPla->dz_mapa;
	

				
				ptr_reciprocal_div--;
				ComponentsPla++;
		
				// Coordenades de mapa inicials...


	}
}*/

/*void SDL_Preguardar_Components_Pla(tComponentsPla  *ComponentsPla , const tParametres_PreGuardat_Components_Pla *PPC,short EsTerra)
{
	int y, y1 ,y2;
	int diff_altura; 
	long escale,  Valor_Cosinus, Valor_Sinus, Xj, Zj,centre_x, centre_z;
	FIXED32	*ptr_reciprocal_div;
	extern s16 *_x1,*_x2;


	_x1 = 

	y1 = PPC->y1;
	y2 = PPC->y2;

	if(y1 < 0 || y2 >= ALTURA_PANTALLA_EFECTIVA) return;



	Valor_Cosinus = PPC->Valor_Cosinus << 8;
	Valor_Sinus = PPC->Valor_Sinus << 8;
	Xj = PPC->Xj;
	Zj = PPC->Zj;
	diff_altura =  PPC->diff_altura;
	ptr_reciprocal_div = (FIXED32 *)PPC->ptr_reciprocal_div;
	

			
	for(y = y1; y <= y2; y++)
	{

#ifdef __ARITMETICA_FIXA__
				escale = (((diff_altura*(*ptr_reciprocal_div))) << DETALL_GRAFIC_X) >> DETALL_GRAFIC_Y;
#else
				escale = (((diff_altura*((long)(*ptr_reciprocal_div*(1 << 8))))) << DETALL_GRAFIC_X) >> DETALL_GRAFIC_Y;
#endif

				ComponentsPla->Z = escale*dX >> 8;

				// Centre de mapa...
				centre_x = WIN_MulFx_16_16(Valor_Cosinus,escale)*dX + (Xj << 8);
				centre_z = WIN_MulFx_16_16(Valor_Sinus,escale)*dX + (Zj<<8);

				// Clcul dels pendents de mapa (dx_mapa,dz_mapa)

				ComponentsPla->dx_mapa = - WIN_MulFx_16_16(Valor_Sinus,escale);
				ComponentsPla->dz_mapa =   WIN_MulFx_16_16(Valor_Cosinus,escale);

				ComponentsPla->u0 = centre_x + (x1[y] - CENTRE_X2D_EFECTIU)*ComponentsPla->dx_mapa;
				ComponentsPla->v0 =	centre_z + (x1[y] - CENTRE_X2D_EFECTIU)*ComponentsPla->dz_mapa;

				
				EsTerra ? ptr_reciprocal_div++ : ptr_reciprocal_div--;
				ComponentsPla++;
		
				// Coordenades de mapa inicials...

	
				ComponentsPla->x0 = centre_x + (x1[i] - CENTRE_X2D_EFECTIU)*PFH.dxmapa;
				ComponentsPla->z0 = centre_z + (x1[i] - CENTRE_X2D_EFECTIU)*PFH.dzmapa;

			

				// Selecci del MIPmap...
			Seleccio_MIPMAP(MIPmap_Seleccionat,escale);
				if(MIPmap_Seleccionat >= Textura[NTextura].Numero_MIPmaps)  MIPmap_Seleccionat = Textura[NTextura].Numero_MIPmaps-1;
					
				PFH.x0 >>= MIPmap_Seleccionat;
				PFH.z0 >>= MIPmap_Seleccionat;
				
				PFH.dxmapa >>= MIPmap_Seleccionat;
				PFH.dzmapa >>= MIPmap_Seleccionat;
				
				PFH.Textura = Textura[NTextura].MIPmap[MIPmap_Seleccionat];
					
				SDL_PintarTiraPla(x1[i], x2[i], i, &PFH);
		}
		else // Es renderitza el paisatge...
		{
		
		}
	}


}*/




#endif

/*typedef struct{

        int x1;
        int x2;
        int y;
        int ID_Textura;

        tComponentsPlaSector  *CPS;

}tParametresPintarTiraPla;
*/
/*
typedef struct{

	int dx_mapa;            // derivada increment u.
	int dz_mapa;            // derivada increment v.
    int intensitat;         // Intensitat de llum segons la distancia...
    int escale;             // Per, ms tard, alhora de fer el mapeig, saber el mipmap.
    int centre_x;           // centre projecci u.
    int centre_z;           // centre projecci v.
    int Propietats_Objecte;
   
}tComponentsPlaSector;
*/
void SDL_PutHorizontalSlice_BLOCK_UVPOW2_WITHOUT_EFFECTS(char *ptr_dst, char *ptr_src, int x2d, int u_mapa, int v_mapa, int du_mapa,int  dv_mapa, int mask_u, int mask_v,int log2_amplada_textura)
{
    int color;

    if(x2d > 0)
    {
        do{
			color = (unsigned char)ptr_src[(((v_mapa >>16)& (mask_v) ) << log2_amplada_textura  ) + ((u_mapa >> 16) & (mask_u))];
//			color = ptr_shade[color << 8];
			

#ifdef __BAIX_DETALL_Y
#ifdef __BAIX_DETALL_X

			// Carreguem 2 colors de textura...
			color = (color << 8) | color;

			*((short *)ptr_dst) = (short)color;
			*((short *)(ptr_dst + AMPLADA_PANTALLA)) = (short)color;
			ptr_dst+=2;
			
#else
			*ptr_dst = (char)color;
			*(ptr_dst + AMPLADA_PANTALLA) = (char)color;
			ptr_dst++;
#endif
#else
#ifdef __BAIX_DETALL_X
			color = (color << 8) | color;
			*((short *)ptr_dst) = (short)color;
			ptr_dst +=2;
#else
			*ptr_dst = (char) color;
			ptr_dst ++;
#endif
#endif

   			u_mapa += du_mapa;
			v_mapa += dv_mapa;

//            u_mapa = u_mapa & ()


            //if(u_mapa < 0) u_mapa = u_mapa + (amplada << 16);
            //if(v_mapa < 0) v_mapa = v_mapa + (altura  << 16);

            

            
        }while(--x2d);
    }
}

void SDL_PutHorizontalSlice_BLOCK_UVPOW2_WITH_EFFECTS(char *ptr_dst, char *ptr_src, unsigned char *ptr_intensitat, int x2d, int u_mapa, int v_mapa, int du_mapa,int  dv_mapa, int mask_u, int mask_v,int log2_amplada_textura)
{
    u16 color;

    if(x2d > 0)
    {
        do{
			color = (unsigned char)ptr_src[(((v_mapa >>16)& (mask_v) ) << log2_amplada_textura  ) + ((u_mapa >> 16) & (mask_u))];
//			color = ptr_shade[color << 8];
			
            color = ptr_intensitat[color << 8];

#ifdef __BAIX_DETALL_Y
#ifdef __BAIX_DETALL_X

			// Carreguem 2 colors de textura...
			color = (color << 8) | color;

			*((short *)ptr_dst) = (short)color;
			*((short *)(ptr_dst + AMPLADA_PANTALLA)) = (short)color;
			ptr_dst+=2;

			
#else
			*ptr_dst = (char)color;
			*(ptr_dst + AMPLADA_PANTALLA) = (char)color;
			ptr_dst++;
#endif
#else
#ifdef __BAIX_DETALL_X
            //color = rand()%256;
			color = (color) | (color << 8);
			*((short *)ptr_dst) = color;
			ptr_dst +=2;
#else
			*ptr_dst = (char) color;
			ptr_dst ++;
#endif
#endif

   			u_mapa += du_mapa;
			v_mapa += dv_mapa;

//            u_mapa = u_mapa & ()


            //if(u_mapa < 0) u_mapa = u_mapa + (amplada << 16);
            //if(v_mapa < 0) v_mapa = v_mapa + (altura  << 16);

            

            
        }while(--x2d);
    }
}


void SDL_PutHorizontalSlice(tParametresPintarTiraPla *PPTP)
{
    int x1,mask_u, amplada_u,                       // r0.
        x2, x2d,                                // r1.
        offset_video,y, log2_V, mask_v, altura_v;         // r2.
    int ID_Textura;void *void_ptr;              // r3.
        tComponentsPlaSector *CPS; int du;      // r4.

    int   dv,                                   // r5.
          intensitat; void *ptr_intensitat;     // r6.
    int   Escale_FX, MIPmap_Adequat, log2_U,    // r7.
          centre_u,u1,                          // r8.
          centre_v,v1;                          // r9.

   int   Propietats;                            // r10.
   char  *ptr_dst,                              // r11.
         *ptr_src;                              // r12.
   int   aux1;                                  // r14


    // 1era carrega...
   
    x1          = PPTP->x1;
    x2          = PPTP->x2;
    y           = PPTP->y;
    ID_Textura  = PPTP->ID_Textura;
    CPS         = PPTP->CPS;

    if(x1 < 0 || x2 >= AMPLADA_PANTALLA_EFECTIVA || x1 >= AMPLADA_PANTALLA_EFECTIVA || x2 < 0 || x1 > x2) return;
    if(y  < 0 || y >= ALTURA_PANTALLA_EFECTIVA) return;
    

    // ok!, ha passat el filtre...
    x2d = x2 - x1;
    x2d = x2d + 1;

    // calculem offset video...
	//dest_ptr = (char *)(SDL_WORK_VRAM + AMPLADA_PANTALLA*(ParametresPintarPla->y << DETALL_GRAFIC_Y) + (ParametresPintarPla->x1 << DETALL_GRAFIC_X));
    //AMPLADA_PANTALLA*(ParametresPintarPla->y << DETALL_GRAFIC_Y) + (ParametresPintarPla->x1 << DETALL_GRAFIC_X)
    offset_video = y << DETALL_GRAFIC_Y;
    offset_video = offset_video*AMPLADA_PANTALLA;
    offset_video = offset_video+(x1 << DETALL_GRAFIC_X);
        
    // Punter video... 
    ptr_dst = WORK_VRAM;
    // Punter video + offset...
    ptr_dst = ((char *)ptr_dst + offset_video);

    if(ID_Textura > 0) goto mapeig_textura; // Mapeig amb color...
    if(ID_Textura < 0) goto mapeig_color;
    goto end;

mapeig_color:
    
    // Prximament...
    memset(ptr_dst,GREY_COLOR,x2d);
    
    goto  end;

mapeig_textura:

    // Carrega derivades...
    du          = CPS->dx_mapa;      
    dv          = CPS->dz_mapa;      
    intensitat  = CPS->intensitat;   
    Escale_FX   = CPS->escale;
    centre_u    = CPS->centre_x;
    centre_v    = CPS->centre_z;

    // Punter + offset textura...
    aux1        = Sizeof_tTextura;
    aux1        = aux1*ID_Textura;
    void_ptr    = Textura;
    void_ptr    = ((char *)void_ptr + aux1);

    // Comprobem si es potencia de 2 i es quadrada...
    Propietats = *((int *)(((int *)void_ptr + 0x2)));

    if(!IS_UPOW2(Propietats))  goto end;
    if(!IS_VPOW2(Propietats))  goto end;
//    if(!IS_SQUARE(Propietats)) goto end; // proximament...

    // Calculem mipmap...
    aux1 = Escale_FX >> 16;
    MIPmap_Adequat = 0;

#ifdef __WITH_MIPMAPS__
    while ((aux1 > 1)) {aux1 = aux1 >> 1; MIPmap_Adequat = MIPmap_Adequat+1;}
                        
    // Numero de NMipmaps (+1 reg aux)...
    aux1 = (int)((char *)void_ptr)[0x1*4];
                        
    if(MIPmap_Adequat >= aux1) // Pintarem x color
    {
         goto mapeig_color;
    }
#endif
    // Carrega de punter mipmap (al punter textura. Donat que no ja no necessito ms punter Textura_Superior,
    // s'utilitzar void_ptr)...

    // Calcul de UV + actualitzaci segons mipmap...
    aux1 = (x1 - CENTRE_X2D_EFECTIU);
    aux1 = aux1*du;
    u1   = centre_u + aux1;
    u1   = u1 >> MIPmap_Adequat;


    aux1 = (x1 - CENTRE_X2D_EFECTIU);
    aux1 = aux1*dv;
    v1   = centre_v + aux1;
    v1   = v1 >> MIPmap_Adequat;

    du = (du  >> MIPmap_Adequat);
    dv = (dv  >> MIPmap_Adequat);

    // Offset vector GFX_MipMap en bytes...
    aux1 = Sizeof_tImatge;
    aux1 = aux1*MIPmap_Adequat;

    // Obtenim punter mipmap...
    void_ptr = *((int **)void_ptr);
            
    // Punter mitmap mitjanat offset aux1...
    void_ptr = ((char *)void_ptr + aux1);

    // mascara U...
    log2_U = (int)((char *)void_ptr)[0x4*3]; // Lectura del log2 U
    mask_u = (1 << log2_U);
    mask_u = mask_u - 1;
   // u1 = u1 & (mask_u << 16); // U esta en APF 16.16
    amplada_u = mask_u + 1;
    

    // mascara V...
    log2_V = (int)((char *)void_ptr)[0x4*4]; // Lectura del log2 V    
    mask_v = (1 << log2_V);
    mask_v = mask_v-1;
  //  v1 = v1 & (mask_v << 16); // V esta en APF 16.16
    altura_v = mask_v + 1;


    // punter font...
    //ptr_src = (char *)((char *)void_ptr)[0x4*0];
    ptr_src  = (char *)(((int *)void_ptr)[0x4*0]);

    // ok ja ho tenim a punt pel mapeig ?
#ifndef __WITH_EFFECTS__
            Propietats = 0;
#endif


   if(Propietats == 0)
    SDL_PutHorizontalSlice_BLOCK_UVPOW2_WITHOUT_EFFECTS(ptr_dst, ptr_src, x2d, u1, v1, du, dv, amplada_u-1, altura_v-1, log2_U);
   else
   {
        ptr_intensitat = (char *)Shade + intensitat;
        SDL_PutHorizontalSlice_BLOCK_UVPOW2_WITH_EFFECTS(ptr_dst, ptr_src, ptr_intensitat, x2d, u1, v1, du, dv, amplada_u-1, altura_v-1, log2_U);
   }








    // 

    // ok, podem mapejar...
    // Calculem
    


  

    

    
    
end:

    u1 = u1;

}


