//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA


#ifndef __DEFINICIONS_H_
#define __DEFINICIONS_H_

/*************\
| DEFINICIONS |
\*************/

// Directives per determinar la plataforma en que es treballar...


#if defined(_WINDOWS) || defined(_LINUX)
#ifndef __SDL__
 #define __SDL__
#endif
 #include "conio.h"
 #include "memory.h"
 #include "string.h"
 #include "SDL/SDL.h"
#endif

#if defined(__arm__) || defined(__thumb__)       // definit en l' arxiu "gcc-arm\arm-thumb-elf\include\machine\stdlib.h"
#ifndef __HAM__
 #define __HAM__
#endif
 #include "myGBA.h"
#endif


#if defined( _WINDOWS) || defined(_LINUX)
 #include "SDL/SDL.h"


 typedef SDL_Surface   *tBuffer;

 typedef Uint64 u64;
 typedef Uint32 u32;
 typedef Uint16 u16;
 typedef Uint8	u8;

 typedef Sint64 s64;
 typedef Sint32 s32;
 typedef Sint16 s16;
 typedef Sint8	s8;

#endif


#include "Aritmetica.h"
#include "util.h"



/************************\
| DEFINICIONS DE JUGADOR |
\************************/

#define PARET_MES_PROXIMA			(DOUBLE_TO_FIXED(16.5))   // 31.5 en APF

// Definici llinterna

#define MAXIMA_ILUMINACIO_LLINTERNA			40
#define MINIMA_DISTANCIA_LLINTERNA			INT_TO_FIXED(4)
#define ATENUACIO_ILUMINACIO_LLINTERNA		DOUBLE_TO_FIXED(-0.1259)
#define MAXIMA_INTENSITAT					150



/*************************\
| DEFINICIONS DE PANTALLA |
\*************************/
#ifdef __SDL__ // treballem sobre plataforma SDL per tant es pot variar la resoluci espaial.
	
	#define AMPLADA_PANTALLA			240
	#define ALTURA_PANTALLA				160
	

	#define VELOCITAT_JUGADOR			 1
	#define LOG2_VELOCITAT_JUGADOR       4 
	#define VELOCITAT_GIR				 8
	#define VELOCITAT_PITCH				 16
	#define VELOCITAT_AIXECAR_SE		 4
	#define VELOCITAT_AJUPIR_SE			 6
	#define VELOCITAT_VOLAR				 8


	

	
#endif

#ifdef __HAM__   // treballem sobre plataforma GBA per tant, la resoluci s de 240x160.
	#define AMPLADA_PANTALLA	   400
	#define ALTURA_PANTALLA		   300

	

	#define VELOCITAT_JUGADOR		 1
	#define LOG2_VELOCITAT_JUGADOR   4
	#define VELOCITAT_GIR            8
	#define VELOCITAT_PITCH			 8

	#define VELOCITAT_AIXECAR_SE		 6
	#define VELOCITAT_AJUPIR_SE			 4
	#define VELOCITAT_VOLAR				 16
	
	

#endif

    #define CENTRE_Y2D    (ALTURA_PANTALLA  >> 1)
	#define CENTRE_X2D    (AMPLADA_PANTALLA >> 1)





//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// INICI DEFINICIONS NIVELL GRFIC
// -------------------------------
//
// LES SEGENTS DEFINICIONS DEFINEIXEN LA QUALITAT DE LA RESOLUCI X I/O Y. CAL POSAR LES SEGUENTS DEFINICIONS EN COMENTARI
// SI ES VOL UTILITZAR MXIM NIVELL DE COORDENADA XY DE PANTALLA.
//
//  IMPORTANT !!! SI ES VOL CREAR LA ROM GBA I SI ES POSA ALGUNA DE LES SEGENTS DEFINICIONS EN COMENTARI, 
// CALDR MODIFICAR LES DEFINCIONS A L'ARXIU ENSAMBLADOR "ARM_ScanLines.s" PER UN CORRECTE FUNCIONAMENT
//
//


#ifdef __SDL__
//#define __BAIX_DETALL_X
//#define __BAIX_DETALL_Y
#endif


//
//
// FI DEFINICIONS NIVELL GRFIC
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////



#ifdef __BAIX_DETALL_X		// 1 baix nivell, 0 alt nivell

	#define DETALL_GRAFIC_X			1
	#define  dX	(AMPLADA_PANTALLA >> 2)

#else
	
	#define DETALL_GRAFIC_X			0					
	#define  dX	(AMPLADA_PANTALLA >> 1)

#endif

#ifdef __BAIX_DETALL_Y		// 1 baix nivell, 0 alt nivell

	#define DETALL_GRAFIC_Y			1
	#define  dY	(AMPLADA_PANTALLA >> 2)

#else

	#define DETALL_GRAFIC_Y			0
	#define  dY	(AMPLADA_PANTALLA >> 1)					

#endif


	
	#define ALTURA_PANTALLA_EFECTIVA  (ALTURA_PANTALLA >> DETALL_GRAFIC_Y)
	#define AMPLADA_PANTALLA_EFECTIVA  (AMPLADA_PANTALLA >> DETALL_GRAFIC_X)

	#define CENTRE_Y2D_EFECTIU      (ALTURA_PANTALLA_EFECTIVA  >> 1)
	#define CENTRE_X2D_EFECTIU      (AMPLADA_PANTALLA_EFECTIVA >> 1)


	#define d						  CENTRE_X2D
	#define d_efectiva				  CENTRE_X2D_EFECTIU




	

/**********************\
| DEFINICIONS DE IMATGE |
\**********************/

//#define N_MIPMAPS				  (3 + 1)


/********************\
| DEFINICIONS RENDER |
\********************/


#define FOV                              90.0
#define INCREMENT_FOV                    (FOV/AMPLADA_PANTALLA_EFECTIVA)
#define TOTAL_INCREMENTS_FOV_EN_360      (360.0/INCREMENT_FOV)
#define MAX_DIST_RENDER				     16000
#define PARET							 0
#define SOLID							 0

/* enum{
    BIT_RENDER_WITH_BRIGHT= 0,
    BIT_RENDER_WITH_GLENZING
 };*/


#define MASK_RENDER_WITH_BRIGH       MASK_BIT(BIT_RENDER_WITH_BRIGHT)
#define MASK_RENDER_WITH_GLENZING    MASK_BIT(BIT_RENDER_WITH_GLENZ)

/*************************\
| DEFINICIONS DE JUGADOR |
\*************************/


#define ALTURA_JUGADOR	40
#define MINIMA_ALTURA_JUGADOR  8
#define INCREMENT_ANGLE_JUGADOR   (360.0/256.0)    //(FOV/AMPLADA_PANTALLA)


/*********************\
| DEFINICIONS DE LUTS |
\*********************/

#define TAMANY_LUT			  256 //ned)(360.0f/(INCREMENT_FOV))

#define FOV_ENUMERAT		 AMPLADA_PANTALLA_EFECTIVA
#define MAX_RECIPROCAL_DIV   MAX_DIST_RENDER+1

/********************\
| ALTRES DEFINICIONS |
\********************/

#define CERT 1
#define FALS 0


/*******************\
| VARIABLES GLOBALS |
\*******************/


#ifdef __HAM__

	extern const FIXED32 _Sinus[256];
	extern const FIXED32 _Cosinus[256];
	extern const FIXED32 BAIX_DETALL_Tangent_Pla[120];
	extern const FIXED32 ALT_DETALL_Tangent_Pla[240];

    extern const int _SinRaig_Baix[120];
    extern const int _SinRaig_Alt [240];
	extern const int _CosRaig_Baix[120];
    extern const int _CosRaig_Alt [240];
	

	#ifdef __BAIX_DETALL_X
		#define _Tangent_Pla BAIX_DETALL_Tangent_Pla
        #define _SinRaig _SinRaig_Baix
        #define _CosRaig _CosRaig_Baix
	#else
		#define _Tangent_Pla ALT_DETALL_Tangent_Pla
        #define _SinRaig _SinRaig_Alt
        #define _CosRaig _CosRaig_Alt
	#endif

	extern const FIXED32 _reciprocal_div[MAX_RECIPROCAL_DIV];


#else

	extern FIXED32 _Sinus[TAMANY_LUT];
	extern FIXED32 _Cosinus[TAMANY_LUT];
	extern FIXED32 Tangent[TAMANY_LUT];

	extern FIXED32 _Tangent_Pla[AMPLADA_PANTALLA_EFECTIVA];
    extern FIXED32 _CosRaig[AMPLADA_PANTALLA_EFECTIVA];
    extern FIXED32 _SinRaig[AMPLADA_PANTALLA_EFECTIVA];
	extern FIXED32 _reciprocal_div[MAX_RECIPROCAL_DIV];

#endif


// DU i DV estn a APF 16.16
#define DU_PAISATGE (long)((AMPLADA_PAISATGE*65536)/TOTAL_INCREMENTS_FOV_EN_360)
#define	DV_PAISATGE (long)((ALTURA_PAISATGE*65536)/(ALTURA_PANTALLA_EFECTIVA + 2*CENTRE_Y2D_EFECTIU ))

#ifdef __HAM__ // Podem aconseguir les dv i du de manera rapida, segons l'amplada i altura de la imatge.

#define GET_DU_PAISATGE(n,amplada_imatge)\
	(n) = FIXED_MUL_65536(amplada_imatge);\
	FastDiv960Fx(n);\
	n = ((n) << DETALL_GRAFIC_X);\

#define GET_DV_PAISATGE(n,altura_imatge)\
	(n) = FIXED_MUL_65536(altura_imatge);\
	FastDiv320Fx(n);\
	n = ((n) << DETALL_GRAFIC_Y);\

#else

#define GET_DU_PAISATGE(n,amplada_imatge) (n=(long)((amplada_imatge*65536)/TOTAL_INCREMENTS_FOV_EN_360))
#define GET_DV_PAISATGE(n,altura_imatge)  (n=(long)((altura_imatge*65536)/(ALTURA_PANTALLA_EFECTIVA + 2*CENTRE_Y2D_EFECTIU )))

#endif
//extern FIXED32 d;
extern FIXED32 reciprocal_dY;
//extern FIXED32 DU_Paisatge;
//extern FIXED32 DV_Paisatge;

// Graus enumerats
#define	GRAU_45   (unsigned char)(32)
#define GRAU_90   (unsigned char)(64)
#define	GRAU_135  (unsigned char)(96)
#define	GRAU_180  (unsigned char)(128)
#define	GRAU_225  (unsigned char)(160)
#define	GRAU_270  (unsigned char)(192)
#define	GRAU_315  (unsigned char)(224)






/************\
| PROTOTIPUS |
\************/

void Inicialitzacio_Variables_Constants();
void Inicialitzacio_De_Constants_LUTS();

#endif










