//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA



#include "geometria.h"
#include "main.h"



//-----------------------------------------------------------------------------
//----------------  FUNCIONS ETAPA GEOMTRICA ---------------------------------
//-----------------------------------------------------------------------------




int InterseccioQuadrats(tQuadrat_XZ Q1, tQuadrat_XZ Q2)
{

	s16 z1min,x1min,x2min,z2min,x_mitg,z_mitg, x_intersecta,z_intersecta;

	x1min = max(Q1.x1,Q2.x1);	
	z1min = max(Q1.z1,Q2.z1);	
	
	x2min = min(Q1.x2,Q2.x2);	
	z2min = min(Q1.z2,Q2.z2);	

	x_mitg = ((x2min + x1min) >> 1);
	z_mitg = ((z2min + z1min) >> 1);

	x_intersecta = ((Q1.x1 <= x_mitg) && (x_mitg <= Q1.x2))&&((Q2.x1 <= x_mitg) && (x_mitg <= Q2.x2));
	z_intersecta = ((Q1.z1 <= z_mitg) && (z_mitg <= Q1.z2))&&((Q2.z1 <= z_mitg) && (z_mitg <= Q2.z2));

	return (x_intersecta && z_intersecta);
	
	
}





//#ifndef __RENDER_RECURSIU__
FUNCIO_A_MEMORIA_INTERNA
//#endif
int LiniaInterseccio
(int x,
 const tJugador *Jugador,
 const tSector *Sector,
 tPunt_Fixa_2D *Inter,
 int UTILITZAR_EL_VERTEX_TRANSFORMAT
)
{
	
	int					LiniaTrobada, 
						LiniaActual,
						fi,
						V0_es_projecta_a_la_esquerra, 
						V1_es_projecta_a_la_dreta,
						NumeroLinies,
                        ProducteVectorial_Eix_D;


	tPunt_Fixa_2D		V1_ull, 
						V0_ull,
						V0_ull_Aux,
						V1_ull_Aux;

	tLiniaSector		*LiniaSector;

	FIXED32				b = 0, 
						x_diff, 
						z_diff, 
						m1, Aux,
						_Tangent_X = _Tangent_Pla[x];

	tSector				*SectorActual = (tSector *)Sector;

	tCachedVertex		*_CachedVertexs = CachedVertexs, 
						*CachedVertex;

	tVertex				*V0_mon,
						*V1_mon;

	u8					AngleDireccioJugador;
	


	
	if(SectorActual == NULL) return -1;
	
	
	// Inicialitzacions...
	LiniaSector = &SectorActual->LiniaSector[0];
	V0_mon = &LiniaSector->Linia.V0;
	LiniaActual = 0;
	LiniaTrobada = -1;
	fi = FALS;
	NumeroLinies = Sector->NumeroLinies;
	
	
	//		 TOOL_PROFILER_START
	

	AngleDireccioJugador = Jugador->AngleDireccio;
	//	 v_p = FALSE;
	
	CachedVertex = &_CachedVertexs[V0_mon->ID_Vertex];
	if(!UTILITZAR_EL_VERTEX_TRANSFORMAT)
	{
		punt_mon_A_pla_projeccio(Jugador, V0_mon->X, V0_mon->Z, &V0_ull);
	}
	else
	{
		if(!CachedVertex->Rotated) // El vertex transformat no el tenim guardat...
		{
			punt_mon_A_pla_projeccio(Jugador, V0_mon->X, V0_mon->Z, &V0_ull);
			CachedVertex->TransformedVertex = V0_ull;
			CachedVertex->Projected = FALSE;
			CachedVertex->Rotated = TRUE;
		}
		else // caldria modificar posicio resepcte jugador vertex...
		{
			V0_ull = CachedVertex->TransformedVertex;
		}
		
	}

//	punt_mon_A_pla_projeccio(Jugador, V0_mon->X, V0_mon->Z, &V0_ull);
	
	
	while((!fi) && (LiniaActual < NumeroLinies))
	{
		V1_mon = &LiniaSector->Linia.V1;
		
		CachedVertex = &_CachedVertexs[V1_mon->ID_Vertex];

		if(!UTILITZAR_EL_VERTEX_TRANSFORMAT)
		{
			punt_mon_A_pla_projeccio(Jugador, V1_mon->X, V1_mon->Z, &V1_ull);
		}
		else
		{
			
			if(!CachedVertex->Rotated) // El vertex transformat no el tenim guardat...
			{
				punt_mon_A_pla_projeccio(Jugador, V1_mon->X, V1_mon->Z, &V1_ull);
				CachedVertex->TransformedVertex = V1_ull;
				CachedVertex->Projected = FALSE;
				CachedVertex->Rotated = TRUE;
			}
			else // caldria modificar posicio resepcte jugador vertex...
			{
				
				V1_ull = CachedVertex->TransformedVertex;
			}
			
			
		}
		
//		punt_mon_A_pla_projeccio(Jugador, V1_mon->X, V1_mon->Z, &V1_ull);
		
		
		V0_ull_Aux = V0_ull;
		V1_ull_Aux = V1_ull;
	
		
		
		if(!((V0_ull.Z < 0) && (V1_ull.Z < 0))) //  Lnia de intersecci vlida...
		{

 			// Determinaci de la b si alguna de les Z dels vrtexs respecte pla s negativa..
			if((V0_ull.Z < 0) || (V1_ull.Z < 0))
			{
				b = 0;
				
				x_diff = (V1_ull_Aux.X - V0_ull_Aux.X);
				z_diff = (V1_ull_Aux.Z - V0_ull_Aux.Z);
				
				
				
				if(x_diff == 0) { b = V0_ull_Aux.X; }
				else
				{
					if(ABS_FX(z_diff) < ONE_FX) // El denominador amplifica...
					{
						if(ABS_FX(x_diff) > ABS_FX(FIXED_MUL_256(z_diff)))	// Es pot considerar pendent molt gran com perqu sigui una lnia vertical...	 
						{
							V0_ull_Aux.Z = V1_ull_Aux.Z;
						}
					}
					else
					{
						// Obtenci del pendent a alta precisi...
#ifdef __ARITMETICA_FIXA__
						m1 = DivFx_16_16(x_diff << 8,z_diff<<8);
#else
						m1 = DivFx(x_diff,z_diff);
#endif
						
						if(ABS_FX(m1) > FIXED_MUL_256(ONE_FX_16_16)) // Es pot considerar pendent molt gran com perqu sigui una lnia vertical...	 
						{
							V0_ull_Aux.Z = V1_ull_Aux.Z;
							
						}
						else b = -MulFx_16_16(V0_ull_Aux.Z,m1) + V0_ull_Aux.X; // Poder introduiex algun error, que far la entrega incorrecta de la lnia de intersecci...
					}
				}
			}

 			ProducteVectorial_Eix_D = (MulFx_16_16(_SinRaig[x],(V1_ull.Z-V0_ull.Z))-MulFx_16_16(_CosRaig[x],(V1_ull.X-V0_ull.X)));// >= 0? CERT:FALS;

			// V0...
            if(V0_ull.Z < 0)  // Fem el producte vectorial si representa una orientaci vlida...
			{
               // ProducteVectorial_Eix_D = (MulFx_16_16(_CosRaig[x],(V1_ull.Z-V0_ull.Z))-MulFx_16_16(_SinRaig[x],(V1_ull.X-V0_ull.X)));// >= 0? CERT:FALS;
				
				if(ProducteVectorial_Eix_D <= 0 ) V0_es_projecta_a_la_esquerra = CERT; // Projectat a l'esquerra...
                //if((b < 0) && (V1_ull.Z > 0)) V0_es_projecta_a_la_esquerra = TRUE;
                else V0_es_projecta_a_la_esquerra = FALS;
				//else  V0_es_projecta_a_la_esquerra = FALS; // Projectat a l'esquerra...
			}
			else
			{
				
#ifdef __ARITMETICA_FIXA__
				Aux = MulFx_16_16(_Tangent_X,V0_ull.Z);
#else
				Aux = FIXED_DIV_256(MulFx_16_16(_Tangent_X,V0_ull.Z));
#endif
				
				if(V0_ull.X <=  Aux) V0_es_projecta_a_la_esquerra = CERT;
				else V0_es_projecta_a_la_esquerra = FALS;
				
				
			}
            
			
			// V1...
			if(V1_ull.Z < 0) // Fem el producte vectorial si representa una orientaci vlida...
			{
              //  ProducteVectorial_Eix_D = (MulFx_16_16(_CosRaig[x],(V1_ull.Z-V0_ull.Z))-MulFx_16_16(_SinRaig[x],(V1_ull.X-V0_ull.X)));// >= 0? CERT:FALS;

				if(ProducteVectorial_Eix_D <= 0) V1_es_projecta_a_la_dreta = CERT;// Projectat la esquerra...
                //if((b > 0) && (V0_ull.Z > 0)) V1_es_projecta_a_la_dreta = TRUE;
				else V1_es_projecta_a_la_dreta = FALS;// V1 no es projecta a la esquerra...
			}
			else
			{
				
#ifdef __ARITMETICA_FIXA__
				Aux = MulFx_16_16(_Tangent_X,V1_ull.Z);
#else
				Aux = FIXED_DIV_256(MulFx_16_16(_Tangent_X,V1_ull.Z));
#endif
				
				if(V1_ull.X > Aux) V1_es_projecta_a_la_dreta = CERT;
				else V1_es_projecta_a_la_dreta = FALS;
				
			}
            


			
			if( V0_es_projecta_a_la_esquerra && V1_es_projecta_a_la_dreta ) // Aleshores s'ha trobat la lnia d'intersecci...
			{
                if(ProducteVectorial_Eix_D > 0)
                {
                    int kk = 0;

                    kk =1;
                }

                if(ProducteVectorial_Eix_D <= 0)
                {
                    int kk = 0;

                    kk =1;
                }
				
				LiniaTrobada = LiniaActual;
				fi = CERT;
				
				Interseccio_Raig_Linia(_Tangent_X, &V0_ull_Aux, &V1_ull_Aux, Inter);
				
				punt_pla_projeccio_A_mon(Jugador, Inter->X, Inter->Z, Inter);
				
				
				// Si la lnia s recta, s'ha de forar que la intersecci ho sigui perqu funcioni la funci Component_U (a l'arxiu "render.c")
				
				if(V0_mon->X == V1_mon->X) Inter->X = V1_mon->X;
				if(V0_mon->Z == V1_mon->Z) Inter->Z = V1_mon->Z;

                				
				
			}
		 }
		 
		 
		 //LiniaAnterior = LiniaActual;
		 V0_ull = V1_ull; 
		 V0_mon = V1_mon;

         	
		 
		 LiniaActual++;
		 LiniaSector++;
		 
	 }
	 
	 //				TOOL_PROFILER_END
	 
	 if(LiniaTrobada >= 0)
	 {
		 if((Inter->X == V1_mon->X) && (Inter->Z == V1_mon->Z)) // En qualsevol cas s'assignar la segent lnia...
		 {
				LiniaTrobada++;

				if(LiniaTrobada >= NumeroLinies) LiniaTrobada = 0;
		 }
	 }
	 
 
	 
	 
	 return LiniaTrobada;	
	 
}



#ifdef __HAM__
MEM_FUNC_IN_IWRAM
#endif
void punt_pla_projeccio_A_mon(const tJugador *Jugador, FIXED32 Xp, FIXED32 Zp, tPunt_Fixa_2D *Punt_Rotat)
{
	//
	// Xp i Zp representen el punt respecte el pla projecci.
	//


	FIXED32 x, z;//_diff = FIXED_TO_INT(Xp - Xo);
	unsigned char Angle = Jugador->AngleDireccio;
	FIXED32		*Cosinus = (FIXED32 *)_Cosinus, *Sinus = (FIXED32 *)_Sinus;
	//int z_diff = FIXED_TO_INT(Zp - Zo);

	x = MulFx(Zp,FIXED_DIV_256(Cosinus[Angle]))  -  MulFx(Xp,FIXED_DIV_256(Sinus[Angle]));
	z = MulFx(Zp,FIXED_DIV_256(Sinus[Angle])) + MulFx(Xp,FIXED_DIV_256(Cosinus[Angle]));

	Punt_Rotat->X = x + Jugador->X;
	Punt_Rotat->Z = z + Jugador->Z;

}



#ifdef __HAM__
MEM_FUNC_IN_IWRAM
#endif
void punt_mon_A_pla_projeccio(const tJugador *Jugador, FIXED32 Xp, FIXED32 Zp, tPunt_Fixa_2D *Punt_Rotat)
{
	// PRE: Entrada de Jugador->X, Jugador->Z, Xp i Zp a una precisi APF 16.8

	unsigned Angle = Jugador->AngleDireccio;
	FIXED32		*Cosinus = (FIXED32 *)_Cosinus, *Sinus = (FIXED32 *)_Sinus;


#ifdef __ARITMETICA_FIXA__ // Aritmertica 23.1
	FIXED32 x_diff = (Xp - Jugador->X) >> (PART_FRACCIONAL - 1);
	FIXED32 z_diff = (Zp - Jugador->Z) >> (PART_FRACCIONAL - 1);

	Punt_Rotat->Z =  FIXED_DIV_512(x_diff*Cosinus[Angle]) + FIXED_DIV_512(z_diff*Sinus[Angle]);
	Punt_Rotat->X = -FIXED_DIV_512(x_diff*Sinus[Angle])   + FIXED_DIV_512(z_diff*Cosinus[Angle]);
#else
	FIXED32 x_diff = Xp - Jugador->X;
	FIXED32 z_diff = Zp - Jugador->Z;

	Punt_Rotat->Z =  FIXED_DIV_256(x_diff*Cosinus[Angle]) + FIXED_DIV_256(z_diff*Sinus[Angle]);
	Punt_Rotat->X = -FIXED_DIV_256(x_diff*Sinus[Angle])   + FIXED_DIV_256(z_diff*Cosinus[Angle]);
#endif


	

	// POST: Retorna el "Punt_Rotat" a una precicisi 16.8
}



/*
void punt_mon_A_pla_projeccio_precis(const tJugador *Jugador, FIXED32 Xp, FIXED32 Zp, tPuntMapa *Punt_Rotat)
{

	// PRE: Entrada de Jugador->X, Jugador->Z, Xp i Zp a una precisi APF 16.8

	FIXED32 x_diff = (Xp - Jugador->X);
	FIXED32 z_diff = (Zp - Jugador->Z);
	unsigned Angle = Jugador->AngleDireccio;
	FIXED32		*Cosinus = (FIXED32 *)_Cosinus, *Sinus = (FIXED32 *)_Sinus;


#ifdef __ARITMETICA_FIXA__
	Punt_Rotat->Z =  MulFx_16_16(x_diff << 8, Cosinus[Angle])  + MulFx_16_16(z_diff << 8,Sinus[Angle]);
	Punt_Rotat->X = -MulFx_16_16(x_diff <<8, Sinus[Angle])    + MulFx_16_16(z_diff << 8, Cosinus[Angle]);
#else
	Punt_Rotat->Z =  MulFx_16_16(x_diff, Cosinus[Angle])  + MulFx_16_16(z_diff,Sinus[Angle]);
	Punt_Rotat->X = -MulFx_16_16(x_diff, Sinus[Angle])    + MulFx_16_16(z_diff, Cosinus[Angle]);
#endif


	// POST: Retorna el "Punt_Rotat" a una precicisi 16.16
}*/
