//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA

#ifndef __GEOMETRIA_H_
#define __GEOMETRIA_H_


#include "Mapa.h"
//#include "main.h"
#include "memoria.h"
#include "definicions.h"

/*************\
| DEFINICIONS |
\*************/


#define QUADRANT_1 1
#define QUADRANT_2 2
#define QUADRANT_3 3
#define QUADRANT_4 4


/********\
| MACROS |
\********/


#define QuadrantPunt(signe_x,signe_y)\
	(signe_y >= 0 ? signe_x >= 0 ? QUADRANT_1 : QUADRANT_2 : signe_x <= 0 ? QUADRANT_3 : QUADRANT_4)



#define Punt_Pertany_A_Quadrat(X,Z,Quadrat)\
	( ((Quadrat.x1) <= (X) && (X) <= (Quadrat.x2)) && \
	  ((Quadrat.z1) <= (Z) && (Z) <= (Quadrat.z2)) )

#define Punt_Intersecta_A_Quadrat(X,Z,Quadrat)\
	Punt_Pertany_A_Quadrat(X,Z,Quadrat) && \
	( ((Quadrat.x1) == (X) || (X) == (Quadrat.x2)) && \
	  ((Quadrat.z1) == (Z) || (Z) == (Quadrat.z2)) )

#define LiniaRecta(Linia)\
   (((Linia.V0.X == Linia.V1.X) && (Linia.V0.Z != Linia.V1.Z)) ||\
	((Linia.V0.X != Linia.V1.X) && (Linia.V0.Z == Linia.V1.Z)))\

/**********************************\
| PROTOTIPUS DE FUNCIONS I ACCIONS |
\**********************************/


int InterseccioQuadrats(tQuadrat_XZ Q1, tQuadrat_XZ Q2);


//void punt_mon_A_pla_projeccio(const tJugador *Jugador, FIXED32 Xp, FIXED32 Zp,  tPuntMapa *Punt_A_Transformar);





/*void punt_mon_A_pla_projeccio_precis(const tJugador *Jugador, FIXED32 Xp, FIXED32 Zp,  tPuntMapa *Punt_A_Transformar)
#ifdef __HAM__
MEM_FUNC_IN_IWRAM
#endif
;*/
int LiniaInterseccio
(int x,
 const tJugador *Jugador,
 const tSector *Sector,
 tPunt_Fixa_2D *Inter,
 int UTILITZAR_EL_VERTEX_TRANSFORMAT
)
//#ifndef __RENDER_RECURSIU__
FUNCIO_A_MEMORIA_INTERNA//MEM_FUNC_IN_IWRAM
//#endif
;


void punt_pla_projeccio_A_mon(const tJugador *Jugador, FIXED32 Xp, FIXED32 Zp, tPunt_Fixa_2D *Punt_Rotat) FUNCIO_A_MEMORIA_INTERNA;
void punt_mon_A_pla_projeccio(const tJugador *Jugador, FIXED32 Xp, FIXED32 Zp,  tPunt_Fixa_2D *Punt_A_Transformar) FUNCIO_A_MEMORIA_INTERNA;




#endif
