//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA

#ifndef __RAYCAST_H__
 #define __RAYCAST_H__

#include "stdlib.h"
#include "stdio.h"


#if defined(_WINDOWS) || defined(_LINUX)
#ifndef __SDL__
 #define __SDL__
#endif
 #include "conio.h"
 #include "memory.h"
 #include "string.h"
 #include "SDL/SDL.h"
#endif

#if defined(__arm__) || defined(__thumb__)       // definit en l' arxiu "gcc-arm\arm-thumb-elf\include\machine\stdlib.h"

#ifndef __HAM__
 #define __HAM__

#endif
 #include "myGBA.h"
 
 // Les seguents variables i prototipus sn necessaris per executar l'eina profiler a qualsevol punt del programa.
 
 extern u32 ham_prof_subticks;
 extern u32 ham_prof_scanline_start,ham_prof_scanline_end;
 extern u32 ham_prof_frames_elapsed;
 
 extern u32 frames_acumulated;
 extern u32 ham_prof_first_run;
 extern void ham_prof_timer3_int();

 
 
#endif

#include "definicions.h"

#include "Mon.h"
#include "Textura.h"
#include "Grafics.h"
#include "Font.h"

#include "teclat.h"
#include "math.h"
#include "malloc.h"
#include "Mates.h"
#include "Render.h"
#include "geometria.h"
#include "Aritmetica.h"
#include "Jugador.h"
#include "animacio.h"
#include "objecte3d.h"
#include "memoria.h"
#include "temps.h"

//#include "paleta.h"


/****************************************\
| DEFINICIO DE DEMOSTRACIO (PROVISIONAL) |
\****************************************/

//#define JESPA3D_VERSION		"Version 0.953" // Versi DEMO
//#define JESPA3D_VERSION		"Version 1.053" // Versi DEMO
//#define JESPA3D_VERSION			1.154 // Versi DEMO
//#define JESPA3D_VERSION			1.266 // Versi DEMO
//#define JESPA3D_VERSION			1.366 // Final versin -- RENDERITZACI DE PENDENTS SENSE MAPEIG --
 #define JESPA3D_VERSION			1.368 // Final versin -- 

extern short sectors_prerenderitzats,sectors_renderitzats;
extern float total_time,total_time_render_1,total_time_render_2,total_time_render_3,total_time_render_4;
extern float FPS;
extern tJugador Jugador;



/*************************\
| DEFINICIO DE PROTOTIPUS |
\*************************/

void Test();
void Inicialitzar();
void DeInicialitzar();


// Provisional per demostraci...
void ActualitzarObjectes(void);



#endif
