//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA









#include "GestFile.h"
#include "stdio.h"
#include "palette.h"
#include "image.h"

/****************\
| GLOBAL VARIBLES|
\****************/

#include "info_reduce.c"
//#include "info_h.c"
//#include "info_c.c"


extern FILE	*fp_config;
char last_char = 0;
extern char *pal;
extern short *pal16;
extern char *shade_table;
extern short shade_table16[PALETTE_SIZE*MAX_LIGHT];
extern char *glenz_table;
extern short glenz_table16[PALETTE_SIZE*PALETTE_SIZE];

int End_Line() {return (last_char == '\n');}

void Get_File_Name(char filename[], char file_name_with_path[])
{
	int pos;


	pos = strlen(file_name_with_path) - 1;
	
	if(pos == 0 || file_name_with_path[pos] == '\0') return;
	
	
	
	while(file_name_with_path[pos] != '/')
	{
		pos--;			
	}

	pos++;

	memset(filename,0,WITH_STRING);

	memcpy(filename,&file_name_with_path[pos],WITH_STRING);
}


int Field_Names_Identical(char Name[])
{
	//
	// PRE: Cursor of file points to character '['...
	//

	int i,Identical,End;


/*	Width_Field = sizeof(Name);

	if(Width_Field <= 0) // Error...
	{
		fprintf(fp_err,"The string Name[] parameter has %i bytes!!!",Width_Field);
		return FALSE;
	}*/

	i = 0;

	Identical = TRUE;
	End = FALSE;

	while(i < WITH_STRING && Identical && !feof(fp_config) && !End)
	{
		
		Next_Char(last_char, fp_config);
		
		if(last_char == ']')	 
		{
			if(Name[i] != '\0') {Identical = FALSE ; End = TRUE;}
			else End = TRUE;
		}
		else if(last_char != Name[i]) Identical = FALSE;
		

		i++;
	}

		
	Next_Line();

	return (Identical && End);
}


void Next_Line()
{


	while(!feof(fp_config) && last_char != '\n')
	{
		Next_Char(last_char,fp_config);
	}
	

	// Next_Char(last_char,fp_config);

	// Now the cursor points to start the next line...

	
}

int Get_Pointer_To_Field(char Name[])
{

	int ok = TRUE;
	int Coment = FALSE;
	int Found_Field = FALSE;

	
	// Reset cursor, to begining the file...
	rewind(fp_config);
	last_char = 0;


//	if(last_char == '[') Found_Field = TRUE;
	

	while(!Found_Field && !feof(fp_config))
	{
		
		Next_Char(last_char,fp_config);


		if(last_char == ';') // We skip all line...
		{
			Next_Line();
		}
		else
		{
			if(last_char == '[') // We found and initial of field...
			{
				// We'll capture the name of field, character by character....

				if(Field_Names_Identical(Name)) // We are the champions :), I found the field.
				{
					Found_Field = TRUE;
					
				}


			}
			
		}
		
		
	}

	return Found_Field;
		
	
}


int End_Field()
{
	// Descripction: This function reads character by character until find it an valid character (A-Z or 1-9 or a-z). This function ignores
	//               character (' ') and ('\t'), and if it find the comment character (';') it go to next line.


	int Found_Valid_Character, End;

	
	End = FALSE;
	Found_Valid_Character = FALSE;


	while(!feof(fp_config) && !Found_Valid_Character && !End)
	{	
		// The cursor of file points to end of line ('\n'), so I read character and, after, avaluates it.
		Next_Char(last_char,fp_config);


		if(last_char == '[') End = TRUE;
		if(last_char == ';') Next_Line();
		
		if(last_char >= 32 && last_char <= 'z') // A valid ascii character...
		{
			if((last_char != '\t') && (last_char!= ' ')) // Is not a special character...
				Found_Valid_Character = TRUE;
		}
	

	}



	return ((End) || (feof(fp_config)));


}


int Get_File_With_Path(char File_Name_With_Path[])
{
	// PRE: The cursor of file ponts to the first character found before on the function "End_Field()"   

	int End, i;

	End = FALSE;
	i = 0;
/*	With_String = sizeof(File_Name);


	if(With_String <= 0) // Error...
	{
		fprintf(fp_err,"The string \"File_Name[]\" parameter of function \"Get_File_Name()\" has %i bytes!!!",With_String);
		return FALSE;
	}*/


	memset(File_Name_With_Path,0,WITH_STRING);

	
		
	while(!feof(fp_config) && !End && i < WITH_STRING)	
	{

		// I read the first character of file name in 'End_Field()', so I don't read any character from file...
			

		if((last_char == ',') ||(last_char == ' ') || (last_char== '\t') || (last_char == '\n') || (last_char==';')) // .. Add more special character.
		{
			// End of the name...

			End = TRUE;									

		
		}
		else
		{
			
			
			
			File_Name_With_Path[i] = last_char;
			i++;
			Next_Char(last_char,fp_config);	
						
			
		}

		
		
	}

//	Next_Line();

	return End;


}

int Next_Image_Spec(char Spec_Name[])
{
	int End_Line = FALSE;
	int Get_Spec = FALSE;
	int i = 0;
	
	memset(Spec_Name,0,WITH_STRING);

	// Getting pointer to the start of specs...
	while((last_char != ',') && (last_char != '\n')) Next_Char(last_char,fp_config);	

	if(last_char =='\n')
	{
		return FALSE;
	}
	
	
	// First read
	Next_Char(last_char,fp_config);	

	// Discarts ...
	while((last_char == ' ') || (last_char == '\t')|| (last_char == ',')) Next_Char(last_char,fp_config);
	

	while(!feof(fp_config) && !End_Line && !Get_Spec && i < WITH_STRING)	
	{
		if(last_char == '\n')
		{
			End_Line = TRUE;
			
		}
		else
		{
			if((last_char == ',') ||(last_char == ' ') || (last_char== '\t') || (last_char == '\n') || (last_char==';')) // .. Add more special character.
			{
				// End of the name...
				
				Get_Spec = TRUE;									
			}
			else
			{
				
				Spec_Name[i] = last_char;
				i++;
				Next_Char(last_char,fp_config);	
			}
		}

	}
	
	return !End_Line;
}


#define FP_IMAGES   0
#define FP_PALETTE  1
#define FP_SHADE    2
#define FP_FONT     3
#define FP_GLENZ    4


int WriteDataFiles(tNodeImage *list_nodes)
{
	//
	// This function writes the data pixels images into module...
	//
	
	FILE	*fp_images, *fp_palette, *fp_shade,*fp_font,*fp_glenz/*,*fp_panorama*/;
	tNodeImage	*actual_node;
//	char   cad[50];
	int		i,j,linear_offset,n_fonts/*,n_panoramas*/;
	
	
	if((fp_shade   = fopen("./IncludeC/shade.raw.c","wt")) == NULL)
	{
		fprintf(fp_err,"\n Error, cannot open file \"Shade.raw.c\" !!!");
		return FALSE;	
	}
	
	if((fp_palette = fopen("./IncludeC/palette.raw.c","wt")) == NULL)
	{
		fprintf(fp_err,"\n Error, cannot open file \"Palette.raw.c\" !!!");
		fclose(fp_shade);	
		return FALSE;
	}

/*	if((fp_panorama = fopen("./IncludeC/panorama.raw.c","wt")) == NULL)
	{
		fprintf(fp_err,"\n Error, cannot open file \"panorama.raw.c\" !!!");
		fclose(fp_shade);
		fclose(fp_palette);
		return FALSE;
	}	*/

	if((fp_font = fopen("./IncludeC/font.raw.c","wt")) == NULL)
	{
		fprintf(fp_err,"\n Error, cannot open file \"font.raw.c\" !!!");
		fclose(fp_shade);
		fclose(fp_palette);
//		fclose(fp_panorama);
		return FALSE;
	}	

	if((fp_images = fopen("./IncludeC/images.raw.c","wt")) == NULL)
	{
		fprintf(fp_err,"\n Error, cannot open file \"font.raw.c\" !!!");
		fclose(fp_shade);
		fclose(fp_palette);
//		fclose(fp_panorama);
		fclose(fp_font);
		return FALSE;
	}
    
    if((fp_glenz = fopen("./IncludeC/glenz.raw.c","wt")) == NULL)
	{
		fprintf(fp_err,"\n Error, cannot open file \"font.raw.c\" !!!");
		fclose(fp_shade);
		fclose(fp_palette);
//		fclose(fp_panorama);
		fclose(fp_font);
        fclose(fp_images);
		return FALSE;
	}	
	
	
	// Ok. Now, writes the grafics files in string C format...
	
	// The palette...
	
	printf("\nWriting data file: Palette.raw.c");

	fprintf(fp_palette,"const unsigned short Palette[%i]={",PALETTE_SIZE);
	
	for(i = 0; i < PALETTE_SIZE; i++)
	{
		if((i&0x3) == 0) fprintf(fp_palette,"\n\t");
		
		fprintf(fp_palette,"0x%04x ,",(ushort)pal16[i]);
	}
	
	fprintf(fp_palette,"\n};\n");
	fclose(fp_palette);
	
	
	// The table of shades...
	
	CLRLINE;
	printf("\rWriting data file: Shade.raw.c");
	
	fprintf(fp_shade,"const unsigned char Shade[%i]={\n\t",PALETTE_SIZE*MAX_LIGHT);
	
	for(i = 0; i < PALETTE_SIZE; i++)
	{
		for(j = 0; j < MAX_LIGHT; j++)
		{
			fprintf(fp_shade,"0x%02x ,",(uchar)shade_table[i*MAX_LIGHT+j]);
		}
		
		fprintf(fp_shade,"\n\t");
	}
	
	fprintf(fp_shade,"\n};\n");

    fprintf(fp_shade,"const unsigned short Shade16[%i]={\n\t",PALETTE_SIZE*MAX_LIGHT);
	
	for(i = 0; i < PALETTE_SIZE; i++)
	{
		for(j = 0; j < MAX_LIGHT; j++)
		{
			fprintf(fp_shade,"0x%04x ,",(ushort)shade_table16[i*MAX_LIGHT+j]);
		}
		
		fprintf(fp_shade,"\n\t");
	}
	
	fprintf(fp_shade,"\n};\n");

	fclose(fp_shade);

	// The glenzing tables...

    printf("\rWriting data file: Glenz.raw.c");
	
	fprintf(fp_glenz,"const unsigned char Glenz[%i]={\n\t",PALETTE_SIZE*PALETTE_SIZE);
	
	for(i = 0; i < PALETTE_SIZE; i++)
	{
		for(j = 0; j < PALETTE_SIZE; j++)
		{
			fprintf(fp_glenz,"0x%02x ,",(uchar)glenz_table[i*PALETTE_SIZE+j]);
		}
		
		fprintf(fp_glenz,"\n\t");
	}
	
	fprintf(fp_glenz,"\n};\n");

    fprintf(fp_glenz,"const unsigned short Glenz16[%i]={\n\t",PALETTE_SIZE*PALETTE_SIZE);
	
	for(i = 0; i < PALETTE_SIZE; i++)
	{
		for(j = 0; j < PALETTE_SIZE; j++)
		{
			fprintf(fp_glenz,"0x%04x ,",(ushort)glenz_table16[i*PALETTE_SIZE+j]);
		}
		
		fprintf(fp_glenz,"\n\t");
	}
	
	fprintf(fp_glenz,"\n};\n");

	fclose(fp_glenz);

	// Get info panorama....

	/*n_panoramas = 0;
	for(actual_node = list_nodes; actual_node != NULL; actual_node = actual_node->PNext)
	{
		if(actual_node->Data_Type.Is_Panorama)
		{

			fprintf(fp_panorama,"const unsigned char Panorama_%02i[%i]={",n_panoramas,actual_node->Data_Type.Height*actual_node->Data_Type.Width);
			n_panoramas ++;

			for(linear_offset = 0; linear_offset < (actual_node->Data_Type.Height*actual_node->Data_Type.Width); linear_offset++)
			{
						
						if((linear_offset%actual_node->Data_Type.Width) == 0) fprintf(fp_panorama,"\n\t");
						
						
						fprintf(fp_panorama,"0x%02x ,",(uchar)actual_node->Data_Type.pixels[linear_offset]);						
						
			}

			fprintf(fp_panorama,"\n};");
			
		
		}

	}

	fclose(fp_panorama);*/


	// Get info fonts....

	n_fonts = 0;
	for(actual_node = list_nodes, j = 0; actual_node != NULL; actual_node = actual_node->PNext,j++)
	{

		if(actual_node->Data_Type.Is_Font)
		{

			fprintf(fp_font,"const unsigned char Font_%02i[%i]={",n_fonts,actual_node->Data_Type.Height*actual_node->Data_Type.Width);
			n_fonts ++;

			for(linear_offset = 0; linear_offset < (actual_node->Data_Type.Height*actual_node->Data_Type.Width); linear_offset++)
			{
						
						if((linear_offset%actual_node->Data_Type.Width) == 0) fprintf(fp_font,"\n\t");
						
						
						fprintf(fp_font,"0x%02x ,",(uchar)actual_node->Data_Type.MipMaps[0].pixels[linear_offset]);						
						
			}
			
			fprintf(fp_font,"\n};\n");
			
		}

	}

	fclose(fp_font);


	
	// And the last, the grafic information mipmap...

	
	CLRLINE;
	printf("\rWriting data file: images.raw.c",i);
		
	fprintf(fp_images,"const unsigned char images[]={");
		

	for(actual_node = list_nodes, j = 0; actual_node != NULL; actual_node = actual_node->PNext,j++)
	{
		
		if(!actual_node->Data_Type.Is_Font)
		{
			
			fprintf(fp_images,"\n\n//The folowing bytes represents grafic \"%s\" with %i MipMaps in raw format...\n\n",actual_node->Data_Type.name,actual_node->Data_Type.N_MipMaps);
			
			for(i = 0; i <= actual_node->Data_Type.N_MipMaps; i++)
			{
			
				if(i == 0)
				{
					fprintf(fp_images,"\n\n// Original image ...\n\n");
				}
				else
				{
					fprintf(fp_images,"\n\n// MipMap %i of image %s...\n\n",i,actual_node->Data_Type.name);
				}
								
				for(linear_offset = 0; linear_offset < (actual_node->Data_Type.MipMaps[i].Height*actual_node->Data_Type.MipMaps[i].Width); linear_offset++)
				{
					
					if((linear_offset%actual_node->Data_Type.MipMaps[i].Width) == 0) fprintf(fp_images,"\n\t");
					
					
					fprintf(fp_images,"0x%02x ,",(uchar)actual_node->Data_Type.MipMaps[i].pixels[linear_offset]);						
					
				}
				
				
			}
			
			
		}
		
		
		
	}

	fprintf(fp_images,"\n};\n\n\n");

	fclose(fp_images);

	CLRLINE;
	printf("\rWriting data file: done!");
	
	
	return TRUE;
	
	
}



int WriteInfoFiles(tNodeImage *list_nodes)
//
// This function writes the reduce config for the images loaded in the program and generates files c,h.
//
{
	FILE	*fp_reduce, *fp_h_info, *fp_c_info, *fp_h_ani, *fp_c_ani,*fp_ARM_info;
	int		nimage,nanimation,n_panoramas, n_fonts;
	tNodeImage   *actual_node;
	char	file_name[WITH_STRING];
	tNodeMasterAnimation *list_type_animation = NULL,*actual_node_ani;
	tNodeFrame  *actual_node_frame;
	int i, Found;

	fp_reduce = fopen("reduce.cfg","wt");
	fp_h_info = fopen("./IncludeC/info_images.h","wt");
	fp_ARM_info = fopen("./IncludeARM/info_images.s","wt");
	fp_c_info = fopen("./IncludeC/info_images.c","wt");
	fp_h_ani = fopen("./IncludeC/info_animations.h","wt");
	fp_c_ani = fopen("./IncludeC/info_animations.c","wt");



	if(fp_reduce == NULL || fp_h_info == NULL || fp_c_info == NULL ||fp_h_ani == NULL  ||fp_c_ani == NULL || fp_ARM_info == NULL)
	{
		fprintf(fp_err,"\n Error opening files for writting infos:\n-reduce: %#x\n-h_info: %#x\n-c_info: %#x\n-h_ani: %#x\n-c_ani: %#x\n",fp_reduce, fp_h_info, fp_c_info,fp_h_ani,fp_c_ani);
		return FALSE;	
	}

	// writes the config reduce header...

	fwrite(cad_reduce_header,sizeof(cad_reduce_header)-1,1,fp_reduce);

	// writes the files to add...

	

	for(actual_node = list_nodes, nimage = 0; actual_node != NULL ; actual_node = actual_node->PNext)
	{
		// writes file includes on reduce config file...
		
		fprintf(fp_reduce,"\n%s",actual_node->Data_Type.name);

		if(!actual_node->Data_Type.Is_Font)		nimage++;


	
	}


	fwrite("\n\n\n\n\n",5,1,fp_reduce);
	// writes the config reduce tail...

	fwrite(cad_reduce_tail,sizeof(cad_reduce_tail)-1,1,fp_reduce);


	// Search mask color sprite (pure pink)...

	i = 0;
	Found = FALSE;
	
	/*while(i < 768 && !Found)
	{
		if(IS_MASK_COLOR(pal[i],pal[i+1],pal[i+2])) {Found = TRUE;Mask_Color = i/3;}
		else i+=3;
	}*/


//	if(!Found) Mask_Color = 0;
	//else Mask_Color = i/3;
	
	// writes the header & C info image files...

	// Header...

	printf("\nWriting info file: info_images.h");

	fprintf(fp_h_info,"#ifndef\t__IMAGE_INFO_H__\t\n");
	fprintf(fp_h_info,"#define\t__IMAGE_INFO_H__\t\n\n\n");
//	fprintf(fp_h_info,"#define\tNSPRITES\t%i",nsprites);
	fprintf(fp_h_info,"\n#define\tN_IMAGES\t%i",nimage+1);
	//fprintf(fp_h_info,"\n#define\tN_MIPMAPS \t%i+1\t// +1 because the mipmap 0 is the original image",N_MIPMAPS);

  	fprintf(fp_h_info,"\n#define\tTRUE\t1\n#define\tFALSE\t0\n\n");

	// TYPES OF COLORS...
    fprintf(fp_h_info,"\n\n#define\tMASK_COLOR\t%i", PALETTE_Closest_Color(255,0, 255, pal));
	fprintf(fp_ARM_info,"\n\n.equ\tMASK_COLOR,\t%i", PALETTE_Closest_Color(255,0, 255, pal));
	fprintf(fp_h_info,"\n#define\tBLACK_COLOR\t%i", PALETTE_Closest_Color(0,0, 0, pal));
	fprintf(fp_h_info,"\n#define\tGREY_COLOR\t%i", PALETTE_Closest_Color(128,128, 128, pal));
	fprintf(fp_h_info,"\n#define\tWHITE_COLOR\t%i", PALETTE_Closest_Color(255,255, 255, pal));
	fprintf(fp_h_info,"\n#define\tRED_COLOR\t%i",PALETTE_Closest_Color(255,0, 0, pal));
	fprintf(fp_h_info,"\n#define\tGREEN_COLOR\t%i",PALETTE_Closest_Color(0,255, 0, pal));
	fprintf(fp_h_info,"\n#define\tBLUE_COLOR\t%i\n\n",PALETTE_Closest_Color(0,0, 255, pal));

    fprintf(fp_h_info,"\n\n// ID defines & mask utilities...\n\n");
    fprintf(fp_h_info,"\n#define		BIT_IS_UPOW2			%i",BIT_IS_UPOW2);
    fprintf(fp_h_info,"\n#define		BIT_IS_VPOW2			%i",BIT_IS_VPOW2);
    fprintf(fp_h_info,"\n#define		BIT_IS_SPRITE			%i",BIT_IS_SPRITE);
    fprintf(fp_h_info,"\n#define		BIT_IS_PANORAMA			%i",BIT_IS_PANORAMA);
    fprintf(fp_h_info,"\n#define		BIT_RENDER_WITH_BRIGHT	%i",BIT_RENDER_WITH_BRIGHT);
    fprintf(fp_h_info,"\n#define		BIT_RENDER_WITH_GLENZ   %i\n\n",BIT_RENDER_WITH_GLENZ);

    
    //IS_UPOW2(p)
    
    fprintf(fp_h_info,"\n\n#define		IS_PASSABLE(p)	     ((p)&(0x1 << BIT_IS_PASSABLE)) ");
    fprintf(fp_h_info,"\n#define		IS_PANORAMA(p)	     ((p)&(0x1 << BIT_IS_PANORAMA)) ");
    fprintf(fp_h_info,"\n#define		WITH_MIPMAPS(p)	     ((p)&(0x1 << BIT_WITH_MIPMAPS))");
    fprintf(fp_h_info,"\n#define		IS_SPRITE(p)		 ((p)&(0x1 << BIT_IS_SPRITE))   ");
    fprintf(fp_h_info,"\n#define		IS_UPOW2(p) 	     ((p)&(0x1 << BIT_IS_UPOW2))");
    fprintf(fp_h_info,"\n#define		IS_VPOW2(p) 	     ((p)&(0x1 << BIT_IS_VPOW2))");
    fprintf(fp_h_info,"\n#define		RENDER_WITH_BRIGHT(p)((p)&(0x1 << BIT_RENDER_WITH_BRIGHT))");
    fprintf(fp_h_info,"\n#define		RENDER_WITH_GLENZ(p) ((p)&(0x1 << BIT_RENDER_WITH_GLENZ))\n\n");


    fprintf(fp_h_info,"\n\ntypedef struct{\n\
                       \tint n_image;\n\
                       \tint width;\n\
                       \tint height;\n\
                       \tint N_MipMaps;\n\
                       \tint Propietries;\n\
                       \tchar name[50];\
    \n}tInfo_Image;\n");
    

	fprintf(fp_h_info,"\nextern const tInfo_Image Info_Image[N_IMAGES];");
	fprintf(fp_h_info,"\nextern const unsigned short Palette[%i];",PALETTE_SIZE);
	fprintf(fp_h_info,"\nextern const unsigned char Shade[];");
    fprintf(fp_h_info,"\nextern const unsigned short Shade16[];");
  	fprintf(fp_h_info,"\nextern const unsigned char Glenz[];");
    fprintf(fp_h_info,"\nextern const unsigned short Glenz16[];");

    // ARM defines...
    fprintf(fp_ARM_info,"\n\n\
    \n@ /*********\\\
    \n@ | DEFINES |\
    \n@ \\*********/\n\n");

	fprintf(fp_ARM_info,"\n\n\n.ptr_shade:\n\t.word Shade\n");
    fprintf(fp_ARM_info,"\n\n\n.ptr_shade16:\n\t.word Shade16\n");
    fprintf(fp_ARM_info,"\n\n\n.ptr_glenz:\n\t.word Glenz\n");
    fprintf(fp_ARM_info,"\n\n\n.ptr_glenz16:\n\t.word Glenz16\n\n\n");

    fprintf(fp_ARM_info," .equ		BIT_IS_UPOW2			,%i\n",BIT_IS_UPOW2);
    fprintf(fp_ARM_info," .equ		BIT_IS_VPOW2			,%i\n",BIT_IS_VPOW2);
    fprintf(fp_ARM_info," .equ		BIT_IS_SPRITE			,%i\n",BIT_IS_SPRITE);
    fprintf(fp_ARM_info," .equ		BIT_IS_PANORAMA			,%i\n",BIT_IS_PANORAMA);
    fprintf(fp_ARM_info," .equ		BIT_RENDER_WITH_BRIGHT	,%i\n",BIT_RENDER_WITH_BRIGHT);
    fprintf(fp_ARM_info," .equ		BIT_RENDER_WITH_GLENZ   ,%i\n\n",BIT_RENDER_WITH_GLENZ);

    fprintf(fp_ARM_info," .equ		MASK_IS_UPOW2			 ,1  <<  BIT_IS_UPOW2\n");
    fprintf(fp_ARM_info," .equ		MASK_IS_VPOW2			 ,1  <<  BIT_IS_VPOW2\n");
    fprintf(fp_ARM_info," .equ		MASK_IS_SPRITE			 ,1  <<  BIT_IS_SPRITE\n");
    fprintf(fp_ARM_info," .equ		MASK_IS_PANORAMA		 ,1  <<  BIT_IS_PANORAMA\n");
    fprintf(fp_ARM_info," .equ		MASK_RENDER_WITH_BRIGHT	 ,1  <<  BIT_RENDER_WITH_BRIGHT\n");
    fprintf(fp_ARM_info," .equ		MASK_RENDER_WITH_GLENZ	 ,1  <<  BIT_RENDER_WITH_GLENZ\n\n");


    // ARM macros...
    fprintf(fp_ARM_info,"\n\n\
    \n@ /*********\\\
    \n@ | MACROS  |\
    \n@ \\*********/\n\n");

    fprintf(fp_ARM_info,"\
    \n.macro IS_UPOW2 a\
    \n    TSTS	\\a,#MASK_IS_UPOW2\
    \n.endm\n\n");

    fprintf(fp_ARM_info,"\
    \n.macro IS_VPOW2 a\
    \n		TSTS	\\a,#MASK_IS_VPOW2\
    \n.endm\n\n");

    fprintf(fp_ARM_info,"\
    \n.macro IS_SPRITE a\
    \n		TSTS	\\a,#MASK_IS_SPRITE\
    \n.endm\n\n");

    fprintf(fp_ARM_info,"\
    \n.macro IS_PANORAMA a\
    \n		TSTS	\\a,#MASK_IS_PANORAMA\
    \n.endm\n\n");


    fprintf(fp_ARM_info,"\
    \n.macro RENDER_WITH_BRIGHT a\
    \n		TSTS	\\a,#MASK_RENDER_WITH_BRIGHT\
    \n.endm\n\n");

    fprintf(fp_ARM_info,"\
    \n.macro RENDER_WITH_GLENZ a\
    \n		TSTS	\\a,#MASK_RENDER_WITH_GLENZ\
    \n.endm\n\n");




//	fprintf(fp_h_info,"\n\nunsigned char *Base_Pointer_MipMap(int n_mipmap);");

	// Search number of fonts and panoramas...
	n_panoramas = n_fonts = 0;
	for(actual_node = list_nodes; actual_node != NULL ; actual_node = actual_node->PNext)
	{
		if(actual_node->Data_Type.Is_Panorama) n_panoramas ++;
		if(actual_node->Data_Type.Is_Font) n_fonts++;
	}

/*	if(n_panoramas != 0)
	{
		fprintf(fp_h_info,"\n\n// Panorama data files...\n\n");

		for(i = 0; i < n_panoramas; i++)
		{
			fprintf(fp_h_info,"\nextern const unsigned char Panorama_%02i[];",i);
		}
	}*/

	if(n_fonts != 0)
	{
		fprintf(fp_h_info,"\n\n// Font data files...\n\n");

		for(i = 0; i < n_fonts; i++)
		{
			fprintf(fp_h_info,"\nextern const unsigned char Font_%02i[];",i);
		}
	}

	fprintf(fp_h_info,"\n\n// MipMap data files...\n\n");
	fprintf(fp_h_info,"\nextern const unsigned char images[];",i);

	fprintf(fp_h_info,"\n\n#endif\n");

	// Module C...
	CLRLINE;
	printf("\rWriting info file: info_images.c");

	fprintf(fp_c_info,"#include\t\"info_images.h\"\n\n");
	fprintf(fp_c_info,"\n\n// Raw data info...\n");
	fprintf(fp_c_info,"\n#include\t\"Shade.raw.c\"");
    fprintf(fp_c_info,"\n#include\t\"Glenz.raw.c\"");
	fprintf(fp_c_info,"\n#include\t\"Palette.raw.c\"");
	//fprintf(fp_c_info,"\n#include\t\"Panorama.raw.c\"");
	fprintf(fp_c_info,"\n#include\t\"Font.raw.c\"");
	fprintf(fp_c_info,"\n#include\t\"Images.raw.c\"",i);

	fprintf(fp_c_info,"\n\n\nconst tInfo_Image Info_Image[N_IMAGES]={\n\n");

	fprintf(fp_c_info,"//   ID_Image        width      height         MipMaps    Propietries       Name\n");
	fprintf(fp_c_info,"//  ---------       ------     -------      -----------   ------------   -------------\n");
	
    fprintf(fp_c_info,"\n\t%4i,\t\t\t%4i,\t\t%4i,\t\t\t%i,\t\t\t0x%x,\t\t\t\"%s\", ",0,0,0,0,0,"image_with_no_effect");
	nimage = 0;


	
	for(actual_node = list_nodes; actual_node != NULL ; actual_node = actual_node->PNext)
	{
		// writes file info_images.c file...

		if(!actual_node->Data_Type.Is_Font)
		{
			fprintf(fp_c_info,"\n\t%4i,\t\t\t%4i,\t\t%4i,\t\t\t%i,\t\t\t0x%x,\t\t\t\"%s\", %s%s%s%s%s%s%s",nimage+1,
																							                actual_node->Data_Type.Width,
																							                actual_node->Data_Type.Height,
																							                actual_node->Data_Type.N_MipMaps+1, // Because the original image (0) is mipmap, too.
																							                actual_node->Data_Type.Propietries,
																							                actual_node->Data_Type.name,
                                                                                                            actual_node->Data_Type.Is_DimXPow2? "// IS_DIMX_POW2=TRUE,":"// IS_DIMX_POW2=FALSE,",
                                                                                                            actual_node->Data_Type.Is_DimYPow2? " IS_DIMY_POW2=TRUE,":" IS_DIMY_POW2=FALSE,",
                                                                                                            actual_node->Data_Type.Is_Sprite? " IS_SPRITE=TRUE,":" IS_SPRITE=FALSE,",
                                                                                                            actual_node->Data_Type.Is_Panorama? " IS_PANORAMA=TRUE,":" IS_PANORAMA=FALSE,",
                                                                                                            actual_node->Data_Type.Is_Passable? " IS_PASSABLE=TRUE,":" IS_PASSABLE=FALSE,",
                                                                                                            actual_node->Data_Type.Is_Font    ? " IS_FONT=TRUE,":" IS_FONT=FALSE,",
                                                                                                            actual_node->Data_Type.N_MipMaps  ? " WITH_MIPMAPS ":" WITHOUT_MIPMAPS"

																								   );
		
		
			// Add frames nodes animations...

			Get_File_Name(file_name, actual_node->Data_Type.name);
			AddNodeList_Animation(file_name, nimage, &list_type_animation);
			
			nimage++;
		}

		
	}

	fwrite("\n};\n",4,1,fp_c_info);

/*	fprintf(fp_c_info,"\n\nunsigned char *Base_Pointer_MipMap(int n_mipmap){");
	fprintf(fp_c_info,"\n\tswitch(n_mipmap) {");

	for(i = 0; i < (N_MIPMAPS+1); i++) 
	{
		fprintf(fp_c_info,"\n\t\tcase %i: return (unsigned char *)&MipMap_%02i[0];break;",i,i);
	}

	fprintf(fp_c_info,"\n\t\tdefault: return (unsigned char *)&MipMap_00[0];",i);
	fprintf(fp_c_info,"\n\t}\n}\n\n");
*/


	// Now, I create the animation info files...

	CLRLINE;
	printf("\rWriting info file: info_animations.c");

	fprintf(fp_c_ani,"\n\n\nconst tInfo_Animation Info_Animation[N_IMAGES]={\n\n");
	fprintf(fp_c_ani,"//   ID_Animation       ID_Frame       ID_key       \n");
	fprintf(fp_c_ani,"//  -------------       --------       -------      \n");

	fprintf(fp_c_ani,"\n\t%4i,\t\t\t%4i,\t\t\"%10s\",",0,0,"animation_with_no_effect");

	for(actual_node_ani = list_type_animation, nanimation = 0; actual_node_ani != NULL ; actual_node_ani = actual_node_ani->PNextNode, nanimation++)
	{
		
		// writes file info_images.c file...
		for(actual_node_frame = actual_node_ani->PFirstFrame; actual_node_frame != NULL ; actual_node_frame = actual_node_frame->PNextFrame)
		{
			fprintf(fp_c_ani,"\n\t%4i,\t\t\t%4i,\t\t\"%10s\",",nanimation+1,actual_node_frame->ID_Image,actual_node_ani->name);
		}
			
	}
	
	fwrite("\n};\n",4,1,fp_c_ani);

	CLRLINE;
	printf("\rWriting info file: info_animations.h");

	fprintf(fp_h_ani,"#define\tN_ANIMATIONS\t%i+1",nanimation);
	fprintf(fp_h_ani,"\n#define\tN_IMAGES\t%i",nimage+1);
	fprintf(fp_h_ani,"\n\ntypedef struct{\n\tint n_animation;\n\tint id_image;\n\tchar name[%i];\n}tInfo_Animation;\n",WITH_STRING);

	//
	// Writes the graphics & palette to module C...
	//

	CLRLINE;
	printf("\rWriting info file: done!\n");
	
	fclose(fp_c_ani);
	fclose(fp_h_ani);
	
	fclose(fp_c_info);
	fclose(fp_h_info);
	fclose(fp_ARM_info);
	fclose(fp_reduce);

	Delete_Nodes_Animation(list_type_animation);

	return TRUE;




}
