//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA


#include "GestNode.h"

////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Implemetation nodes manegenmen for add ingo images to modules info_image.c & info_image.h...
//
//
void AddNodeList_Image_Sort_To_Descendent(int ID_Node,tImage type, tNodeImage **list_nodes)
{
	tNodeImage *New_Node, *Actual_Node, *Previus_Node;
	int End;

	
	New_Node = (tNodeImage *)malloc(sizeof(tNodeImage));

	if(New_Node == NULL)
	{
		fprintf(fp_err,"\nNot enought memory in function \"AddNodeList_Sort_To_Ascendent()\" for reserve %d bytes !!!",sizeof(tNodeImage));
		return;
	}

	New_Node->ID_Node  = ID_Node;
	New_Node->Data_Type = type;

	if(list_nodes == NULL) // The node be will first...
	{
		*list_nodes = New_Node;
		(*list_nodes)->PNext = NULL;
	}
	else
	{
		Previus_Node = Actual_Node = *list_nodes;
		End = FALSE;
		
		while(Actual_Node != NULL && !End)
		{
			if(ID_Node  > Actual_Node->ID_Node  )
			{
				End = TRUE;			
			}
			else
			{
				Previus_Node = Actual_Node;
				Actual_Node = Actual_Node->PNext;				
			
			}
		
		
		}

		if(Previus_Node == *list_nodes && Actual_Node == *list_nodes) // The new node will be the first of list nodes...
		{
			New_Node->PNext = *list_nodes;
			*list_nodes = New_Node;
		}
		else
		{
			Previus_Node->PNext = New_Node;
			New_Node->PNext = Actual_Node;

		}
	
	}



}

void AddNodeList_Image_FIFO(tImage type, tNodeImage **list_nodes)
{
	tNodeImage *New_Node, *Actual_Node;


	
	New_Node = (tNodeImage *)malloc(sizeof(tNodeImage));

	if(New_Node == NULL)
	{
		fprintf(fp_err,"\nNot enought memory in function \"AddNodeList_Image_FIFO()\" for reserve %d bytes !!!",sizeof(tNodeImage));
		return;
	}

	New_Node->ID_Node  = -1;
	New_Node->Data_Type = type;
	New_Node->PNext = NULL;

	if(*list_nodes == NULL) // The node be will first...
	{
		*list_nodes = New_Node;
		
	}
	else
	{
		Actual_Node = *list_nodes;
		
		
		while(Actual_Node->PNext != NULL)
		{
			Actual_Node = Actual_Node->PNext;				
		
		}

		Actual_Node->PNext = New_Node;
	
	}



}



void AddNodeList_Image_Sort_To_Ascendent(int ID_Node,tImage type, tNodeImage **list_nodes)
{
	tNodeImage *New_Node, *Actual_Node, *Previus_Node;
	int End;

	New_Node = (tNodeImage *)malloc(sizeof(tNodeImage));

	if(New_Node == NULL)
	{
		fprintf(fp_err,"\nNot enought memory in function \"AddNodeList_Sort_To_Descendent()\" for reserve %d bytes !!!",sizeof(tNodeImage));
		return;
	}

	New_Node->ID_Node  = ID_Node;
	New_Node->Data_Type = type;

	if(list_nodes == NULL) // The node be will first...
	{
		*list_nodes = New_Node;
		(*list_nodes)->PNext = NULL;
	}
	else
	{
		Previus_Node = Actual_Node = *list_nodes;
		End = FALSE;
		
		while(Actual_Node != NULL && !End)
		{
			if( ID_Node < Actual_Node->ID_Node)
			{
				End = TRUE;			
			}
			else
			{
				Previus_Node = Actual_Node;
				Actual_Node = Actual_Node->PNext;				
			
			}
		
		
		}

		if(Previus_Node == *list_nodes && Actual_Node == *list_nodes) // The new node will be the first of list nodes...
		{
			New_Node->PNext = *list_nodes;
			*list_nodes = New_Node;
		}
		else
		{
			Previus_Node->PNext = New_Node;
			New_Node->PNext = Actual_Node;

		}
	
	}


}


void Delete_Nodes_Image(tNodeImage *list_nodes)
{
	tNodeImage *Actual_Node;
	int i;
	

	while(list_nodes != NULL)
	{
		Actual_Node = list_nodes;
		list_nodes = list_nodes->PNext;

		// Free pixels of original image...

	//	CLRLINE;
	//	printf("\rFree \"%s\": Original",Actual_Node->Data_Type.name);
		if(Actual_Node->Data_Type.pixels != NULL) free(Actual_Node->Data_Type.pixels);

		if(Actual_Node->Data_Type.MipMaps!= NULL)
		{
			
			for(i = 0; i < Actual_Node->Data_Type.N_MipMaps; i++)
			{
				//printf(" Mip%1i: ",i);
				if((Actual_Node->Data_Type.MipMaps[i].pixels) != NULL) 
				{
					free(Actual_Node->Data_Type.MipMaps[i].pixels);
					//printf("OK ");
				}
				else
				{
					//printf("NULL");
				}
				
			}
		}
		else
		{
			printf("whiout MipMap information!!!");
		}

		free(Actual_Node);
	
	}

//	CLRLINE;
//	printf("\rFree: done!");

//	printf("\n");
}

//
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Implemetation nodes manegenmen for add info animations to modules info_animations.c & info_animations.h...
//
//


int Extract_ID_Frame(char ID_key[], int *ID_Frame, char name_file[])
{
	int pos, tst_num1, tst_num2;

	pos = strlen(name_file)-1;

	if(pos <= 0) return FALSE;

	while(name_file[pos] != '.' && (pos >= 1))
	{
		pos--;
	}

	pos--;
	if(pos <=1) return FALSE;

	tst_num1 = char_is_a_number(name_file[pos ]); 
	tst_num2 = char_is_a_number(name_file[pos-1]);
	
	*ID_Frame = (name_file[pos-1]-'0')*10 + (name_file[pos]-'0');

	pos -= 2;

	memcpy(ID_key,name_file,pos+1);
		
	return (tst_num1 && tst_num2);
}

int CadenesIguals(char *cad1,char *cad2,int longitud)
{
	int i, fi;

	i = 0;
	fi = FALSE;
	
	while(!fi && i < (longitud-1) )
	{
		if(cad1[i] == '\0' || cad1[i] == '\n' || cad2[i] == '\0' || cad2[i] == '\n' || cad2[i] != cad1[i])
		{
			fi = TRUE;
		}
		else
		{
		
			i++;
		}
		
	}

	return (cad1[i] == cad2[i]);
}



void AddNodeList_Animation(char name_image[],int ID_Image, tNodeMasterAnimation **list_type_animation)
{
	//
	//  PRE: The get list nodes of all images.
	//

	tNodeMasterAnimation   *Actual_Node, *New_Node, *Node_Found;
	tNodeFrame *New_Frame,  *Actual_Frame, *Previus_Frame, *list_frames;
	int ID_Frame, Valid_Frame;

	int  Found,End;
    char ID_key[WITH_STRING]={0};


		
	// reserve for memory ?
	
	
	
	New_Frame = (tNodeFrame *)malloc(sizeof(tNodeFrame));

	if(New_Frame == NULL)
	{
		fprintf(fp_err,"\nNot enought memory in function \"AddNodeList_Animation_Sort_To_Ascendent()\" for reserve %d bytes !!!",sizeof(tNodeFrame));
		return;
	}

	New_Frame->ID_Image   = ID_Image;
	New_Frame->PNextFrame = NULL;


	if(*list_type_animation != NULL)
	{
		Found = FALSE;




		if(Valid_Frame = Extract_ID_Frame(ID_key, &ID_Frame,name_image))
		{
		
			// Search the animation node, by name key "name_image"
			for(Actual_Node = *list_type_animation; Actual_Node != NULL && !Found;Actual_Node=Actual_Node->PNextNode)
			{
				if(Actual_Node->Is_Animation)
				{
					if(strncmp(Actual_Node->name,ID_key,WITH_STRING) == 0)
					{
						Node_Found = Actual_Node;
						Found = TRUE;
					}
				}
				
			}

		}
				
		
		if(!Found || !Valid_Frame) // I will create new animation...
		{

			
			New_Node  = (tNodeMasterAnimation *)malloc(sizeof(tNodeMasterAnimation));

			if(New_Node == NULL)
			{
				fprintf(fp_err,"\nNot enought memory in function \"AddNodeList_Animation()\" for reserve %d bytes !!!",sizeof(tNodeMasterAnimation));
				return;
			}

			

			Actual_Node = *list_type_animation;

			while(Actual_Node->PNextNode != NULL)
			{
				Actual_Node=Actual_Node->PNextNode;
			}

			if(Valid_Frame)
			{
				sprintf(New_Node->name,ID_key,WITH_STRING);
				New_Frame->ID_Frame = ID_Frame;
				New_Node->Is_Animation = TRUE;
				
			}
			else
			{
				sprintf(New_Node->name,name_image,WITH_STRING);
				New_Frame->ID_Frame = 0;
				New_Node->Is_Animation = FALSE;
				
			}
			
			
			
			New_Node->PFirstFrame = New_Frame;
	
			
			New_Node->PNextNode = NULL;
			Actual_Node->PNextNode = New_Node;


		
		}
		else // I add new frame order to ascendent (1,2,3,4...
		{

			// first, we have to get the number of animation....

			New_Frame->ID_Frame = ID_Frame;
			// Second, we have find the node with the ID_Frame little than the ID...

			list_frames = Previus_Frame = Actual_Frame = Node_Found->PFirstFrame;


			End = FALSE;
		
			while(Actual_Frame != NULL && !End)
			{
				if(ID_Frame  < Actual_Frame->ID_Frame )
				{
					End = TRUE;			
				}
				else
				{
					Previus_Frame = Actual_Frame;
					Actual_Frame = Actual_Frame->PNextFrame;				
					
				}
				
				
			}

			

			if(Previus_Frame == list_frames && Actual_Frame == list_frames) // The new Frame will be the first of list Frames...
			{
				New_Frame->PNextFrame = list_frames;
				(*list_type_animation)->PFirstFrame = New_Frame;
			}
			else
			{
				Previus_Frame->PNextFrame = New_Frame;
				New_Frame->PNextFrame     = Actual_Frame;
				
			}

			/*while(Actual_Frame->PNextFrame != NULL)
			{
				Actual_Frame=Actual_Frame->PNextFrame;
			}*/

//			Actual_Frame->PNextFrame = New_Frame;
									
		}
	}
	else // We will add first node...
	{
		New_Node  = (tNodeMasterAnimation *)malloc(sizeof(tNodeMasterAnimation));

		if(New_Node == NULL)
		{
					fprintf(fp_err,"\nNot enought memory in function \"AddNodeList_Animation_Sort_To_Ascendent()\" for reserve %d bytes !!!",sizeof(tNodeMasterAnimation));
					return;
		}
		


	
		if(Extract_ID_Frame(ID_key, &ID_Frame,name_image))
		{
			sprintf(New_Node->name,ID_key,WITH_STRING);
			New_Frame->ID_Frame = ID_Frame;
			New_Node->Is_Animation = TRUE;
		
		}
		else
		{
			sprintf(New_Node->name,name_image,WITH_STRING);
			New_Frame->ID_Frame = 0;
			New_Node->Is_Animation = FALSE;
		
		}

		

		New_Node->PNextNode   = NULL;

	
		New_Node->PFirstFrame = New_Frame;


	

		*list_type_animation  = New_Node;
		
		
	
	}
}



void Delete_Nodes_Animation(tNodeMasterAnimation *list_nodes)
{
	tNodeMasterAnimation	 *Actual_Node;
	tNodeFrame				 *ActualFrame,*list_frames;
	

	while(list_nodes != NULL)
	{
		Actual_Node  = list_nodes;
		
		list_frames = Actual_Node->PFirstFrame;
		
		while(list_frames != NULL)
		{
			ActualFrame = 	list_frames;
			list_frames =   list_frames->PNextFrame;
			free(ActualFrame);
			
		}
		
		list_nodes = list_nodes->PNextNode;

		free(Actual_Node);
	
	}
}


//
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////
