//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA


#include "Image.h"

extern char *pal;


void IMAGE_SetImagePropietries(tNodeImage *list_nodes)
{
    tNodeImage *list;
    int   *p;
    int i, found_mask_color;
    int mask_color;


    mask_color = PALETTE_Closest_Color(255,0, 255, pal);
    
    
    for(list = list_nodes; list != NULL; list = list->PNext)
    {
          list->Data_Type.Propietries=0;

          if(IS_POW2(list->Data_Type.Width))
          {
              list->Data_Type.Is_DimXPow2 = TRUE;
              SET_MASK_IMAGE_PROPIETRY(list->Data_Type.Propietries,BIT_IS_UPOW2);  
          }
          else
          {
            list->Data_Type.Is_DimXPow2 = FALSE;
          }

          if(IS_POW2(list->Data_Type.Height))
          {
              list->Data_Type.Is_DimYPow2 = TRUE;
            SET_MASK_IMAGE_PROPIETRY(list->Data_Type.Propietries,BIT_IS_VPOW2);  
          }
          else
          {
            list->Data_Type.Is_DimYPow2 = FALSE;
          }

          found_mask_color = FALSE;

          // Searching a mask color for determination of sprite...
          for(i = 0, p = list->Data_Type.MipMaps->pixels; !found_mask_color && i < (list->Data_Type.Width*list->Data_Type.Height); i++, p++)
          {
              if(*p == mask_color) found_mask_color = TRUE;          
          }

          if(found_mask_color)
          {
              list->Data_Type.Is_Sprite = TRUE;
              SET_MASK_IMAGE_PROPIETRY(list->Data_Type.Propietries,BIT_IS_SPRITE);  
             
          }
          else
          {
            list->Data_Type.Is_Sprite = FALSE;
          }


          // Setting the other bits...

          if(list->Data_Type.Is_Passable)
          {
            SET_MASK_IMAGE_PROPIETRY(list->Data_Type.Propietries,BIT_IS_PASSABLE);  
          }

          if(list->Data_Type.Is_Panorama)
          {
            SET_MASK_IMAGE_PROPIETRY(list->Data_Type.Propietries,BIT_IS_PANORAMA);  
          }

          if(list->Data_Type.N_MipMaps != 0)
          {
            SET_MASK_IMAGE_PROPIETRY(list->Data_Type.Propietries,BIT_WITH_MIPMAPS);  
          }



    }




}