//    Copyright (C) 2006 Jordi Espada Brau (jespa003@hotmail.com, u1034294@correu.udg.es)
//    Free Software Foundation, Inc.  Contributed by Gustawo Patow Ariel
//
//    This file is part of Jespa3D Engine.
//
//    Jespa3D Engine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Jespa3D Engine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Jespa3D Engine; ; see the file COPYING. if not, write to 
//    the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
//    Boston, MA  02111-1307  USA


#include "palette.h"



char frecuency[256][256][256];


int NearestColorFound(int r, int g, int b, int *color_index,tColorReduce *Color_Table_Reduce)
{
	int Color_Found,i,dif_r,dif_g,dif_b;
	float dist, dist_min = 200000.0f;
	
	
	i = 0; Color_Found = FALSE;

	while((i < COLORS_TO_REDUCE))
	{
		dif_r = Color_Table_Reduce[i].r-r;
		dif_g = Color_Table_Reduce[i].g-g;
		dif_b = Color_Table_Reduce[i].b-b;
		
		dist = (float)sqrt(dif_r*dif_r + dif_g*dif_g + dif_b*dif_b);

		if(dist < MIN_DIST)
		{

			Color_Found = TRUE;

			if(dist < dist_min)
			{
				*color_index = i;
				dist_min = dist;
			}


		}
		
		i = i + 1;
		
	
	}

	

	return Color_Found;
	
}

void Insert_Color(tColorReduce  *Color_Table_Reduce,tColorReduce Color)
{
	int i, j, Found, color_index;
	// let search the position...

	i = 0;
	Found = FALSE;

	


	if(NearestColorFound(Color.r, Color.g, Color.b, &color_index,Color_Table_Reduce)) // I found a similar color...
	{
			Color_Table_Reduce[color_index].frequency+=Color.frequency;
		//	Color_Table_Reduce[color_index].r= (Color_Table_Reduce[color_index].r + Color.r) >> 1;
		//	Color_Table_Reduce[color_index].g= (Color_Table_Reduce[color_index].g + Color.g) >> 1;
		//	Color_Table_Reduce[color_index].b= (Color_Table_Reduce[color_index].b + Color.b) >> 1;
	}
	else
	{

		while(i < COLORS_TO_REDUCE && !Found)
		{
			if(Color.frequency > Color_Table_Reduce[i].frequency) // I found the position...
			{
				Found = TRUE;		
			}
			else
			{
				i = i + 1;		
			}
			
		}
		
		// Ok. now insert new color to the table...
		
		if(Found)
		{
			// Rotate to right the positions to i...
			for(j = COLORS_TO_REDUCE-1; j > i; j--)
			{
				Color_Table_Reduce[j]= Color_Table_Reduce[j-1];
			}
			
			// We be insert the color...
			Color_Table_Reduce[i] = Color;
		}
	}

}


char *Build_Palette(tNodeImage *list_nodes, int Save_Info_Palette)
{
//	char ***frecuency = NULL;
	tNodeImage *actual_node; 
	int i,j;
	unsigned int r,g,b;
	tColorReduce  Color_Table_Reduce[256], Color;
	char *Palette = NULL;

			// Reduce the palette...

	// alloc mem...

	
/*	if((frecuency = (char ***)malloc(sizeof(char **)*256)) == NULL)
	{
		fprintf(fp_err,"\n Error to reserve %d bytes for frecuency.",sizeof(char **)*256);	
		exit(EXIT_FAILURE);
	}

*/
	for(i = 0; i < 256; i++)
	{
	/*	if((frecuency[i] = (char **)malloc(sizeof(char *)*256)) == NULL)
			
		{
			fprintf(fp_err,"\n Error to reserve %d bytes for frecuency[%i].",sizeof(char *)*256,i);	
			exit(EXIT_FAILURE);
		}*/

		for( j = 0; j < 256; j++)
		{
	/*		if((frecuency[i][j] = (char *)malloc(256)) == NULL)
			{
				fprintf(fp_err,"\n Error to reserve %d bytes for frecuency[%i][%i].",256,i,j);	
				exit(EXIT_FAILURE);
			
			}*/
			memset(&frecuency[i][j][0],0,256);
		}

	}

	// get the frequency..	
	
	// first get the frecuency of any color...

	// for all nodes...

/*	for(i = 0; i < 256;i ++)
	for(j = 0; j < 256;j ++)
		memset(&frecuency[i][j][0],0,256);*/
	
	actual_node = list_nodes;
	while(actual_node != NULL)
	{
		
		// For total dim(image) do...
		for(i = 0; i < actual_node->Data_Type.Height; i++)
		{
			for(j = 0; j < actual_node->Data_Type.Width; j++)
			{
				r = (actual_node->Data_Type.pixels[i*actual_node->Data_Type.Width+j] >> 16)&0xFF;
				g = (actual_node->Data_Type.pixels[i*actual_node->Data_Type.Width+j] >> 8 )&0xFF;
				b = (actual_node->Data_Type.pixels[i*actual_node->Data_Type.Width+j]      )&0xFF;

				if(!NEAREST_TO_MASK_COLOR(r,g,b))
				{
					frecuency[r][g][b]++;					
				}

				
			}


		
		}

		actual_node = actual_node->PNext;
	
	}

	// char *Reduce_Pal(tNode *list_nodes)

	// Get the MAX_COLOR used...


	// memset for the 256 colors...

	memset(&Color_Table_Reduce[0],0,sizeof(tColorReduce)*256);


	for(r = 0; r < 256; r++)
		for(b = 0; b < 256 ; b++)
			for(g = 0; g < 256; g++)
			{
				if(Color_Table_Reduce[COLORS_TO_REDUCE-1].frequency < frecuency[r][g][b]) 
				{

					Color.frequency = frecuency[r][g][b];
					Color.r = r;
					Color.b = b;
					Color.g = g;

					Insert_Color(Color_Table_Reduce,Color);
									
				
				}
			
			}

	// Insert the color mask...

	Color_Table_Reduce[COLORS_TO_REDUCE].r = (char)0xFF;
	Color_Table_Reduce[COLORS_TO_REDUCE].g = (char)0;
	Color_Table_Reduce[COLORS_TO_REDUCE].b = (char)0xFF;

	// Ok. now convert the format of rgb color 8:8:8 to 6:6:6...

	Palette = (char *)malloc(256*3*sizeof(char));
	

	if(Palette != NULL)
	{
		
		memset(Palette,0,256*3*sizeof(char));

		for(i = 0; i < 256; i++)
		{
			Palette[i*3]   = Color_Table_Reduce[i].r;
			Palette[i*3+1] = Color_Table_Reduce[i].g;
			Palette[i*3+2] = Color_Table_Reduce[i].b;			
		}
	}
	else fprintf(fp_err,"\nDon't enough memory for alloc %d bytes",256*3);
	
	
/*	for(i = 0; i < 256; i++)
	{
		
		for( j = 0; j < 256; j++)
		{
			free(frecuency[i][j]);		
			
		}

		free(frecuency[i]);

	}

	free(frecuency);*/

	if(Save_Info_Palette)
	{
		int k1,k2;
		uint *pixels;
		tImage Info_Palette;
		uchar red,green,blue;

		pixels = (uint *) malloc(PALETTE_SIZE*2*2*sizeof(uint));

		if(pixels != NULL)
		{
		
		// Save palette information to TGA file...

		for(k1= 0; k1 < 2; k1++)
		{
			
			for(i = 0; i < PALETTE_SIZE; i++)
			{
				red		=	Palette[i*3];
				green	=	Palette[i*3+1];
				blue	=	Palette[i*3+2];
				
				for(k2 = 0; k2 < 2; k2++)
				{
					pixels[(k1)*PALETTE_SIZE*2 + i*2 + k2] = (red << 16) | (green << 8) | blue;
				}
				
			}
		}

		Info_Palette.Width = PALETTE_SIZE*2;
		Info_Palette.Height = 2;
		Info_Palette.bpp = 24;
		Info_Palette.pixels = pixels;

		SaveTGA("Out\\Info_Palette.tga",&Info_Palette);

		free(pixels);


		}
	}

	return Palette;

}



uchar PALETTE_Closest_Color(float red,float green, float blue, char *Palette)
{

	uchar red_pal,green_pal,blue_pal,index_palette_with_closest_color;
	uint  color2;
	float redscore, greenscore, bluescore,score,bestscore;

	
	
	bestscore = FLT_MAX;

	
	for(color2 = 0; color2 < PALETTE_SIZE; color2++) // Search the best match...
	{
		red_pal = Palette[color2*3];
		green_pal = Palette[color2*3+1];
		blue_pal = Palette[color2*3+2];
		
		redscore = (float)fabs(red_pal-red);
		greenscore=(float)fabs(green_pal-green);
		bluescore=(float)fabs(blue_pal-blue);
		
		score = redscore + greenscore + bluescore;

        score = sqrt(redscore*redscore + greenscore*greenscore + bluescore*bluescore);
		
		if(score<bestscore)
		{
			bestscore = score;
			index_palette_with_closest_color = color2;
			
		}
		
		
		
		
	}

	return index_palette_with_closest_color;


}

uchar *Create_Table_Shades(char *Palette, int Save_Info_Shade)
{
	int color;//, color2;
	int level;
	float redlite, greenlite, bluelite;
	uchar	red, green, blue;
	uchar	*Table_Shade;
	
//	float score, bestscore,redscore,greenscore,bluescore;
	
	
	if((Table_Shade = (uchar *) malloc(PALETTE_SIZE*MAX_LIGHT)) == NULL)
	{
		fprintf(fp_err,"\n Cannot reserve memory for %i bytes",PALETTE_SIZE*MAX_LIGHT);
		return NULL;
	}
	
	
	//printf("\nBuilding the palette");
	
	for(color = 0; color < PALETTE_SIZE; color++)
	{
		//printf(".");// I give signal of live so the user doesn't think that the program is died.
		
		
		// Build the shades....
		for(level = 0; level < MID_LEVEL; level++)
		{
			
			//rgb_values(Palette[color],red,green,blue);
			
			red = Palette[color*3];
			green = Palette[color*3+1];
			blue = Palette[color*3+2];
			
			redlite = (float) (red-RED_SHADE_TARGET)/MAX_LIGHT_SHADES*level + RED_SHADE_TARGET;
			greenlite = (float) (green-GREEN_SHADE_TARGET)/MAX_LIGHT_SHADES*level + GREEN_SHADE_TARGET;
			bluelite = (float) (blue-BLUE_SHADE_TARGET)/MAX_LIGHT_SHADES*level + BLUE_SHADE_TARGET;


			Table_Shade[color*MAX_LIGHT + level] = PALETTE_Closest_Color(redlite,greenlite,bluelite,Palette);
			
			/*bestscore = FLT_MAX;
			
			for(color2 = 0; color2 < PALETTE_SIZE; color2++) // Search the best match...
			{
				red = Palette[color2*3];
				green = Palette[color2*3+1];
				blue = Palette[color2*3+2];
				
				redscore = (float)fabs(red-redlite);
				greenscore=(float)fabs(green-greenlite);
				bluescore=(float)fabs(blue-bluelite);
				
				score = redscore + greenscore + bluescore;
				
				if(score<bestscore)
				{
					bestscore = score;
					Table_Shade[color*MAX_LIGHT + level] = color2;
					
				}
				
				
				
				
			}*/
		}
		
		
		// Build the intensities....
		for(level = MID_LEVEL; level < MAX_LIGHT; level++)
		{
			
			//rgb_values(Palette[color],red,green,blue);
			
			red = Palette[color*3];
			green = Palette[color*3+1];
			blue = Palette[color*3+2];
			
			redlite = (float) (RED_INTENSITY_TARGET-red)/MAX_LIGHT_INTENSITY*(level-MID_LEVEL) + red;
			greenlite = (float) (GREEN_INTENSITY_TARGET-green)/MAX_LIGHT_INTENSITY*(level-MID_LEVEL) + green;
			bluelite = (float) (BLUE_INTENSITY_TARGET-blue)/MAX_LIGHT_INTENSITY*(level-MID_LEVEL) + blue;

			Table_Shade[color*MAX_LIGHT + level] = PALETTE_Closest_Color(redlite,greenlite,bluelite,Palette);
			
			/*bestscore = FLT_MAX;
			
			for(color2 = 0; color2 < PALETTE_SIZE; color2++) // Search the best match...
			{
				red = Palette[color2*3];
				green = Palette[color2*3+1];
				blue = Palette[color2*3+2];
				
				redscore = (float)fabs(red-redlite);
				greenscore=(float)fabs(green-greenlite);
				bluescore=(float)fabs(blue-bluelite);
				
				score = redscore + greenscore + bluescore;
				
				if(score<bestscore)
				{
					bestscore = score;
					Table_Shade[color*MAX_LIGHT + level] = color2;
					
				}
				
				
				
				
			}*/
		}
		
	
	}
	
	if(Save_Info_Shade)
	{
		int i,j,k1,k2;
		uint *pixels;
		tImage Image;

		// Writes the shade table in pixels of 8x8...
		
		pixels = (uint *)malloc(PALETTE_SIZE*2*MAX_LIGHT*2*sizeof(uint));

		if(pixels == NULL)
		{
			fprintf(fp_err,"\n Cannot reserve % bytes for save the output table of shades!");
		
		}
		else
		{
			
		
			for(i = 0; i < PALETTE_SIZE; i++)
			{
				for(k1 = 0; k1 < 2; k1++) // Duplicates the row...
				{
					for(j = 0; j < 	MAX_LIGHT; j++)
					{
						for(k2 = 0; k2 < 2; k2++) // Duplicates the column...
						{
							red		=	Palette[Table_Shade[i*MAX_LIGHT+j]*3];
							green	=	Palette[Table_Shade[i*MAX_LIGHT+j]*3+1];
							blue	=	Palette[Table_Shade[i*MAX_LIGHT+j]*3+2];
			

							pixels[i*2*(2*MAX_LIGHT) + k1*MAX_LIGHT*2 + j*2 + k2] = (red << 16) | (green << 8) | blue;//Palette[Table_Shade[i*PALETTE_SIZE+j]];
						}
						
					}
				}

				
				
				
				
				
			}
			
			// And the last thing, must save the info pixels in TGA file...

			Image.pixels	= pixels;
			Image.Height	= PALETTE_SIZE*2;
			Image.Width		= MAX_LIGHT*2;
			Image.bpp		= 24;
			SaveTGA("Out\\Shades.tga", &Image);
			
			free(pixels);

		}

		
	}
	
	return Table_Shade;
}




void Convert_MipMap_To_256_Colors(tMipMap *MipMap, char *palette)
{
	//
	// This function will convert rgb MipMap to 8 bpp paletized.
	//
	int x,y;
	float r,g,b;

	if(palette == NULL) return; // The palette has not initilized...

	for(y = 0; y < MipMap->Height; y++)
	{
		for(x = 0; x < MipMap->Width; x++)
		{

			r = (float)((MipMap->pixels[y*MipMap->Width+x] >> 16)&0x000000FF);
			g = (float)((MipMap->pixels[y*MipMap->Width+x] >> 8 )&0x000000FF);
			b = (float)((MipMap->pixels[y*MipMap->Width+x]      )&0x000000FF);

			MipMap->pixels[y*MipMap->Width+x] = PALETTE_Closest_Color(r,g,b,palette);
		}
	}

    MipMap->bpp = 8;
    MipMap->palette = palette;

    
    
}




void Reduce_Images_To_256_Colors(tNodeImage *__list_nodes,char *palette)
{
	tNodeImage  *actual_node;
	int i;

	if(__list_nodes == NULL)
	{
		fprintf(fp_err,"\n Error, __list_nodes es NULL!");
		return;
	}

	if(palette == NULL)
	{
		fprintf(fp_err,"\n Error, the palette es NULL!");
		return;
	}

	actual_node = __list_nodes;

	
	while(actual_node != NULL)
	{
//		gotoxy(0,20);
//		printf("\nReducing to 256 mipmap %i image: %s",actual_node->Data_Type.name);

		for(i = 0; i <= actual_node->Data_Type.N_MipMaps; i++)
		{
			//CLRSCR;
			//GOTOXY(0,20);
			CLRLINE;
			printf("\rReducing image: \"%s\" mipmap %i",actual_node->Data_Type.name,i);

			Convert_MipMap_To_256_Colors(&actual_node->Data_Type.MipMaps[i],palette);
		}

		actual_node->Data_Type.palette = palette;


		actual_node = actual_node->PNext;
	}

	CLRLINE;
	printf("\rReducing image: done!");


}


short Convert_32To16(uchar __r, uchar __g, uchar __b)
{

	long result, r,g,b;

	r = __r >> 3;//5
	g = __g >> 3;//5
	b = __b >> 3;//5

	result = (b << 10) | ( g << 5) | r;

	return ((short)result);
	

}


short  *Reduce_Palete_24bpp_To_16bpp(char *pal)
{
	short *pal16;
	int i;

	pal16 = (short *)malloc(sizeof(short)*PALETTE_SIZE);


	if(pal16 == NULL)
	{
		fprintf(fp_err,"\n Error, cannot reserve %i bytes for reduce palette 24 to 16 bpp!",PALETTE_SIZE*sizeof(short));
		return NULL;
	}

	for(i = 0; i < PALETTE_SIZE; i++)
	{
		pal16[i] = Convert_32To16(pal[i*3], pal[i*3+1], pal[i*3+2]);
	}

	return pal16;
}






// Creates a 50% of transparency (sometimes called glenzing, too), LUT table...
uchar *PAL_Create_Table_Glenz(char *Palette, int Save_Info_Glenz)
{
	int color, color2;//, color2;
//	int level;
	float redlite, greenlite, bluelite;
	uchar	red, green, blue;
    uchar	red2, green2, blue2;
	uchar	*Table_Glenz;
	
//	float score, bestscore,redscore,greenscore,bluescore;
	
	
	if((Table_Glenz = (uchar *) malloc(PALETTE_SIZE*PALETTE_SIZE)) == NULL)
	{
		fprintf(fp_err,"\n Cannot reserve memory for %i bytes",PALETTE_SIZE*PALETTE_SIZE);
		return NULL;
	}
	
	
	//printf("\nBuilding the palette");
	
	for(color = 0; color < PALETTE_SIZE; color++)
	{
		//printf(".");// I give signal of live so the user doesn't think that the program is died.
	    // get the actual RGB color palette...

		red   = Palette[color*3];
		green = Palette[color*3+1];
		blue  = Palette[color*3+2];	
		
		// Build the transparency....
		for(color2 = 0; color2 < PALETTE_SIZE; color2++)
		{

            // get the RGB color2 palette...

			red2   = Palette[color2*3];
			green2 = Palette[color2*3+1];
			blue2  = Palette[color2*3+2];

            // combining both colors to 50 % of transparency...

			redlite   = (float)(red  *0.5f + red2  * 0.5f);
			greenlite = (float)(green*0.5f + green2* 0.5f);
			bluelite  = (float)(blue *0.5f + blue2 * 0.5f);
            			
			//rgb_values(Palette[color],red,green,blue);
			

			Table_Glenz[color*PALETTE_SIZE + color2] = PALETTE_Closest_Color(redlite,greenlite,bluelite,Palette);
			
			/*bestscore = FLT_MAX;
			
			for(color2 = 0; color2 < PALETTE_SIZE; color2++) // Search the best match...
			{
				red = Palette[color2*3];
				green = Palette[color2*3+1];
				blue = Palette[color2*3+2];
				
				redscore = (float)fabs(red-redlite);
				greenscore=(float)fabs(green-greenlite);
				bluescore=(float)fabs(blue-bluelite);
				
				score = redscore + greenscore + bluescore;
				
				if(score<bestscore)
				{
					bestscore = score;
					Table_Glenz[color*MAX_LIGHT + level] = color2;
					
				}
				
				
				
				
			}*/
		}
		
		

		
	
	}
	
	if(Save_Info_Glenz)
	{
		int i,j,k1,k2;
		uint *pixels;
		tImage Image;

		// Writes the glenzing table in pixels of 8x8...
		
		pixels = (uint *)malloc(PALETTE_SIZE*2*PALETTE_SIZE*2*sizeof(uint));

		if(pixels == NULL)
		{
			fprintf(fp_err,"\n Cannot reserve % bytes for save the output table of glenzing!");
		
		}
		else
		{
			
		
			for(i = 0; i < PALETTE_SIZE; i++)
			{
				for(k1 = 0; k1 < 2; k1++) // Duplicates the row...
				{
					for(j = 0; j < 	PALETTE_SIZE; j++)
					{
						for(k2 = 0; k2 < 2; k2++) // Duplicates the column...
						{
							red		=	Palette[Table_Glenz[i*PALETTE_SIZE+j]*3];
							green	=	Palette[Table_Glenz[i*PALETTE_SIZE+j]*3+1];
							blue	=	Palette[Table_Glenz[i*PALETTE_SIZE+j]*3+2];
			

							pixels[i*2*(2*PALETTE_SIZE) + k1*PALETTE_SIZE*2 + j*2 + k2] = (red << 16) | (green << 8) | blue;//Palette[Table_Glenz[i*PALETTE_SIZE+j]];
						}
						
					}
				}

				
				
				
				
				
			}
			
			// And the last thing, must save the info pixels in TGA file...

			Image.pixels	= pixels;
			Image.Height	= PALETTE_SIZE*2;
			Image.Width		= PALETTE_SIZE*2;
			Image.bpp		= 24;
			SaveTGA("Out\\Glenzing.tga", &Image);
			
			free(pixels);

		}

		
	}
	
	return Table_Glenz;
}