#ifndef __PALETTE_H__
#define __PALETTE_H__


#include "GestNode.h"
#include "malloc.h"
#include "stdlib.h"
#include "string.h"
#include "math.h"
#include "float.h"
#include "GFX_Grafics.h"



#define COLORS_TO_REDUCE		254
#define MIN_DIST				10

#define RED_SHADE_TARGET         0
#define GREEN_SHADE_TARGET       0
#define BLUE_SHADE_TARGET        0

#define RED_INTENSITY_TARGET     255
#define GREEN_INTENSITY_TARGET   255
#define BLUE_INTENSITY_TARGET    255

#define PALETTE_SIZE			 256
#define MAX_LIGHT				 256
#define MID_LEVEL				 (MAX_LIGHT >> 1)
#define MAX_LIGHT_SHADES		 MID_LEVEL
#define MAX_LIGHT_INTENSITY		 (PALETTE_SIZE-MID_LEVEL)



#define IS_MASK_COLOR(r,g,b)		 (((r&0xFF) == 0xFF)  && ((g) == 0) && ((b&0xFF) == 0xFF))
#define NEAREST_TO_MASK_COLOR(r,g,b) (sqrt(((r)-0xFF)*((r)-0xFF) + (b*b) + ((g)-0xFF)*((g)-0xFF)) < MIN_DIST)


// PRECONDITION: Comp is rgb packed in format 8:8:8
#define DAC8_TO_DAC6_COLOR(comp)\
    comp = comp << 4;\
    comp = comp * (255/63);\
    comp = (comp<<2) + (comp>>4);\






typedef struct _tColorReduce{

	int frequency;
	char	r,g,b;


}tColorReduce;

extern FILE *fp_err;
//extern char  *pal

char *Build_Palette(tNodeImage *list_nodes, int Save_Info_Palette);
uchar *Create_Table_Shades(char *Palette, int Save_Info_Shade);
void Convert_Image_To_256_Colors(tImage *Image, char *palette);
void Reduce_Images_To_256_Colors(tNodeImage *__list_nodes,char *palette);
short  *Reduce_Palete_24bpp_To_16bpp(char *pal);
uchar PALETTE_Closest_Color(float red,float green, float blue, char *Palette);
uchar *PAL_Create_Table_Glenz(char *Palette, int Save_Info_Glenz);

//char  PAL_IsSprite(



#endif