#include "mygba.h"
#include "math.h"

//the krawall modules
#include "afm.h"

#include "gfx/master.pal.c"
#include "gfx/nuvols.raw.c"
#include "gfx/nuvols.map.c"
#include "gfx/terra.raw.c"
#include "gfx/terra.map.c"
#include "LUTs.c"

extern const unsigned char _binary_module_mod_start;
//extern void ARM_hblFunc(void);

/*
----------------------------------
 Program entry point
----------------------------------
*/


#define RADIANT(x)   (float)(((x)*PI)/180.0f)
#define ALTURA_SOSTRE  256
#define ALTURA_SOSTRE_FX    (128 << 8)
#define ONE          256

u8 g_NewFrame=0;
u8 frames=0;
u32 horitzo = 80;
u32 Xj=512 << 8;
u32 Zj=512 << 8;
u32 Yj = 32;
u32 i = 0;
u8 AngleJugador = 0;




MEM_FUNC_IN_IWRAM void hblFunc()
{
    FIXED Distancia, x_centre_rot, z_centre_rot, dx_mapa, dz_mapa, x0, z0, TempC, TempS, Escalat_Z;



        int   i = F_VCNT_CURRENT_SCANLINE;   // *(volatile u16 *)(MEM_IO + 0x06)		// Vertical counter(0-227)



        if((1 <= i && i <= 158))
        {

        TempC = COS[AngleJugador];
        TempS = SIN[AngleJugador];

        if(i >= horitzo)   Distancia = ((Yj))*reciprocal_div[i-horitzo-1] >> 1;
        else  Distancia = (ALTURA_SOSTRE-Yj)*reciprocal_div[horitzo-i] >> 1;

        x_centre_rot = (TempC*Distancia >> 8) + (Xj);
        z_centre_rot = (TempS*Distancia >> 8) + (Zj);

        Escalat_Z = Distancia >> 7;

        dx_mapa = -TempS*Escalat_Z >> 8;
        dz_mapa =  TempC*Escalat_Z >> 8;

        x0 = x_centre_rot - (dx_mapa << 7);
        z0 = z_centre_rot - (dz_mapa << 7);

        if(i>=horitzo){

            R_BG3ROTDX = dx_mapa;//#define R_BG3ROTDX     *(volatile u16 *)(MEM_IO + 0x030)
            R_BG3ROTDY = dz_mapa;//#define R_BG3ROTDY     *(volatile u16 *)(MEM_IO + 0x034)

            R_BG3ROTX = x0;// #define R_BG3ROTX     *(volatile u32 *)(MEM_IO + 0x038)
            R_BG3ROTY = z0;// #define R_BG3ROTY     *(volatile u32 *)(MEM_IO + 0x03C)

        }else

           R_BG2ROTDX = dx_mapa; // #define R_BG2ROTDX     *(volatile u16 *)(MEM_IO + 0x020)
           R_BG2ROTDY = dz_mapa; // #define R_BG2ROTDY     *(volatile u16 *)(MEM_IO + 0x024)

            R_BG2ROTX = x0;// #define R_BG2ROTX     *(volatile u32 *)(MEM_IO + 0x028)
            R_BG2ROTY = z0;// #define R_BG2ROTY     *(volatile u32 *)(MEM_IO + 0x02C)

        }





}


MEM_FUNC_IN_IWRAM void vblFunc()
{
    FIXED Distancia, x_centre_rot, z_centre_rot, dx_mapa, dz_mapa, x0, z0, TempC, TempS, Escalat_Z;

	frames++;
	

	
	if(F_CTRLINPUT_UP_PRESSED) {if((Yj-1)  > 0)   {Yj--; if(horitzo  > 2) horitzo-=2;}}
    else  {if(horitzo < 80) horitzo ++;
          /*else horitzo = 80;*/}
    
	if(F_CTRLINPUT_DOWN_PRESSED){if((Yj+1) < ALTURA_SOSTRE) {Yj++;if(horitzo < 158) horitzo+=2; }}
	else {if(horitzo > 80) horitzo --;
         /*else horitzo = 80;*/}

/*	if(F_CTRLINPUT_B_PRESSED) */  {  Zj+=SIN[AngleJugador];  Xj+=COS[AngleJugador]; }	
/*	if(F_CTRLINPUT_A_PRESSED) {    Zj-=SIN[AngleJugador];Xj-=COS[AngleJugador]; }*/


	
	if(F_CTRLINPUT_LEFT_PRESSED)    (--AngleJugador);
	if(F_CTRLINPUT_RIGHT_PRESSED)   (++AngleJugador);

	
	
	ham_CreateWin(0,0,horitzo,240,160,WIN_BG3,WIN_BG2,0);	
	
    TempC = COS[AngleJugador];
    TempS = SIN[AngleJugador];

    Distancia = (((ALTURA_SOSTRE_FX-Yj)))*reciprocal_div[horitzo] >> 11;//(reciprocal_div[80-i] << 6) >> 8;


            x_centre_rot = (TempC*Distancia >> 8) + (Xj);
            z_centre_rot = (TempS*Distancia >> 8) + (Zj);

            Escalat_Z = Distancia >> 7;

            dx_mapa = -TempS*Escalat_Z >> 8;
           dz_mapa =  TempC*Escalat_Z >> 8;

           x0 = x_centre_rot - (dx_mapa << 7);
           z0 = z_centre_rot - (dz_mapa << 7);

           R_BG2ROTDX = dx_mapa;
           R_BG2ROTDY = dz_mapa;

            R_BG2ROTX = x0;
            R_BG2ROTY = z0;
            
            i = 0;



	g_NewFrame=1;
	

}



int main(void)
{

	map_fragment_info_ptr mymap2,mymap3;

	


    // initialize HAMlib
    ham_Init();


    // Inicialitzacio mode rajola amb dos fons rotables i/o escalables
    ham_SetBgMode(2);

    // Configura el fons 2 pq sigui inifinit...
    M_BG2CNT_WRAP_SET_ON;
    M_BG3CNT_WRAP_SET_ON;


    // inicialitzaci de les paletes per objectes i el fons
	ham_LoadBGPal(&master_Palette,sizeof(master_Palette));

	// crrega de les rajoles
	ham_bg[2].ti = ham_InitTileSet(&nuvols_Tiles,SIZEOF_16BIT(nuvols_Tiles),1,1);
	ham_bg[3].ti = ham_InitTileSet(&terra_Tiles,SIZEOF_16BIT(terra_Tiles),1,1);
	
	// inicialitzaci d'un mapa buit
	ham_bg[2].mi = ham_InitMapEmptySet(0,1);
	ham_bg[3].mi = ham_InitMapEmptySet(3,1);

	// Es fa una referncia a les dades de mapa en la ROM
	 mymap2 = ham_InitMapFragment(&nuvols_Map,16,16,0,0,16,16,1);
     mymap3 = ham_InitMapFragment(&terra_Map,128,128,0,0,128,128,1);
	
    // Cpia (en aquest cas sencera) de mapa al BG2 i a les coordenades x=0 y=0
	ham_InsertMapFragment(mymap2,2,0,0);
	ham_InsertMapFragment(mymap3,3,0,0);
	
	// l'habilitem pq es veigi a pantalla
	ham_InitBg(2,1,1,0);
	ham_InitBg(3,1,1,0);
	
    ham_CreateWin(0,0,horitzo,240,160,WIN_BG3,WIN_BG2,0);	

    // inicialitzaci de la rutina d'interrupci VBLANK

    ham_StartIntHandler(INT_TYPE_HBL,&hblFunc);
    ham_StartIntHandler(INT_TYPE_VBL,&vblFunc);
    
    
    


 //  	ham_StartIntHandler(INT_TYPE_VCNT,&vcntFunc);



    while(1)
    {
 
       if(g_NewFrame)
       {
           // update player+mixing buffers
           // you must call this once each frame (timing doesnt matter)

           g_NewFrame=0;
       }

    }
}




