@ /***********************\
@ | ZONA MEMORIA i TAMANY  |
@ \***********************/

.CODE 32

.SECTION .iwram



@ /***********************\
@ | PROTOTIPUS DE FUNCIONS |
@ \***********************/


.GLOBL   ARM_ScanLineVertical_HIGH
.TYPE    ARM_ScanLineVertical_HIGH, function


.GLOBL   ARM_ScanLineVertical_LOW
.TYPE    ARM_ScanLineVertical_LOW, function


@ /**************************\
@ | IMPLEMENTACIO DEFUNCIONS |
@ \**************************/


ARM_ScanLineVertical_LOW:

@
@Recordant l'estructura, del pas de parametres per aquesta funci, en C,
@
@ typedef struct _tParametresScanLineVertical{
@
@	char *ptr_video,*ptr_textura;
@	Fixed32 v1,Escalat_v;
@	int NumeroPixels;
@
@ }tParametresScanLineVertical;
@
@
@

@ Utilitzaci de registres i variables compreses
@ ----------------------------------------------
@
@ r0  = parametre punter a l'estructura tParametresScanLineVertical, punter video amb offset prviament afegit. 
@ r1  = punter textura amb offset u, prviament afegit.
@ r2  = v1 
@ r3  = Escalat_v
@ r4  = NumeroPixels
@ r5  = offset_textura, Color
@ r6  = mascara

@
@ L'implementaci d'aquest scanline, suposa l'utilitzaci de textures de 64x64. Tamb es suposa que, el
@ numero de pixels a escriure s'han donat correctament. 
@


    STMFD   sp!, {r4-r6}                        @ empilem registres				
                
    @ Crrega dels 9 parametres als registres r0-r8 i la variable de nivell grfic...
                
    LDMIA   r0,{r0-r4}

	@ Mascara de textura , d'altura 64 texels...
    MOV r6,#63

	CMP	R4,#0
	BEQ	Acabar_ScanLineVertical_L	     @ Acabem ja que no tenim pixels a pintar.

@@@@@@@@@@@@@@@@@@@@@@@- BUCLE PRINCIPAL DEL PINTAT SCANLINE -@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

Mentre1_L:		                     @ do{
				
	
	AND	r5,r6,r2,LSR #8         @ Offset_textura = (v1 >> 8) & 63;
	LDRB	r5,[r1,r5, LSL #6]	 @ Color = ptr_textura[(v1 << 6)]]
	ORR	r5,r5,r5,LSL #8		 @ Color |= Color << 8;
	STRH	r5,[r0],#240	 	 @ *((short *)(ptr_video)) = Color; ptr_video += 240;

	ADD  	r2,r2,r3		 @ v1 = v1 + Escalat_v;
       	SUBS 	r4,r4,#1             	 @ NumeroPixels --;

	BNE  	Mentre1_L        @ }while(NumeroPixels > 0)
                                            				


@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@				
				
Acabar_ScanLineVertical_L:

        LDMFD   sp!, {r4-r6}            @ Restore registers
        BX      lr




@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@				
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@				
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@				



ARM_ScanLineVertical_HIGH:

@
@Recordant l'estructura, del pas de parametres per aquesta funci, en C,
@
@ typedef struct _tParametresScanLineVertical{
@
@	char *ptr_video,*ptr_textura;
@	Fixed32 v1,Escalat_v;
@	int NumeroPixels;
@
@ }tParametresScanLineVertical;
@
@
@

@ Utilitzaci de registres i variables compreses
@ ----------------------------------------------
@
@ r0  = parametre punter a l'estructura tParametresScanLineVertical, punter video amb offset prviament afegit. 
@ r1  = punter textura amb offset u, prviament afegit.
@ r2  = v1 
@ r3  = Escalat_v
@ r4  = NumeroPixels
@ r5  = offset_textura, Color
@ r6  = mascara
@ r7  = aux.
@ r8  = aux.


@
@ L'implementaci d'aquest scanline, suposa l'utilitzaci de textures de 64x64. Tamb es suposa que, el
@ numero de pixels a escriure s'han donat correctament. 
@


    STMFD   sp!, {r4-r8}                        @ empilem registres				
                
    @ Crrega dels 9 parametres als registres r0-r8 i la variable de nivell grfic...
                
    LDMIA   r0,{r0-r4}

    @ Mascara de textura , d'altura 64 texels...
    MOV r6,#63
    
    EOR     r8,r8,r8
    TSTS    r0,#1

    BEQ     Continua1_H

    BIC     r0,r0,#1                @ r0 = r0 & !0x1 (0xFFFFFFFFE)
    MOV     r8,#1

Continua1_H:

    CMP	R4,#0
    BEQ	Acabar_ScanLineVertical_H	     @ Acabem ja que no tenim pixels a pintar.

@@@@@@@@@@@@@@@@@@@@@@@- BUCLE PRINCIPAL DEL PINTAT SCANLINE -@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

Mentre1_H:		                     @ do{
				
	
	AND	r5,r6,r2,LSR #8         @ Offset_textura = (v1 >> 8) & 63;
	LDRB	r5,[r1,r5, LSL #6]	 @ Color = ptr_textura[(v1 << 6)]]

	LDRH    r7,[r0]			@ Llegim 16 bits de video...
				
				TSTS  r8,#1
                BEQ   Pixel_Parell_H

                @ Machaquem la posici senar (8 bits de menys pes)...

                AND     r7,r7,#0xFF              @ r7 = r7 & 0xFF
                ORR     r7,r7,r5,LSL #8         @ r7 = r7 | (r5 >> 8)


                B       Continua_H

Pixel_Parell_H:  @ Machaquem la posici parell (8 bits de ms pes)...

               MOV  r7,r7,LSR #8                 @ r7 = r7 & 0xF
               ORR  r7,r5,r7,LSL #8              @ r7 = r5 | r7 << 8


Continua_H:            				


	           STRH	r7,[r0],#240	 	 @ *((short *)(ptr_video)) = Color; ptr_video += 240;

	           ADD  	r2,r2,r3		 @ v1 = v1 + Escalat_v;
       	        SUBS 	r4,r4,#1             	 @ NumeroPixels --;

	           BNE  	Mentre1_H        @ }while(NumeroPixels > 0)
                                            				


@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@				
				
Acabar_ScanLineVertical_H:

        LDMFD   sp!, {r4-r8}            @ Restore registers
        BX      lr





@ The end...


 
