#ifndef __GRAFICS_H
 #define __GRAFICS_H


#include "raycast.h"
//#include "dos.h"

/*************\
| DEFINICIONS |
\*************/


#ifdef __SDL__

    extern SDL_Surface *Video;

#define sdl_work_vram (char *)Video->pixels

#endif

#ifdef __HAM__
    #define gba_work_vram ((ham_GetBGBuffer() == 1) ? ((char*)0x06000000) : ((char*)0x0600A000))
#endif

/***********************\
| DEFINICIONS DE TIPUS  |
\***********************/

typedef struct _tParametresPutSprite{
    
    int x_pos,y_pos,amplada_sprite,altura_sprite,mascara;
    char *src;

}tParametresPutSprite;



/*********\
| MACROS  |
\*********/


#if defined( _WINDOWS) || defined(_LINUX)
 //
 // Per decodificar un color de la paleta GBA als valors R,G o B.
 // 

    #define RGB_GET_R_VALUE(rgb)    ((rgb & 0x001f) << 3)
    #define RGB_GET_G_VALUE(rgb)    (((rgb >> 5) & 0x001f) << 3)
    #define RGB_GET_B_VALUE(rgb)    (((rgb >> 10) & 0x001f) << 3)

#endif
	
	
void PutPixel(int x, int y, char color);	
	


/************************\
| PROTOTIPUS DE FUNCIONS |
\************************/


void Inicialitzar_SDL();




#ifdef __HAM__
	extern void ARM_PutSprite(const tParametresPutSprite *P_PutSprite);
	#define PutSprite ARM_PutSprite
#endif

#ifdef __SDL__
	void SDL_PutSprite(const tParametresPutSprite  *P_PutSprite);
	#define PutSprite SDL_PutSprite
#endif


 




#endif



