#include "Mapa.h"
#include "Textura.h"



unsigned LOG2_AMPLADA_GRAELLA;
unsigned LOG2_ALTURA_GRAELLA;
Fixed32 DISTANCIA_MES_LLARGA;


const char Mapa[MAX_GRAELLES_Z+1][MAX_GRAELLES_X+1] =
{
//
// '0' representa que no hi ha paret, altrament hi ha paret.
//
                                        //  +----------------------------------------- > X+
 0,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  //  |

 0,1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,  //  |            270
 0,1, 3, 3, 0, 0, 0, 0, 0, 0, 3, 3, 1,  //  |             |
 0,1, 3, 3, 0, 0, 0, 0, 0, 0, 3, 3, 1,  //  |             |
 0,1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,  //  |   180 _____|______ 0
									    //  |             |
 0,1, 0, 0, 0, 4, 4, 4, 0, 0, 0, 0, 1,  //  |             |
 0,1, 0, 0, 0, 4, 6, 4, 0, 0, 0, 0, 1,  //  |             |  
 0,1, 0, 0, 0, 4, 0, 4, 0, 0, 0, 0, 1,  //  |            90
 0,1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,  //  |
 
 0,1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,  //  |
 0,1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,  //  |
 0,1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,  //  |
 0,1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,  //  |
 
 0,1, 0, 0, 0, 4, 0, 4, 0, 0, 0, 0, 1,  //  |
 0,1, 0, 0, 0, 4, 6, 4, 0, 0, 0, 0, 1,  //  |
 0,1, 0, 0, 0, 4, 4, 4, 0, 0, 0, 0, 1,  //  |
 0,1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,  //  |
 
 0,1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,  //  |
 0,1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,  //  |
 0,1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,  //  |
 0,1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,  //  |
 
 0,1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,  //  |
 0,1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,  //  |
 0,1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,  //  |
 0,1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,  //  |
								        //  |
 0,1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,  //  |
 0,1, 3, 3, 0, 0, 0, 0, 0, 0, 3, 3, 1,  //  |
 0,1, 3, 3, 0, 0, 0, 0, 0, 0, 3, 3, 1,  //  V
 0,1, 2, 2, 2, 5, 5, 5, 2, 2, 2, 2, 1   //  Z+

};





void PosicioMapaRaigX(Fixed32 PosicioRaigX,Fixed32 PosicioRaigZ,int AngleRaig,int *PosMapaX,int *PosMapaZ)
{
 if(AngleRaig > GRAU_270 || AngleRaig < GRAU_90 ) // Raig projectat a la dreta...
 {
  (*PosMapaX) = FIXED_2_INT((PosicioRaigX >> LOG2_AMPLADA_GRAELLA)) + 1;
  (*PosMapaZ) = FIXED_2_INT((PosicioRaigZ >> LOG2_ALTURA_GRAELLA)) + 1;
 }
 else // Raig projectat a l' esquerra...
 {
  (*PosMapaX) = FIXED_2_INT((PosicioRaigX >> LOG2_AMPLADA_GRAELLA));
  (*PosMapaZ) = FIXED_2_INT((PosicioRaigZ >> LOG2_ALTURA_GRAELLA)) + 1;
 }
}


void PosicioMapaRaigZ(Fixed32 PosicioRaigX,Fixed32 PosicioRaigZ,int AngleRaig,int *PosMapaX,int *PosMapaZ)
{
 if(AngleRaig < GRAU_180 ) // Raig projectat cap al sud...
 {
   (*PosMapaX) = FIXED_2_INT((PosicioRaigX >> LOG2_AMPLADA_GRAELLA) )+ 1;
  (*PosMapaZ) = FIXED_2_INT((PosicioRaigZ >> LOG2_ALTURA_GRAELLA) )+ 1;
 }
 else // Raig projectat cap al nord...
 {
  (*PosMapaX) = FIXED_2_INT((PosicioRaigX >> LOG2_AMPLADA_GRAELLA) )+ 1;
  (*PosMapaZ) = FIXED_2_INT((PosicioRaigZ >> LOG2_ALTURA_GRAELLA));
 }
}



// Inicialitza les variables globals...
void Inicialitzar_Mapa()
{
	DISTANCIA_MES_LLARGA = DOUBLE_2_FIXED(sqrt(pow(MAX_UNITATS_MAPA_Z,2)+pow(MAX_UNITATS_MAPA_Z,2)));

	LOG2_AMPLADA_GRAELLA = log_2(AMPLADA_TEXTURA);
	LOG2_ALTURA_GRAELLA = log_2(ALTURA_TEXTURA);


}

