#ifndef __RENDER_H
 #define __RENDER_H

#include "Tipus.h"
#include "Grafics.h"
#include "Mapa.h"
#include "Raycast.h"
#include "Mates.h"


/************\
| DEFINCIONS |
\************/


#define FOV             60.0f
#define INCREMENT_FOV   (FOV/(float)AMPLADA_PANTALLA)
#define CENTRE_Y2D      (ALTURA_PANTALLA >> 1)
#define CENTRE_Y3D      ((ALTURA_TEXTURA >> 1) << 8 )
#define TAMANY_LUTS     (int)(360.f/INCREMENT_FOV)


/*******************\
| VARIABLES GLOBALS |
\*******************/

extern const Fixed32 CorreccioEfectePeix[AMPLADA_PANTALLA];
extern const Fixed32 Sinus[TAMANY_LUTS];
extern const Fixed32 Cosinus[TAMANY_LUTS];
extern const Fixed32 Tangent[TAMANY_LUTS];

extern int GRAU_0;  
extern int GRAU_30; 
extern int GRAU_45; 
extern int GRAU_70; 
extern int GRAU_90; 
extern int GRAU_110; 
extern int GRAU_135;
extern int GRAU_180;
extern int GRAU_225;
extern int GRAU_250;
extern int GRAU_270;
extern int GRAU_290;
extern int GRAU_310;
extern int GRAU_360;

extern int  BAIX_DETALL;

/********************\
| DEFINICIO DE TIPUS |
\********************/

typedef struct _tParametresScanLineVertical{

	char    *ptr_video,*ptr_textura;
	Fixed32 v1,Escalat_v;
    int     NumeroPixels;
	
}tParametresScanLineVertical;



/**********************************\
| PROTOTIPUS DE FUNCIONS I ACCIONS |
\**********************************/

#ifdef __HAM__
    inline extern void ARM_ScanLineVertical_LOW(tParametresScanLineVertical *ParametresScanLineVertical);
    inline extern void ARM_ScanLineVertical_HIGH(tParametresScanLineVertical *ParametresScanLineVertical); // Noms a la versi RAY_CASTING_003 per demostrar que es un traat de tira lent.
#endif



void Render_Init();
void  Renderitzar(Fixed32 XPosJugador,Fixed32 YPosJugador,int AngleJugador);
 




#endif
