#include "raycast.h"



/*******************\
| VARIABLES GLOBALS |
\*******************/



int main(int argc, char *argv[])
{


	Fixed32 XPosJugador,ZPosJugador;
	int ticks_ini,ticks_fi;
	int AngleJugador;

	float FPS;

	char *p_video;

#ifdef __SDL__
    /* Initialize the SDL library */

	Inicialitzar_SDL();

	p_video = (char *)Video->pixels;
	
	InicialitzarTeclat();
	
#endif
	
#ifdef __HAM__

    TOOL_PROFILER_INIT
	
    ham_Init();

   ham_SetBgMode(4);

#endif

	// Inicialitzacio de constants per la renderitzaci...
    Render_Init();

	XPosJugador = INT_2_FIXED(500);//MAX_UNITATS_MAPA_X/2;
	ZPosJugador = INT_2_FIXED(384);//608;//MAX_UNITATS_MAPA_Y/2;
	AngleJugador = (int)(0.0f/INCREMENT_FOV);//111.5f;



	// Inicialitzacions...

	InicialitzarTextures();
	Inicialitzar_Mapa();

  // and then call the function specified
 
    

	
	do{

		#ifdef __SDL__

		if(SDL_MUSTLOCK(Video))
		{
				SDL_LockSurface(Video);
		}
		
        SDL_FillRect(Video,NULL,40);
        
        ticks_ini = SDL_GetTicks();
        
		Renderitzar(XPosJugador,ZPosJugador,AngleJugador);
		
		ticks_fi = SDL_GetTicks();
		
		FPS = (1000.0f)/( (float)(ticks_fi-ticks_ini+1));
		
        SDL_UnlockSurface(Video);

        #endif
        
        #ifdef __HAM__
        
            ham_ClearBackBuffer(0);


            
            TOOL_PROFILER_START
            
    		Renderitzar(XPosJugador,ZPosJugador,AngleJugador);
    		
    		FPS = 1000.0f/(float)((ham_prof_frames_elapsed*16.7680f+ham_prof_subticks*0.0038f));
    		
    		TOOL_PROFILER_END


        
        #endif

	
		EscriureTextAPantalla(0,0,"Angle:\nPosicio X:\nPosicio Y:\nFPS:",0);
		EscriureNumeroRealAPantalla(56,0,(float)AngleJugador*INCREMENT_FOV,0);

		EscriureNumeroEnterAPantalla(88,8,FIXED_2_INT(XPosJugador),0);
       EscriureNumeroEnterAPantalla(88,16,FIXED_2_INT(ZPosJugador),0);
		EscriureNumeroRealAPantalla(56,24,FPS,0);
	
	
		#ifdef __SDL__
    	    SDL_Flip(Video);
        #endif
        #ifdef __HAM__
 
             ham_FlipBGBuffer ();     //ham_CopyObjToOAM();	       	
        #endif

	    ActualitzarJugador(&XPosJugador,&ZPosJugador,&AngleJugador);	

	}while(!TeclaEscape());

	exit(0);
}




void ActualitzarJugador(Fixed32 *Xj,Fixed32 *Zj,int *AngleJugador)
{

 Fixed32 DeltaX,DeltaZ;
 int XMapPos , ZMapPos , XPosJugador = FIXED_2_INT(*Xj), ZPosJugador = FIXED_2_INT(*Zj);

 
 DeltaX= FIXED_2_INT(MulFx(Cosinus[*AngleJugador],INT_2_FIXED(VELOCITAT_JUGADOR)));
 DeltaZ= FIXED_2_INT(MulFx(Sinus[*AngleJugador],INT_2_FIXED(VELOCITAT_JUGADOR)));

 XMapPos = (XPosJugador >> LOG2_AMPLADA_GRAELLA) + 1;
 ZMapPos = (ZPosJugador >> LOG2_ALTURA_GRAELLA) + 1;
	


 if (TeclaDreta())
 {
	(*AngleJugador) += VELOCITAT_GIR;
	if((*AngleJugador) >= GRAU_360) (*AngleJugador) -= GRAU_360;
 }

 
 if(TeclaEsquerra())
 {
	(*AngleJugador) -= VELOCITAT_GIR;
	if((*AngleJugador) < 0) (*AngleJugador) += GRAU_360;
 }
 
 
 
  if(TeclaAmunt()) // Realitzem els increments DeltaX, DeltaZ.
  {
	(XPosJugador) += DeltaX; 
	(ZPosJugador) += DeltaZ;
  }
  
  if(TeclaAvall()) // Realitzem el contrari, decrementar.
  {
    DeltaX=-DeltaX;
	DeltaZ=-DeltaZ;
	
	(XPosJugador) += DeltaX; 
	(ZPosJugador) += DeltaZ;
  }

  if(TeclaEnter())
  {
	BAIX_DETALL = 1 - BAIX_DETALL;
  }



  
  // Zona de detecci collisi jugador amb paret...

  if(DeltaX > 0) // Jugador camina cap a la dreta...
  {
	  if(Mapa[ZMapPos][((XPosJugador + PARET_MES_PROXIMA) >> 6) + 1] != 0)
	  {
		(XPosJugador) = ((XMapPos) << LOG2_AMPLADA_GRAELLA) - PARET_MES_PROXIMA; 
	  }
  
  }

  if(DeltaX < 0) // Jugador camina cap a l'esquerra...
  {
	  if(Mapa[ZMapPos][((XPosJugador - PARET_MES_PROXIMA) >> 6) + 1] != 0)
	  {
		(XPosJugador) = ((XMapPos - 1) << LOG2_AMPLADA_GRAELLA) + PARET_MES_PROXIMA; 
	  }
  
  }

  if(DeltaZ > 0) // Jugador camina cap avall...
  {
	  if(Mapa[((ZPosJugador  + PARET_MES_PROXIMA) >> LOG2_ALTURA_GRAELLA) +1][XMapPos] != 0)
	  {
		(ZPosJugador) = ((ZMapPos) << LOG2_ALTURA_GRAELLA) - PARET_MES_PROXIMA; 
	  }
  
  }

  if(DeltaZ < 0) // Jugador camina cap amunt...
  {
	  if(Mapa[((ZPosJugador - PARET_MES_PROXIMA) >> LOG2_ALTURA_GRAELLA)+1][XMapPos] != 0)
	  {
		(ZPosJugador) = ((ZMapPos - 1) << LOG2_ALTURA_GRAELLA) + PARET_MES_PROXIMA; 
	  }
  
  }

  *Xj = INT_2_FIXED(XPosJugador);
  *Zj = INT_2_FIXED(ZPosJugador);


}




