#ifndef __RAYCAST_H
 #define __RAYCAST_h

#include "stdlib.h"
#include "stdio.h"


#if defined(_WINDOWS) || defined(_LINUX)
#ifndef __SDL__
 #define __SDL__
#endif
 #include "conio.h"
 #include "memory.h"
 #include "string.h"
 #include "SDL/SDL.h"
#endif

#if defined(__arm__) || defined(__thumb__)       // definit en l' arxiu "gcc-arm\arm-thumb-elf\include\machine\stdlib.h"
#ifndef __HAM__
 #define __HAM__
#endif
 #include "myGBA.h"
#endif

#include "Mapa.h"
#include "Textura.h"
#include "Grafics.h"
#include "Font.h"

#include "teclat.h"
#include "math.h"
#include "malloc.h"
#include "Mates.h"
#include "Render.h"
#include "FixedPoint.h"

//#include "paleta.h"


/*************\
| DEFINICIONS |
\*************/

#define CERT 1
#define FALS 0


// Definicions de pantalla i jugador...

#ifdef __SDL__

	#define AMPLADA_PANTALLA		240
	#define ALTURA_PANTALLA			160
	#define VELOCITAT_JUGADOR      4
	#define VELOCITAT_GIR          4

#endif

#ifdef __HAM__

	#define AMPLADA_PANTALLA		240
	#define ALTURA_PANTALLA			160
	#define VELOCITAT_JUGADOR      16
	#define VELOCITAT_GIR          36

#endif


#define ALTURA_HOME                32
#define PARET_MES_PROXIMA	       32

// Definicions de angle raig enumerat...

/*extern Fixed32  V_SCALE;
extern int  GRAU_30;
extern int  GRAU_90;
extern int  GRAU_180;
extern int  GRAU_270;
extern int  GRAU_360;
#define  TAMANY_LUTS     (int)(360.f/INCREMENT_FOV)*/
#if defined(__arm__) || defined(__thumb__)
    #define max(a,b)  (((a) > (b)) ? (a) : (b))
    #define min(a,b)  (((a) < (b)) ? (a) : (b))
#endif



/*************************\
| DEFINICIO DE PROTOTIPUS |
\*************************/


void ActualitzarJugador(Fixed32 *XPosJugador,Fixed32 *YPosJugador,int *AngleJugador);





#endif
